#include <iostream>
#include <vector>
#include <map>
#include <queue>
#include <bitset>
#include <algorithm>
#include <cassert>
#include <functional>

using namespace std;

const int N = 32;

int end_game(int f) {
    for (int i = 0; ; i++) {
        if (i % 2 == f) {
            cout << 0 << endl;
            return 1;
        } else {
            int x, y;
            cin >> x >> y;
            x--;
            y--;
            if (x == 0 && y == 0) {
                return 0;
            }
        }
    }
}

void play_game(int f, string &s) {
    vector<vector<int>> a(N, vector<int> (N));
    auto color = [&](int i, int j) {
        for (int ti = 0; ti <= i; ti++) {
            for (int tj = j; tj < N; tj++) {
                a[ti][tj] = 1;
            }
        }
    };
    auto cnt = [&](int i, int j) {
        int ans = 0;
        for (int ti = 0; ti <= i; ti++) {
            for (int tj = j; tj < N; tj++) {
                ans += !a[ti][tj];
            }
        }
        return ans;
    };
    for (int c = 0; ; c++) {
        if (c % 2 == f) {
            if (s.empty()) {
                cout << 1 << ' ' << 1 << endl;
                return;
            }
            int mn = N * N + 1;
            int bi = -1;
            int bj = -1;
            for (int i = 0; i < N; i++) {
                for (int j = 0; j < N; j++) {
                    if (!a[i][j] && cnt(i, j) % 2 == s.back() - '0') {
                        if (cnt(i, j) < mn) {
                            mn = cnt(i, j);
                            bi = i;
                            bj = j;
                        }
                    }
                }
            }
            if (bi == -1) {
                cout << 1 << ' ' << 1 << endl;
                return;
            } else {
                assert(!a[bi][bj]);
                cout << bj + 1 << ' ' << bi + 1 << endl;
                color(bi, bj);
                s.pop_back();
            }
        } else {
            int j, i;
            cin >> j >> i;
            j--;
            i--;
            if (i == 0 && j == 0) return;
            color(i, j);
        }
    }
}

void solve_1() {
    string s;
    cin >> s;
    for (int i = 0; ; i++) {
        if (s.empty()) {
            while (!end_game(i % 2)) {
                //
            }
            return;
        } else {
            play_game(i % 2, s);
        }
    }
}

void rec(vector<pair<int, int>> turns, int f, string &res) {
    vector<vector<int>> a(N, vector<int> (N));
    auto color = [&](int i, int j) {
        for (int ti = 0; ti <= i; ti++) {
            for (int tj = j; tj < N; tj++) {
                a[ti][tj] = 1;
            }
        }
    };
    auto cnt = [&](int i, int j) {
        int ans = 0;
        for (int ti = 0; ti <= i; ti++) {
            for (int tj = j; tj < N; tj++) {
                ans += !a[ti][tj];
            }
        }
        return ans;
    };
    int c = 0;
    for (auto [i, j] : turns) {
        if (i == 0 && j == 0) {
            return;
        }
        if ((c % 2) == f) {
            //we
            res.push_back('0' + ((cnt(i, j) % 2)));
            color(i, j);
        } else {
            color(i, j);
        }
        c ^= 1;
    }
}

void solve_2(int m) {
    int cnt;
    cin >> cnt;
    string res;
    for (int c = 0; c < cnt; c++) {
        vector<pair<int, int>> g;
        while (true) {
            int i, j;
            cin >> j >> i;
            i--;
            j--;
            g.push_back({i, j});
            if (i == 0 && j == 0) break;
        }
        rec(g, c % 2, res);
    }
    while (res.size() > m) res.pop_back();
    reverse(res.begin(), res.end());
    cout << res << endl;
}   

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

    int t;
    cin >> t;
    if (t == 1) {
        int n, m, k;
        cin >> n >> k >> m;
        solve_1();
    } else {
        int n, m, k;
        cin >> n >> k >> m;
        solve_2(m);
    }
}