#include <iostream>
#include <algorithm>
#include <numeric>
#include <vector>

using namespace std;
using pi = pair<int, int>;

const int N = 1e5+7;

vector<int> g[N];
vector<pi> res[N];
bool man[N];

bool solve(int v) {
    if (man[v]) {
        int k = g[v].size();
        vector<int> p = g[v];
        for (int i : p) {
            if (!solve(i)) return false;
        }

        sort(p.begin(), p.end());
        do {
            for (auto [i0, j0] : res[p[0]]) {
                bool ok = true;
                for (int i = 1; i < k; ++i) {
                    auto x = lower_bound(res[p[i]].begin(), res[p[i]].end(), pi{j0, -1});
                    if (x == res[p[i]].end()) {
                        ok = false;
                        break;
                    } else {
                        j0 = x->second;
                    }
                }
                if (ok) {
                    res[v].emplace_back(i0, j0);
                }
            }
        } while(next_permutation(p.begin(), p.end()));

        sort(res[v].begin(), res[v].end());
        res[v].erase(unique(res[v].begin(), res[v].end(), [](pi& l, pi& r) {
            return l.first == r.first;
        }), res[v].end());

        return !res[v].empty();
    } else {
        for (int x : g[v]) res[v].emplace_back(x, x);
        sort(res[v].begin(), res[v].end());
        return true;
    }
}

int main() {
    int n; cin >> n;
    for (int i = 1; i <= n; ++i) {
        int t; cin >> t;
        if (t == 1) man[i] = true;
        int k; cin >> k;
        g[i].resize(k);
        for (int& x : g[i]) cin >> x;
    }

    auto ok = solve(1);
    cout << (ok ? "Yes" : "No") << endl;
}