#include <iostream>
#include <algorithm>
#include <numeric>
#include <vector>

using namespace std;
using pi = pair<int, int>;

const int N = 1e5+7;

vector<int> g[N], ans[N];
vector<pi> res[N];
bool man[N];

bool solve(int v) {
    if (man[v]) {
        int k = g[v].size();
        vector<int> p = g[v];
        for (int i : p) {
            if (!solve(i)) return false;
        }

        sort(p.begin(), p.end());
        do {
            for (auto [i0, j0] : res[p[0]]) {
                bool ok = true;
                for (int i = 1; i < k; ++i) {
                    auto x = lower_bound(res[p[i]].begin(), res[p[i]].end(), pi{j0, -1});
                    if (x == res[p[i]].end()) {
                        ok = false;
                        break;
                    } else {
                        j0 = x->second;
                    }
                }
                if (ok) {
                    res[v].emplace_back(i0, j0);
                }
            }
        } while(next_permutation(p.begin(), p.end()));

        sort(res[v].begin(), res[v].end());
        res[v].erase(unique(res[v].begin(), res[v].end(), [](pi& l, pi& r) {
            return l.first == r.first;
        }), res[v].end());

        vector<pi> kek;
        for (int i = res[v].size(); i--; ) {
            if (i + 1 == res[v].size() || res[v][i].second < res[v][i+1].second) {
                kek.push_back(res[v][i]);
            }
        }

        reverse(kek.begin(), kek.end());
        kek.swap(res[v]);

        return !res[v].empty();
    } else {
        for (int x : g[v]) res[v].emplace_back(x, x);
        sort(res[v].begin(), res[v].end());
        return true;
    }
}

void gans(int v, int I0) {
    if (man[v]) {
        vector<int> p = g[v];
        int k = p.size();
        sort(p.begin(), p.end());
        do {
            int J0 = lower_bound(res[v].begin(), res[v].end(), pi {I0, -1})->second;
            for (auto [i0, j0] : res[p[0]]) {
                int save = j0;
                if (i0 != I0) continue;
                bool ok = true;
                for (int i = 1; i < k; ++i) {
                    auto x = lower_bound(res[p[i]].begin(), res[p[i]].end(), pi{j0, -1});
                    if (x == res[p[i]].end()) {
                        ok = false;
                        break;
                    } else {
                        j0 = x->second;
                    }
                }
                if (ok && j0 == J0) {
                    ans[v] = p;
                    j0 = save;
                    gans(p[0], i0);
                    for (int i = 1; i < k; ++i) {
                        auto x = lower_bound(res[p[i]].begin(), res[p[i]].end(), pi{j0, -1});
                        gans(p[i], x->first);
                        j0 = x->second;
                    }
                    break;
                }
            }
        } while(next_permutation(p.begin(), p.end()));
    } else {
        ans[v] = { I0 };
    }
}

int main() {
    int n; cin >> n;
    for (int i = 1; i <= n; ++i) {
        int t; cin >> t;
        if (t == 1) man[i] = true;
        int k; cin >> k;
        g[i].resize(k);
        for (int& x : g[i]) cin >> x;
    }

    auto ok = solve(1);
    cout << (ok ? "Yes" : "No") << endl;
    if (ok) {
        gans(1, res[1][0].first);
        for (int i = 1; i <= n; ++i) {
            for (int x : ans[i]) cout << x << ' ';
            cout << '\n';
        }
    }
}