#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <string>

using namespace std;
const int N = 33;

int opX = 0, opY = 0;
const int LG = 8;
int n = 0;

int a[N][N];

pair<int, int> getIth(int x)
{
	int cnt = -1;
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < n; ++j)
		{
			if (a[i][j] == 0)
			{
				if (cnt == x)
					return { i, j };
				++cnt;
			}
		}
	}
	return { 0, 0 };
}

int getPos(int x, int y)
{
	int cnt = -1;
	for (int i = 0; i < n; ++i)
	{
		for (int j = 0; j < n; ++j)
		{
			if (a[i][j] == 0)
			{
				if (i == x && j == y)
					return cnt;
				++cnt;
			}
		}
	}
	return -1;
}

int getNum(int pos, const string& s)
{
	int res = 0;
	for (int i = 0; i < LG && i + pos < s.size(); ++i)
		res |= ((s[i + pos] - '0') << i);
	return res;
}

void color(int x, int y)
{
	for (int i = x; i < n; ++i)
		for (int j = y; j < n; ++j)
			a[i][j] = 1;
}

void doMove(int x, int y)
{
	color(x, y);
	cout << x + 1 << " " << y + 1 << endl;
	if (x == 0 && y == 0)
		return;
	cin >> opX >> opY;
	--opX, --opY;
	color(opX, opY);
}

void toStr(int x, string& s)
{
	for (int i = LG - 1; i >= 0; --i)
		s.push_back('0' + ((x >> i) & 1));
}

int main()
{
	//ios::sync_with_stdio(false);
	//cin.tie(0), cout.tie(0);

	//freopen("\\\\.\\pipe\\game.in", "r", stdin);
	//freopen("\\\\.\\pipe\\game.out", "w", stdout);

	int t = 0;
	cin >> t;

	int k = 0, m = 0;
	cin >> n >> k >> m;
	if (t == 1)
	{
		string s;
		cin >> s;

		int turn = 0, curPos = 0;
		while (curPos <= m + 2)
		{
			for (int i = 0; i < n; ++i)
				fill(a[i], a[i] + n, 0);

			if (turn)
			{
				cin >> opX >> opY;
				--opX, --opY;
				color(opX, opY);
			}

			while (true)
			{
				auto pos = getIth(getNum(curPos, s));
				color(pos.first, pos.second);
				doMove(pos.first, pos.second);
				if (pos.first != 0 || pos.second != 0)
					curPos += LG;
				else
					break;
				if (opX == 0 && opY == 0)
					break;
			}
			turn = 1 - turn;
		}

		cout << 0 << endl;
	}
	else
	{
		cin >> k;
		int turn = 0;
		string ans;
		while (ans.size() < m)
		{
			for (int i = 0; i < n; ++i)
				fill(a[i], a[i] + n, 0);

			if (turn)
			{
				cin >> opX >> opY;
				--opX, --opY;
				color(opX, opY);
			}

			while (opX != 0 || opY != 0)
			{
				int x = 0, y = 0;
				cin >> x >> y;
				--x, --y;
				if (x == 0 && y == 0)
					break;
				int num = getPos(x, y);
				toStr(num, ans);
				color(x, y);

				cin >> opX >> opY;
				--opX, --opY;
				color(opX, opY);
			}
			turn = 1 - turn;
		}

		cout << ans.substr(0, m) << endl;
	}

	return 0;
}

/*
4 16 4
1 3
2 1
1 2
1 1
1 2
3 1
2 1
1 1
1 2
3 1
2 1
1 1*/