#include <bits/stdc++.h>

int n, m, k;

const int MAXN = 32;
bool field[MAXN][MAXN];

std::pair<int, int> convert(int x, int y) {
    int x1 = n - y, y1 = x - 1;
    return std::make_pair(x1, y1);
}

void makeMove(int x, int y) {
    std::tie(x, y) = convert(x, y);
    for (int i = x; i >= 0; i--) for (int j = y; j < n; j++) field[i][j] = true;
}

std::pair<int, int> findMove(int parity=-1) {
    for(int i = n; i > 0; i--) {
        for(int j = n; j > 0; j--) {
            if(i == 1 && j == 1) break;

            auto [x, y] = convert(i, j);
            if(field[x][y]) continue;

            if(parity == -1 || (x + y) % 2 == parity) return std::make_pair(i, j);
        }
    }

    return std::make_pair(1, 1);
}

void printField() {
    for(int i = 0; i < n; i++) {
        for(int j = 0; j < n; j++) {
            std::cout << field[i][j] << ' ';
        }
        std::cout << '\n';
    }
}

void solve1() {
    std::string s;
    std::cin >> s;

    int ind = 0;

    bool botFirst = false;
    while (ind < s.size()) {
        // play game here
        memset(field, 0, sizeof field);
        if(botFirst) {
            int x, y;
            std::cin >> x >> y;
            makeMove(x, y);
        }

        while(true) {
            std::pair<int, int> nowMove;
            if(ind < s.size()) nowMove = findMove(s[ind++] - '0');
            else nowMove = findMove(-1);

            std::cout << nowMove.first << ' ' << nowMove.second << std::endl;
            makeMove(nowMove.first, nowMove.second);
            if(nowMove == std::make_pair(1, 1)) break;
            int x, y;
            std::cin >> x >> y;
            makeMove(x, y);
//            printField();
            if(x == 1 && y == 1) break;
        }

        botFirst ^= 1;
    }

    if(botFirst) {
        int x, y;
        std::cin >> x >> y;
    }

    std::cout << 0 << std::endl;
}

void solve2() {
    int cnt;
    std::cin >> cnt;

    std::string s;
    int x, y;
    for(bool bot = false; std::cin >> x >> y; bot ^= 1) {
        if(!(x == 1 && y == 1) && bot) s += (x + y) % 2 + '0';
    }

    std::cout << s << '\n';
}

int main() {
//    freopen("/tmp/game.in", "r", stdin);
//    freopen("/tmp/game.out", "w", stdout);
//    freopen("/tmp/log.txt", "r", stdin);

    int type;
    std::cin >> type;
    std::cin >> n >> m >> k;
    if (type == 1) solve1();
    else solve2();
}
