#pragma GCC optimize("unroll-loops,avx,avx2,no-stack-protector,Ofast")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4.1,sse4.2")

#include <bits/stdc++.h>

int n, m, k;

const int MAXN = 32;
bool field[MAXN][MAXN];
int willPaint[MAXN][MAXN];

std::pair<int, int> convert(int x, int y) {
    int x1 = n - y, y1 = x - 1;
    return std::make_pair(x1, y1);
}

void makeMove(int x, int y) {
    std::tie(x, y) = convert(x, y);
    for (int i = x; i >= 0; i--) {
        if (field[i][y]) break;
        for (int j = y; j < n; j++) {
            if (field[i][j]) break;
            field[i][j] = true;
        }
    }
}

int getPaint(int x1, int y1, int x2, int y2) {
    int res = willPaint[x2][y2];
    if(x1) res -= willPaint[x1 - 1][y2];
    if(y1) res -= willPaint[x2][y1 - 1];
    if(x1 && y1) res += willPaint[x1 - 1][y1 - 1];
    return res;
}

std::pair<int, int> findMove(int parity = -1) {
    if (parity == -1) {
        // just win
        bool first = field[convert(1, 2).first][convert(1, 2).second];
        bool second = field[convert(2, 1).first][convert(2, 1).second];
        if (first && second) {
            return std::make_pair(1, 1);
        } else if (!second) {
            return std::make_pair(2, 1);
        } else return std::make_pair(1, 2);
    }

    memset(willPaint, 0, sizeof(willPaint));

    willPaint[0][0] = field[0][0];
    for (int i = 1; i < MAXN; i++) {
        willPaint[i][0] += willPaint[i - 1][0] + !field[i][0];
        willPaint[0][i] += willPaint[0][i - 1] + !field[0][i];
    }
    for (int i = 1; i < MAXN; i++) {
        for (int j = 1; j < MAXN; j++) {
            willPaint[i][j] = !field[i][j] + willPaint[i - 1][j] + willPaint[i][j - 1] - willPaint[i - 1][j - 1];
        }
    }

    std::pair<std::pair<int, int>, int> best;
    best.second = 0x3f3f3f3f;
    for (int i = n; i > 0; i--) {
        int lx, ly, rx, ry;
        lx = 0, ly = convert(i, 0).first;
        rx = convert(i, 0).second, ry = n - 1;
        if(getPaint(lx, ly, rx, ry) > best.second) break;

        for (int j = n; j > 0; j--) {
            if (i == 1 && j == 1) break;

            auto[x, y] = convert(i, j);
            if (field[x][y]) continue;

            lx = 0, ly = y;
            rx = x, ry = n - 1;
            int will = getPaint(lx, ly, rx, ry);
            if(will > best.second) break;
            if ((x + y) % 2 == parity && will < best.second) best = std::make_pair(std::make_pair(i, j), will);
        }
    }

    if (best.second == 0x3f3f3f3f) return std::make_pair(1, 1);
    else return best.first;
}

void printField() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            std::cout << field[i][j] << ' ';
        }
        std::cout << '\n';
    }
}

void solve1() {
    std::string s;
    std::cin >> s;

    int ind = 0;

    bool botFirst = false;
    while (ind < s.size()) {
        // play game here
        memset(field, 0, sizeof field);
        if (botFirst) {
            int x, y;
            std::cin >> x >> y;
            makeMove(x, y);
        }

        while (true) {
            std::pair<int, int> nowMove;
            if (ind < s.size()) nowMove = findMove(s[ind++] - '0');
            else nowMove = findMove(-1);

            std::cout << nowMove.first << ' ' << nowMove.second << std::endl;
            makeMove(nowMove.first, nowMove.second);
            if (nowMove == std::make_pair(1, 1)) break;
            int x, y;
            std::cin >> x >> y;
            makeMove(x, y);
            if (x == 1 && y == 1) break;
        }

        botFirst ^= 1;
    }

    if (botFirst) {
        int x, y;
        std::cin >> x >> y;
    }

    std::cout << 0 << std::endl;
    exit(0);
}

void solve2() {
    assert(0);
    int cnt;
    std::cin >> cnt;

    std::string s;
    int x, y;
    for (bool bot = false; std::cin >> x >> y; bot ^= 1) {
        if (!(x == 1 && y == 1) && bot) s += (x + y) % 2 + '0';
    }

    std::cout << s << '\n';
}

int main() {
//    freopen("/tmp/game.in", "r", stdin);
//    freopen("/tmp/game.out", "w", stdout);
//    freopen("/tmp/log.txt", "r", stdin);

    int type;
    std::cin >> type;
    std::cin >> n >> m >> k;
    if (type == 1) solve1();
    else solve2();
}
