#include <iostream>
#include <string>
#include <unordered_set>
#include <vector>

using namespace std;

void read_card(vector<unordered_set<int>> &ones, vector<pair<unordered_set<int>,
        unordered_set<int>>> &groups,
               const string &s, int idx) {
    int k;
    cin >> k;

    for (int i = 0; i < k; ++i) {
        int a;
        char c;

        cin >> a >> c;

        --a;

        if (s[a] == c) {
            ones[idx].insert(a);
            groups[a].first.insert(idx);
        }
        else {
            groups[a].second.insert(idx);
        }
    }
}

int main() {
    int n, m;
    cin >> n >> m;

    string s;
    cin >> s;

    vector<unordered_set<int>> ones(n);
    vector<pair<unordered_set<int>, unordered_set<int>>> groups(m);

    for (int i = 0; i < n; ++i) {
        read_card(ones, groups, s, i);
    }

    unordered_set<int> probable_indices;
    unordered_set<int> unused_indices;
    for (int i = 0; i < n; ++i) {
        probable_indices.insert(i);
        unused_indices.insert(i);
    }
    for (auto &g : groups) {
        for (int idx : g.second) probable_indices.erase(idx);
    }

    unordered_set<int> uncleared_cells;
    for (int i = 0; i < m; ++i) uncleared_cells.insert(i);
    vector<int> indices;

    while (!probable_indices.empty()) {
        for (auto idx : probable_indices) {
            indices.push_back(idx);
            unused_indices.erase(idx);

            vector<int> to_erase;
            for (int i : ones[idx]) uncleared_cells.erase(i);
        }

        probable_indices.clear();

        for (int i : unused_indices) {
            probable_indices.insert(i);
        }
        for (int i : uncleared_cells) {
            auto &g = groups[i];
            for (int idx : g.second) probable_indices.erase(idx);
        }
    }

    if (uncleared_cells.empty()) {
        for (int i : indices) {
            cout << i + 1 << " ";
        }
        cout << endl;
    } else cout << -1 << endl;
}
