#include <bits/extc++.h>

using namespace std;

typedef long long ll;
typedef double dl;
typedef vector<int> vi;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define sz(a) (int((a).size()))
#define forn(i, n) for (int i = 0; i < (n); i++)

#ifndef SEVA
#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#endif
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,avx,avx2,mmx,abm,fma,popcnt,tune=native")

mt19937 rnd(3456);

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
}

const int N = 500 + 10;

vector<int> g[N];
vector<int> vars[N];

bool dp[N][N][N];

void DFS(int v, int n) {
    if (g[v].empty()) {
        // consultant
        for (auto& i : vars[v])
            dp[v][i][i] = true;
    }
    else {
        for (auto& to : g[v]) {
            DFS(to, n);
        }
        vi p(sz(g[v]));
        iota(all(p), 0);
        do {
            for (int s = 0; s < n; s++) {
                int r = s - 1;
                bool ans = true;

                for (auto& id : p) {
                    int kid = g[v][id];
                    int l = r + 1;
                    bool found = false;
                    for (int r1 = l; r1 < n && !found; r1++) {
                        if (dp[kid][l][r1]) {
                            found = true;
                            r = r1;
                        }
                    }
                    ans &= found;
                }
                if (ans) {
                    dp[v][s][r] = true;
                }
                else {
                    break;
                }
            }
        } while (next_permutation(all(p)));
    }
    for (int l = 0; l < n; l++) {
        for (int r = 0; r < n; r++) {
            if (!dp[v][l][r])
                continue;
            bool b = false;
            for (int l1 = l; l1 >= 0 && !b; l1--) {
                for (int r1 = r; r1 < n && !b; r1++) {
                    if (l1 == l && r1 == r)
                        continue;
                    if (dp[v][l1][r1]) {
                        b = true;
                    }
                    dp[v][l1][r1] = dp[v][l][r];
                }
            }
        }
    }
}

void Solve() {
    int n;
    cin >> n;
    vi values;
    for (int i = 1; i <= n; i++) {
        int type;
        cin >> type;
        if (type == 1) {
            int k;
            cin >> k;
            forn(j, k) {
                int kid;
                cin >> kid;
                g[i].emplace_back(kid);
            }
        }
        else {
            int m;
            cin >> m;
            forn(j, m) {
                int v;
                cin >> v;
                vars[i].emplace_back(v);
                values.emplace_back(v);
            }
        }
    }
    sort(all(values));
    values.resize(unique(all(values)) - values.begin());
    for (int i = 1; i <= n; i++) {
        for (auto& v : vars[i])
            v = int(lower_bound(all(values), v) - values.begin());
    }
    DFS(1, n);
    if (dp[1][0][n - 1]) {
        cout << "Yes" << nl;
    }
    else {
        cout << "No" << nl;
    }
}

signed main() {
    IO();
    Solve();
    return 0;
}