#include <iostream>
#include <bitset>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

void print(bitset<100000> & a, int m)
{
	for (int i = 0; i < m; i++)
		cout << a[i];
	cout << endl;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0); cout.tie(0);

	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	bitset<100000> set_bs;
	for (int i = 0; i < m; i++)
		set_bs[i] = 1;
	vector<pair<int, pair<bitset<100000>, bitset<100000>>>> cards(n);
	vector<bool> used(n, false);
	vector<set<int>> st(m);
	set<int> very_good;
	for (int i = 0; i < n; i++)
	{
		cards[i].first = i;
		cards[i].second.second |= set_bs;
		cards[i].second.first.reset();
		int k;
		cin >> k;
		for (int j = 0; j < k; j++)
		{
			int a;
			char c;
			cin >> a >> c;
			cards[i].second.second[a - 1] = 0;
			if (s[a - 1] != c)
			{
				cards[i].second.first[a - 1] = 1;
				st[a - 1].insert(i);
			}
		}
		if (cards[i].second.first.none())
			very_good.insert(i);
	}

	vector<int> ans;
	bool f = true;
	bitset<100000> t;
	t |= set_bs;

	for (auto& x : very_good)
	{
		used[x] = true;
		ans.push_back(x);
		t &= cards[x].second.second;
	}

	for (int k = 0; k < m; k++)
	{
		if (t[k]) continue;
		for (auto& x : st[k])
		{
			if (used[x]) continue;
			if ((t & cards[x].second.first).none())
			{
				ans.push_back(x);
				used[x] = true;
				t &= cards[x].second.second;
				break;
			}
		}
	}
	
	for (int i = 0; i < n; i++)
	{
		if (used[i]) continue;
		if ((t & cards[i].second.first).none())
		{
			ans.push_back(i);
			used[i] = true;
			t &= cards[i].second.second;
		}
	}

	if (ans.size() != n || t.any())
	{
		cout << "-1";
		return 0;
	}

	for (auto& x : ans)
		cout << x + 1 << " ";
}