#include <bits/stdc++.h>
using namespace std;

const int INF = 1e5 + 10;

int n;

vector<vector<int>> child;
vector<vector<int>> jobs;
vector<vector<int>> maxbymin;
vector<int> order;

void dfs(int v) {
	for ( int to : child[v] ) {
		dfs(to);
	}

	if ( !child[v].empty() ) order.push_back(v);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n;

	child = vector<vector<int>>(n, vector<int>(0));
	jobs = vector<vector<int>>(n, vector<int>(0));

	int _t, _k; int _x;
	vector<int> arr = {};
	for ( int i = 0; i < n; ++i ) {
		cin >> _t >> _k;

		for ( int j = 0; j < _k; ++j ) {
			if ( _t == 1 ) {
				cin >> _x;
				_x--;
				child[i].push_back(_x);
			} else {
				cin >> _x;
				jobs[i].push_back(_x);
				arr.push_back(_x);
			}
		}
	}

	sort(arr.begin(), arr.end());
	// arr.erase(unique(arr.begin(), arr.end()), arr.end());

	maxbymin = vector<vector<int>>(n, vector<int>(arr.size(), INF));

	for ( int i = 0; i < n; ++i ) {
		if ( child[i].size() > 0 ) continue;
		for ( int j = 0; j < jobs[i].size(); ++j )
			jobs[i][j] = lower_bound(arr.begin(), arr.end(), jobs[i][j]) - arr.begin();
		sort(jobs[i].begin(), jobs[i].end());

		for ( int j = 0; j < jobs[i].size(); ++j ) {
			for ( int x = (j == 0 ? 0 : jobs[i][j - 1] + 1); x <= jobs[i][j]; ++x ) {
				maxbymin[i][x] = jobs[i][j];
			}
		}
	}

	order = {};
	dfs(0);
	vector<int>  perm;
	for ( int _v = 0; _v < order.size(); ++_v ) {
		int v = order[_v];

		perm = vector<int>(child[v].size());
		for ( int i = 0; i < perm.size(); ++i ) perm[i] = i;

		do {
			int cur;
			for ( int x = 0; x < arr.size(); ++x ) {
				cur = x;

				for ( int j = 0; j < perm.size(); ++j ) {
					if ( cur == INF ) break;

					cur = maxbymin[child[v][perm[j]]][cur];
				}

				maxbymin[v][x] = min(maxbymin[v][x], cur);
			}
		} while ( next_permutation(perm.begin(), perm.end()) );
	}

	bool flag = false;
	for ( int x = 0; x < arr.size(); ++x ) {
		if ( maxbymin[0][x] != INF ) flag = true;
	}

	if ( flag ) {
		cout << "Yes" << endl;
	} else {
		cout << "No" << endl;
	}
	return 0;
}