#include <iostream>

#include <algorithm>

#include <vector>
#include <string>

using namespace std;

typedef long long ll;

vector<int> group;
int pos;

bool comp(pair<int, vector<int>> a, pair<int, vector<int>> b) {
	if (group[a.first] != group[b.first])
		return group[a.first] < group[b.first];
	return a.second[pos] < b.second[pos];
}

int main() {
	int n, m; cin >> n >> m;

	if (n > 100) {
		string s; cin >> s;
		vector<pair<int, vector<int>>> a(n, { 0, vector<int>(m, 0) });
		vector<vector<int>> b(n, vector<int>(m, 0));

		for (int i = 0; i < n; i++) {
			a[i].first = i;
			int k; cin >> k;
			for (int j = 0; j < k; j++) {
				int pos; cin >> pos;
				pos--;
				char c; cin >> c;
				b[i][pos] = c;
				if (c != s[pos])
					a[i].second[pos] = 1;
			}
		}

		for (int q = 0; q < 10; q++) {
			group.resize(n);
			for (int i = 0; i < n; i++) {
				group[i] = 0;
			}

			for (pos = 0; pos < m; pos++) {
				sort(a.begin(), a.end(), comp);
				vector<int> new_group(n);
				int cur = 0;
				new_group[a[0].first] = cur;
				for (int i = 1; i < n; i++) {
					if (group[a[i - 1].first] < group[a[i].first] || (group[a[i - 1].first] == group[a[i].first] && a[i - 1].second[pos] < a[i].second[pos]))
						cur++;
					new_group[a[i].first] = cur;
				}

				group = new_group;
			}
		}

		bool flag = true;
		vector<bool> used(m);
		for (int j = 0; j < n; j++) {
			int pos = a[j].first;
			for (int i = 0; i < m; i++) {
				if (b[pos][i] == 0)
					continue;
				if (b[pos][i] == s[i])
					used[i] = true;
				if (b[pos][i] != s[i] && !used[i]) {
					flag = false;
				}
			}
		}


		for (auto c : used) {
			if (!c) {
				flag = false;
			}
		}

		if (flag) {
			for (auto c : a) {
				cout << c.first + 1 << ' ';
			}
		}
		else {
			cout << -1;
		}
	}
	else {
		string s; cin >> s;
		vector<pair<int, vector<int>>> a(n, { 0, vector<int>(m, 0) });
		vector<vector<int>> b(n, vector<int>(m, 0));

		for (int i = 0; i < n; i++) {
			a[i].first = i;
			int k; cin >> k;
			for (int j = 0; j < k; j++) {
				int pos; cin >> pos;
				pos--;
				char c; cin >> c;
				b[i][pos] = c;
				if (c != s[pos])
					a[i].second[pos] = 2;
				else
					a[i].second[pos] = 1;
			}
		}

		for (int q = 0; q < 1000; q++) {
			for (int pos = 0; pos < m; pos++) {
				for (int i = 0; i < n - 1; i++) {
					if (a[i].second[pos] == 1)
						break;
					if (a[i].second[pos] == 2) {
						int good = i;
						vector<int> tmp;
						for (int j = n - 1; j >= i + 1; j--) {
							if (a[j].second[pos] == 1) {
								tmp.push_back(j);
							}
						}

						if (tmp.size() > 0) {
							int tmp_i = rand() % tmp.size();
							good = tmp[tmp_i];
						}

						for (int k = good; k > i; k--) {
							swap(a[k], a[k - 1]);
						}
					}
				}
			}

			bool flag = true;
			vector<bool> used(m);
			for (int j = 0; j < n; j++) {
				int pos = a[j].first;
				for (int i = 0; i < m; i++) {
					if (b[pos][i] == 0)
						continue;
					if (b[pos][i] == s[i])
						used[i] = true;
					if (b[pos][i] != s[i] && !used[i]) {
						flag = false;
					}
				}
			}


			for (auto c : used) {
				if (!c) {
					flag = false;
				}
			}

			if (flag) {
				for (auto c : a) {
					cout << c.first + 1 << ' ';
				}
				return 0;
			}
		}

		cout << -1;
	}
	return 0;
}