#include <bits/stdc++.h>

using namespace std;

string to_bin(int x) {
    string ans;
    while (x != 0) {
        ans += '0' + x % 2;
        x /= 2;
    }

    reverse(ans.begin(), ans.end());
    return ans;
}

int from_bin(string s) {
    int ans = 0;

    for (int i = 0; i < s.size(); i++) {
        ans = ans * 2 + s[i] - '0';
    }

    return ans;
}

const int MAXN = 32;
int n, k, m;
int table[MAXN][MAXN];

int bot_step() {
    int r, c;
    cin >> r >> c;
    r--;
    c--;

    for (int i = r; i < n; i++) {
        for (int j = c; j < n; j++) {
            table[i][j] = 1;
        }
    }

    return r == 0 && c == 0;
}

void my_step(int r, int c) {
    cout << (r + 1) << " " << (c + 1) << endl;
    for (int i = r; i < n; i++) {
        for (int j = c; j < n; j++) {
            table[i][j] = 1;
        }
    }
}

void play() {
    cin >> n >> k >> m;
    string s;
    cin >> s;

    int ind = 0, game_ind = 0, game_fin = -1;
    for (int game_ind = 0; true; game_ind++) {
        for (int step = 0; true; step++) {
            if (game_ind % 2 == 1) {
                if (bot_step()) {
                    break;
                }
            }

            if (step == 0) {
                if (ind == m) {
                    cout << 0 << "\n";
                    exit(0);
                }

                for (int i = min(m - ind, 4); i >= 0; i--) {
                    for (int j = min(m - ind - i, 4); j >= 0; j--) {
                        int r = from_bin(s.substr(ind, i)), c = from_bin(s.substr(ind + i, j));

                        if (to_bin(r).size() != i && to_bin(c).size() != i) {
                            continue;
                        }

                        cerr << r << " " << c << " 1!" << to_bin(r) << " 2!" << to_bin(c) << "\n";

                        r += 1;
                        c += 1;

                        my_step(r, c);
                        ind += i + j;
                        goto next;
                    }
                }

                next:;
            } else {
                if (table[1][0] == 0) {
                    my_step(1, 0);
                } else {
                    my_step(0, 1);
                }
            }

            if (game_ind % 2 == 0) {
                if (bot_step()) {
                    break;
                }
            }
        }
    }

    cout << 0 << endl;
    exit(0);
}

void answer() {
    cin >> n >> k >> m;
    int games = 1;
    cin >> games;

    string ans;
    int ind_game = 0;
    for (int game_ind = 0; game_ind < games; game_ind++) {
        for (int step = 0; true; step++) {
            if (game_ind % 2 == 1) {
                if (bot_step()) {
                    break;
                }
            }

            if (step == 0) {
                int r, c;
                cin >> r >> c;

                r--;
                c--;
                r--;
                c--;

                ans += to_bin(r) + to_bin(c);
            } else {
                int r, c;
                cin >> r >> c;
            }

            if (game_ind % 2 == 0) {
                if (bot_step()) {
                    break;
                }
            }
        }
    }

    cout << ans;
}

int32_t main() {
    int start = 1;
    cin >> start;

    if (start == 1) {
        play();
    } else {
        answer();
    }

    return 0;
}
