#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<pii> vii;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)1e9 + 10;
const int MOD = (int)1e9 + 7;

void dfs(int v, vvi& a, vvi& s, vvi& r) {
	if (a[v].empty()) {
		int cur = 0;
		for (int i = 1; i < N; ++i) {
			while (cur < s[v].size() && s[v][cur] < i)
				++cur;
			if (cur < s[v].size())
				r[v][i] = s[v][cur];
		}
		return;
	}
	for (int u : a[v])
		dfs(u, a, s, r);
	for (int l = 1; l < N; ++l) {
		sort(a[v].begin(), a[v].end());
		do {
			int l1 = l;
			bool flag = 1;
			for (int u : a[v]) {
				l1 = r[u][l1];
				if (l1 == -1) {
					flag = 0;
					break;
				}
			}
			if (flag && (r[v][l] == -1 || r[v][l] > l1))
				r[v][l] = l1;
		} while (next_permutation(a[v].begin(), a[v].end()));
	}
	return;
}

void dfs1(int v, vvi& a, vvi& s, vvi& r, vi& c, int l) {
	if (a[v].empty()) {
		c[v] = r[v][l];
		return;
	}
	sort(a[v].begin(), a[v].end());
	do {
		int l1 = l;
		bool flag = 1;
		for (int u : a[v]) {
			l1 = r[u][l1];
			if (l1 == -1) {
				flag = 0;
				break;
			}
		}
		if (flag && r[v][l] == l1)
			break;
	} while (next_permutation(a[v].begin(), a[v].end()));
	int l1 = l;
	for (int u : a[v]) {
		dfs1(u, a, s, r, c, l1);
		l1 = r[u][l1];
	}
	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int n;
	cin >> n;
	vvi r(n, vi(N, -1));
	vvi a(n);
	vvi s(n);
	for (int i = 0; i < n; ++i) {
		int t;
		cin >> t;
		if (t == 1) {
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j) {
				int x;
				cin >> x;
				--x;
				a[i].pb(x);
			}
		}
		else {
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j) {
				int x;
				cin >> x;
				s[i].pb(x);
			}
			sort(s[i].begin(), s[i].end());
		}
	}
	dfs(0, a, s, r);
	if (r[0][1] == -1) {
		cout << "No";
		return 0;
	}
	vi c(n);
	dfs1(0, a, s, r, c, 1);
	cout << "Yes\n";
	for (int i = 0; i < n; ++i) {
		if (!a[i].empty()) {
			for (int x : a[i])
				cout << x + 1 << ' ';
			cout << endl;
		}
		else {
			cout << c[i] << endl;
		}
	}

	return 0;
}