#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("O3,no-stack-protector,delete-null-pointer-checks")
//#pragma GCC target("avx,sse,sse4.1,sse4.2,mmx,abm,popcnt")

vector<vector<int>> graph;
vector<char>  used;

struct dp_val {
	int min;
	int max;
};

vector<dp_val> dp;

const int INF = 1000000007;

void init(dp_val *val) {
	val->min = INF;
	val->max = 0;
}

void update(dp_val *val, int x) {
	val->min = min(val->min, x);
	val->max = max(val->max, x);
}

bool intersect_segs(int l1, int r1, int l2, int r2) {
	return min(r1, r2) >= min(l1, l2);
}

bool DFS(int v) {
	used[v] = 1;
	vector<int> to_check;
	for (int u : graph[v]) {
		if (used[u]) {
			continue;
		}
		if (!DFS(u)) {
			return false;
		}
		to_check.push_back(u);
		update(&dp[v], dp[u].min);
		update(&dp[v], dp[u].max);
	}
	if (to_check.size() < 2) {
		return true;
	}
	dp_val a = dp[to_check[0]];
	dp_val b = dp[to_check.back()];
	if (intersect_segs(a.min, a.max, b.min, b.max)) {
		return false;
	}
	return true;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	chrono::high_resolution_clock::time_point start = chrono::high_resolution_clock::now();
	chrono::high_resolution_clock::time_point finish;
	int n;
	cin >> n;
	graph.resize(n);
	dp.resize(n);
	used.resize(n);
	vector<vector<int>> ords(n);
	for (int i = 0; i < n; ++i) {
		init(&dp[i]);
		int type;
		int k;
		cin >> type;
		cin >> k;
		if (type == 1) {
			graph[i].reserve(k);
			for (int j = 0; j < k; ++j) {
				int child;
				cin >> child;
				--child;
				graph[i].push_back(child);
				graph[child].push_back(i);
			}
		} else {
			ords[i].reserve(k);
			for (int j = 0; j < k; ++j) {
				int val;
				cin >> val;
				ords[i].push_back(val);
			}
		}
	}
	bool res = false;
	random_device r;
	mt19937 rnd(r());
	while (true) {
		for (int i = 0; i < n; ++i) {
			init(&dp[i]);
			used[i] = 0;
			random_shuffle(graph[i].begin(), graph[i].end());
			if (!ords[i].empty()) {
				update(&dp[i], ords[i][rnd() % ords.size()]);
			}
		}
		res |= DFS(0);
		finish = chrono::high_resolution_clock::now();
		chrono::duration<double> diff = finish - start;
		if (diff.count() > 0.995) {
			break;
		}
	}
	cout << (res ? "Yes" : "No") << '\n';
}
