#include <bits/stdc++.h>

using namespace std;

//#pragma GCC optimize("O3,no-stack-protector,delete-null-pointer-checks")
//#pragma GCC target("avx,sse,sse4.1,sse4.2,mmx,abm,popcnt")

vector<vector<int>> graph;
vector<char>  used;

struct dp_val {
	int min;
	int max;
};

vector<dp_val> dp;

const int INF = 1000000000;

void init(dp_val *val) {
	val->min = INF;
	val->max = 0;
}

void update(dp_val *val, int x) {
	val->min = min(val->min, x);
	val->max = max(val->max, x);
}

bool intersect_segs(int l1, int r1, int l2, int r2) {
	return min(l1, l2) > max(r1, r2);
}

bool DFS(int v) {
	used[v] = 1;
	vector<int> to_check;
	for (int u : graph[v]) {
		if (used[u]) {
			continue;
		}
		if (!DFS(u)) {
			return false;
		}
		to_check.push_back(u);
		update(&dp[v], dp[u].min);
		update(&dp[v], dp[u].max);
	}
	if (to_check.size() < 2) {
		return true;
	}
	if (intersect_segs(dp[to_check[0]].min, dp[to_check[0]].max, dp[to_check[1]].min, dp[to_check[1]].max)) {
		return false;
	}
	return true;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	int n;
	cin >> n;
	graph.resize(n);
	dp.resize(n);
	used.resize(n);
	for (int i = 0; i < n; ++i) {
		init(&dp[i]);
		int type;
		int k;
		cin >> type;
		cin >> k;
		if (type == 1) {
			graph[i].reserve(k);
			for (int j = 0; j < k; ++j) {
				int child;
				cin >> child;
				--child;
				graph[i].push_back(child);
				graph[child].push_back(i);
			}
		} else {
			for (int j = 0; j < k; ++j) {
				int val;
				cin >> val;
				update(&dp[i], val);
			}
		}
	}
	cout << (DFS(0) ? "Yes" : "No") << '\n';
}
