#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <string>
#include <vector>

using namespace std;

#define endl '\n'

const int Base = 1e5 + 55;

int n, m;
string s;
vector<int> good[Base];
int badCnt[Base];
vector<int> cards[Base];
bool haveSym[Base];
int cntSym = 0;
vector<int> zeros;

int getZeroId()
{
	if (zeros.empty())
	{
		return -1;
	}

	int res = zeros.back();
	zeros.pop_back();
	return res;
}

void addCard(int id)
{
	for (auto x : good[id])
	{
		while (!cards[x].empty())
		{
			badCnt[cards[x].back()]--;
			if (badCnt[cards[x].back()] == 0)
			{
				zeros.push_back(cards[x].back());
			}
			cards[x].pop_back();
		}
	}
}

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif // _DEBUG

	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m;

	cin >> s;

	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		for (int j = 0; j < k; j++)
		{
			int pos;
			char key;
			cin >> pos >> key;
			pos--;
			if (!haveSym[pos])
			{
				haveSym[pos] = true;
				cntSym++;
			}
			if (s[pos] != key)
			{
				badCnt[i]++;
				cards[pos].push_back(i);
			}
			else
			{
				good[i].push_back(pos);
			}
		}
		if (badCnt[i] == 0)
		{
			zeros.push_back(i);
		}
	}

	if (cntSym < m)
	{
		cout << -1 << endl;
		return 0;
	}

	vector<int> ans;
	for (int i = 0; i < n; i++)
	{
		int id = getZeroId();
		if (id == -1)
		{
			cout << -1 << endl;
			return 0;
		}
		ans.push_back(id + 1);
		addCard(id);
	}

	for (auto x : ans)
	{
		cout << x << ' ';
	}
	cout << endl;
}