#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <fstream>
#include <algorithm>
#include <vector>
#include <string>
#include <queue>
#include <stack>
#include <bitset>
#include <cassert>
#include <map>

using namespace std;

typedef long long ll;

#ifndef _DEBUG
const int N = 500010;
#else
const int N = 100;
#endif
const int LOGN = 20;
const int ALP = 28;

vector < int > g[N], cg[N];

vector < int > dp[N];

vector < int > pl[N];

int ul[N];

void dfs(int v, int p) {
	if (g[v].size() == 0) {
		dp[v].push_back(ul[v]);
		return;
	}
	for (int to : g[v]) {
		if (to == p)
			continue;
		dfs(to, v);
	}
	for (int to : g[v]) {
		if (to == p)
			continue;
		for (int i = 0; i < dp[to].size(); ++i)
			dp[v].push_back(dp[to][i]);
	}
}

int n;

bool done = false;

void get_ord(int v) {
	if (done)
		return;
	if (v == n + 1) {
		for (int i = 1; i <= n; ++i)
			dp[i].clear();
		dfs(1, 1);
		for (int i = 1; i < dp[1].size(); ++i) {
			if (dp[1][i - 1] >= dp[1][i])
				return;
		}
		done = true;
		cout << "Yes\n";
		for (int i = 1; i <= n; ++i) {
			if (g[i].size() > 0) {
				for (int j : g[i])
					cout << j << ' ';
			}
			else {
				cout << ul[i];
			}
			cout << '\n';
		}
		return;
	}
	if (cg[v].size() == 0) {
		for (int i = 0; i < pl[v].size(); ++i) {
			ul[v] = pl[v][i];
			get_ord(v + 1);
		}
		return;
	}
	g[v].clear();
	g[v].resize(cg[v].size());
	vector < int > p(g[v].size());
	for (int i = 0; i < p.size(); ++i)
		p[i] = i;
	do {
		for (int i = 0; i < g[v].size(); ++i)
			g[v][i] = cg[v][p[i]];
		get_ord(v + 1);
	} while (next_permutation(p.begin(), p.end()));
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
#ifdef _DEBUG
	freopen("Test.txt", "r", stdin);
#endif

	

	cin >> n;

	for (int i = 1; i <= n; ++i) {
		int type;
		cin >> type;
		if (type == 1) {
			int k;
			cin >> k;
			for (int j = 0; j < k; ++j) {
				int x;
				cin >> x;
				cg[i].push_back(x);
			}
		}
		else {
			int m;
			cin >> m;
			for (int j = 0; j < m; ++j) {
				int x;
				cin >> x;
				pl[i].push_back(x);
			}
		}
	}

	get_ord(1);

	if (!done)
		cout << "No";
	
}