#include <iostream>
#include <vector>
#include <algorithm>
#include <queue>

using namespace std;

struct letter {
	int pos;
	char ch;
	int idx;
};

int main() {
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector<pair<vector<letter>, int>> cards(n);
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		cards[i].second = i;
		cards[i].first = vector<letter>(k);
		for (auto& elem : cards[i].first) {
			cin >> elem.pos >> elem.ch;
			elem.pos--;
			elem.idx = i;
		}
	}
	sort(cards.begin(), cards.end(), [](pair<vector<letter>, int>& a, pair<vector<letter>, int>& b) {
		if (a.first.size() == b.first.size()) return a.second < b.second;
		return a.first.size() < b.first.size();
		});
	queue<int> answ;
	vector<bool> matter(m, true);
	while (true) {
		bool has_ok = false;
		for (int i = 0; i < cards.size(); i++) {
			bool ok_now = true;
			for (auto& elem : cards[i].first) {
				if (matter[elem.pos] && s[elem.pos] != elem.ch) {
					ok_now = false;
					break;
				}
			}
			if (ok_now) {
				has_ok = true;
				answ.push(cards[i].second);
				for (auto& elem : cards[i].first) {
					matter[elem.pos] = false;
				}
				cards.erase(cards.begin() + i);
				i--;
			}
		}
		if (!has_ok) break;
	}
	bool has_answ = true;
	for (int i = 0; i < m; i++) if (matter[i]) has_answ = false;
	if (!has_answ) {
		cout << -1 << endl;
	}
	else {
		while (!answ.empty()) {
			cout << answ.front() + 1 << " ";
			answ.pop();
		}
	}

}