#include <iostream>
#include <vector>
#include <set>

using namespace std;

const int INF = 1e9 + 7;

inline void changeKey(set<pair<int, int>> &badSet, vector<int> &badCnt, int ind, int val) {
    if (badCnt[ind] == INF) {
        return;
    }
    badSet.erase({badCnt[ind], ind});
    badCnt[ind] += val;
    badSet.insert({badCnt[ind], ind});
}


int main() {
    int n, m; cin >> n >> m;
    string pattern; cin >> pattern;
    vector<vector<int>> cards(n);
    vector<vector<int>> badCards(m);
    vector<int> badCnt(n);
    set<pair<int, int>> badSet;
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        for (int j = 0; j < k; j++) {
            int ind; cin >> ind;
            char c; cin >> c;
            if (pattern[ind - 1] == c) {
                cards[i].push_back(ind - 1);
            } else {
                badCards[ind - 1].push_back(i);
                badCnt[i]++;
            }
        }
    }

    // Init set
    for (int i = 0; i < n; i++) {
        badSet.insert({badCnt[i], i});
    }
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        auto x = *badSet.begin();
        int val = x.first, ind = x.second;
        if (val != 0) {
            cout << -1 << endl;
            return 0;
        }
        ans.push_back(ind);
        badSet.erase(x);
        badCnt[ind] = INF;
        for (int j : cards[ind]) {
            for (int card : badCards[j]) {
                changeKey(badSet, badCnt, card, -1);
            }
            badCards[j].clear();
        }
    }
    for (int i : ans) {
        cout << i + 1 << ' ';
    }
    cout << endl;
}
