#include <bits/stdc++.h>

template<class T>
std::istream& operator>>(std::istream &in, std::vector<T> &a) {
    for (auto &x : a)
        in >> x;
    return in;
}
template<class T>
std::ostream& operator<<(std::ostream &out, const std::vector<T> &a) {
    for (auto &x : a)
        out << x << " ";
    return out;
}
template<class T, class U>
std::istream& operator>>(std::istream &in, std::pair<T, U> &a) {
    in >> a.first >> a.second;
    return in;
}
template<class T, class U>
std::ostream& operator<<(std::ostream &out, const std::pair<T, U> &a) {
    out << a.first << " " << a.second;
    return out;
}

struct node {
    int32_t val, vl, vr;
    node *left = nullptr, *right = nullptr;
    node() {}
    node(int32_t tl, int32_t tr, const std::vector<int32_t> &a) {
        val = a[tl];
        vl = tl, vr = tr;
        if (vr - vl > 1) {
            left = new node(vl, (vl + vr) >> 1, a);
            right = new node((vl + vr) >> 1, vr, a);
            val = std::max(left->val, right->val);
        }
    }
    int32_t get(int32_t ql, int32_t qr) {
        if (vl == ql && vr == qr)
            return val;
        int32_t vm = (vl + vr) >> 1;
        if (qr <= vm)
            return left->get(ql, qr);
        if (ql >= vm)
            return right->get(ql, qr);
        return std::max(left->get(ql, vm), right->get(vm, qr));
    }
    void change(int32_t pos, int32_t x) {
        if (vr - vl == 1) {
            val = x;
            return;
        }
        int32_t vm = (vl + vr) >> 1;
        if (pos < vm)
            left->change(pos, x);
        else
            right->change(pos, x);
        val = std::max(left->val, right->val);
    }
};

signed main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0), std::cout.tie(0);
    int32_t k, n;
    std::cin >> k >> n;
    std::vector<std::vector<char>> chared_del(k, std::vector<char>(k));
    std::cin >> chared_del;
    std::vector<std::vector<bool>> del(k, std::vector<bool>(k));
    for (int32_t left = 0; left < k; ++left) {
        for (int32_t right = 0; right < k; ++right) {
            del[left][right] = chared_del[left][right] - '0';
        }
    }
    std::string s;
    std::cin >> s;
    std::vector<int32_t> a(s.size());
    for (int32_t ind = 0; ind < n; ++ind)
        a[ind] = s[ind] - 'a';
    std::vector<int32_t> far(n);
    node *far_tree = new node(0, n, std::vector<int32_t>(n));
    std::set<std::pair<int32_t, int32_t>> st;
    st.emplace(n, k);
    std::vector<int32_t> last_pos(k + 1, n);
    for (int32_t ind = n - 1; ind >= 0; --ind) {
        for (int j = ind + 1; j <= n;) {
            if (j == n) {
                far[ind] = j;
                break;
            }
            if (!del[a[ind]][a[j]]) {
                far[ind] = std::max(far[ind], j);
                break;
            }
            j = far[j];
        }
    }
    a.emplace_back(-1);
    for (auto &x : a)
        x = -x;
    node *a_tree = new node(0, n + 1, a);
    for (auto &x : a)
        x = -x;
    std::vector<int> bst(n);
    for (int i = 0; i < n; ++i) {
        bst[i] = -a_tree->get(i + 1, far[i] + 1);
    }
    std::cerr <<"! " << bst << std::endl;
    std::cerr << far << std::endl;
    std::vector<std::vector<int>> nxts(n);
    for (int i = 0; i < n; ++i ) {
        for (int j = i + 1; j <= far[i]; ++j) {
            if (a[j] == bst[i])
                nxts[i].emplace_back(j);
        }
    }
    for (auto x : nxts)
        std::cerr << x << std::endl;
    std::vector<int> cur;
    cur.emplace_back(0);
    std::string ans = "";
    while (true) {
        std::cerr << "# " << cur << std::endl;
        if (a[cur[0]] == -1)
            break;
        ans.push_back('a' + a[cur[0]]);
        std::vector<int> perf_cur;
        int i = 0, j = 0;
        while (i < cur.size()) {
            perf_cur.emplace_back(cur[i]);
            while (j < cur.size() && far[cur[j]] <= far[cur[i]])
                ++j;
            i = j;
        }
        cur = {};
        for (auto t : perf_cur) {
            for (auto nxt : nxts[t])
                cur.emplace_back(nxt);
        }
    }
    std::cout << ans;

    return 0;
}
