#include <bits/stdc++.h>

template<class T>
std::istream& operator>>(std::istream &in, std::vector<T> &a) {
    for (auto &x : a)
        in >> x;
    return in;
}
template<class T>
std::ostream& operator<<(std::ostream &out, const std::vector<T> &a) {
    for (auto &x : a)
        out << x << " ";
    return out;
}
template<class T, class U>
std::istream& operator>>(std::istream &in, std::pair<T, U> &a) {
    in >> a.first >> a.second;
    return in;
}
template<class T, class U>
std::ostream& operator<<(std::ostream &out, const std::pair<T, U> &a) {
    out << a.first << " " << a.second;
    return out;
}

/*
 * Протокол:
 * Забьем на проигрыши выигрыши
 * будем выбирать минимальную клетку с соответствующими очередными
 */

int n = 32, k = 8, m = 1e5;
const int L = 3;
std::vector<std::vector<int32_t>> p(n, std::vector<int32_t>(n));
std::vector<int32_t> hm(n * n + 1);

int getpos(std::vector<std::vector<int32_t>> &a, std::pair<int32_t, int32_t> move) {
    for (int32_t i = n - 1; i >= 0; --i) {
        for (int32_t j = n - 1; j >= 0; --j) {
            p[i][j] = (i + 1 < n ? p[i + 1][j] : 0) + (j + 1 < n ? p[i][j + 1] : 0) -
                    (i + 1 < n && j + 1 < n ? p[i + 1][j + 1] : 0) + !a[i][j];
        }
    }
    std::fill(hm.begin(), hm.end(), 0);
    for (int32_t i = 0; i < n; ++i)
        for (int32_t j = 0; j < n; ++j)
            hm[p[i][j]]++;

    if (n * n - hm[0] + 3 < (1 << L))
        return -1;
    int32_t sum = 0;
    for (int i = 1; i < p[move.first][move.second]; ++i) {
        sum += hm[i];
    }
    std::cerr << p[move.first][move.second] << "!";
    for (int32_t i = 0; i < n; ++i) {
        for (int32_t j = 0; j < n; ++j) {
            if (i == move.first && j == move.second)
                return sum;
            sum += (p[move.first][move.second] == p[i][j]);
        }
    }
    assert(0);
    return -1;
}
std::pair<int32_t, int32_t> getmove(std::vector<std::vector<int32_t>> &a, int x) {
    for (int32_t i = n - 1; i >= 0; --i) {
        for (int32_t j = n - 1; j >= 0; --j) {
            p[i][j] = (i + 1 < n ? p[i + 1][j] : 0) + (j + 1 < n ? p[i][j + 1] : 0) -
                      (i + 1 < n && j + 1 < n ? p[i + 1][j + 1] : 0) + !a[i][j];
        }
    }
    std::fill(hm.begin(), hm.end(), 0);
    for (int32_t i = 0; i < n; ++i)
        for (int32_t j = 0; j < n; ++j)
            hm[p[i][j]]++;

    if (n * n - hm[0] + 3 < (1 << L))
        return {0, 0};
    int32_t sum = 0, it = 1;
    while (sum + hm[it] <= x)
        sum += hm[it], ++it;
    for (int32_t i = 0; i < n; ++i) {
        for (int32_t j = 0; j < n; ++j) {
            if (p[i][j] == it) {
                if (sum == x)
                    return {i, j};
                sum += 1;
            }
        }
    }
    assert(0);
    return {1, 1};
}
void procmove(std::vector<std::vector<int32_t>> &a, std::pair<int32_t, int32_t> move) {
    for (int i = move.first; i < n; ++i) {
        for (int j = move.second; j < n; ++j) {
            a[i][j] = 1;
        }
    }
}

signed main() {
    std::ios::sync_with_stdio(0);
    std::cin.tie(0), std::cout.tie(0);
    int type;
    std::cin >> type;
    if (type == 1) {
        std::string x;
        std::cin >> n >> k >> m >> x;
        while (x.length() % L != 0)
            x.push_back('0');
        m = x.length();
        int it = 0, numhod = 0;
        while (true) {
            if (it == m) {
                std::cout << 0 << std::endl;
                return 0;
            }
            std::vector<std::vector<int>> a(n, std::vector<int>(n));
            if (numhod & 1) {
                std::pair<int, int> move;
                std::cin >> move;
                --move.first, --move.second;
                procmove(a, move);
            }
            while (true) {
                if (it == m) {
                    std::cout << "1 1" << std::endl;
                    return 0;
                }
                std::pair<int, int> move;
                std::string curs = "";
                for (int lol = 0; lol < L; ++lol)
                    curs.push_back(x[lol + it]);
                move = getmove(a, std::bitset<L>(curs).to_ullong());
                std::cout << move.first + 1 << " " << move.second + 1 << std::endl;
                if (move == std::pair{0, 0})
                    break;
                it += L;
                procmove(a, move);
                std::cin >> move;
                --move.first, --move.second;
                procmove(a, move);
                if (move == std::pair{0, 0})
                    break;
            }
            ++numhod;
        }
    } else {
        int q;
        int32_t truem = m;
        std::cin >> n >> k >> m >> q;
        truem = m;
        std::string ans = "";
        while (m % L != 0)
            ++m;
        for (int numhod = 0; numhod < q; ++numhod) {
            int lol = numhod & 1;
            std::vector<std::vector<int>> a(n, std::vector<int>(n));
            while (true) {
                std::pair<int, int> move;
                std::cin >> move;
                --move.first, --move.second;
                if (move == std::pair{0, 0}) {
                    break;
                }
                if (lol) {
                    procmove(a, move);
                    lol ^= 1;
                    continue;
                }
                int keek = getpos(a, move);
                procmove(a, move);
                if (keek == -1)
                    continue;
                ans += std::bitset<L>(keek).to_string();
                lol ^= 1;
            }
        }
        ans.erase(ans.begin() + truem, ans.end());
        std::cout << ans << std::endl;
    }
    return 0;
}
