//
// Created by roi on 08.04.2021.
//
#include <bits/stdc++.h>

using namespace std;

using ll = long long;

template<typename T>
using vec = vector<T>;

#define int ll

namespace sol1 {

void run() {
  int n, k, m;
  cin >> n >> k >> m;
  string s;
  cin >> s;
  vec<vec<int>> f(n + 2, vec<int>(n + 2));
  for (int i = 1; i <= n; i++) {
    f[i][n + 1] = f[n + 1][i] = 1;
  }
  auto color = [&](int x, int y) {
    for (int i = x; i <= n; i++) {
      for (int j = y; j <= n; j++) {
        f[i][j] = 1;
      }
    }
  };
  auto get = [&]() -> pair<int, int> {
    int x, y;
    cin >> x >> y;
    color(x, y);
    return {x, y};
  };
  auto set = [&](int x, int y) {
    color(x, y);
    cout << x << ' ' << y << endl;
  };
  auto collect = [&]() {
    vec<pair<int, int>> vc;
    for (int i = 1; i <= n; i++) {
      for (int j = 1; j <= n; j++) {
        if (f[i][j]) continue;
        bool ok = false;
        for (int di = -1; di <= 1; di++) {
          for (int dj = -1; dj <= 1; dj++) {
            if (f[i + di][j + dj]) {
              ok = true;
            }
          }
        }
        if (ok)
          vc.emplace_back(i, j);
      }
    }
    sort(vc.begin(), vc.end());
    return vc;
  };
  int pos = 0;
  for (int iter = 0; ; iter++) {
    f.assign(n + 2, vec<int>(n + 2));
    for (int i = 1; i <= n; i++) {
      f[i][n + 1] = f[n + 1][i] = 1;
    }
    if (pos == m) {
      cout << "0" << endl;
      return;
    }
    for (int who = iter % 2; ; who = 1 - who) {
      if (who == 0) {
        if (pos == m) {
          set(1, 1);
          break;
        }
        auto positions = collect();
        assert(!positions.empty());
        while (__builtin_popcount(positions.size()) > 1) {
          positions.pop_back();
        }
        int lg = 0;
        int ss = positions.size();
        while (ss > 1) {
          ss /= 2;
          lg++;
        }
        lg = min(lg, m - pos);
        int id = 0;
        for (int i = 0; i < lg; i++) {
          if (s[pos + i] == '1') {
            id += (1 << i);
          }
        }
        set(positions[id].first, positions[id].second);
        pos += lg;
        if (positions[id].first == 1 && positions[id].second == 1) {
          break;
        }
      } else {
        auto [x, y] = get();
        if (x == 1 && y == 1) {
          f.assign(n + 2, vec<int>(n + 2));
          for (int i = 1; i <= n; i++) {
            f[i][n + 1] = f[n + 1][i] = 1;
          }
          break;
        }
      }
    }
  }
}

}

namespace sol2 {

void run() {
  assert(false);
  int n, m, k;
  cin >> n >> k >> m;
  string ans;
  int pos = 0;
  int cc;
  cin >> cc;
  int who = 0;
  int iter = 0;
  vec<vec<int>> f(n + 2, vec<int>(n + 2));
  for (int i = 1; i <= n; i++) {
    f[i][n + 1] = f[n + 1][i] = 1;
  }
  auto color = [&](int x, int y) {
    for (int i = x; i <= n; i++) {
      for (int j = y; j <= n; j++) {
        f[i][j] = 1;
      }
    }
  };
  auto get = [&]() -> pair<int, int> {
    int x, y;
    cin >> x >> y;
    color(x, y);
    return {x, y};
  };
  auto set = [&](int x, int y) {
    color(x, y);
    cout << x << ' ' << y << endl;
  };
  auto collect = [&]() {
    vec<pair<int, int>> vc;
    for (int i = 1; i <= n; i++) {
      for (int j = 1; j <= n; j++) {
        if (f[i][j]) continue;
        bool ok = false;
        for (int di = -1; di <= 1; di++) {
          for (int dj = -1; dj <= 1; dj++) {
            if (f[i + di][j + dj]) {
              ok = true;
            }
          }
        }
        if (ok)
          vc.emplace_back(i, j);
      }
    }
    sort(vc.begin(), vc.end());
    return vc;
  };
  int x, y;
  while (cin >> x >> y) {
    if (who == 0) {
      if (pos < m) {
        auto positions = collect();
        while (__builtin_popcount(positions.size()) > 1) {
          positions.pop_back();
        }
        int lg = 0;
        int ss = positions.size();
        while (ss > 1) {
          ss /= 2;
          lg++;
        }
        lg = min(lg, m - pos);
        int id = 0;
        for (int i = 0; i < positions.size(); i++) {
          if (positions[i] == pair(x, y)) {
            id = i;
            break;
          }
        }
        for (int i = 0; i < lg; i++) {
          if (id & (1 << i)) {
            ans.push_back('1');
          } else {
            ans.push_back('0');
          }
        }
        pos += lg;
      }
      color(x, y);
      if (x == 1 && y == 1) {
        iter++;
        who = iter % 2;
        f.assign(n + 2, vec<int>(n + 2));
        for (int i = 1; i <= n; i++) {
          f[i][n + 1] = f[n + 1][i] = 1;
        }
      } else {
        who = 1 - who;
      }
    } else {
      color(x, y);
      if (x == 1 && y == 1) {
        iter++;
        who = iter % 2;
        f.assign(n + 2, vec<int>(n + 2));
        for (int i = 1; i <= n; i++) {
          f[i][n + 1] = f[n + 1][i] = 1;
        }
      } else {
        who = 1 - who;
      }
    }
  }
  cout << ans << endl;
}

}

void run() {
//  freopen("/tmp/game.in", "r", stdin);
//  freopen("/tmp/game.out", "w", stdout);
  int T;
  cin >> T;
  if (T == 1) {
    sol1::run();
  } else {
    sol2::run();
  }
}

signed main() {
#ifdef LOCAL
//  freopen("input.txt", "r", stdin);
  freopen("/tmp/game.in", "r", stdin);
  freopen("/tmp/game.out", "w", stdout);
#else
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
#endif
  run();
  return 0;
}
