#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <numeric>
#include <functional>
#include <algorithm>

#include <ctime>
#include <array>
#include <random>

struct Vec {
	int x, y;

	bool operator==(const Vec &other)const {
		return x == other.x && y == other.y;
	}
};

int n, k, m;

int get(const std::vector<std::vector<bool>> &vec, Vec v, int d) {
	int res = 0;
	for (int i = v.x; i < std::min(n, v.x + d + 1); i++) {
		for (int j = v.y; j < std::min(n, v.y + d + 1); j++) {
			if (!vec[i][j]) {
				res++;
				if (res > d) {
					return res;
				}
			}
		}
	}
	return res;
}

std::vector<Vec> get(const std::vector<std::vector<bool>> &vec, int d) {
	std::vector<Vec> res;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < n; j++) {
			if (!vec[i][j] && get(vec, Vec{ i, j }, d) <= d) {
				res.push_back(Vec{ i, j });
			}
		}
	}
	return res;
}

constexpr int G = 5;

int32_t main() {
	//freopen("\\\\.\\pipe\\game.in", "r", stdin);
	//freopen("\\\\.\\pipe\\game.out", "w", stdout);

	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::mt19937 rnd(134);

	int _t;
	std::cin >> _t;
	std::cin >> n >> k >> m;
	if (_t == 1) { 
		std::vector<bool> mes(m);
		for (int i = 0; i < m; i++) {
			char ch;
			std::cin >> ch;
			mes[i] = ch == '1';
		}
		std::reverse(mes.begin(), mes.end());

		for (bool first = true; !mes.empty(); first ^= true) {
			std::vector<std::vector<bool>> vec(n, std::vector<bool>(n, false));
			bool turn = first;
			while (vec != std::vector<std::vector<bool>>(n, std::vector<bool>(n, true))) {
				int x, y;
				if (turn) {
					auto ps = get(vec, G);

					std::shuffle(ps.begin(), ps.end(), rnd);
					std::stable_sort(ps.begin(), ps.end(), [&](Vec a, Vec b) {
						return std::array{ get(vec, a, G), a.x, a.y } < std::array{ get(vec, b, G), b.x, b.y };
						});

					int r = 0;
					for (; (1 << r) <= ps.size(); r++) {
						;
					}
					r--;
					r = std::min<int>(r, mes.size());
					r = std::min<int>(r, 3);
					int p = 0;
					for (int i = 0; i < r; i++) {
						p |= int(mes.back()) << i;
						mes.pop_back();
					}
					x = ps[p].x;
					y = ps[p].y;
					std::cout << x + 1 << " " << y + 1 << std::endl;

				} else {
					std::cin >> x >> y;
					x--; y--;
				}

				for (int i = x; i < n; i++) {
					for (int j = y; j < n; j++) {
						vec[i][j] = true;
					}
				}

				turn ^= true;
			}
		}
		std::cout << "0" << std::endl;
	} else {
		int goFuck;
		std::cin >> goFuck;

		std::vector<bool> mes;
		for (bool first = true; mes.size() < m; first ^= true) {
			std::vector<std::vector<bool>> vec(n, std::vector<bool>(n, false));
			bool turn = first;
			while (vec != std::vector<std::vector<bool>>(n, std::vector<bool>(n, true))) {
				int x, y;
				if (turn) {
					auto ps = get(vec, G);			
					
					std::shuffle(ps.begin(), ps.end(), rnd);
					std::stable_sort(ps.begin(), ps.end(), [&](Vec a, Vec b) {
						return std::array{ get(vec, a, G), a.x, a.y } < std::array{ get(vec, b, G), b.x, b.y };
						});

					int r = 0;
					for (; (1 << r) <= ps.size(); r++) {
						;
					}
					r--;
					r = std::min<int>(r, m - mes.size());
					std::cin >> x >> y;
					x--; y--;
					int p = std::find(ps.begin(), ps.end(), Vec{ x, y }) - ps.begin();
					for (int i = 0; i < r; i++) {
						mes.push_back((p >> i) & 1);
					}
				} else {
					std::cin >> x >> y;
					x--; y--;
				}

				for (int i = x; i < n; i++) {
					for (int j = y; j < n; j++) {
						vec[i][j] = true;
					}
				}

				turn ^= true;
			}
		}
		for (int i = 0; i < m; i++) {
			std::cout << mes[i];
		}
		std::cout << std::endl;
	}



	return 0;
}

/*
1
4 4 4
0101

2 3
1 1
1 1
3 2
1 1
1 1
2 3
1 1
1 1
3 2
1 1




*/