#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <assert.h>
#include <cmath>

using namespace std;
typedef long long LL;

vector<vector<bool>> canDelete;

bool can_delete(char prev, char next) {
	int id1 = prev - 'a';
	int id2 = next - 'a';
	return canDelete[id1][id2];
}

//newId >= oldId
bool isSubstringLess(string& source, int oldId, int newId) {
	for (int i = 0; i < source.size() - newId; i++)
	{
		if (source[newId + i] < source[oldId + i]) {
			return true;
		}
		else if (source[newId + i] > source[oldId + i]) {
			return false;
		}
	}

	return true;
}

string solveK2(string s) {
	if (can_delete('a', 'b')) {
		if (can_delete('b', 'a')) {
			if (can_delete(s[0], s[0])) {
				string ans = "";
				ans += s[0];
				return ans;
			}

			string ans = "";
			ans += s[0];
			for (int i = 1; i < s.size(); i++)
			{
				if (s[i] != s[i - 1]) {
					break;
				}
				ans += s[i];
			}
			return ans;
		}

		int cntA = 0, cntB = 0;
		bool foundA = false;
		for (int i = 0; i < s.size(); i++)
		{
			if (s[i] == 'a') {
				cntA++;
				foundA = true;
			}
			else if(!foundA){
				cntB++;
			}
		}

		if (can_delete('b', 'a') && cntB > 0) {
			cntA = 0;
		}

		if (can_delete('a', 'a')) {
			cntA = min(1, cntA);
			if (s[0] == 'a') {
				cntB = 0;
			}
		}
		if (can_delete('b', 'b')) {
			cntB = min(1, cntB);
		}

		string ans = "";

		for (int i = 0; i < cntB; i++)
		{
			ans += 'b';
		}
		for (int i = 0; i < cntA; i++)
		{
			ans += 'a';
		}
		return ans;
	}
	else {
		string rebuilt = "";
		rebuilt += s[0];
		int lastB = (s[0] == 'b') ? 0 : -1;

		for (int i = 1; i < s.size(); i++)
		{
			if (can_delete('b', 'b')) {
				if (s[i] == 'b' && s[i - 1] == 'b') {
					continue;
				}
			}
			if (s[i] == 'b') {
				lastB = rebuilt.size();
			}
			
			rebuilt += s[i];
		}

		if (lastB >= 0) {
			if (can_delete('b', 'a')) {
				while (rebuilt.size() > lastB + 1) {
					rebuilt.pop_back();
				}
			}
		}

		if (can_delete('a', 'a')) {
			while (rebuilt.size() > lastB + 2) {
				rebuilt.pop_back();
			}
		}

		if (can_delete('b', 'a') && can_delete('b', 'b')) {
			if (can_delete('a', 'a') && lastB == -1) {
				return "a";
			}
			string ans = "";
			for (int i = 0; i < rebuilt.size(); i++)
			{
				ans += rebuilt[i];
				if (rebuilt[i] == 'b') {
					break;
				}
			}

			return ans;
		}

		return rebuilt;
	}
}

string minimize(string s, char first) {
	if (s.size() == 0) {
		string ans = "";
		ans += first;
		return ans;
	}
	if (can_delete(first, s[0])) {
		int minId = 0;
		int currentId = 0;
		while (can_delete(first, s[currentId])) {
			if (s.size() == currentId + 1) {
				minId = currentId + 1;
				break;
			}
			if (isSubstringLess(s, minId, currentId + 1)) {
				minId = currentId + 1;
			}
			currentId++;
		}

		string ans = "";
		ans += first;
		for (int i = minId; i < s.size(); i++)
		{
			ans += s[i];
		}

		return ans;
	}
	else {
		string ans = "";
		ans += first;
		ans += s;

		return ans;
	}
}

LL seed = 1791791791;
LL times = 113;
LL mod = 1000000007;
int rand() {
	seed *= times;
	seed %= mod;
	return seed;
}

int main() {
	//while (true) {
		int k, n;
		cin >> k;// = 1 + (rand() % (100));
		cin >> n;

		//for (int mask = 0; mask < 16; mask++)
		//{
			canDelete.resize(k, vector<bool>(k, 0));

			for (int i = 0; i < k; i++)
			{
				string can;
				cin >> can;
				for (int j = 0; j < k; j++)
				{
					canDelete[i][j] = (bool)(can[j] - '0');
					//canDelete[i][j] = (mask >> (i * 2 + j)) % 2;
				}
			}

			string s;
			
			cin >> s;

			for (int i = 0; i < n; i++)
			{
				//s += ('a') + (rand() % 2);
			}

			/*if (k == 1) {
				if (canDelete[0][0]) {
					cout << 'a' << endl;
					return 0;
				}
				else {
					cout << s << endl;
					return 0;
				}
			}*/
			string ans1;
			if (k == 2) {
				ans1 = solveK2(s);
				cout << ans1 << endl;
				return 0;
			}

			string current = "";
			for (int i = s.size() - 1; i >= 0; i--)
			{
				current = minimize(current, s[i]);
			}

			cout << current << endl;

			/*if (current != ans1) {
				cout << "FAIL!!!" << endl;
				cout << s << endl;
				cout << n << endl;
				cout << ans1 << endl;
				cout << current << endl;
				for (int i = 0; i < 2; i++)
				{
					for (int j = 0; j < 2; j++)
					{
						cout << canDelete[i][j] << " ";
					}
					cout << endl;
				}
				return 0;
			}*/
		//}

		//cin >> k >> n;
	//}
	

	return 0;
}