#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <assert.h>
#include <cmath>

using namespace std;
typedef long long LL;

vector<set<int>> lower;
vector<set<pair<int, int>>> tasks;

void solve(int id) {
	for (auto s : lower[id])
	{
		solve(s);
	}

	if (lower[id].size() == 0) {
		return;
	}
	if (lower[id].size() == 1) {
		for (auto s : tasks[*lower[id].begin()])
		{
			tasks[id].insert(s);
		}
	}

	auto second = lower[id].begin();
	second++;

	for (auto s = tasks[*lower[id].begin()].begin(); s != tasks[*lower[id].begin()].end(); s++)
	{
		for (auto t = tasks[*second].begin(); t != tasks[*second].end(); t++)
		{
			auto sval = *s, tval = *t;
			if (sval.first > tval.second) {
				tasks[id].insert({ tval.first, sval.second });
			}
			if (sval.second < tval.first) {
				tasks[id].insert({ sval.first, tval.second });
			}
		}
	}
}

int main() {
	int n;
	cin >> n;

	lower.resize(n);
	tasks.resize(n);

	for (int i = 0; i < n; i++)
	{
		int type;
		cin >> type;
		if (type == 1) {
			int k;
			cin >> k;
			for (int j = 0; j < k; j++)
			{
				int s;
				cin >> s;
				s--;
				lower[i].insert(s);
			}
		}
		else {
			int m;
			cin >> m;
			for (int i = 0; i < m; i++)
			{
				int t;
				cin >> t;
				tasks[i].insert({ t, t });
			}
		}
	}

	solve(0);

	if (tasks[0].size() > 0) {
		cout << "Yes" << endl;
	}
	else {
		cout << "No" << endl;
	}

	return 0;
}