#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (auto x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
	#define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
	#define dbg(...)
#endif

const int INF = 1e9;

struct grid {
	int n;
	vec<vec<char>> a;

	grid(int n) : n(n), a(n, vec<char>(n)) {}

	inline int try_to_go(int x, int y) {
		x--, y--;
		int cnt = 0;
		for (int i = x; i < n; i++) {
			for (int j = y; j < n; j++) {
				cnt += !a[i][j];
			}
		}
		return cnt;
	}

	inline void go(int x, int y) {
		x--, y--;
		assert(a[x][y] == 0);
		for (int i = x; i < n; i++) {
			for (int j = y; j < n; j++) {
				a[i][j] = 1;
			}
		}
	}
};

void solve1() {
	int n, k, m;
	cin >> n >> k >> m;
	string s;
	cin >> s;
	assert(len(s) == m);
	s += "000000";
	int pos = 0;
	for (int i = 0; pos < m; i++) {
		int x, y;
		grid cur(n);
		auto win = [&]() {
			cout << "1 2" << endl;
			cin >> x >> y;
			cout << "2 1" << endl;
			cin >> x >> y;
			assert(x == 1 && y == 1);
		};
		auto solve = [&]() {
			for (int rep = 0; rep < 10 && pos < m; rep++) {
				int mn = INF;
				pair<int, int> where_mn{-1, -1};
				for (int i = 1; i <= n; i++) {
					for (int j = 1; j <= n; j++) {
						if (cur.a[i][j]) {
							continue;
						}
						int cost = cur.try_to_go(i, j);
						if (cost % 2 == s[pos] % 2 && mn > cost) {
							mn = cost;
							where_mn = {i, j};
						}
					}
				}
				if (mn == INF) {
					break;
				}
				pos++;
				cout << where_mn.first << ' ' << where_mn.second << endl;
				cur.go(where_mn.first, where_mn.second);
				cin >> x >> y;
				cur.go(x, y);
			}
		};
		if (i % 2 == 0) {
			solve();
			win();
		} else {
			cin >> x >> y;
			cur.go(x, y);
			solve();
			win();
		}
	}
	cout << 0 << endl;
}

void solve2() {
	int n, k, m;
	cin >> n >> k >> m;
	int cnt;
	cin >> cnt;
	string s;
	for (int i = 0; i < cnt; i++) {
		vec<pair<int, int>> steps;
		int x, y;
		do {
			cin >> x >> y;
			steps.emplace_back(x, y);
		} while (x != 1 || y != 1);
		grid cur(n);
		for (int j = 0; j < len(steps) && len(s) < m; j++) {
			if (j % 2 == i % 2) {
				s.push_back('0' + cur.try_to_go(steps[j].first, steps[j].second) % 2);
			}
			cur.go(steps[j].first, steps[j].second);
		}
	}
	assert(len(s) == m);
	cout << s << '\n';
}

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	int t;
	cin >> t;
	if (t == 1) {
		solve1();
	} else {
		solve2();
	}
}
