#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <array>
#include <cstdio>
#include <climits>
int main()
{
	int n, m; std::cin >> n >> m;;
	std::string s; std::cin >> s;
	std::vector<std::vector<std::pair<int,char>>> cards(n);
	for(int i = 0; i < n; i++)
	{
		int k; std::cin >> k;
		for(int j = 0; j < k; j++)
		{
			int a; char buf[5];
			scanf("%d%s", &a, buf);
			a--;
			cards[i].push_back({a, buf[0]});
		}
	}
	std::vector<char> alive(m, true);
	std::vector<char> used(n, false);
	std::vector<int> ans;
	//count mismatches for each card
	//store cards that have the wrong letter for each position
	std::vector<int> mismatch(n);
	std::set<std::pair<int,int>> mmset;
	std::vector<std::vector<int>> imismatch(m);
	for(int i = 0; i < n; i++)
	{
		int a = 0;
		for(auto[j, c] : cards[i])
		{
			if(c == s[j]) continue;
			a++;
			imismatch[j].push_back(i);
		}
		mismatch[i] = a;
		mmset.insert({a, i});
	}
	//first card must have no mismatches. find such a card and place it
	//then recalculate mismatches for all other cards
	for(int i = 0; i < n; i++)
	{
		//for(int ci = 0; ci < n; ci++)
		{
			auto[cmm,ci] = *mmset.begin();
			//printf("ci=%d, cmm=%d\n", ci, cmm);
			if(cmm != 0) break;
			mmset.erase(mmset.begin());
			if(used[ci]) continue;
			bool ok = true;
			for(auto[j, c] : cards[ci])
			{
				if(alive[j] && c != s[j])
				{
					ok = false;
					break;
				}
			}
			//printf("i=%d, ci=%d, ok=%d\n", i, ci, ok);
			if(!ok) continue;
			ans.push_back(ci);
			for(auto[j, c] : cards[ci])
			{
				if(!alive[j]) continue;
				alive[j] = false;
				for(int i : imismatch[j])
				{
					mmset.erase({mismatch[i], i});
					mismatch[i]--;
					mmset.insert({mismatch[i], i});
				}
			}
			used[ci] = true;
			//break;
		}
	}
	for(int i = 0; i < n; i++)
		if(!used[i]) ans.push_back(i);
	for(int i = 0; i < m; i++)
	{
		if(!alive[i]) continue;
		printf("-1\n");
		return 0;
	}
	for(int x : ans)
		printf("%d ", x + 1);
	printf("\n");
}
