#include <iostream>
#include <map>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

vector<map<int,char>> cards;
vector<int> perm;
string s;
int n,m;

bool panic = false;
vector<bool> done;

void go(int l, int r, int i){
    if(i == m) return;
    if(r - l < 1) {
        if(!done[i]) {
            if(cards[perm[l]].count(i)) {
                if (cards[perm[l]][i] == s[i]) {
                    done[i] = true;
                } else {
                    panic = true;
                    return;
                }
            }
        }
        go(l, r, i + 1);
        return;
    }
    if(done[i]) {
        go(l, r, i + 1);
        return;
    }

    int cur = l;
    int end_ptr = r;

    bool has_one = false;

    while(cur < end_ptr){
        if(cards[perm[cur]].count(i)) {
            if (cards[perm[cur]][i] != s[i]){
                swap(perm[cur], perm[end_ptr]);
                end_ptr--;
            }else{
                has_one = true;
                cur++;
            }
        }else{
            cur++;
        }
    }

    if(has_one)
        done[i] = true;

    if(cards[perm[cur]].count(i)) {
        if (cards[perm[cur]][i] != s[i]) {
            if(!has_one) {
                panic = true;
                return;
            }

            go(l, cur - 1, i + 1);
            if (panic) return;
            go(cur, r, i + 1);
        } else {
            done[i] = true;

            go(l, cur, i + 1);
            if (panic) return;
            go(cur + 1, r, i + 1);
        }
    }else{
        if(r != end_ptr){
            panic = true;
            return;
        }
        go(l, cur, i + 1);
        if (panic) return;
        go(cur + 1, r, i + 1);
    }
}

int main() {

    cin >> n >> m;
    cin >> s;

    cards.resize(n);
    done.resize(m);

    for (int i = 0; i < n; ++i) {
        perm.push_back(i);

        int k;
        cin >> k;
        for (int j = 0; j < k; ++j) {
            int pos;
            string c;
            cin >> pos >> c;
            cards[i][pos-1] = c[0];
        }
    }

    go(0, n - 1, 0);
    for(bool b : done){
        panic = panic || !b;
    }
    if(panic){
        cout << -1 << endl;
        return 0;
    }

    for (int i = 0; i < n; ++i) {
        cout << perm[i] + 1 << " ";
    }
    cout << endl;

    return 0;
}
/*
1 1
a
1 1 a


3 4
glhf
3 1 r 3 h 4 i
3 1 r 2 l 3 o
2 1 g 4 f

2 2
aa
2 1 a 2 b
2 1 b 2 a

*/