#include <iostream>
#include <cassert>
#include <algorithm>
#include <set>
#include <map>
#include <vector>

using namespace std;

const int BAD_LEFT = INT32_MAX;
vector<int> tree[100010];
vector<int> improves[100010];
int mask = 0;

int go(int from, int left){
    if(left == BAD_LEFT) return BAD_LEFT;
    if(tree[from].empty()){
        auto ptr = upper_bound(improves[from].begin(), improves[from].end(), left);
        if(ptr == improves[from].end()){
            return BAD_LEFT;
        }
        return *ptr;
    }

    int first = ((1<<from)&mask)? 1:0;
    int second = 1 - first;

    int new_left = go(tree[from][first], left);
    return go(tree[from][second], new_left);
}

int main() {

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int type;
        cin >> type;
        if(type == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int rab;
                cin >> rab;
                tree[i + 1].push_back(rab);
            }
        }else{
            int mi;
            cin >> mi;
            for (int j = 0; j < mi; ++j) {
                int imp;
                cin >> imp;
                improves[i+1].push_back(imp);
            }
            sort(improves[i+1].begin(), improves[i+1].end());
        }
    }

    bool succ = false;
    for (int i = 0; i < (1 << n); ++i) {
        mask = i;
        succ = go(1, -1) != BAD_LEFT;
        if(succ) break;
    }
    assert(succ);

    cout << (succ ? "Yes" : "No") << endl;

    return 0;
}
/*

6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
2 2 40 70
1 2 3 2
2 4 30 90 91 92

3
1 2 2 3
2 1 1
2 1 2

3
1 2 2 3
2 1 1
2 1 1

5
1 2 2 2
2 1 2
1 2 4 5
2 1 1
2 1 3
 *
 *
 *
 *
 *
 *
 *
 */