#include <bits/stdc++.h>

using namespace std;
using ll = long long;

#define ALL(x) (x).begin(), (x).end()

int n;

const int MAX_N = 100000;

vector<int> graph[MAX_N];
vector<int> possibilities[MAX_N];

vector<int> workers_indices;
map<int, int> rw_ind, wr_ind;
vector<int> workers_choices;
vector<vector<int>> order;

void full_reset() {
    order.clear();
    order.resize(n);
}

bool is_sorted(vector<int> &arr) {
    for (int i = 0; i < arr.size() - 1; ++i) {
        if (arr[i] > arr[i + 1]) return false;
    }
    return true;
}

vector<int> check(int v = 0) {
    if (graph[v].empty()) {
        order[v].emplace_back(possibilities[v][workers_choices[rw_ind[v]]] - 1);
        return {possibilities[v][workers_choices[rw_ind[v]]]};
    }
    vector<vector<int>> results;
    for (int u : graph[v]) {
        results.emplace_back(check(u));
        if (results.back().empty()) return {};
    }
    vector<pair<int, int>> to_sort(results.size());
    for (int i = 0; i < results.size(); ++i) {
        to_sort[i] = {results[i][0], i};
    }
    sort(ALL(to_sort));
    vector<int> mine;
    for (auto e : to_sort) {
        order[v].emplace_back(graph[v][e.second]);
        for (int i = 0; i < results[e.second].size(); ++i) {
            mine.emplace_back(results[e.second][i]);
        }
    }
    if (!is_sorted(mine)) return {};
    return mine;
}

bool generate_all(int cur) {
    if (cur == workers_indices.size()) {
        vector<int> pos_ans = check();
        if (!pos_ans.empty()) {
            cout << "Yes\n";
            for (int i = 0; i < n; ++i) {
                for (int e : order[i]) {
                    cout << e + 1 << ' ';
                }
                cout << '\n';
            }
            return true;
        } else {
            full_reset();
            return false;
        }
    } else {
        for (int i = 0; i < possibilities[wr_ind[cur]].size(); ++i) {
            workers_choices[cur] = i;
            if (generate_all(cur + 1)) {
                return true;
            }
        }
    }
    return false;
}

int solve() {
    if (!(cin >> n))
        return 1;
    full_reset();
    for (int i = 0; i < n; ++i) {
        int t;
        cin >> t;
        if (t == 1) {
            int k;
            cin >> k;
            for (int j = 0; j < k; ++j) {
                int e;
                cin >> e;
                e--;
                graph[i].emplace_back(e);
            }
        } else {
            int mi;
            cin >> mi;
            rw_ind[i] = workers_indices.size();
            wr_ind[workers_indices.size()] = i;
            workers_indices.emplace_back(i);
            for (int j = 0; j < mi; ++j) {
                int e;
                cin >> e;
                possibilities[i].emplace_back(e);
            }
        }
    }
    workers_choices.resize(workers_indices.size());
    if (!generate_all(0)) {
        cout << "No\n";
    }
    return 0;
}

int main() {
#ifdef LOCAL
    freopen("D.in", "r", stdin);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int tests = 1e9;
    // cin >> tests;
    for (int i = 1; i <= tests; ++i) {
        if (solve())
            break;
#ifdef LOCAL
        cout << "-------------------------\n";
#endif
    }
}
