#include "bits/stdc++.h"

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef long double ld;

namespace {
    template<typename F, typename S>
    istream& operator>>(istream& in, pair<F, S>& p) {return in >> p.first >> p.second;}
    template<typename T>
    istream& operator>>(istream& in, vector<T>& v) {
        for (auto& e : v)
            in >> e;
        return in;
    }
}

void solve1();
void solve2();

signed main(int argc, char* argv[]) {
#ifdef GEN
    freopen("gen.in", "r", stdin);
    freopen(argv[1], "w", stdout);
#endif
//    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);

    int type;
    cin >> type;
    if (type == 1)
        solve1();
    else
        solve2();
}

int n, k, m;
vector<vector<bool>> taken;

void requestNewGame() {
    cout << 1 << " " << 1 << endl;
    taken = vector<vector<bool>>(n, vector<bool>(n, false));

    int i, j;
    cin >> i >> j;
    i--; j--;
    for (int ni = n - 1; ni >= i; ni--)
        for (int nj = n - 1; nj >= j; nj--)
            taken[ni][nj] = true;
}

bool saveData(int val) {
    for (int i = n - 1; i >= 0; i--) {
        for (int j = n - 1; j >= 0; j--) {
            if (taken[i][j])
                continue;
            if (val == 0) {
                for (int ni = n - 1; ni >= i; ni--)
                    for (int nj = n - 1; nj >= j; nj--)
                        taken[ni][nj] = true;
                cout << i + 1 << " " << j + 1 << endl;
                return true;
            } else
                val--;
        }
    }
    return false;
}

void input() {
    int i, j;
    cin >> i >> j;
    if (i == 1 && j == 1) {
        taken = vector<vector<bool>>(n, vector<bool>(n, false));
        cin >> i >> j;
    }
    i--; j--;
    for (int ni = n - 1; ni >= i; ni--)
        for (int nj = n - 1; nj >= j; nj--)
            taken[ni][nj] = true;
}

void solve1() {
    cin >> n >> k >> m;
    bitset<100007> s;
    cin >> s;
    taken = vector<vector<bool>>(n, vector<bool>(n, false));
    for (int offset = 0; offset < m; offset += 3) {
        bool transmitted = false;
        while (!transmitted) {
            int val = (s[offset]) + (s[offset + 1] << 1) + (s[offset + 2] << 2);
            transmitted = saveData(val);
            if (!transmitted) {
                requestNewGame();
            }
        }
        input();
    }
    cout << "1 1" << endl;
    cin >> n >> k;
    cout << 0 << endl;
}

void solve2() {
    cin >> n >> k >> m;
    bitset<100007> s;
    int _games;
    cin >> _games;
    taken = vector<vector<bool>>(n, vector<bool>(n, false));
    for (int offset = 0; offset < m; offset += 3) {
        int ri, rj;
        cin >> ri >> rj;
        if (ri == 1 && rj == 1) {
            taken = vector<vector<bool>>(n, vector<bool>(n, false));

            int i, j;
            cin >> i >> j;
            i--; j--;
            for (int ni = n - 1; ni >= i; ni--)
                for (int nj = n - 1; nj >= j; nj--)
                    taken[ni][nj] = true;
            cin >> ri >> rj;
        }
        ri--;
        rj--;
        int val = 0;
        for (int i = n - 1; i >= 0; i--) {
            for (int j = n - 1; j >= 0; j--) {
                if (taken[i][j])
                    continue;
                if (i == ri && j == rj) {
                    for (int ni = n - 1; ni >= i; ni--)
                        for (int nj = n - 1; nj >= j; nj--)
                            taken[ni][nj] = true;
                    s[offset] = val % 2;
                    s[offset + 1] = (val >> 1) % 2;
                    s[offset + 2] = (val >> 2) % 2;
                    break;
                } else
                    val++;
            }
        }
        input();
    }
    for (int i = 0; i < m; i++)
        cout << s[m - 1 - i];
    cout << endl;
}