#include <iostream>
#include <vector>
#include <queue>
#include <ios>
using namespace std;

int main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int n, m;
	cin >> n >> m;
	string s;
	cin >> s;
	vector<vector<int>> wrong_perf(m);
	vector<vector<int>> right_positions(n);

	queue<int> q;
	vector<bool> used_perf(n);
	vector<bool> used_pos(m);
	vector<int> ans;

	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		bool has_bad = false;
		for (int j = 0; j < k; j++) {
			int pos;
			char c;
			cin >> pos >> c;
			pos--;
			if (s[pos] == c) {
				right_positions[i].push_back(pos);
			}
			else {
				wrong_perf[pos].push_back(i);
				has_bad = true;
			}
		}

		if (!has_bad) {
			q.push(i);
			used_perf[i] = true;
		}
	}

	while (!q.empty()) {
		int perf = q.front();
		q.pop();
		ans.push_back(perf);
		
		for (int pos : right_positions[perf]) {
			if (!used_pos[pos]) {
				used_pos[pos] = true;
				for (int other_perf : wrong_perf[pos]) {
					if (used_perf[other_perf])
						continue;
					q.push(other_perf);
					used_perf[other_perf] = true;
				}
			}
		}
	}

	if (ans.size() != n)
		cout << -1;
	else {
		for (int p : ans) {
			cout << p + 1 << " ";
		}
	}
}