#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

bool field[50][50];
int prefsum[50][50];

void recalc(int n) {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            prefsum[i + 1][j + 1] = (int)field[i + 1][j + 1] + prefsum[i + 1][j] + prefsum[i][j + 1] - prefsum[i][j];
        }
    }
}

inline int free(int n, int i, int j) {
    return (n - i + 1) * (n - j + 1) - prefsum[i][j];
}

void make(int i, int j, int n) {
    for (int x = n; x >= i; x--) {
        for (int y = n; y >= j; y--) field[x][y] = 1;
    }
}

void solve1() {
    int n, k, m;
    cin >> n >> k >> m;

    string s;
    cin >> s;

    int pref = 0;
    int curr = 0;
    while (true) {
        if (curr == 0 && pref == m) {
            cout << 0 << endl;
            return;
        }

        if (curr == 1) {
            int x, y;
            cin >> x >> y;
            make(x, y, n);
            recalc(n);
        }

        while (true) {
            int whx = -1, why = -1, mn = 1000000;
            for (int i = n; i >= 1; i--) {
                for (int j = n; j >= 1; j--) {
                    if (field[i][j] == 0 && (pref == m || free(n, i, j) % 2 == (s[pref] - '0'))) {
                        if (mn > free(n, i, j)) {
                            mn = free(n, i, j);
                            whx = i;
                            why = j;
                        }
                    }
                }
            }

            if (whx == -1) {
                whx = 1;
                why = 1;
            }

            if (whx == 1 && why == 1) {
                cout << 1 << ' ' << 1 << endl;
                for (int i = 1; i <= n; i++) {
                    for (int j = 1; j <= n; j++) {
                        field[i][j] = 0;
                    }
                }

                recalc(n);
                break;
            }

            cout << whx << ' ' << why << endl;
            pref++;
            int a, b;
            cin >> a >> b;

            if (a == 1 && b == 1) {
                for (int i = 1; i <= n; i++) {
                    for (int j = 1; j <= n; j++) {
                        field[i][j] = 0;
                    }
                }

                recalc(n);
                break;
            }

            make(a, b, n);
            make(whx, why, n);
            recalc(n);
        }

        curr = 1 - curr;
    }
}

void solve2() {
    int n, k, m;
    cin >> n >> k >> m;

    string answ = "";

    int games;
    cin >> games;

    while (games--) {
        int turns;
        cin >> turns;
        for (int i = 0; i < turns; i++) {
            int x, y;
        cin >> x >> y;
            if (i % 2 == 0) {
                if (x == 1 && y == 1) break;
                auto ret = free(n, x, y);
                answ += ret % 2 + '0';
            }

            make(x, y, n);
            recalc(n);
        }

        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++) field[i][j] = 0;
        }

        recalc(n);
    }

    cout << answ << endl;
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef localfile
        //freopen("input.txt", "r", stdin);
    #endif // localfile

    int ttt;
    cin >> ttt;

    if (ttt == 1) {
        solve1();
    }

    else {
        solve2();
    }

    return 0;
}

