#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <string>
#include <cmath>
#include <numeric>
#include <random>

using namespace std;

typedef long long ll;
typedef long double ld;

const int INF = 1e9 + 7;
const int N = 1.1e5;
int tr[4 * N];

// st min
int Get(int l, int r, int ndx = 1, int L = 0, int R = N - 1) {
	if (r < L || R < l || L > R) return INF;
	if (l <= L && R <= r) return tr[ndx];
	return min(Get(l, r, 2 * ndx, L, (L + R) / 2),
		Get(l, r, 2 * ndx + 1, 1 + (L + R) / 2, R));
}

void Set(int pos, int val, int ndx = 1, int L = 0, int R = N - 1) {
	if (pos < L || R < pos || L > R) return;
	if (pos <= L && R <= pos) tr[ndx] = val;
	else {
		Set(pos, val, 2 * ndx, L, (L + R) / 2),
		Set(pos, val , 2 * ndx + 1, 1 + (L + R) / 2, R);
		tr[ndx] = min(tr[2 * ndx], tr[2 * ndx + 1]);
	}
}


vector <string> v;

bool IsDel(string s) {
	while (s.size() > 1) {
		bool ok = false;
		for (int j = s.size() - 1; j > 0; j--) {
			if (v[s[j - 1] - 'a'][s[j] - 'a'] == '1') {
				s.erase(s.begin() + j);
				ok = true;
				break;
			}
		}
		if (!ok)
			return false;
	}
	return true;
}

void Solve() {
	string s;
	int k, n; cin >> k >> n;
	v.resize(k);
	for (auto& j : v) cin >> j;
	cin >> s;
	 
	vector <string> ans(n+1);

	vector <int> whereDel(n, -INF);
	vector <vector <int>> poses(k, { -INF });
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < k; j++) {
			if (v[j][s[i] - 'a'] == '1')
				whereDel[i] = max(whereDel[i], poses[j].back());
		}
		Set(i, whereDel[i]);
		for (int j = 0; j < k; j++)
			while (poses[j].back() > whereDel[i])
				poses[j].pop_back();
		poses[s[i] - 'a'].push_back(i);
	}

	for (int i = n - 1; i >= 0; i--) {
		string st = s.substr(i);
		string q; q += st[0];
		string best = q + ans[i + 1];
		for (int j = 1; j < st.size(); j++) {
			q += st[j];
			if (Get(i + 1, i + j) >= i) best = min(best, st[0] + ans[i + q.size()]);
		}
		ans[i] = best;
	}

	cout << ans[0];
}


int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	ios_base::sync_with_stdio(false);
	Solve();
}