#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(o) o.begin(), o.end()


vector<vector<int>> children;
vector<vector<int>> variants;
vector<int> chosen;
vector<vector<int>> answer;


vector<int> try_dfs(int v = 0) {
    if (children[v].empty()) {
        answer[v] = {(variants[v][chosen[v]])};
        return vector<int>{variants[v][chosen[v]]};
    }

    vector<vector<int>> list;
    for (int child : children[v]) {
        auto res = try_dfs(child);
        if (res.empty()) return {};
        list.push_back(res);
    }
    if (list.empty()) return {};
    vector<int> indexes(list.size());
    iota(all(indexes), 0);

    sort(all(list));
    do {
        bool flag = true;
        for (int i = 0; i < list.size() - 1; ++i) {
            if (list[indexes[i]].back() > list[indexes[i + 1]].front()) {
                flag = false;
                break;
            }
        }
        if (flag) {
            vector<int> res;
            for (auto &e : list) {
                for (auto &i : e) {
                    res.push_back(i);
                }
            }

            answer[v].resize(indexes.size());
            for (int i = 0; i < indexes.size(); i++) {
                answer[v][i] = children[v][indexes[i]] + 1;
            }
            return res;
        }
    } while(next_permutation(all(indexes)));
    return {};
}

bool choose_next() {
    for (int i = 0; i < chosen.size(); ++i) {
        if (variants[i].empty()) {
            continue;
        }
        chosen[i]++;
        if (chosen[i] >= variants[i].size()) {
            chosen[i] = 0;
        } else {
            return true;
        }
    }
    return false;
}

void solve() {
    int n; cin >> n;
    children.assign(n, vector<int>());
    variants.assign(n, vector<int>());
    chosen.assign(n, 0);
    answer.assign(n, vector<int>());
    for (int i = 0; i < n; ++i) {
        int type; cin >> type;
        if (type == 1) {
            int m; cin >> m;
            for (int j = 0; j < m; ++j) {
                int k; cin >> k;
                children[i].push_back(k - 1);
            }
        } else {
            int m; cin >> m;
            for (int j = 0; j < m; ++j) {
                int k; cin >> k;
                variants[i].push_back(k);
            }
        }
    }

    do {
        bool fail = try_dfs().empty();
        if (!fail) {
            cout << "Yes\n";
            // for (int i = 0; i < n; ++i) {
            //     for (int e : answer[i]) {
            //         cout << e << " ";
            //     }
            //     cout << "\n";
            // }
            return;
        }
    } while (choose_next());
    cout << "No\n";
}

int main() {
#if ELT
    freopen("../D.txt", "r", stdin);
    int q; cin >> q;
    for (int i = 0; i < q; i++) {
        cout << " -- TEST " << i + 1 << " --\n";
        solve();
    }
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
#endif
    return 0;
}
