#include <iostream>
#include <string>
#include <vector>
#include <algorithm>

using namespace std;

int n, m;
string s;
vector<pair<int, char>>* cards;

bool check(vector<int>& order)
{
	string res;
	for (int i = 0; i < m; i++)
		res.push_back(' ');
	for (int i = 0; i < n; i++)
	{
		for (const auto& el : cards[order[i]])
		{
			if (res[el.first] == ' ')
				res[el.first] = el.second;
		}
	}
	for (int i = 0; i < m; i++)
	{
		if (res[i] != s[i])
			return false;
	}
	return true;
}

vector<int> ans;

bool find_order(vector<int>& now)
{
	if (now.size() == n)
	{
		if (check(now))
		{
			ans = now;
			return true;
		}
		return false;
	}
	for (int i = 0; i < n; i++)
	{
		if (find(now.begin(), now.end(), i) != now.end())
			continue;
		now.push_back(i);
		if (find_order(now))
			return true;
		now.pop_back();
	}
	return false;
}

int main()
{
	cin >> n >> m;
	cin >> s;
	cards = new vector<pair<int, char>>[n];
	for (int i = 0; i < n; i++)
	{
		int k;
		cin >> k;
		cards[i].resize(k);
		for (int j = 0; j < k; j++)
		{
			cin >> cards[i][j].first >> cards[i][j].second;
			cards[i][j].first--;
		}
	}
	vector<int> now;
	if (find_order(now))
	{
		for (int i = 0; i < n; i++)
			cout << ans[i] + 1 << " ";
		cout << "\n";
	}
	else
	{
		cout << -1 << "\n";
	}
}
