#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define all(a) a.begin(), a.end()

#define ll long long

#define pii pair<int, int>
#define ft first
#define sd second
#define mp make_pair

const int MAX_K = 26;

bool can[MAX_K][MAX_K];

struct my_string {
	string* s;
	my_string() :
		s(nullptr)
	{};
	my_string(char c) {
		s = new string();
		s->push_back(c);
	}
	my_string(my_string old, char append) :
		s(old.s)
	{
		s->push_back(append);
	}

};

void solve() {
	int k, n;
	cin >> k >> n;
	for (int i = 0; i < k; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < k; j++)
			can[i][j] = (s[j] == '1');
	}
	vector<int> vals;
	vals.reserve(n);
	for (int i = 0; i < n; i++) {
		char c;
		cin >> c;
		vals.push_back(c - 'a');
	}
	vector<vector<bool>> can_be_deleted(n + 1, vector<bool>(n + 1, false));
	for (int i = 0; i <= n; i++)
		can_be_deleted[i][i] = true;
	for (int i = 1; i < n; i++)
		if (can[vals[i - 1]][vals[i]])
			can_be_deleted[i][i + 1] = true;
	for (int len = 2; len < n; len++)
		for (int l = 1; l <= n - len; l++) {
			int r = l + len;
			for (int m = l; m < r; m++)
				if (can_be_deleted[l][m] && can_be_deleted[m + 1][r])
					if (can[vals[l - 1]][vals[m]]) {
						can_be_deleted[l][r] = true;
						break;
					}
		}
	vector<int> layer;
	vector<int> ans;
	layer.push_back(0);
	ans.push_back(vals[0]);
	while (true) {
		bool br = false;
		for (int i : layer)
			if (can_be_deleted[i + 1][n]) {
				br = true;
				break;
			}
		if (br)
			break;
		for (int next = 0;; next++) {
			bool found = false;
			for (int i : layer) {
				if (found)
					break;
				for (int j = i + 1; j < n; j++)
					if (vals[j] == next && can_be_deleted[i + 1][j]) {
						found = true;
						break;
					}
			}
			if (!found)
				continue;
			else {
				ans.push_back(next);
				vector<int> newlayer;
				vector<bool> used(n);
				for (int i : layer) {
					for (int j = i + 1; j < n; j++)
						if (!used[j] && vals[j] == next && can_be_deleted[i + 1][j]) {
							used[j] = true;
							newlayer.push_back(j);
						}
				}
				swap(layer, newlayer);
				break;
			}
		}
	}
	for (int c : ans)
		cout << (char)('a' + c);
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	// cin >> t;
	while (t--)
		solve();
}
/*
3 7
010
001
100
abacaba
*/

/*
3 5
010
001
100
bcacb
*/