#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define all(a) a.begin(), a.end()

#define ll long long

#define pii pair<int, int>
#define ft first
#define sd second
#define mp make_pair

int n, k, m;

const int magic = 32;

string bits;
int transfered = 0;

void make_move(vector<vector<bool>>& field, vector<vector<int>>& sufixsums, int x, int y) {
	for (int x1 = x; x1 < n; x1++)
		for (int y1 = y; y1 < n; y1++)
			field[x1][y1] = true;
	for (int x1 = n - 1; x1 >= 0; x1--)
		for (int y1 = n - 1; y1 >= 0; y1--)
			sufixsums[x1][y1] = sufixsums[x1 + 1][y1] + sufixsums[x1][y1 + 1]
			- sufixsums[x1 + 1][y1 + 1] + field[x1][y1];
	int zero = 0;
}

vector<int> powers = { 1, 2, 4, 8, 16, 32, 64, 128, 256, 512, 1024 };

void play_game(bool first) {
	vector<vector<bool>> field(n, vector<bool>(n, false));
	vector<vector<int>> sufixsums(n + 1, vector<int>(n + 1, 0));
	while (sufixsums[0][0] < n * n) {
		if (!first) {
			int x, y;
			cin >> x >> y;
			x--;
			y--;
			make_move(field, sufixsums, x, y);
		}
		else if (transfered == m) {
			make_move(field, sufixsums, 0, 0);
			cout << "1 1\n";
			cout.flush();
		}
		else {
			vector<pii> legit;
			for (int i = 0; i < n; i++)
				for (int j = 0; j < n; j++) {
					if (!field[i][j] && ((n - i) * (n - j) - sufixsums[i][j]) <= magic)
						legit.push_back(mp(i, j));
				}
			int power = --upper_bound(all(powers), legit.size()) - powers.begin();
			power = min(power, m - transfered);
			legit.resize(1 << power);
			int ind = 0;
			for (int i = transfered; i < transfered + power; i++)
				if (bits[i] == '1')
					ind += (1 << (i - transfered));
			make_move(field, sufixsums, legit[ind].ft, legit[ind].sd);
			cout << legit[ind].ft + 1 << ' ' << legit[ind].sd + 1 << '\n';
			cout.flush();
			transfered += power;
		}
		first = !first;
	}
}

void abort_game(bool first) {
	if (!first) {
		int x, y;
		cin >> x >> y;
	}
	cout << "0\n";
	cout.flush();
}

void in_game(bool first) {
	vector<vector<bool>> field(n, vector<bool>(n, false));
	vector<vector<int>> sufixsums(n + 1, vector<int>(n + 1, 0));
	while (sufixsums[0][0] < n * n) {
		if (!first || transfered == m) {
			int x, y;
			cin >> x >> y;
			x--;
			y--;
			make_move(field, sufixsums, x, y);
		}
		else {
			vector<pii> legit;
			for (int i = 0; i < n; i++)
				for (int j = 0; j < n; j++) {
					if (!field[i][j] && ((n - i) * (n - j) - sufixsums[i][j]) <= magic)
						legit.push_back(mp(i, j));
				}
			int power = --upper_bound(all(powers), legit.size()) - powers.begin();
			power = min(power, m - transfered);
			legit.resize(1 << power);
			int x, y;
			cin >> x >> y;
			x--;
			y--;
			make_move(field, sufixsums, x, y);
			int ind = 0;
			while (legit[ind].ft != x || legit[ind].sd != y)
				ind++;
			for (int i = transfered; i < transfered + power; i++) {
				bits[i] = '0' + (ind & 1);
				ind >>= 1;
			}
			transfered += power;
		}
		first = !first;
	}
}

void solve() {
	int t;
	cin >> t >> n >> k >> m;
	if (t == 1) {
		cin >> bits;
		bool first = true;
		while (transfered < m) {
			play_game(first);
			first = !first;
		}
		abort_game(first);
	}
	else {
		int games;
		cin >> games;
		bits.resize(m);
		bool first = true;
		for (int i = 0; i < games; i++) {
			in_game(first);
			first = !first;
		}
		cout << bits;
	}
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
	// cin >> t;
	while (t--)
		solve();
}
/*
3 7
010
001
100
abacaba
*/

/*
3 5
010
001
100
bcacb
*/
/*
32 28
29 31
21 32
32 20
27 31
20 31
12 32
25 30
1 1
*/