#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <bitset>
#include <array>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <functional>
#include <random>
#include <chrono>
#include <time.h>
#include <limits>
#include <cmath>
#include <cassert>

using namespace std;

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

template<typename T1, typename T2> ostream& operator<< (ostream& out, const pair<T1, T2>& a) {
	out << "{" << a.first << ", " << a.second << "}";
	return out;
}

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

#define int long long 
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
#else 
	#define dbg(x)
#endif

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const long long INF = 1e18;

const int N = 11;

int n;
vector<int> g[N];
int sz[N];
vector<int> have[N];
int take[N];

int r;

void dfs(int v) {
	if (g[v].empty()) {
		int pos = upper_bound(all(have[v]), r) - have[v].begin();
		if (pos == sz[v]) {
			r = INF;
		} else {
			take[v] = have[v][pos];
			r = have[v][pos];
		}
		return;
	}
	for (auto u : g[v]) {
		dfs(u);
	}
}

void f(int v) {
	if (v == n) {
		r = 0;
		dfs(0);
		if (r < INF) {
			cout << "Yes\n";
			for (int i = 0; i < n; i++) {
				if (!g[i].empty()) {
					for (auto u : g[i]) {
						cout << u + 1 << " ";
					}
				} else {
					cout << take[i] << " ";
				}
				cout << "\n";
			}
			exit(0);
		}
	}
	if (g[v].empty()) {
		f(v + 1);
	} else {
		sort(all(g[v]));
		do {
			f(v + 1);
		} while (next_permutation(all(g[v])));
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n;
	for (int i = 0; i < n; i++) {
		int t;
		cin >> t;
		if (t == 1) {
			int szw;
			cin >> szw;
			g[i].resize(szw);
			for (int j = 0; j < szw; j++) {
				cin >> g[i][j];
				g[i][j]--;
			}
		} else {
			cin >> sz[i];
			have[i].resize(sz[i]);
			for (int j = 0; j < sz[i]; j++) {
				cin >> have[i][j];
			}
			sort(all(have[i]));
		}
	}
	f(0);
	cout << "No\n";
}
/*
6
1 3 5 4 6
2 3 10 61 60
2 2 80 20
1 2 3 2 
2 4 30 90 91 92 

3 
1 2 2 3
2 1 1 
2 1 2 

5
1 2 2 3 
2 1 2 
1 2 4 5 
2 1 1 
2 1 3
*/