#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cmath>
#include <numeric>
using namespace std;

int n;
vector<vector<int>> graph, a;
vector<int> alist;

int mask;

pair<int, int> dfs(int v, int p = -1)
{
	if (graph[v].size() == 1 && p != -1)
	{
		for (auto&i: a[v])
		{
			int x = (lower_bound(alist.begin(), alist.end(), i)) - alist.begin();

			if (x >= alist.size() || alist[x] != i) continue;
			if (((mask >> x) & 1) == 0) continue;
			return { i, i };
		}

		return { -1, -1 };
	}

	vector<pair<int, int>> res;
	for (auto&i: graph[v])
		if (i != p)
		{
			pair<int, int> tres = dfs(i, v);
			if (tres.first == -1)
				return { -1, -1 };
			res.push_back(tres);
		}

	vector<int> ord(res.size());
	iota(ord.begin(), ord.end(), 0);
	sort(ord.begin(), ord.end(), [&](int x, int y) {
		return res[x] < res[y];
	});
	
	for (int i = 0; i < (int)ord.size() - 1; ++i)
		if (res[ord[i]].second > res[ord[i + 1]].first)
			return { -1, -1 };

	return { res[ord[0]].first, res[ord.back()].second };
}

int main()
{
	cin >> n;
	graph.resize(n);
	a.resize(n);

	int acnt = 0;
	for (int i = 0; i < n; ++i)
	{
		int h; cin >> h;
		if (h == 1)
		{
			int k; cin >> k;
			graph[i].resize(k);
			for (auto& j : graph[i])
			{
				cin >> j, --j;
				graph[j].push_back(i);
			}
				
		}
		if (h == 2)
		{
			int k; cin >> k; acnt += k;
			a[i].resize(k);
			for (auto& j : a[i])
				cin >> j, alist.push_back(j);
		}
	}
	sort(alist.begin(), alist.end());

	bool good = false;
	for (mask = 0; mask < (1 << acnt); ++mask)
		if (good |= (dfs(0).first != -1))
			break;

	cout << (good ? "Yes\n" : "No\n");

	return 0;
}