#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>

using namespace std;
using ll = long long;

struct Node
{
	ll sum;
	ll add;
	Node(ll s = 0) { sum = s; add = 0; }

};

struct SegmentTree
{
	vector<Node> tree;

	Node merge(Node n1, Node n2)
	{
		return Node(n1.sum + n2.sum);
	}

	void push(ll v)
	{
		tree[2 * v + 1].sum += tree[v].add;
		tree[2 * v + 2].sum += tree[v].add;
		tree[2 * v + 1].add += tree[v].add;
		tree[2 * v + 2].add += tree[v].add;
		tree[v].add = 0;
	}

	void init(ll v, ll l, ll r, vector<ll>& start)
	{
		if (l == r)
		{
			tree[v] = Node(start[l]);
			return;
		}
		push(v);
		ll m = (r + l) / 2;

		init(2 * v + 1, l, m, start);
		init(2 * v + 2, m + 1, r, start);

		tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
	}

	Node query(ll v, ll l, ll r, ll id)
	{
		if (l == r && l == id)
		{
			return tree[v];
		}
		if (r < id || id < l)
			return Node(0);

		push(v);
		ll m = (r + l) / 2;

		return merge(query(2 * v + 1, l, m, id),
			query(2 * v + 2, m + 1, r, id));

	}

	void add(ll v, ll l, ll r, ll ql, ll qr, ll val)
	{
		if (ql <= l && r <= qr)
		{
			tree[v].sum += val;
			tree[v].add += val;
			return;
		}
		if (ql > r || l > qr)
			return;
		push(v);
		ll m = (r + l) / 2;

		add(2 * v + 1, l, m, ql, qr, val);
		add(2 * v + 2, m + 1, r, ql, qr, val);

		tree[v] = merge(tree[2 * v + 1], tree[2 * v + 2]);
	}
};

const ll inf = 1e18;

signed main()
{
	ll k, n; cin >> k >> n;
	vector<vector<ll>> a(k, vector<ll>(k, 0));
	for (int i = 0; i < k; ++i)
		for (int j = 0; j < k; ++j)
		{
			char c; cin >> c;
			a[i][j] = c - '0';
		}
	string s; cin >> s;
//	s.push_back('a' - 1);
	bool act = true;
	while (act)
	{
		string mins("z",n + 1);
		act = false;
		for (int i = s.size() - 1; i >= 1; --i)
		{
			if (a[s[i - 1] - 'a'][s[i] - 'a'])
			{
				mins = min(mins, s.substr(0, i) + s.substr(i + 1));
				act = true;
			}
		}
		if (act)
		{
			s = mins;
		}
	}
	cout << s;
	return 0;
}