#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef long double ld;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

const ll SZ = 5e5 + 100, K = 30, P = 23423, MOD = 1e9 + 9;

ll k, n;
bool grid[K][K];
ll lst[SZ], lst2[SZ], pw[SZ];

struct hash_string {
	vector<char> q, q2;
	vector<long long> hsh, hsh2;

	void insert(char ch) {
		q.push_back(ch);
		hsh2.clear();
		q2.clear();

		hsh.push_back(((hsh.back() * P) + (q.back() - 'a' + 1)) % MOD);
	}

	void insert2(char ch) {
		q2.push_back(ch);

		if (hsh2.size() == 0) {
			hsh2.push_back(((hsh.back() * P) + (q2.back() - 'a' + 1)) % MOD);
		}
		else {
			hsh2.push_back(((hsh2.back() * P) + (q2.back() - 'a' + 1)) % MOD);
		}
	}

	ll get_hash(ll l, ll r) { // [l, r] 1-indexation
		ll k = hsh[r] - (hsh[l - 1] * pw[r - l + 1]) % MOD;
		if (k < 0) k += MOD;
		return k;
	}

	ll get_hash2(ll l, ll r) { // [l, r] 1-indexation
		ll h1, h2;
		if (r < hsh.size()) {
			h1 = hsh[r];
		}
		else {
			h1 = hsh2[r - hsh.size()];
		}

		if (l - 1 < hsh.size()) {
			h2 = hsh[l - 1];
		}
		else {
			h2 = hsh[l - 1 - hsh.size()];
		}

		ll k = h1 - (h2 * pw[r - l + 1]) % MOD;
		if (k < 0) k += MOD;
		return k;
	}

	bool lss() {
		int l = 0, r = q.size() + 1;
		ll sz = hsh.size() + hsh2.size();
		while (r - l > 1) {
			int mid = (l + r) / 2;

			if (get_hash2(sz - mid, sz - 1) == get_hash(hsh.size() - mid, hsh.size() - 1)) {
				l = mid;
			}
			else {
				r = mid;
			}
		}

		if (l == sz) return 1;
		if (l == q.size()) return 0;
		char a;
		if (sz - 1 - l < q.size()) {
			a = q[sz - 1 - l];
		}
		else {
			a = q2[sz - 1 - l - q.size() - 1];
		}
		return a < q[q.size() - 1 - l];
	}

	hash_string() { hsh.push_back(0); }
};

hash_string dp[SZ];

int main() {
	fastInp;

	cin >> k >> n;

	pw[0] = 1;
	for (int i = 1; i < SZ; i++) {
		pw[i] = (pw[i - 1] * P) % MOD;
	}
	for (int i = 0; i < k; i++) {
		string s;
		cin >> s;
		for (int j = 0; j < k; j++) {
			grid[i][j] = s[j] - '0';
		}
	}

	string s;
	cin >> s;

	lst[s.size() - 1] = s.size() - 1;

	for (int i = s.size() - 2; i >= 0; i--) {
		lst[i] = i;
		ll i1 = s[i] - 'a', i2 = s[i + 1] - 'a';

		while (lst[i] < s.size() - 1) {
			ll i1 = s[i] - 'a', i2 = s[lst[i] + 1] - 'a';
			if (grid[i1][i2]) {
				lst[i] = lst[lst[i] + 1];
			}
			else {
				break;
			}
		}
	}

	vector<ll> posses;
	hash_string ans;

	ll i = 0;
	while (i < s.size()) {
		posses.push_back(i);
		i = lst[i] + 1;
	}

	reverse(posses.begin(), posses.end());

	ll pr = s.size();
	for (auto c : posses) {
		for (int j = pr - 1; j > c; j--) {
			ans.insert2(s[j]);
			ll t = ans.q2.size();
			vector<char> t2 = ans.q2;
			if (ans.lss()) {
				for (auto k : t2) {
					ans.insert(k);
				}
			}
		}

		ans.insert(s[c]);
		pr = c;
	}

	reverse(ans.q.begin(), ans.q.end());
	for (auto c : ans.q) {
		cout << char(c);
	}

	return 0;
}

/*
3 7
010
001
100
abacaba

3 5
010
001
100
bcacb
*/