#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>

using namespace std;

const int MAX_MEM = 6e8;
char mem[MAX_MEM];
int m_pos = 0;

void* operator new(size_t n) {
    assert((m_pos += n) <= MAX_MEM);
    return (void*) (mem + m_pos - n);
}

void operator delete(void*) noexcept { }

#define int long long
const int SZ = 1e5 + 4;

int k, n;
int a[26][26];
string s;

void read() {
    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
        }
    }
    cin >> s;
}

bool check(int a[26][26], string s) {
    return a[0][0] == s[0] - '0' && a[0][1] == s[1] - '0' && a[1][0] == s[2] - '0' && a[1][1] == s[3] - '0';
}

void solve() {
    vector<pair<char, int>> v;
    for (int i = 0; i < n; ++i) {
        if (v.empty() || v.back().first != s[i]) {
            v.emplace_back(s[i], 1);
        } else {
            ++v.back().second;
        }
    }

    if (check(a, "0000")) {
        cout << s << "\n";
        return;
    }
    if (check(a, "1111")) {
        cout << s[0] << "\n";
        return;
    }
    if (check(a, "1000")) {

        if (v.back().first == 'a') {
            v.back().second = 1;
        }

        for (int i = 0; i < v.size(); ++i) {
            for (int j = 0; j < v[i].second; ++j) {
                cout << v[i].first;
            }
        }

        cout << "\n";
        return;
    }

    if (check(a, "0100")) {
        for (int i = 1; i < v.size(); ++i) {
            if (v[i].first == 'b') {
                v[i].second = 0;
            }
        }

        for (int i = 0; i < v.size(); ++i) {
            for (int j = 0; j < v[i].second; ++j) {
                cout << v[i].first;
            }
        }

        cout << "\n";
        return;
    }

    if (check(a, "1100")) {
        if (v[0].first == 'b') {
            for (int i = 0; i < 1; ++i) {
                for (int j = 0; j < v[i].second; ++j) {
                    cout << v[i].first;
                }
            }
        }

        if (v.size() != 1) cout << 'a';

        cout << "\n";
        return;
    }

    if (check(a, "0010")) {
        if (v.size() != 1 && v.back().first == 'a') {
            v.back().second = 0;
        }

        for (int i = 0; i < v.size(); ++i) {
            for (int j = 0; j < v[i].second; ++j) {
                cout << v[i].first;
            }
        }

        cout << "\n";
        return;
    }

    if (check(a, "1010")) {
        if (v.back().first == 'a') {
            v.back().second = v.size() == 1;
        }

        for (int i = 0; i < v.size(); ++i) {
            for (int j = 0; j < v[i].second; ++j) {
                cout << v[i].first;
            }
        }

        cout << "\n";
        return;
    }

    if (check(a, "0110")) {
        for (int i = 0; i < 1; ++i) {
            for (int j = 0; j < v[i].second; ++j) {
                cout << v[i].first;
            }
        }

        cout << "\n";
        return;
    }

    if (check(a, "1110")) {
        if (v[0].first == 'a') {
            cout << 'a' << "\n";
            return;
        }

        for (int i = 0; i < 1; ++i) {
            for (int j = 0; j < v[i].second; ++j) {
                cout << v[i].first;
            }
        }

        if (v.size() != 1) {
            cout << 'a';
        }

        cout << "\n";
        return;
    }

    if (check(a, "0001")) {
        for (int i = 0; i < v.size(); ++i) {
            if (v[i].first == 'b') {
                v[i].second = 1;
            }
        }

        for (int i = 0; i < v.size(); ++i) {
            for (int j = 0; j < v[i].second; ++j) {
                cout << v[i].first;
            }
        }

        cout << "\n";
        return;
    }

    if (check(a, "1001")) {
        for (int i = 0; i < v.size(); ++i) {
            if (v[i].first == 'b') {
                v[i].second = 1;
            }
        }

        if (v.back().first == 'a') {
            v.back().second = 1;
        }

        for (int i = 0; i < v.size(); ++i) {
            for (int j = 0; j < v[i].second; ++j) {
                cout << v[i].first;
            }
        }

        cout << "\n";
        return;
    }

    if (check(a, "0101")) {
        for (int i = 0; i < v.size(); ++i) {
            if (v[i].first == 'b') {
                v[i].second = i == 0;
            }
        }

        for (int i = 0; i < v.size(); ++i) {
            for (int j = 0; j < v[i].second; ++j) {
                cout << v[i].first;
            }
        }

        cout << "\n";
        return;
    }

    if (check(a, "1101")) {
        for (int i = 0; i < v.size(); ++i) {
            if (v[i].first == 'b') {
                v[i].second = i == 0;
            }
        }

        if (v[0].first == 'a') {
            cout << 'a' << "\n";
            return;
        } else if (v.size() == 1) {
            cout << 'b' << "\n";
            return;
        } else {
            cout << "ba\n";
            return;
        }
    }

    if (check(a, "0011")) {
        assert(0);
        if (v[0].first == 'b') {
            cout << 'b' << "\n";
            return;
        }

        for (int i = 0; i < 1; ++i) {
            for (int j = 0; j < v[i].second; ++j) {
                cout << v[i].first;
            }
        }

        if (v.size() != 1) cout << 'b';

        cout << "\n";
        return;
    }

    if (check(a, "1011")) {
        if (v[0].first == 'b') {
            cout << 'b' << "\n";
            return;
        }

        for (int i = 0; i < 1; ++i) {
            for (int j = 0; j < v[i].second; ++j) {
                cout << v[i].first;
            }
        }

        if (v.size() != 1) cout << 'b';

        cout << "\n";
        return;
    }

    if (check(a, "0111")) {
        if (v[0].first == 'b') {
            cout << 'b' << "\n";
            return;
        }

        for (int i = 0; i < 1; ++i) {
            for (int j = 0; j < v[i].second; ++j) {
                cout << v[i].first;
            }
        }

        cout << "\n";
        return;
    }
    assert(0);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}