#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <map>
#include <cassert>
#include <algorithm>

using namespace std;

const int MAX_MEM = 6e8;
char mem[MAX_MEM];
int m_pos = 0;

void* operator new(size_t n) {
    assert((m_pos += n) <= MAX_MEM);
    return (void*) (mem + m_pos - n);
}

void operator delete(void*) noexcept { }

#define int long long
const int SZ = 1e5 + 4;

int k, n;
int a[26][26];
string s;

void read() {
    cin >> k >> n;
    for (int i = 0; i < k; ++i) {
        for (int j = 0; j < k; ++j) {
            char c;
            cin >> c;
            a[i][j] = c - '0';
        }
    }
    cin >> s;
}

void solve() {
    vector<pair<char, int>> v;
    for (int i = 0; i < n; ++i) {
        if (v.empty() || v.back().first != s[i]) {
            v.emplace_back(s[i], 1);
        } else {
            ++v.back().second;
        }
    }

    for (int i = 0; i < v.size(); ++i) {
        if (v[i].first == 'b') {
            if (a[0][1]) {
                v[i].second = i == 0;
            } else if (a[1][1]) {
                v[i].second = 1;
            }
        }
    }

    while (v.back().second == 0 || v.back().first == 'a') {
        v.pop_back();
        if (v.back().first == 'a') {
            if (a[1][0]) {
                v.back().second = v.size() == 1;
            } else if (a[0][0]) {
                v.back().second = 1;
            }
        }
    }

    for (int i = 0; i < v.size(); ++i) {
        for (int j = 0; j < v[i].second; ++j) {
            cout << v[i].first;
        }
    }

    cout << "\n";
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    read();
    solve();

    return 0;
}