#include <iostream>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

const int N = 3e5 + 7;

int used[N];
set<pair<int, int>> s;
vector<int> g[N];
vector<pair<int, int>> et;

vector<pair<pair<int, int>, pair<int, int>>> ans;

void dfs(int cur, int p) {
	used[cur] = 1;
	for (auto t : g[cur]) {
		if (!used[t]) {
			if (s.count({cur, t})) et.push_back({cur, t});
			dfs(t, cur);
			if (s.count({t, cur})) et.push_back({t, cur});
		}
	}
}

int ok(pair<int, int> a, pair<int, int> b) {
	return a.first == b.second || a.second == b.first;
}

signed main() {

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--;
		v--;
		g[u].push_back(v);
		g[v].push_back(u);
		s.insert({u, v});
	}
	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			et.clear();
			dfs(i, -1);
			// for (auto [u, v] : et) {
			// 	cerr << u + 1 << ' ' << v + 1 << endl;
			// }
			if ((int)et.size() % 2 == 1) {
				cout << "No\n";
				return 0;
			}
			for (int i = 0; i + 1 < (int)et.size(); i += 2) {
				if (!ok(et[i], et[i + 1])) {
					cout << "No\n";
					return 0;
				}
			}
			for (int i = 0; i + 1 < (int)et.size(); i += 2) {
				ans.push_back({et[i], et[i + 1]});
			}
		}
	}
	cout << "Yes\n";
	for (auto [f, s] : ans) {
		cout << f.first + 1 << ' ' << f.second + 1 << ' ' << s.first + 1 << ' ' << s.second + 1 << '\n';
	} 
}