#include <bits/stdc++.h>

using namespace std;

#define ld long double
#define all(x) x.begin(), x.end()

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")

const int inf = 2e9 + 10;

vector<int> w;
vector<vector<int>> g;
vector<vector<int>> id;
vector<int> res;

set<pair<int, int>> s;

void dfs(int v, int mask, int mn, int mx) {
    if (s.count({v, mask}))return;
    s.insert({v, mask});
    if (mn != inf)res[v] = min(res[v], mn + mx);

    for (int i = 0; i < g[v].size(); ++i) {
        if (((mask >> id[v][i]) & 1) == 0)
            dfs(g[v][i], mask + (1 << id[v][i]), min(mn, w[id[v][i]]), max(mx, w[id[v][i]]));
    }
}


void dfs2(int v, int p, int mn, int mx) {
    res[v] = mn + mx;
    for (int i = 0; i < g[v].size(); ++i) {
        if (g[v][i] != p) {
            dfs2(g[v][i], v, min(mn, w[id[v][i]]), max(mx, w[id[v][i]]));
        }
    }
}

struct dsu {
    int n;
    vector<int> p;
    vector<int> res;
    vector<vector<int>> q;

    dsu(int N) {
        n = N;
        p.resize(n);
        q.resize(n);
        res.resize(n, inf);
        for (int i = 0; i < n; ++i) {
            p[i] = i;
            if (i != 0)q[i].push_back(i);
        }
    }

    int find(int x) {
        if (x == p[x])return x;
        return (p[x] = find(p[x]));
    }

    void unite(int x, int y, int val) {
        int fx = find(x);
        int fy = find(y);
        if (fx == fy)return;
        if (fx == find(0)) {
            while (!q[fy].empty()) {
                int z = q[fy].back();
                q[fy].pop_back();
                res[z] = val;
            }
        }
        if (fy == find(0)) {
            while (!q[fy].empty()) {
                int z = q[fy].back();
                q[fy].pop_back();
                res[z] = val;
            }
        }
        if (q[fx].size() > q[fy].size())swap(fx, fy);
        while (!q[fx].empty()) {
            int z = q[fx].back();
            q[fx].pop_back();
            q[fy].push_back(z);
        }
        p[fx] = fy;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    g.resize(n);
    id.resize(n);
    w.resize(m);
    vector<pair<int, pair<int, int>>> edges(m);

    for (int i = 0; i < m; ++i) {
        int v, u, t;
        cin >> v >> u >> t;
        --v, --u;
        edges[i] = {t, {v, u}};
        w[i] = t;
        g[v].push_back(u);
        g[u].push_back(v);
        id[v].push_back(i);
        id[u].push_back(i);
    }
    if (false) {
        res.resize(n, inf);
        dfs(0, 0, inf, -inf);
        for (int i = 1; i < n; ++i) cout << res[i] << '\n';
    } else if (false) {
        res.resize(n, inf);
        dfs2(0, -1, inf, -inf);
        for (int i = 1; i < n; ++i) cout << res[i] << '\n';
    } else {
        sort(all(edges));
        dsu d(n);
        for (int i = 0; i < m; ++i) {
            int v = edges[i].second.first;
            int u = edges[i].second.second;
            d.unite(v, u, edges[i].first);
        }
        for(int i = 1; i < n; ++i) cout << d.res[i] << '\n';
    }
}