#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_N = 300005;
int n, m;
vector<int> g[MAX_N], gr[MAX_N];
bool dp[MAX_N][3];
bool vis[MAX_N];
bool used[MAX_N];
int minb[MAX_N], maxb[MAX_N];
vector<pair<pair<int, int>, pair<int, int>>> ans;
bool eup[MAX_N], edown[MAX_N];

void dfs(int v, int p)
{
	vis[v] = 1;
	for (int nxt : g[v])
	{
		if (nxt != p)
		{
			edown[nxt] = 1;
		}
	}
	for (int nxt : gr[v])
	{
		if (nxt != p)
		{
			eup[nxt] = 1;
		}
	}

	for (int nxt : g[v])
	{
		if (nxt != p && !vis[nxt])
		{
			dfs(nxt, v);
		}
	}
	for (int nxt : gr[v])
	{
		if (nxt != p && !vis[nxt])
		{
			dfs(nxt, v);
		}
	}

	int minbal = 0, maxbal = 0;
	for (int nxt : g[v])
	{
		if (nxt != p && !used[nxt])
		{
			used[nxt] = 1;
			minbal--;
			maxbal--;

			if (dp[nxt][2])
			{
				maxbal++;
			}
			else if (dp[nxt][0])
			{
				//+=0
			}
			else if (dp[nxt][1])
			{
				maxbal--;
			}

			if (dp[nxt][1])
			{
				minbal--;
			}
			else if (dp[nxt][0])
			{
				//-=0
			}
			else if (dp[nxt][2])
			{
				minbal++;
			}
		}
	}
	for (int nxt : gr[v])
	{
		if (nxt != p && !used[nxt])
		{
			used[nxt] = 1;
			minbal++;
			maxbal++;

			if (dp[nxt][2])
			{
				maxbal++;
			}
			else if (dp[nxt][0])
			{
				//+=0
			}
			else if (dp[nxt][1])
			{
				maxbal--;
			}

			if (dp[nxt][1])
			{
				minbal--;
			}
			else if (dp[nxt][0])
			{
				//-=0
			}
			else if (dp[nxt][2])
			{
				minbal++;
			}
		}
		else if (nxt != p && used[nxt])
		{
			minbal++;
			maxbal++;
		}
	}

	if (minbal <= -1 && maxbal >= -1)
		dp[v][2] = 1;
	if (minbal <= 1 && maxbal >= 1)
		dp[v][1] = 1;
	if (minbal <= 0 && maxbal >= 0)
		dp[v][0] = 1;

	if (!eup[v])
		dp[v][1] = 0;
	if (!edown[v])
		dp[v][2] = 0;

	if (!dp[v][0] && !dp[v][1] && !dp[v][2])
	{
		cout << "No";
		exit(0);
	}
}

pair<int, int> get_ans(int v, int p, int mod)
{
	vis[v] = 1;
	vector<int> zup, zdown;

	int pl = mod - minb[v];
	for (int nxt : g[v])
	{
		if (nxt != p && !vis[nxt])
		{
			if (dp[nxt][1])
			{
				if (dp[nxt][2] && p >= 2)
				{
					auto it = get_ans(nxt, v, 1);
					p -= 2;
					ans.push_back({ {v, nxt}, it });
					if (eup[nxt])
						zup.push_back(nxt);
				}
				else if (dp[nxt][0] && p >= 1)
				{
					auto it = get_ans(nxt, v, 0);
					p -= 1;
					if (eup[nxt])
						zup.push_back(nxt);
					if (edown[nxt])
						zdown.push_back(nxt);
				}
				else
				{
					auto it = get_ans(nxt, v, -1);
					p -= 0;
					ans.push_back({ it, {nxt, v} });
					if (edown[nxt])
						zdown.push_back(nxt);
				}
			}
			else if (dp[nxt][0])
			{
				if (dp[nxt][2] && p >= 1)
				{
					auto it = get_ans(nxt, v, 1);
					p -= 1;
					ans.push_back({ {v, nxt}, it });
					if (eup[nxt])
						zup.push_back(nxt);
				}
				else
				{
					auto it = get_ans(nxt, v, 0);
					p -= 0;
					if (eup[nxt])
						zup.push_back(nxt);
					if (edown[nxt])
						zdown.push_back(nxt);
				}
			}
			else if (dp[nxt][2])
			{
				auto it = get_ans(nxt, v, 1);
				p -= 0;
				ans.push_back({ {v, nxt}, it });
				if (eup[nxt])
					zup.push_back(nxt);
			}
		}
	}
	for (int nxt : gr[v])
	{
		if (nxt != p && !vis[nxt])
		{
			if (dp[nxt][1])
			{
				if (dp[nxt][2] && p >= 2)
				{
					auto it = get_ans(nxt, v, 1);
					p -= 2;
					ans.push_back({ {v, nxt}, it });
					if (eup[nxt])
						zup.push_back(nxt);
				}
				else if (dp[nxt][0] && p >= 1)
				{
					auto it = get_ans(nxt, v, 0);
					p -= 1;
					if (eup[nxt])
						zup.push_back(nxt);
					if (edown[nxt])
						zdown.push_back(nxt);
				}
				else
				{
					auto it = get_ans(nxt, v, -1);
					p -= 0;
					ans.push_back({ it, {nxt, v} });
					if (edown[nxt])
						zdown.push_back(nxt);
				}
			}
			else if (dp[nxt][0])
			{
				if (dp[nxt][2] && p >= 1)
				{
					auto it = get_ans(nxt, v, 1);
					p -= 1;
					ans.push_back({ {v, nxt}, it });
					if (eup[nxt])
						zup.push_back(nxt);
				}
				else
				{
					auto it = get_ans(nxt, v, 0);
					p -= 0;
					if (eup[nxt])
						zup.push_back(nxt);
					if (edown[nxt])
						zdown.push_back(nxt);
				}
			}
			else if (dp[nxt][2])
			{
				auto it = get_ans(nxt, v, 1);
				p -= 0;
				ans.push_back({ {v, nxt}, it });
				if (eup[nxt])
					zup.push_back(nxt);
			}
		}
	}

	int sz = min(zup.size(), zdown.size());
	for (int i = 0; i < sz; i++)
	{
		ans.push_back({ {zup[i], v}, {v, zdown[i]} });
	}

	if (mod == 1)
		return { v, zdown.back() };
	else if (mod == -1)
		return { zup.back(), v };
	else
		return { -1, -1 };
}

int main()
{
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	int a, b;
	for (int i = 0; i < m; i++)
	{
		cin >> a >> b;
		g[a].push_back(b);
		gr[b].push_back(a);
	}

	for (int i = 1; i <= n; i++)
	{
		if (!vis[i])
		{
			dfs(i, 0);
			if (!dp[i][0])
			{
				cout << "No";
				return 0;
			}
		}
	}

	cout << "Yes" << endl;

	for (int i = 1; i <= n; i++)
	{
		vis[i] = 0;
	}
	for (int i = 1; i <= n; i++)
	{
		if (!vis[i])
		{
			get_ans(i, 0, 0);
		}
	}

	for (auto it : ans)
	{
		cout << it.first.first << " " << it.first.second << " " << it.second.first << " " << it.second.second << endl;
	}

	return 0;
}