#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_N = 300005;
int n, m;
vector<pair<int, int>> g[MAX_N];
int ans[MAX_N];

void dfs(int v, int p, int mn, int mx)
{
	ans[v] = mn + mx;
	for (auto nxt : g[v])
	{
		if (nxt.first != p)
		{
			dfs(nxt.first, v, min(mn, nxt.second), max(mx, nxt.second));
		}
	}
}

int main()
{
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	int a, b, t;
	for (int i = 0; i < m; i++)
	{
		cin >> a >> b >> t;
		g[a].push_back({ b, t });
		g[b].push_back({ a, t });
	}

	vector<pair<int, int>> vec;
	for (int i = 1; i <= n; i++)
	{
		sort(g[i].rbegin(), g[i].rend());
		vec.clear();
		for (int j = 0; j < g[i].size(); j++)
		{
			while (!vec.empty() && vec.back().first == g[i][j].first)
				vec.pop_back();
			vec.push_back(g[i][j]);
		}
		g[i] = vec;
	}

	dfs(1, 0, 2e9, -1);

	for (int i = 2; i <= n; i++)
	{
		cout << ans[i] << endl;
	}

	return 0;
}