#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <cmath>
#include <algorithm>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <queue>
#include <assert.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
const ll INF = (ll)1e18;
const double PI = acos(-1.0);

const int MAX_N = 300005;
int n, m;
vector<pair<int, int>> g[MAX_N];
int dp[MAX_N];
bool vis[MAX_N];
priority_queue<pair<int, int>> q;

int main()
{
	//freopen(".in", "r", stdin);
	//freopen(".out", "w", stdout);
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	cin >> n >> m;
	int a, b, t;
	for (int i = 0; i < m; i++)
	{
		cin >> a >> b >> t;
		g[a].push_back({ b, t });
		g[b].push_back({ a, t });
	}

	vector<pair<int, int>> vec;
	for (int i = 1; i <= n; i++)
	{
		sort(g[i].rbegin(), g[i].rend());
		vec.clear();
		for (int j = 0; j < g[i].size(); j++)
		{
			while (!vec.empty() && vec.back().first == g[i][j].first)
				vec.pop_back();
			vec.push_back(g[i][j]);
		}
		g[i] = vec;
	}

	for (int i = 1; i <= n; i++)
	{
		dp[i] = 2e9;
		vis[i] = 0;
	}
	dp[1] = 0;
	q.push({ 0, 1 });
	while (!q.empty())
	{
		int v = q.top().second;
		q.pop();
		if (vis[v])
			continue;
		vis[v] = 1;

		for (auto nxt : g[v])
		{
			if (!vis[nxt.first] && dp[nxt.first] > max(dp[v], nxt.second))
			{
				dp[nxt.first] = max(dp[v], nxt.second);
				q.push({ -dp[nxt.first], nxt.first });
			}
		}
	}

	for (int i = 2; i <= n; i++)
	{
		cout << dp[i] << endl;
	}

	return 0;
}