#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <map>
#include <set>
#include <string>
#include <deque>
#include <cassert>

using namespace std;

typedef long long ll;

const int INF = 2e9;

#define all(x) x.begin(), x.end()
//#define int ll

struct edge
{
	int to, cost, in;
	edge() {}
	edge(int to, int cost, int in) : to(to), cost(cost), in(in) {}
};

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#else
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	int n, m, a, b, c;
	cin >> n >> m;
	vector<vector<edge>> g(n);
	for (int i = 0; i < m; ++i) {
		cin >> a >> b >> c;
		--a, --b;
		g[a].emplace_back(b, c, i);
		g[b].emplace_back(a, c, i);
	}
	vector<int> d(n, INF);
	vector<set<int>> used(n);
	d[0] = 1e9;
	set<pair<int, int>> s;
	s.emplace(d[0], 0);
	while (!s.empty()) {
		int v = s.begin()->second, cost = s.begin()->first;
		s.erase(s.begin());
		for (auto& u : g[v]) {
			if (used[u.to].count(u.in))
				continue;
			if (d[u.to] > min(cost, u.cost)) {
				used[u.to].emplace(u.in);
				s.erase({ d[u.to], u.to });
				d[u.to] = min(cost, u.cost);
				s.emplace(d[u.to], u.to);
			}
		}
	}
	for (int i = 1; i < n; ++i)
		cout << d[i] + (int)(1e9) << '\n';
	return 0;
}