#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <cassert>
#include <ctime>
#include <random>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#include <list>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("rename-registers")
#pragma GCC optimize("fast-math")

#define all(q) q.begin(), q.end()

using namespace std;
using ll = long long;
constexpr int INF = (int)2e9;
constexpr int MAXN = (int)1e5;

struct llist {
	int x;
	int h;
	int ind;
	llist *next;
	llist *prev;

	llist() : x(0), h(0), ind(-1), next(nullptr), prev(nullptr) {};
	llist(int x, int h, int ind) : x(x), h(h), ind(ind), next(nullptr), prev(nullptr) {};
};

inline int prev_x(llist *el, int xbeg) noexcept {
	if (el->prev == nullptr)
		return xbeg;
	else
		return el->prev->x;
}

inline int next_x(llist *el, int xend) noexcept {
	if (el->next == nullptr)
		return xend;
	else
		return el->next->x;
}

int inq[MAXN];
int timer = 0;

int main(int argc, char *argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, q;
	cin >> n >> q;
	vector<int> x(n), h(n);
	for (int i = 0; i < n; ++i)
		cin >> x[i] >> h[i];

	while (q--) {
		int l, r;
		cin >> l >> r;
		--l;

		int xbeg = l > 0 ? x[l - 1] : x[l];
		int xend = r < n ? x[r] : x[r - 1];
		llist *beg = new llist(x[l], h[l], l);
		llist *last = beg;
		for (int i = l + 1; i < r; ++i) {
			llist *buf = new llist(x[i], h[i], i);
			last->next = buf;
			buf->prev = last;
			last = buf;
		}

		queue<llist *> q;
		++timer;
		for (llist *cur = beg; cur != nullptr; cur = cur->next) {
			if (cur->x - cur->h >= prev_x(cur, xbeg)) {
				inq[cur->ind] = timer;
				q.push(cur);
				continue;
			}

			if (cur->x + cur->h <= next_x(cur, xend)) {
				inq[cur->ind] = timer;
				q.push(cur);
				continue;
			}
		}

		int ans = 0;
		while (!q.empty()) {
			++ans;
			llist *cur = q.front();
			q.pop();
			
			if (cur->prev != nullptr) {
				cur->prev->next = cur->next;
				if (inq[cur->prev->ind] != timer) {
					if (cur->prev->x + cur->prev->h <= next_x(cur->prev, xend)) {
						inq[cur->prev->ind] = timer;
						q.push(cur->prev);
					}
				}
			}

			if (cur->next != nullptr) {
				cur->next->prev = cur->prev;
				if (inq[cur->next->ind] != timer) {
					if (cur->next->x - cur->next->h >= prev_x(cur->next, xbeg)) {
						inq[cur->next->ind] = timer;
						q.push(cur->next);
					}
				}
			}

			delete cur;
		}

		cout << ans << '\n';
	}

	return 0;
}