#ifdef _MSC_VER
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <iomanip>
#include <cassert>
#include <ctime>
#include <random>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <queue>
#include <deque>
#include <list>
#else
#include <bits/stdc++.h>
#include <bits/extc++.h>
#endif

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("rename-registers")
#pragma GCC optimize("fast-math")

#define all(q) q.begin(), q.end()

using namespace std;
using ll = long long;
constexpr int INF = (int)2e9;
constexpr int MAXN = (int)1e5;

struct llist {
	int x;
	int h;
	int ind;
	int next;
	int prev;

	llist() : x(0), h(0), ind(-1), next(-1), prev(-1) {};
	llist(int x, int h, int ind) : x(x), h(h), ind(ind), next(-1), prev(-1) {};
};

llist node[MAXN];
int write_ind = 0;

inline int prev_x(int el, int xbeg) noexcept {
	if (node[el].prev == -1)
		return xbeg;
	else
		return node[node[el].prev].x;
}

inline int next_x(int el, int xend) noexcept {
	if (node[el].next == -1)
		return xend;
	else
		return node[node[el].next].x;
}

int inq[MAXN];
int timer = 0;

int main(int argc, char *argv[]) {
	ios::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, q;
	cin >> n >> q;
	vector<int> x(n), h(n);
	for (int i = 0; i < n; ++i)
		cin >> x[i] >> h[i];

	while (q--) {
		int l, r;
		cin >> l >> r;
		--l;

		int xbeg = l > 0 ? x[l - 1] : x[l];
		int xend = r < n ? x[r] : x[r - 1];
		int write_ind = 0;
		int beg = 0;
		node[write_ind++] = llist(x[l], h[l], l);
		int last = beg;
		for (int i = l + 1; i < r; ++i) {
			int buf = write_ind;
			node[write_ind++] = llist(x[i], h[i], i);
			node[last].next = buf;
			node[buf].prev = last;
			last = buf;
		}

		queue<int> q;
		++timer;
		for (int i = beg; i != -1; i = node[i].next) {
			if (node[i].x - node[i].h >= prev_x(i, xbeg)) {
				inq[node[i].ind] = timer;
				q.push(i);
				continue;
			}

			if (node[i].x + node[i].h <= next_x(i, xend)) {
				inq[node[i].ind] = timer;
				q.push(i);
				continue;
			}
		}

		int ans = 0;
		while (!q.empty()) {
			++ans;
			int v = q.front();
			q.pop();

			if (node[v].prev != -1) {
				node[node[v].prev].next = node[v].next;
				if (inq[node[node[v].prev].ind] != timer) {
					if (node[node[v].prev].x + node[node[v].prev].h <= next_x(node[v].prev, xend)) {
						inq[node[node[v].prev].ind] = timer;
						q.push(node[v].prev);
					}
				}
			}

			if (node[v].next != -1) {
				node[node[v].next].prev = node[v].prev;
				if (inq[node[node[v].next].ind] != timer) {
					if (node[node[v].next].x - node[node[v].next].h >= prev_x(node[v].next, xbeg)) {
						inq[node[node[v].next].ind] = timer;
						q.push(node[v].next);
					}
				}
			}
		}

		cout << ans << '\n';
	}

	return 0;
}