#include <iostream>
#include <string>
#include <vector>
#include <stack>
#include <queue>
#include <algorithm>
#include <cassert>
#include <cstring>
#include <set>
using namespace std;
#define cap(x) (x).size()
#define pb push_back
#define all(x) (x).begin(), (x).end()
using ll = long long;
const int N = 3e5 + 100;
vector<int> g[N];
set<int> in[N], out[N];
int used[N];
int pw[N];
void dfs(int v) {
	used[v] = 1;
	for (int to : g[v]) if (!used[to]) {
		dfs(to);
		pw[v]++;
	}
}
int main() {
	ios::sync_with_stdio(0);
	cin.tie(0), cout.tie(0);
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; i++) {
		int x, y;
		cin >> x >> y;
		g[x].pb(y);
		g[y].pb(x);
		in[y].insert(x);
		out[x].insert(y);
	}
	for (int i = 1; i <= n; i++) if (!used[i]) dfs(i);
	queue<int> q;
	vector<vector<int>> ans;
	for (int i = 1; i <= n; i++) if (!pw[i]) q.push(i);
	auto er = [&](int x, int y) {
		assert(out[x].count(y));
		assert(in[y].count(x));
		out[x].erase(y);
		in[y].erase(x);
	};
	auto dec = [&](int x) {
		pw[x]--;
		if (pw[x] == 0) q.push(x);
	};
	while (cap(q)) {
		int v = q.front();
		q.pop();
		if (out[v].empty() && in[v].empty()) {
			continue;
		}
		if (cap(out[v])) {
			int u = *out[v].begin();
			int e = -1;
			for (int x : out[u]) {
				if (e == -1) e = x;
				else if (pw[x] == 0) e = x;
			}
			if (e == -1) {
				cout << "No\n";
				return 0;
			}
			er(v, u);
			er(u, e);
			ans.pb({ v, u, u, e });
			dec(u);
			if (!out[e].count(u)) dec(e);
		}
		else {
			int u = *in[v].begin();
			int e = -1;
			for (int x : in[u]) {
				if (e == -1) e = x;
				else if (pw[x] == 0) e = x;
			}
			if (e == -1) {
				cout << "No\n";
				return 0;
			}
			er(u, v);
			er(e, u);
			ans.pb({ u, v, e, u });
			dec(u);
			if (!in[e].count(u)) dec(e);
		}
	}
	cout << "Yes\n";
	for (auto e : ans) {
		for (int i : e) cout << i << ' ';
		cout << '\n';
	}
	return 0;
}

/*

5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/