#include <iostream>
#include <vector>

using namespace std;

#pragma GCC optimize("Ofast")

const long long INF = 1e18;

struct Res {
    long long val;
    char c;
    int last;
    Res(): val(-INF), c('#'), last(-1) {}
    Res(long long val, char c, int last): val(val), c(c), last(last) {}
};

long long values[26];

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    values[0] = 1;
    for (int i = 1; i < 26; i++) {
        if (i % 2) {
            values[i] = values[i - 1] * 5;
        }
        else {
            values[i] = values[i - 1] * 2;
        }
    }
    int q;
    cin >> q;
    while (q--) {
        string s;
        cin >> s;
        int n = s.size();
        vector<vector<Res>> dp(n, vector<Res>(26));
        if (s.back() != '?') {
            dp[n - 1][s.back() - 'A'] = Res(values[s.back() - 'A'], s.back(), -1);
        }
        else {
            for (int i = 0; i < 26; i++) {
                dp[n - 1][i] = Res(values[i], 'A' + i, -1);
            }
        }

        for (int i = n - 2; i >= 0; i--) {
            if (s[i] != '?') {
                int x = s[i] - 'A';
                for (int j = 0; j <= x; j++) {
                    if (dp[i][x].val < values[x] + dp[i + 1][j].val) {
                        dp[i][x] = Res(values[x] + dp[i + 1][j].val, 'A' + x, j);
                    }
                }
                for (int j = x + 1; j < 26; j++) {
                    if (dp[i][j].val < dp[i + 1][j].val - values[x]) {
                        dp[i][j] = Res(dp[i + 1][j].val - values[x], 'A' + x, j);
                    }
                }
            }
            else {
                for (int x = 0; x < 26; x++) {
                    for (int j = 0; j <= x; j++) {
                        if (dp[i][x].val < values[x] + dp[i + 1][j].val) {
                            dp[i][x] = Res(values[x] + dp[i + 1][j].val, 'A' + x, j);
                        }
                    }
                    for (int j = x + 1; j < 26; j++) {
                        if (dp[i][j].val < dp[i + 1][j].val - values[x]) {
                            dp[i][j] = Res(dp[i + 1][j].val - values[x], 'A' + x, j);
                        }
                    }
                }
            }
        }
        long long ans = -INF;
        int index = -1;
        for (int i = 0; i < 26; i++) {
            if (dp[0][i].val > ans) {
                ans = dp[0][i].val;
                index = i;
            }
        }
        string str;
        str += dp[0][index].c;
        for (int i = 1; i < n; i++) {
            index = dp[i - 1][index].last;
            str += dp[i][index].c;
        }
        cout << ans << '\n' << str << '\n';
    }
/*
4
BBBC
????
A?B?C?D
YYYYY?
*/

    return 0;
}
