#include <bits/stdc++.h>

#pragma GCC optimize("Ofast")

using namespace std;

const int MAXN = 1.5e5 + 10;

struct Edge {
    int u;
    int v;
};

array<vector<int>, MAXN> graph;
vector<Edge> edges;
array<int, MAXN> used;
array<int, MAXN> cntout;
array<int, MAXN> cntin;
array<int, MAXN> parent;
array<set<int>, MAXN> out;
array<set<int>, MAXN> in;
vector<tuple<int, int, int, int>> ans;

void dfs1(int vertex, int par) {
    used[vertex] = 1;
    parent[vertex] = par;
    for (auto elem : graph[vertex]) {
        if (!used[elem]) {
            dfs1(elem, vertex);
        }
    }
}

bool dfs2(int vertex) {
    used[vertex] = 1;
    // cout << vertex << endl;
    for (auto elem : graph[vertex]) {
        if (!used[elem]) {
            if (!dfs2(elem)) return 0;
        }
    }
    int par = parent[vertex];
    if (par == -1) {
        if (cntin[vertex] != cntout[vertex]) {
            return 0;
        }
        // cout << vertex << ' ' << cntin[vertex] << ' ' << cntout[vertex] << '\n';
        for (auto elem : graph[vertex]) {
            // cout << vertex << ' ' << elem << endl;
            if (cntin[elem] >= 2 || cntout[elem] >= 2) return 0;
            if (cntin[elem] == 1 && cntout[elem] == 1) {
                cntin[elem] = 0;
                in[vertex].erase(elem);
                cntout[elem] = 0;
                out[vertex].erase(elem);
                cntin[vertex]--;
                cntout[vertex]--;
                ans.push_back({elem, vertex, vertex, elem});
            } else if (cntin[elem] == 1) {
                if (cntin[vertex] == 0) {
                    return 0;
                } else {
                    int to_err = *in[vertex].begin();
                    if (to_err == par) {
                        auto it = in[vertex].begin();
                        to_err = *(++it);
                    }
                    in[vertex].erase(to_err);
                    out[to_err].erase(vertex);
                    cntout[to_err]--;
                    out[vertex].erase(elem);
                    ans.push_back({to_err, vertex, vertex, elem});
                }  
                cntin[vertex]--;
                cntout[vertex]--;
            } else if (cntout[elem] == 1) {
                if (cntout[vertex] == 0) {
                    return 0;
                } else {
                    int to_err = *out[vertex].begin();
                    if (to_err == par) {
                        auto it = out[vertex].begin();
                        to_err = *(++it);
                    }
                    out[vertex].erase(to_err);
                    in[to_err].erase(vertex);
                    cntin[to_err]--;
                    in[vertex].erase(elem);
                    ans.push_back({elem, vertex, vertex, to_err});
                }  
                
                cntin[vertex]--;
                cntout[vertex]--;
            }
            cntin[elem] = 0;
            cntout[elem] = 0;
        }
        return 1;
    }
    // cout << vertex << ' ' << cntin[vertex] << ' ' << cntout[vertex] << '\n';
    if (abs(cntin[vertex] - cntout[vertex]) > 1) return 0;
    for (auto elem : graph[vertex]) {
        if (elem != par) {
            if (cntin[elem] >= 2 || cntout[elem] >= 2) return 0;
            if (cntin[elem] == 1 && cntout[elem] == 1) {
                in[vertex].erase(elem);
                out[vertex].erase(elem);
                cntin[vertex]--;
                cntout[vertex]--;
                ans.push_back({elem, vertex, vertex, elem});
            } else if (cntin[elem] == 1) {
                if (cntin[vertex] == 1 && out[par].count(vertex) == 1) {
                    out[par].erase(vertex);
                    in[vertex].erase(par);
                    out[vertex].erase(elem);
                    cntout[par]--;
                    ans.push_back({par, vertex, vertex, elem});
                } else if (cntin[vertex] == 0) {
                    return 0;
                } else {
                    int to_err = *in[vertex].begin();
                    if (to_err == par) {
                        auto it = in[vertex].begin();
                        to_err = *(++it);
                    }
                    in[vertex].erase(to_err);
                    out[to_err].erase(vertex);
                    cntout[to_err]--;
                    out[vertex].erase(elem);
                    ans.push_back({to_err, vertex, vertex, elem});
                }  
                cntin[vertex]--;
                cntout[vertex]--;
            } else if (cntout[elem] == 1) {
                if (cntout[vertex] == 1 && in[par].count(vertex) == 1) {
                    in[par].erase(vertex);
                    out[vertex].erase(par);
                    in[vertex].erase(elem);
                    cntout[par]--;
                    ans.push_back({elem, vertex, vertex, par});
                } else if (cntout[vertex] == 0) {
                    return 0;
                } else {
                    int to_err = *out[vertex].begin();
                    if (to_err == par) {
                        auto it = out[vertex].begin();
                        to_err = *(++it);
                    }
                    out[vertex].erase(to_err);
                    in[to_err].erase(vertex);
                    cntin[to_err]--;
                    in[vertex].erase(elem);
                    ans.push_back({elem, vertex, vertex, to_err});
                }  
                cntin[vertex]--;
                cntout[vertex]--;
            }
            cntin[elem] = 0;
            cntout[elem] = 0;
            // cout << vertex << ' ' << elem << endl;
        }
    }
    return 1;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        u--;v--;
        graph[u].push_back(v);
        graph[v].push_back(u);
        edges.push_back(Edge{u, v});
        cntout[u]++;
        cntin[v]++;
    }
    
    // for (auto e : edges) {
    //     if (e.u == parent[e.v]) {
    //         in[e.v].insert(e.u);
    //     }
    //     if (e.v == parent[e.u]) {
    //         out[e.u].insert(e.v);
    //     }
    // }
    for (auto e : edges) {
        in[e.v].insert(e.u);
        out[e.u].insert(e.v);
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            dfs1(i, -1);
        }
    }
    ans.reserve(m);
    fill(used.begin(), used.end(), 0);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) {
            if (!dfs2(i)) {
                cout << "No";
                return 0;
            }
        }
    }
    cout << "Yes\n";
    for (auto [a,b,c,d] : ans) {
        cout << a + 1 << ' ' << b + 1 << ' ' << c + 1 << ' ' << d + 1 << '\n';
    }
    return 0;
}