#include <bits/stdc++.h>

using namespace std;

void IO() {
#ifdef DIVAN
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
}

#define all(x) x.begin(), x.end()
#define sz(x) ((int)x.size())
#define forn(i, n) for (int i = 0; i < (n); ++i)
#define eb emplace_back
#define vi vector<int>
#define pi pair<int,int>
#define vpi vector<pi>

typedef long long ll;


const int INF = 2139062143;
const int nINF = -2139062144;
const ll INFL = 9187201950435737471;
const ll nINFL = -9187201950435737472;

const int MAXN = 2000 + 15;

int ans[MAXN];
vi comp[MAXN];
int par[MAXN];
int now, one;
vpi adj[MAXN];
int cost[MAXN];
int add;
int used[MAXN];
map <int, vpi> edges;

int GetPar(int v) {
    if (par[v] == -1) {
        return v;
    }
    return par[v] = GetPar(par[v]);
}

void Merge(int a, int b) {
    a = GetPar(a);
    b = GetPar(b);
    if (a == b) {return;}
    if (a == one) {
        for (auto u : comp[b]) {
            ans[u] = min(ans[u], now + add);
        }
    }
    if (b == one) {
        for (auto u : comp[a]) {
            ans[u] = min(ans[u], now + add);
        }
    }
    if (sz(comp[a]) > sz(comp[b])) {
        swap(a, b);
    }
    for (auto u : comp[a]) {
        comp[b].eb(u);
    }
    comp[a].clear();
    par[a] = b;
}

void Solve(int n, map<int,vpi> edges) {
    for (int i = 1; i <= n; ++i) {
        comp[i] = {i};
        par[i] = -1;
    }
    now = 0;
    for (auto &[x, y] : edges) {
        now = x;
        for (auto [a, b] : y) {
            one = GetPar(1);
            Merge(a, b);
        }
    }
}

void DFS(int v) {
    for (auto [to, num] : adj[v]) {
        if (!used[to]) {
            used[to] = used[v];
            DFS(to);
        }
    }
}

void Solve() {
    memset(ans, 127, sizeof(ans));
    int n, m;
    cin >> n >> m;
    vpi e;
    forn(i, m) {
        int a, b, c;
        cin >> a >> b >> c;
        adj[a].eb(b, i);
        adj[b].eb(a, i);
        cost[i] = c;
        e.eb(a, b);
    }
    forn(i, m) {
        memset(used, 0, sizeof(used));
        add = cost[i];
        edges.clear();
        auto[a, b] = e[i];
        used[a] = 1;
        used[b] = 2;
        DFS(a);
        DFS(b);
        forn(j, m) {
            auto[a1, b1] = e[j];
            if (used[a1] != used[b1]) {
                edges[cost[j]].eb(a1, b1);
            }
        }
        Solve(n, edges);
    }
    for (int i = 2; i <= n; ++i) {
        cout << ans[i] << '\n';
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    while(t--) {
        Solve();
    }
    return 0;
}