#include <iostream>
#include <vector>
#include <cmath>

using namespace std;

long long vals[26];

long long toLong(const string &moscowNum) {
        long long res = 0;
        int lastIdx = (int)moscowNum.length() - 1;
        long long max = vals[moscowNum[lastIdx] - 'A'];

        for (int i = lastIdx; i >= 0; i--) {
            int idx = moscowNum[i] - 'A';
            long num = vals[idx];

            if (num < max) res -= num;
            else {
                res += num;
                max = num;
            }
        }

        return res;
    }

    long long fixMoscowNum(string &num) {
        long long max_ = 0;
        vector<int> ids;

        for (int i = 0; i < num.length(); i++) {
            char ch = num[i];
            if (ch == '?') {
                ids.push_back(i);

                num[i] = (char) (max_ + 'A');
            } else max_ = max(max_, (long long)num[i] - 'A');
        }

        string tmpNum = num;
        max_ = toLong(tmpNum);

        for (int i : ids) {
            tmpNum[i] = 'Z';
            long val = toLong(tmpNum);

            if (val > max_) {
                max_ = val;
                for (int j : ids) num[j] = tmpNum[j];
            }
        }

        return max_;
    }

int main() {
    vals[0] = 1;
    vals[1] = 5;
    for (int i = 2; i < 26; i++) {
        vals[i] = vals[i - 2] * 10;
    }

    int q;
    cin >> q;

    for (int i = 0; i < q; i++) {
        string num;
        cin >> num;
        cout << fixMoscowNum(num) << "\n" << num << "\n";
    }

    cout.flush();
}
