#include <algorithm>
#include <iostream>
#include <cstring>
#include <string>
#include <vector>
#include <set>
#include <map>
using namespace std;

typedef long long ll;
#define fastio ios::sync_with_stdio(false), cin.tie(0)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define rforn(i, n) for (int i = (n) - 1; i >= 0; i--)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

const int N1 = 300100;
vector<pair<int, int>> g[N1];

int d0[N1];
void dfs0(int v, int p = -1, int mn = 1e9, int mx = 0) {
	d0[v] = mn + mx;
	for (auto u : g[v]) {
		if (u.first == p) continue;
		dfs0(u.first, v, min(mn, u.second), max(mx, u.second));
	}
}

int d1[N1];

const int N2 = 20;
int dp[N2][1 << N2];

const int N3 = 2010;
int a[N3];
int b[N3];

int timer = 0;
int tin[N1];
int up[N1];
bool used[N1];
set<pair<int, int>> bridges;

void dfs1(int v, int p = -1) {
	tin[v] = timer++;
	up[v] = tin[v];

	used[v] = true;
	bool found = false;
	for (auto u : g[v]) {
		if (u.first == p) {
			if (!found) {
				found = true;
				continue;
			}
		}
		if (!used[u.first]) {
			dfs1(u.first, v);
			up[v] = min(up[v], up[u.first]);
			if (up[u.first] > tin[v]) {
				bridges.insert(make_pair(v, u.first));
				bridges.insert(make_pair(u.first, v));
			}
		}
		else {
			up[v] = min(up[v], tin[u.first]);
		}
	}
}

int c[N1];

void dfs2(int v, int color) {
	used[v] = true;
	c[v] = color;

	for (auto u : g[v]) {
		if (used[u.first] || bridges.find(make_pair(v, u.first)) != bridges.end()) continue;
		dfs2(u.first, color);
	}
}

vector<pair<int, int>> g2[N1];
int mnc[N1];
int res3[N1];

void dfs3(int v, int mn = 1e9) {
	mn = min(mn, mnc[v]);
	res3[v] = mn;
	used[v] = true;

	for (auto u : g2[v]) {
		if (used[u.first]) continue;
		dfs3(u.first, min(mn, u.second));
	}
}

int main() {
	fastio;
	int n, m;
	cin >> n >> m;
	map<pair<pair<int, int>, int>, int> id;
	vector<pair<pair<int, int>, int>> e;
	forn(i, m) {
		int a, b, t;
		cin >> a >> b >> t;
		a--, b--;
		g[a].push_back(make_pair(b, t));
		g[b].push_back(make_pair(a, t));
		id[make_pair(make_pair(a, b), t)] = i;
		id[make_pair(make_pair(b, a), t)] = i;
		e.push_back(make_pair(make_pair(a, b), t));
	}

	bool flag1 = true, flag2 = true;
	for (auto i : g[0]) {
		if (i.second != 0) flag1 = false;
		if (i.second != 1e9) flag2 = false;
	}

	if (flag2) {
		dfs1(0);
		memset(used, 0, sizeof(used));
		int color = 0;
		forn(i, n) {
			if (!used[i]) {
				dfs2(i, color++);
			}
		}

		for (auto& i : mnc) {
			i = 1e9;
		}

		for (auto i : e) {
			if (c[i.first.first] == c[i.first.second]) {
				mnc[c[i.first.first]] = min(mnc[c[i.first.first]], i.second);
			}
			else {
				g2[c[i.first.first]].push_back(make_pair(c[i.first.second], i.second));
				g2[c[i.first.second]].push_back(make_pair(c[i.first.first], i.second));
			}
		}

		memset(used, 0, sizeof(used));
		dfs3(0);

		for (int i = 1; i < n; i++) {
			cout << (int)1e9 + res3[c[i]] << '\n';
		}
		return 0;
	}

	if (m == n - 1) {
		dfs0(0);
		for (int i = 1; i < n; i++) {
			cout << d0[i] << '\n';
		}
		return 0;
	}

	if (flag1) {
		set<pair<int, int>> q;
		q.insert(make_pair(0, 0));
		forn(i, n) d1[i] = 1e9 + 1;
		d1[0] = 0;

		while (q.size()) {
			int v = q.begin()->second;
			q.erase(q.begin());
			for (auto u : g[v]) {
				if (d1[u.first] > max(d1[v], u.second)) {
					q.erase(make_pair(d1[u.first], u.first));
					d1[u.first] = max(d1[v], u.second);
					q.insert(make_pair(d1[u.first], u.first));
				}
			}
		}
		for (int i = 1; i < n; i++) {
			cout << d1[i] << '\n';
		}
		return 0;
	}

	if (n <= 20 && m <= 20) {
		for (auto& i : dp) {
			for (auto& j : i) {
				j = 2e9 + 1;
			}
		}
		set<pair<int, pair<int, int>>> q;
		q.insert(make_pair(0, make_pair(0, 0)));
		dp[0][0] = 0;
		while (q.size()) {
			auto v = q.begin()->second;
			q.erase(q.begin());
			int mn = 1e9, mx = 0;
			forn(i, m) {
				if (v.second >> i & 1) {
					mn = min(mn, e[i].second);
					mx = max(mx, e[i].second);
				}
			}
			for (auto u : g[v.first]) {
				int k = id[make_pair(make_pair(v.first, u.first), u.second)];
				if (v.second >> k & 1) continue;
				int curmn = min(mn, u.second);
				int curmx = max(mx, u.second);
				int s = (v.second ^ (1 << k));
				if (dp[u.first][s] > curmn + curmx) {
					q.erase(make_pair(dp[u.first][s], make_pair(u.first, s)));
					dp[u.first][s] = curmn + curmx;
					q.insert(make_pair(dp[u.first][s], make_pair(u.first, s)));
				}
			}
		}
		for (int i = 1; i < n; i++) {
			int ans = 2e9 + 1;
			forn(j, (1 << m)) {
				ans = min(ans, dp[i][j]);
			}
			cout << ans << '\n';
		}
		return 0;
	}

	for (auto& i : a) i = 1e9 + 1;
	for (auto& i : b) i = 1e9 + 1;
	forn(i, n - 1) {
		for (auto j : g[i]) {
			if (j.first < i) continue;
			if (a[j.first] > j.second) {
				a[j.first] = j.second;
			}
		}
	}

	vector<int> ans(n, 2e9);

	int mn1 = 1e9, mx1 = 0;
	for (int i = 1; i < n; i++) {
		mn1 = min(mn1, a[i]);
		mx1 = max(mx1, a[i]);

		ans[i] = mn1 + mx1;
		int mn = 1e9 + 1;
		for (auto j : g[i]) {
			if (j.first < i) {
				mn = min(mn, j.second);
			}
		}
		if (mn > 1e9) continue;
		b[i] = mn1 + max(mx1, mn);
	}

	for (int i = n - 2; i >= 1; i--) {
		b[i] = min(b[i], b[i + 1]);
		ans[i] = min(ans[i], b[i]);
	}
	for (int i = 1; i < n; i++) {
		cout << ans[i] << '\n';
	}

	return 0;
}