#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef double dl;
typedef vector<int> vi;
typedef pair<int, int> pi;

#define nl '\n'
#define all(a) (a).begin(), (a).end()
#define minq(a, b) (a) = min(a, b)
#define maxq(a, b) (a) = max(a, b)
#define forn(i, n) for (int i = 0; i < (n); i++)
#define sz(a) int((a).size())

void IO() {
#ifdef SEVA
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
}

const int N = (int) 2e5 + 10;

vector<int> g[N], gt[N];

bool used[N];
vi edgeDn[N], edgeUp[N];
bool fromP[N], toP[N];
vector<pair<pair<int, int>, pair<int, int>>> ans;

void DFS(int v, int p = 0) {
    used[v] = true;
    int kids = 0;
    for (auto &to : g[v]) {
        if (to == p) {
            toP[v] = true;
            continue;
        }
        if (used[to])
            continue;
        DFS(to, v);
        kids++;
    }
    for (auto &to : gt[v]) {
        if (to == p) {
            fromP[v] = true;
            continue;
        }
        if (used[to])
            continue;
        DFS(to, v);
        kids++;
    }
    for (; !edgeDn[v].empty() && !edgeUp[v].empty();) {
        ans.emplace_back(make_pair(edgeUp[v].back(), v), make_pair(v, edgeDn[v].back()));
        edgeDn[v].pop_back();
        edgeUp[v].pop_back();
    }
    if (!edgeDn[v].empty() && fromP[v] && p != 0) {
        ans.emplace_back(make_pair(p, v), make_pair(v, edgeDn[v].back()));
        fromP[v] = false;
        edgeDn[v].pop_back();
    }
    if (!edgeUp[v].empty() && toP[v] && p != 0) {
        ans.emplace_back(make_pair(edgeUp[v].back(), v), make_pair(v, p));
        toP[v] = false;
        edgeUp[v].pop_back();
    }
    if (!edgeUp[v].empty() || !edgeDn[v].empty()) {
        cout << "No" << nl;
        exit(0);
    }
    if (toP[v]) {
        if (p == 0) {
            cout << "No" << nl;
            exit(0);
        }
        edgeUp[p].push_back(v);
    }
    if (fromP[v]) {
        if (p == 0) {
            cout << "No" << nl;
            exit(0);
        }
        edgeDn[p].push_back(v);
    }
}

void Solve() {
    int n, m;
    cin >> n >> m;
    forn(i, m) {
        int u, v;
        cin >> u >> v;
        g[u].push_back(v);
        gt[v].push_back(u);
    }
    for (int i = 1; i <= n; i++) {
        if (used[i])
            continue;
        DFS(i);
    }
    cout << "Yes" << nl;
    for (auto& [e1, e2] : ans) {
        cout << e1.first << ' ' << e1.second << ' ' << e2.first << ' ' << e2.second << nl;
    }
}

signed main() {
    IO();
    int t = 1;
//    cin >> t;
    forn(i, t) {
        Solve();
    }
}
