#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vii = vector<int>;

void optimize() {
    ios::sync_with_stdio(false);
    cin.tie(0);
}

const int N = 3001;
int n, m;

vii g[N];
bool dp[3][N]; //[0 - all, 1 - down, 2 - up][v]
set<int> g1[N];
bool used[N];

pii r[N];
vector<pair<pii, pii>> ans;

int edge[N][N]; // 0 - no edge, 1 - down, 2 - up, 3 - both;

void dfs(int v) {
    used[v] = 1;
    int in = 0, out = 0;
    vector<int> ins, outs;
    bool f = 1;
    for (int u : g1[v]) {
        if (used[u]) continue;
        dfs(u);
        bool fout = 0, fin = 0;
        if (edge[v][u] == 3 || edge[v][u] == 1) {
            ++out; outs.push_back(u); fout = 1;
        }
        if (edge[v][u] == 3 || edge[v][u] == 2) {
            ++in; ins.push_back(u); fin = 1;
        }
        if (!dp[1][u] && !dp[0][u] && !dp[2][u])
            f = 0;
        else if (dp[1][u]) {
            if (!fout) f = 0;
            else ans.push_back({{v + 1, u + 1}, r[u]});
            --out;
        }
        else if (dp[2][u]) {
            if (!fin) f = 0;
            else ans.push_back({r[u], {u + 1, v + 1}});
            --in;
        }
    }
    while (!ins.empty() && !outs.empty()) {
        ans.push_back({{ins.back() + 1, v + 1}, {v + 1, outs.back() + 1}});
        ins.pop_back(); outs.pop_back();
    }
    if (!f) {}
    else if (in == out) dp[0][v] = 1;
    else if (in == out + 1) dp[2][v] = 1, r[v] = {ins[0] + 1, v + 1};
    else if (out == in + 1) dp[1][v] = 1, r[v] = {v + 1, outs[0] + 1};
}

int main() {
    optimize();
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v; --u; --v;
        g[u].push_back(v);
        if (edge[u][v] == 0) edge[u][v] = 1, edge[v][u] = 2;
        else if (edge[u][v] == 2) edge[u][v] = 3, edge[v][u] = 3;
        g1[u].insert(v); g1[v].insert(u);
    }
    bool f = 1;
    for (int i = 0; i < n; ++i) {
        if (!used[i]) dfs(i), f = f && dp[0][i];
    }

    cout << (f ? "Yes" : "No") << '\n';
    if (f) {
        for (auto p : ans) {
            cout << p.first.first << " " << p.first.second << " " << p.second.first << " " << p.second.second << '\n';
        }
    }

    return 0;
}
