#include <iostream>
#include <vector>
#include <map>

using namespace std;

struct edge{
    int v, u;
};

struct ed{
    int v, t;
};

const int MAXN = 15e4;
vector <pair <edge, edge>> ans;
vector <bool> visited(MAXN);
vector <ed> g[MAXN];
bool ch = true;

pair <int, edge> get(int v){
    //cout << v << endl;
    visited[v] = true;
    vector <edge> pos, neg;
    for (auto e : g[v]) {
        if (visited[e.v])
            continue;
        auto x = get(e.v);
        if (abs(x.first + e.t) > 1)
            ch = false;
        if (x.first == 0) {
            if (e.t >= 0) {
                pos.push_back({v, e.v});
            }
            if (e.t <= 0) {
                neg.push_back({e.v, v});
            }
        }
        if (x.first < 0) {
            ans.push_back({{v, e.v}, x.second});
            if (e.t <= 0) {
                neg.push_back({e.v, v});
            }
        }
        if (x.first > 0) {
            ans.push_back({x.second, {e.v, v}});
            if (e.t >= 0) {
                pos.push_back({v, e.v});
            }
        }
    }
    if (abs((int)(pos.size() - neg.size())) > 1)
        ch = false;
    while (pos.size() > 0 && neg.size() > 0) {
        ans.push_back({neg.back(), pos.back()});
        neg.pop_back();
        pos.pop_back();
    }
    if (pos.size() > 0) {
        return {-1, pos.back()};
    }
    if (neg.size() > 0) {
        return {1, neg.back()};
    }
    return {0, {0, 0}};
}

signed main() {
    int n, m;
    cin >> n >> m;
    map <int, int> a[n];
    vector <int> kekk[n];

    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        a[x][y] += 1;
        a[y][x] -= 1;
        kekk[x].push_back(y);
        kekk[y].push_back(x);
    }

    for (int i = 0; i < n; ++i) {
        for (auto j : kekk[i]) {
            if (a[i][j] == -2)
                continue;
            g[i].push_back({j, a[i][j]});
            a[i][j] = -2;
        }
    }

    for (int i = 0; i < n; ++i) {
        if (visited[i])
            continue;
        auto x = get(i);
        ch = ch && (x.first == 0);
    }
    if (ch) {
        cout << "Yes" << endl;
        for (auto i : ans) {
            cout << i.first.v + 1 << " " << i.first.u + 1 << " " << i.second.v + 1 << " " << i.second.u + 1 << endl;
        }
    }
    else {
        cout << "No";
    }
}


