#include <iostream>
#include <vector>
#include <queue>

#define int long long

using namespace std;

struct edge{
    int u, t;
};

const int MAXN = 300004, INF = 1e16;
vector <edge> g[MAXN];
vector <int> ans(MAXN, INF);
vector <bool> visited(MAXN);

void dfs(int v, int mival, int maval) {
    visited[v] = true;
    ans[v] = mival + maval;
    for (auto e : g[v]) {
        if (visited[e.u])
            continue;
        dfs(e.u, min(mival, e.t), max(maval, e.t));
    }
}

signed main() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int x, y, z;
        cin >> x >> y >> z;
        x--;
        y--;
        g[x].push_back({y, z});
        g[y].push_back({x, z});
    }
    dfs(0, INF, 0);
    for (int i = 1; i < n; ++i) {
        cout << ans[i] << "\n";
    }
}
