#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cassert>
#include <queue>
#include <set>
#define int long long
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>
#define all(a) a.begin(), a.end()
using namespace std;
const int N = 5e5;

int x[N], h[N], n, q;
set<int> b;

bool check(int v) {
	auto it = b.upper_bound(v);
	if (it == b.end() || x[*it] - x[v] >= h[v])
		return true;
	it = b.lower_bound(v);
	if (it == b.begin()) 
		return true;
	it--;
	if (x[v] - x[*it] >= h[v]) 
		return true;
	return false;
}

int solve(int l, int r) {
	b.clear();
	for (int i = l - 1; i <= r + 1; ++i)
		b.insert(i);
	queue<int> q;
	for (int i = l; i <= r; ++i)
		if (check(i)) {
			q.push(i);
			b.erase(i);
		}
	while (q.size()) {
		int v = q.front(); q.pop();
		auto it = b.upper_bound(v);
		if (it != b.end() && *it <= r && check(*it)) {
			q.push(*it);
			b.erase(*it);
		}
		it = b.lower_bound(v);
		if (it != b.begin()) {
			it--;
			if (*it >= l && check(*it)) {
				q.push(*it);
				b.erase(*it);
			}
		}
	}
	return r - l + 1 - (b.size() - 2);
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);
	cin >> n >> q;
	for (int i = 0; i < n; ++i)
		cin >> x[i + 1] >> h[i + 1];
	x[0] = x[1];
	x[n + 1] = x[n];
	while (q--) {
		int l, r;
		cin >> l >> r;
		cout << solve(l, r) << "\n";
	}
}
/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/