#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <cassert>
#include <cstring>
#include <string>
#include <list>

using namespace std;

#define range(i, n) for (int i = 0; i < (n); ++i)
#define prange(i, n) for (int i = 1; i <= (n); ++i)
#define rrange(i, n) for (int i = (n) - 1; i >= 0; --i)

typedef long long ll;
typedef pair<int, int> pii;
#define fi first
#define se second
#define pb push_back
#define all(a) (a).begin(), (a).end()

void setup() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

void solve();

int main() {
    setup();
    int t = 1;
//    cin >> t;
    range(i, t) {
        solve();
    }
}

const int MAXN = 3e5 + 10;
vector<pii> graph[MAXN];
int mins[MAXN];
int maxs[MAXN];
int n, m;

void treeDfs(int v, int p, int mn, int mx) {
    mins[v] = mn;
    maxs[v] = mx;
    for (auto [u, t] : graph[v]) {
        if (u == p) continue;
        treeDfs(u, v, min(mn, t), max(mx, t));
    }
}

void solve() {
    cin >> n >> m;
    range(i, m) {
        int v, u, t; cin >> v >> u >> t; --v; --u;
        graph[v].pb({u, t});
        graph[u].pb({v, t});
    }
    treeDfs(0, -1, 1e9, 0);
    prange(i, n - 1) {
        cout << mins[i] + maxs[i] << '\n';
    }
}



