#include <bits/stdc++.h>
using namespace std;

int n, m;

vector<vector<int>> d;
vector<set<int>> g;

vector<tuple<int, int, int>> ans;
vector<bool> used;

vector<int> up;
vector<int> down;

int sz_u, sz_d;

bool dfs(int v, int p = -1) {
	if ( used[v] ) return true;

	used[v] = true;

	for ( int to : d[v] ) {
		if ( !dfs(to, v) )
			return false;
	}

	up = {};
	down = {};

	for ( int to : d[v] ) {
		if ( to == p ) continue;

		if ( g[to].find(v) != g[to].end() ) up.push_back(to);
		if ( g[v].find(to) != g[v].end() ) down.push_back(to);
	}

	while ( (!up.empty()) && (!down.empty()) ) {
		ans.push_back({up.back() + 1, v + 1, down.back() + 1});
		//no need to delete these edges?

		up.pop_back(); down.pop_back();
	}

	if ( up.empty() ) {
		if ( (int)down.size() > 1 ) return false;
		if ( down.empty() ) return true;
		if ( p == -1 ) return false;

		auto it = g[p].find(v);
		if ( it == g[p].end() ) return false;

		ans.push_back({p + 1, v + 1, down.back() + 1});
		g[p].erase(it);
	} else {
		if ( (int)up.size() > 1 ) return false;
		if ( up.empty() ) return true;
		if ( p == -1 ) return false;

		auto it = g[v].find(p);
		if ( it == g[v].end() ) return false;

		ans.push_back({up.back() + 1, v + 1, p + 1});
		g[v].erase(it);
	}

	return true;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m;

	d = vector<vector<int>>(n, vector<int>(0));
	g = vector<set<int>>(n, set<int>());

	int u, v;
	for ( int i = 0; i < m; ++i ) {
		cin >> u >> v;
		u--; v--;

		if ( g[v].find(u) == g[v].end() ) {
			d[u].push_back(v);
			d[v].push_back(u);
		}

		g[u].insert(v);
	}

	used = vector<bool>(n, false);
	ans = {};

	for ( v = 0; v < n; ++v ) {
		if ( used[v] ) continue;

		if ( !dfs(v) ) {
			cout << "No" << endl;
			return 0;
		}
	}

	cout << "Yes" << endl;

	for ( int i = 0; i < ans.size(); ++i )
		cout << get<0>(ans[i]) << " " << get<1>(ans[i]) << " " << get<1>(ans[i]) << " " << get<2>(ans[i]) << "\n";

	return 0;
}