#include <bits/stdc++.h>
using namespace std;

const int INF = 1e9;

int n, m;
vector<vector<int>> g;
vector<vector<int>> t;

vector<int> ans;

vector<tuple<int, int, int>> edges;

class DSU {
public:
	int sz;
	vector<int> parent;
	vector<int> rank;
	vector<vector<int>> children;

	DSU(int _sz) {
		sz = _sz;

		parent = vector<int>(sz); for ( int i = 0; i < sz; ++i ) parent[i] = i;
		rank = vector<int>(sz, 1);
		children = vector<vector<int>>(sz, vector<int>(0));
	}

	int find(int v) {
		if ( parent[v] == v ) return v;

		return find(parent[v]);
	}

	void join(int u, int v) {
		u = find(u); v = find(v);

		if ( u == v ) return;

		if ( rank[u] < rank[v] ) swap(u, v);

		parent[v] = u;
		children[v].push_back(u);

		if ( rank[u] == rank[v] ) rank[u]++;
	}

	void get_children(int v, vector<int> & put) {
		put.push_back(v);

		for ( int to : children[v] ) get_children(to, put);
	}
};

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);

	cin >> n >> m;
	
	g = vector<vector<int>>(n, vector<int>(0));
	t = vector<vector<int>>(n, vector<int>(0));
	ans = vector<int>(n, 0);

	int _u, _v, _t;
	edges = {};

	for ( int i = 0; i < m; ++i ) {
		cin >> _u >> _v >> _t;
		_u--; _v--;

		g[_u].push_back(_v);
		g[_v].push_back(_u);

		t[_u].push_back(_t);
		t[_v].push_back(_t);

		edges.push_back({_t, _u, _v});
	}

	sort(edges.begin(), edges.end());

	DSU dsu(n);

	int u, v, tm;
	int one;

	vector<int> list;

	for ( int i = 0; i < edges.size(); ++i ) {
		tie(tm, u, v) = edges[i];
		u = dsu.find(u); v = dsu.find(v);
		one = dsu.find(0);

		if ( (u != one) && (v != one) ) {
		} else if ( (u == one) && (v == one) ) {
			continue;
		} else if ( u == one ) {
			list = {};
			dsu.get_children(v, list);

			for ( int w : list ) {
				ans[w] = tm;
			}
		} else {
			list = {};

			dsu.get_children(u, list);

			for ( int w : list ) {
				ans[w] = tm;
			}
		}

		dsu.join(u, v);
	}

	for ( int i = 1; i < n; ++i )
		cout << ans[i] << "\n";

	return 0;
}