#include <iostream>

#include <algorithm>

#include <vector>
#include <map>

using namespace std;

typedef long long ll;

vector<vector<pair<int, int>>> g;

vector<int> ans;

map<int, map<int, bool>> used_e;

void dfs(int v, int a, int b) {
	ans[v] = min(ans[v], a + b);
	
	for (auto to : g[v]) {
		if (!used_e[v][to.first]) {
			used_e[v][to.first] = used_e[to.first][v] = true;
			dfs(to.first, min(a, to.second), max(b, to.second));
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false), cin.tie(NULL), cout.tie(NULL);

	int n, m; cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int v, u, c; cin >> v >> u >> c;
		v--; u--;

		g[v].push_back({ u, c });
		g[u].push_back({ v, c });
	}

	ans.assign(n, 2e9);

	dfs(0, 1e9, 0);

	for (int i = 1; i < n; i++) {
		cout << ans[i] << '\n';
	}
	
	return 0;
}