#include <bits/stdc++.h>
using namespace std;

using ll = long long;

const int MAXN = 2e5;

int n, m, timer = 1;
set<int> g[MAXN], nfg[MAXN];
vector<int> tin(MAXN), tout(MAXN);

void dfs(int v, int prev = -1) {
    tin[v] = timer++;

    for (int u : g[v]) {
        if (u == prev) {
            continue;
        }

        dfs(u, v);
    }

    tout[v] = timer++;
}

// v -> u
inline bool is_child(int u, int v) {
    //cerr << v << " -> " << u << ": " << tin[v] << " " << tin[u] << " " << tout[u] << " " << tout[v] << "\n";
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

struct Three {
    int a, b, c;

    Three(int a, int b, int c) : a(a), b(b), c(c) {}
};

vector<Three> ans;
vector<char> used(MAXN);

void mark2_dfs(int v, int prev = -1) {
    used[v] = true;
    if (prev != -1) {
        ans.emplace_back(prev, v, prev);
    }

    for (int u : g[v]) {
        if (u == prev) {
            continue;
        }

        mark2_dfs(u, v);
    }
}

int mark_dfs(int v, int mark, int child, int prev = -1) {
    used[v] == true;

    int cnt = 0;
    for (int u : g[v]) {
        if (u == prev || !is_child(child, u)) {
            if (u != prev) {
                cerr << v << " " << u << " " << prev << " " << child << " " << is_child(child, u) << "\n";
                mark2_dfs(u, v);
            }

            continue;
        }

        if (prev != -1) {
            if (mark) {
                ans.emplace_back(prev, v, u);
            } else {
                ans.emplace_back(u, v, prev);
            }
        }

        cnt = mark_dfs(u, mark ^ 1, child, v);
    }

    return cnt + 1;
}


int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;

        u--;
        v--;

        g[u].insert(v);
        g[v].insert(u);
        nfg[u].insert(v);
    }

    vector<pair<int, int>> empty;
    for (int i = 0; i < n; i++) {
        if (nfg[i].size() != g[i].size()) {
            for (int j : g[i]) {
                if (nfg[i].count(j) == 0) {
                    empty.emplace_back(i, j);
                }
            }
        }
    }

    if (empty.size() == 0) {
        for (int i = 0; i < n; i++) {
            if (!used[i]) {
                mark2_dfs(i);
            }
        }
    } else {
        pair<int, int> a = empty[0];
        pair<int, int> b = empty[1];


        dfs(a.first);
        if (!is_child(b.first, a.second) || !is_child(b.second, a.second)) {
            swap(a, b);
            cerr << "WAS THERE";
            dfs(a.first);

            if (!is_child(b.first, a.second) || !is_child(b.second, a.second)) {
                //exit(-1);
            }
        }

        cerr << a.first << " " << a.second << "\n";
        cerr << b.first << " " << b.second << "\n";


        //dfs(empty.front().first);

        int cnt = mark_dfs(a.first, 1, is_child(b.first, b.second) ? b.first : b.second);
        cerr << cnt << " :" << !is_child(b.first, b.second);

        if ((cnt % 2 == 1 && is_child(b.first, b.second)) || (cnt % 2 == 0 && is_child(b.second, b.first))) {
            cout << "No\n";
            exit(0);
        }

    }

    cout << "Yes\n";
    for (auto& i : ans) {
        cout << (i.a + 1) << " " << (i.b + 1) << " " << (i.b + 1) << " " << (i.c + 1) << "\n";
    }

    return 0;
}
