#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2e5;

struct Edge{
    int u, v, col, num;
    Edge(int up = 0, int vp = 0, int colp = 0, int nump = 0)
    {
        u = up;
        v = vp;
        col = colp;
        num = nump;
    }
};


pair<int, int> dp[MAXN];
vector<int> dp_ans[MAXN];

vector<pair<int, int>> ans;

vector<Edge> gr[MAXN];
vector<int> ugr[MAXN];
int used[MAXN];
int root = 1;
bool cor = true;

void fill()
{
    for (int i = 0; i < MAXN; i++)
        used[i] = 0;
}


void dfs_color(int v, int c)
{
    used[v] = 1;
    for (auto &e : gr[v])
        e.col = c;
    for (auto u : ugr[v])
        if (used[u] == 0)
            dfs_color(u, 1 - c);
}


void dp_dfs(int v, int p)
{
    used[v] = 1;
    for (auto u : ugr[v])
        if (used[u] == 0)
            dp_dfs(u, v);
    int cnt_z = 0, cnt_n = 0;
    vector<int> loc_z, loc_n;
    for (auto &e : gr[v])
    {
        if (e.v != p && e.u != p)
        {
            if (e.col == 0)
            {
                cnt_z++;
                loc_z.push_back(e.num);
            }
            else
            {
                cnt_n++;
                loc_n.push_back(e.num);
            }
        }
    }
    for (auto u : ugr[v])
        if (u != p)
            for (auto e : gr[u])
                if (e.v == v)
                {
                    if (e.col == 0)
                    {
                        cnt_z++;
                        loc_z.push_back(e.num);
                    }
                    else
                    {
                        cnt_n++;
                        loc_n.push_back(e.num);
                    }
                }
    int gl_cnt_z = 0, gl_cnt_n = 0;
    for (auto u : ugr[v])
        if (u != p)
        {
            int need_z = dp[u].second;
            int need_n = dp[u].first;
            cnt_z -= need_z;
            cnt_n -= need_n;
            if (cnt_z < 0 || cnt_n < 0)
                cor = false;
            if (cor && need_n > 0)
                for (auto &nm : dp_ans[u])
                {
                    ans.push_back({nm, loc_n[gl_cnt_n]});
                    gl_cnt_n++;
                }
            else if (cor && need_z > 0)
                for (auto &nm : dp_ans[u])
                {
                    ans.push_back({nm, loc_z[gl_cnt_z]});
                    gl_cnt_z++;
                }
        }
    int mn = min(cnt_z, cnt_n);
    cnt_z -= mn;
    cnt_n -= mn;
    while (gl_cnt_z < loc_z.size() && gl_cnt_n < loc_n.size())
    {
        ans.push_back({loc_z[gl_cnt_z], loc_n[gl_cnt_n]});
        gl_cnt_z++;
        gl_cnt_n++;
    }
    while (gl_cnt_z < loc_z.size())
    {
        dp_ans[v].push_back(loc_z[gl_cnt_z]);
        gl_cnt_z++;
    }
    while (gl_cnt_n < loc_n.size())
    {
        dp_ans[v].push_back(loc_n[gl_cnt_n]);
        gl_cnt_n++;
    }
    dp[v] = {cnt_z, cnt_n};
}


int main()
{
    int n, m; cin >> n >> m;
    vector<Edge> all;
    for (int i = 0; i < m; i++)
    {
        int u, v; cin >> u >> v;
        gr[u].push_back(Edge(u, v, 0, i));
        all.push_back(Edge(u, v, 0, i));
        //gr[v].push_back(Edge(u, v, 0));
        ugr[u].push_back(v);
        ugr[v].push_back(u);
    }

    for (int i = 0; i < MAXN; i++)
    {
        sort(ugr[i].begin(), ugr[i].end());
        ugr[i].erase(unique(ugr[i].begin(), ugr[i].end()), ugr[i].end());
    }

    fill();
    for (int i = 1; i < n + 1; i++)
        if (used[i] == 0)
            dfs_color(i, 0);

    fill();
    for (int i = 1; i < n + 1; i++)
        if (used[i] == 0)
        {
            dp_dfs(i, -1);
            if (dp[i] != make_pair(0, 0))
                cor = false;
        }

    if (cor)
    {
        cout << "Yes" << endl;
        for (int i = 0; i < ans.size(); i++)
        {
            if (all[ans[i].first].v ==  all[ans[i].second].u)
            {
                cout << all[ans[i].first].u << " " << all[ans[i].first].v << " ";
                cout << all[ans[i].second].u << " " << all[ans[i].second].v << " ";
                cout << endl;
            }
            else
            {
                cout << all[ans[i].second].u << " " << all[ans[i].second].v << " ";
                cout << all[ans[i].first].u << " " << all[ans[i].first].v << " ";
                cout << endl;
            }
        }
    }
    else
        cout << "No" << endl;
    return 0;
}
