#include <bits/stdc++.h>
using namespace std;
#define int long long
typedef vector<int> vi;
typedef vector<vi> v2i;
typedef pair<int, int> pii;
typedef vector<pii> vp;
typedef vector<vp> v2p;
const int inf = 2e9, big = 1e9;

struct EdgeInfo {
    int to, t, id;
};
typedef vector<vector<EdgeInfo>> graph;

void dfs_bri(int v, int p, vi& used, graph& g, vi& deep, vi& fup, vi& bri) {
    fup[v] = deep[v];
    for (auto[to, t, id] : g[v]) {
        if (to != p) {
            if (deep[to] == -1) {
                used[id] = 1;
                deep[to] = deep[v] + 1;
                dfs_bri(to, v, used, g, deep, fup, bri);
                fup[v] = min(fup[v], fup[to]);
                if (deep[v] < fup[to])
                    bri[id] = 1;
            }
            else
                fup[v] = min(fup[v], deep[to]);
        }
        else if (!used[id])
            fup[v] = min(fup[v], deep[to]);
    }
}

void dfs_paint(int v, graph& g, vi& bri, vi& color, int p) {
    color[v] = p;
    for (auto[to, t, id] : g[v]) {
        if (color[to] == -1 && !bri[id])
            dfs_paint(to, g, bri, color, p);
    }
}

void dfs(int v, v2p& g, vi& ans, vi& used, int way) {
    used[v] = 1;
    way = min(way, ans[v]);
    ans[v] = way;
    for (auto[to, t] : g[v])
        if (!used[to])
            dfs(to, g, ans, used, min(way, t));
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    graph g(n);
    for (int i = 0; i < m; ++i) {
        int v, u, t;
        cin >> v >> u >> t;
        --v, --u;
        g[v].push_back({u, t, i});
        g[u].push_back({v, t, i});
    }
    vi used(m), deep(n, -1), fup(n), bri(m);
    dfs_bri(0, -1, used, g, deep, fup, bri);
    vi color(n, -1);
    int paint = 0;
    for (int v = 0; v < n; ++v)
        if (color[v] == -1)
            dfs_paint(v, g, bri, color, paint++);
    v2p g2(paint);
    vi comp(paint, inf);
    for (int v = 0; v < n; ++v)
        for (auto[to, t, id] : g[v]) {
            if (color[v] != color[to])
                g2[color[v]].emplace_back(color[to], t);
            else
                comp[color[v]] = min(comp[color[v]], t);
        }
    vi used2(paint);
    dfs(0, g2, comp, used2, inf);
    for (int v = 1; v < n; ++v)
        cout << big + comp[color[v]] << '\n';
}
