#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)2e18 + 10;
const int MOD = (int)1e9 + 7;

vector<pair<pii, pii>> ans;

int dfs(int v, vvi& a, vvi& b, int p, vc& used) {
	used[v] = 1;
	int c1 = 0, c2 = 0;
	vi edg1, edg2;
	for (int u : a[v]) {
		if (u == p)
			c1 = 1;
		if (used[u])
			continue;
		int x = dfs(u, a, b, v, used);
		if (x == 1)
			edg2.pb(u);
		else if (x == -1)
			edg1.pb(u);
	}
	for (int u : b[v]) {
		if (u == p)
			c2 = 1;
		if (used[u])
			continue;
		int x = dfs(u, a, b, v, used);
		if (x == 1)
			edg2.pb(u);
		else if (x == -1)
			edg1.pb(u);
	}
	int x = (int)edg1.size() - (int)edg2.size();
	if (abs(x) > 1) {
		cout << "No";
		exit(0);
	}
	for (int i = 0; i < min(edg1.size(), edg2.size()); ++i)
		ans.pb({ {edg2[i], v}, {v, edg1[i]} });
	if (x == 1) {
		if (!c2) {
			cout << "No";
			exit(0);
		}
		c2 = 0;
		ans.pb({ {p, v}, {v, edg1.back()} });
	}
	if (x == -1) {
		if (!c1) {
			cout << "No";
			exit(0);
		}
		c1 = 0;
		ans.pb({ {edg2.back(), v }, {v, p} });
	}
	if (c1 && c2) {
		ans.pb({ {p, v}, {v, p} });
		return 0;
	}
	if (c1)
		return 1;
	if (c2)
		return -1;
	return 0;
}

void solve() {

	int n, m;
	cin >> n >> m;
	if (m == 0)
		return;
	vvi a(n);
	vvi b(n);
	for (int i = 0; i < m; ++i) {
		int u, v;
		cin >> u >> v;
		--u; --v;
		a[u].pb(v);
		b[v].pb(u);
	}
	vc used(n);
	for (int i = 0; i < n; ++i) {
		if (!used[i])
			dfs(i, a, b, -1, used);
	}
	cout << "Yes\n";
	for (int i = 0; i < m / 2; ++i)
		cout << ans[i].first.first + 1 << ' ' << ans[i].first.second + 1 << ' '\
		<< ans[i].second.first + 1 << ' ' << ans[i].second.second + 1 << endl;

	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	solve();

	return 0;
}