#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>

#define sqr(x) ((x) * (x))
#define mp make_pair
#define pb push_back
#define endl '\n'
//#define int ll

#pragma warning (disable : 4996)

using namespace std;

typedef long double ld;
typedef long long ll;
typedef pair<int, int> pii;
typedef vector<pii> vii;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<char> vc;

const ld EPS = 1e-8;
const int N = (int)1e5 + 10;
const int INF = (int)2e9 + 10;
const int MOD = (int)1e9 + 7;

int input() {
	int x = 0;
	char c = ' ';
	while (!isdigit(c))
		c = _getchar_nolock();
	while (isdigit(c)) {
		x = x * 10 + (c - '0');
		c = _getchar_nolock();
	}
	return x;
}

void print(int x) {
	for (char c : to_string(x))
		_putchar_nolock(c);
	_putchar_nolock(endl);
	return;
}

void dfs(int v, vector<vii>& g, vi& ans, vi& m, int p = -1, int mn = INF) {
	mn = min(mn, m[v]);
	ans[v] = mn;
	for (int i = 0; i < g[v].size(); ++i) {
		int u = g[v][i].first, t = g[v][i].second;
		if (u == p)
			continue;
		dfs(u, g, ans, m, v, min(mn, t));
	}
	return;
}

void dfs1(int v, vector<vii>& a, vc& used, vi& up, vi& d, set<pii>& ed, int p = -1) {
	if (p == -1)
		d[v] = 0;
	else
		d[v] = d[p] + 1;
	used[v] = 1;
	up[v] = d[v];
	bool f = 1;
	for (int i = 0; i < a[v].size(); ++i) {
		int u = a[v][i].first;
		if (u == p && f) {
			f = 0;
			continue;
		}
		if (!used[u]) {
			dfs1(u, a, used, up, d, ed, v);
			up[v] = min(up[v], up[u]);
		}
		else
			up[v] = min(up[v], d[u]);
	}
	if (p != -1 && up[v] == d[v])
		ed.insert({ p, v });
	return;
}

void dfs2(int v, vector<vii>& a, vc& used, set<pii>& ed, vi& c, int col) {
	used[v] = 1;
	c[v] = col;
	for (int i = 0; i < a[v].size(); ++i) {
		int u = a[v][i].first;
		if (used[u] || ed.find({ v, u }) != ed.end() || ed.find({ u, v }) != ed.end())
			continue;
		dfs2(u, a, used, ed, c, col);
	}
	return;
}

void sep(int n, vector<vii>& a, vi& c, vi& mn, vector<vii>& g) {
	vi up(n);
	set<pii> ed;
	vc used(n);
	vi d(n);
	dfs1(0, a, used, up, d, ed);
	used = vc(n);
	int k = 0;
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs2(i, a, used, ed, c, k);
			++k;
		}
	}
	g.resize(k);
	mn = vi(k, INF);
	for (int v = 0; v < n; ++v) {
		for (int i = 0; i < a[v].size(); ++i) {
			int u = a[v][i].first, t = a[v][i].second;
			if (c[v] == c[u])
				mn[c[v]] = min(mn[c[v]], t);
			else
				g[c[v]].pb({ c[u], t });
		}
	}
	return;
}

void solve() {
	int n = input(), m = input();
	vector<vii> a(n);
	for (int i = 0; i < m; ++i) {
		int u = input(), v = input(), t = input();
		--u; --v;
		a[u].pb({ v, t });
		a[v].pb({ u, t });
	}
	vi c(n), mn;
	vector<vii> g;
	sep(n, a, c, mn, g);
	vi ans(mn.size());
	dfs(0, g, ans, mn);
	for (int i = 1; i < n; ++i)
		print(ans[c[i]] + (int)1e9);

	return;
}

signed main() {
#ifdef LOCAL
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	solve();

	return 0;
}