﻿#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

const int INF = 1e9;

void dfsg1(int v, vector<int>& used, vector<pair<int, int>>& dp, vector<vector<pair<int, int>>>& g) {
	used[v] = 1;
	for (auto i : g[v]) {
		if (!used[i.first]) {
			dp[i.first].first = min(dp[v].first, i.second);
			dp[i.first].second = max(dp[v].second, i.second);
			dfsg1(i.first, used, dp, g);
		}
	}
}

void solg1(int n, int m) {
	int u, v, t;
	vector<vector<pair<int, int>>> g(n);
	vector<int> used(n, 0);
	vector<pair<int, int>> dp(n);
	dp[0] = make_pair(INF, 0);
	for (int i = 0; i < m; ++i) {
		cin >> u >> v >> t;
		--u;
		--v;
		g[u].emplace_back(v, t);
		g[v].emplace_back(u, t);
	}
	dfsg1(0, used, dp, g);
	for (int i = 1; i < n; ++i) {
		cout << dp[i].first + dp[i].second << '\n';
	}
}

struct edgeg2 {
	int u, v, t;

	edgeg2() = default;
	edgeg2(int u, int v, int t) : u(u - 1), v(v - 1), t(t) {}

	bool operator<(const edgeg2& other) const {
		return t < other.t;
	}
};

int get_parent(int v, vector<int>& p, vector<int>& val) {
	if (p[v] == v) {
		return v;
	}
	p[v] = get_parent(p[v], p, val);
	if (val[v] == -1) {
		val[v] = val[p[v]];
	}
	return p[v];
}

void solg2(int n, int m) {
	int u, v;
	vector<edgeg2> e(m);
	for (int i = 0; i < m; ++i) {
		cin >> e[i].u >> e[i].v >> e[i].t;
	}
	sort(e.begin(), e.end());
	vector<int> p(n), val(n, -1);
	for (int i = 0; i < n; ++i) {
		p[i] = i;
	}
	for (edgeg2& i : e) {
		u = get_parent(i.u, p, val);
		v = get_parent(i.v, p, val);
		if (u == v) {
			continue;
		}
		if (u == 0) {
			val[v] = i.t;
			p[v] = u;
		}
		else if (v == 0) {
			val[u] = i.t;
			p[u] = v;
		}
		else {
			p[u] = v;
		}
	}
	for (int i = 1; i < n; ++i) {
		get_parent(i, p, val);
		cout << val[i] << '\n';
	}
}

int main() {
	int n, m;
	cin >> n >> m;
	if (m == n - 1) {
		solg1(n, m);
	}
	else {
		solg2(n, m);
	}
	return 0;
}
