#include <bits/stdc++.h>

using namespace std;

vector< vector<int> > adjf;
vector< vector< tuple<int, bool, bool> > > adj;
vector<int> height;
vector< tuple<int, bool*, bool*> > parent;
vector<bool> used;

void dfs(int u, int p, int h) {
	used[u] = true;
	height[u] = h;
	for(auto& [v, down, up]: adj[u]) {
		if(v == p) {
			v = -1;
			down = false;
			up = false;
			continue;
		}
		dfs(v, u, h + 1);
		parent[v] = {u, &down, &up};
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n, m;
	cin >> n >> m;

	adjf.resize(n);
	adj.resize(n);
	for(int i = 0; i < m; i++) {
		int u, v;
		cin >> u >> v;
		u--; v--;
		adjf[u].push_back(v);
		adj[u].emplace_back(v, false, false);
		adj[v].emplace_back(u, false, false);
	}
	for(int u = 0; u < n; u++) {
		sort(adjf[u].begin(), adjf[u].end());
		sort(adj[u].begin(), adj[u].end());
		adj[u].erase(unique(adj[u].begin(), adj[u].end()), adj[u].end());
	}
	for(int u = 0; u < n; u++) {
		for(auto& [v, down, up]: adj[u]) {
			auto it = lower_bound(adjf[u].begin(), adjf[u].end(), v);
			if(it != adjf[u].end() && *it == v) {
				down = true;
			}
			it = lower_bound(adjf[v].begin(), adjf[v].end(), u);
			if(it != adjf[v].end() && *it == u) {
				up = true;
			}
		}
	}

	height.resize(n);
	bool rootfalse = false;
	parent.resize(n, {-1, &rootfalse, &rootfalse});
	used.resize(n);
	for(int u = 0; u < n; u++) {
		if(!used[u]) {
			dfs(u, -1, 0);
		}
	}

	vector<int> byheight(n);
	iota(byheight.begin(), byheight.end(), 0);
	sort(byheight.begin(), byheight.end(), [&](int i, int j) {
		return height[i] > height[j];
	});

	vector< tuple<int, int, int, int> > ans;
	for(int u: byheight) {
		// cerr << "u=" << u + 1 << endl;
		if(height[u] == 0) {
			continue;
		}
		auto [p, pdown, pup] = parent[u];
		auto& down = *pdown;
		auto& up = *pup;
		// cerr << p + 1 << (down && up ? " <-> " : (down ? " -> " : (up ? " <- " : " . "))) << u + 1 << endl;
		if(down && up) {
			down = false;
			up = false;
			// cerr << "self" << endl;
			ans.emplace_back(p, u, u, p);
		} else if(down) {
			for(auto& [v, vdown, vup]: adj[p]) {
				if(vup) {
					// cerr << "via " << v + 1 << endl;
					ans.emplace_back(p, u, v, p);
					vup = false;
					down = false;
					break;
				}
			}
			if(down) {
				if(*get<1>(parent[p])) {
					// cerr << "via parent" << endl;
					ans.emplace_back(get<0>(parent[p]), p, p, u);
					*get<1>(parent[p]) = false;
					down = false;
				}
				if(down) {
					cout << "No" << endl;
					return 0;
				}
			}
		} else if(up) {
			for(auto& [v, vdown, vup]: adj[p]) {
				if(vdown) {
					// cerr << "via " << v + 1 << endl;
					ans.emplace_back(u, p, p, v);
					vdown = false;
					up = false;
					break;
				}
			}
			if(up) {
				if(*get<2>(parent[p])) {
					// cerr << "via parent" << endl;
					ans.emplace_back(p, get<0>(parent[p]), u, p);
					*get<2>(parent[p]) = false;
					up = false;
				}
				if(up) {
					cout << "No" << endl;
					return 0;
				}
			}
		}
	}

	cout << "Yes" << endl;
	for(auto [a, b, c, d]: ans) {
		cout << a + 1 << " " << b + 1 << " " << c + 1 << " " << d + 1 << "\n";
	}

	return 0;
}