#include <bits/stdc++.h>

using namespace std;

const int INF = 1000000000;


int n, m;


class DSU {
public:
	vector< vector<int> > items;
	vector<int> parent;
	vector<int> mint;

	DSU() {
	}
	DSU(int n) {
		resize(n);
	}

	void resize(int n) {
		items.resize(n);
		parent.resize(n);
		for(int i = 0; i < n; i++) {
			items[i].push_back(i);
			parent[i] = i;
		}
		mint.resize(n, INF);
	}

	int get(int i) {
		return i == parent[i] ? i : parent[i] = get(parent[i]);
	}

	void unite(int u, int v) {
		u = get(u);
		v = get(v);
		assert(u != v);
		if(items[u].size() > items[v].size()) {
			swap(u, v);
		}
		for(int x: items[u]) {
			parent[x] = v;
			items[v].push_back(x);
		}
		items[u].clear();
		mint[v] = min(mint[u], mint[v]);
	}
};


vector< vector< tuple<int, int, int> > > adj;
DSU dsu_conn;
DSU dsu_scc;

vector<int> ans;
int curmax;
vector< vector<int> > adjscc;
vector<int> sccparent;

int lca(int u, int v) {
	if(u == v) {
		return u;
	}
	set<int> uoof, voof;
	uoof.insert(u);
	voof.insert(v);
	while(true) {
		// cerr << "u=" << u << ", v=" << v << endl;
		if(u != -1) {
			u = sccparent[u];
			uoof.insert(u);
			if(voof.count(u)) {
				return u;
			}
		}
		if(v != -1) {
			v = sccparent[v];
			voof.insert(v);
			if(uoof.count(v)) {
				return v;
			}
		}
	}
}

void add_edge(int u, int v, int i, int t) {
	if(dsu_scc.get(u) == dsu_scc.get(v)) {
		return;
	}

	if(dsu_conn.get(u) != dsu_conn.get(0)) {
		swap(u, v);
	}
	assert(dsu_conn.get(u) == dsu_conn.get(0));

	if(dsu_conn.get(v) == dsu_conn.get(0)) {
		int u1 = dsu_scc.get(u);
		int v1 = dsu_scc.get(v);
		int u0 = u1;
		int v0 = v1;
		int u1bot = -1;
		int v1bot = -1;
		int w1 = lca(u1, v1);
		assert(w1 != -1);
		while(u1 != w1 && u1 != v0) {
			for(int x: adjscc[u1]) {
				sccparent[x] = w1;
			}
			// cerr << "scc " << u1 << " " << w1 << endl;
			dsu_scc.unite(u1, w1);
			u1 = sccparent[u1];
		}
		while(v1 != w1 && v1 != u0) {
			for(int x: adjscc[v1]) {
				sccparent[x] = w1;
			}
			// cerr << "scc " << v1 << " " << w1 << endl;
			dsu_scc.unite(v1, w1);
			v1 = sccparent[v1];
		}
		dsu_scc.mint[dsu_scc.get(w1)] = min(dsu_scc.mint[dsu_scc.get(w1)], t);
	} else {
		dsu_conn.unite(u, v);
		int u1 = dsu_scc.get(u);
		dsu_scc.mint[v] = t;
		adjscc[u1].push_back(v);
		sccparent[v] = u1;
		// cerr << "par " << v << " " << u1 << endl;
	}

	for(int i = 1; i < n; i++) {
		if(dsu_conn.get(i) == dsu_conn.get(0)) {
			int curmin = INF;
			int v = dsu_scc.get(i);
			// cerr << v << " need " << dsu_scc.get(0) << endl;
			while(v != dsu_scc.get(0)) {
				curmin = min(curmin, dsu_scc.mint[v]);
				// cerr << v << endl;
				if(v == -1) {
					exit(0);
				}
				v = sccparent[v];
			}
			// cerr << endl;
			curmin = min(curmin, dsu_scc.mint[dsu_scc.get(0)]);
			ans[i] = min(ans[i], curmax + curmin);
		}
	}
}

vector<bool> was_added;
void dfs100(int u) {
	for(auto [v, e, t]: adj[u]) {
		if(!was_added[e]) {
			was_added[e] = true;
			add_edge(u, v, e, t);
			dfs100(v);
		}
	}
}


signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	cin >> n >> m;

	vector< vector< tuple<int, int, int> > > adj1(n);
	vector< tuple<int, int, int, int> > weights;
	for(int i = 0; i < m; i++) {
		int u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		adj1[u].emplace_back(v, i, t);
		adj1[v].emplace_back(u, i, t);
		weights.emplace_back(t, u, v, i);
	}
	sort(weights.begin(), weights.end());


	ans.resize(n, INF * 2);

	adj.resize(n);

	dsu_conn.resize(n);
	dsu_scc.resize(n);

	was_added.resize(m);

	adjscc.resize(n);
	sccparent.resize(n, -1);

	for(auto [t, u, v, i]: weights) {
		curmax = t;

		adj[u].emplace_back(v, i, t);
		adj[v].emplace_back(u, i, t);

		int u1 = dsu_conn.get(u);
		int v1 = dsu_conn.get(v);
		if(v1 == dsu_conn.get(0)) {
			if(u1 == v1) {
				was_added[i] = true;
				add_edge(u, v, i, t);
				continue;
			}
			swap(u1, v1);
			swap(u, v);
		}
		if(u1 == dsu_conn.get(0)) {
			dfs100(u);
		}
	}

	for(int i = 1; i < n; i++) {
		cout << ans[i] << "\n";
	}

	return 0;
}