#pragma GCC optimize("Ofast")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <algorithm>
#include <math.h>
#include <vector>
#include <string>
#include <map>

using namespace std;

typedef int ll;

const ll N = 3e5 + 10;
const ll inf = 2e9 + 100;

vector <ll> e[N];
pair <pair <ll, ll>, ll> edge[N];
ll ans[N];
bool used[2 * N];
ll t = 0;

void dfs(ll x, ll p, ll mi, ll ma) {
	t++;
	if (t > 5e7) {
		return;
	}
	ans[x] = min(mi + ma, ans[x]);
	for (ll i = 0; i < e[x].size(); i++) {
		if (used[e[x][i]] || used[e[x][i] ^ 1]) {
			continue;
		}
		ll k = e[x][i];
		used[k] = 1;
		dfs(edge[k].first.second, x, min(mi, edge[k].second), max(ma, edge[k].second));
		if (t > 5e7) {
			return;
		}
		used[k] = 0;
	}
}


vector <pair <ll, ll>> e1[N];

void dfs1(ll x, ll p, ll mi, ll ma) {
	ans[x] = mi + ma;
	for (ll i = 0; i < e1[x].size(); i++) {
		if (p == e1[x][i].first) {
			continue;
		}
		dfs1(e1[x][i].first, x, min(mi, e1[x][i].second), max(ma, e1[x][i].second));
	}
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#endif
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	ll n, m;
	cin >> n >> m;
	for (ll i = 0; i < m; i++) {
		ll a, b, c; cin >> a >> b >> c;
		a--; b--;
		e[a].push_back(2 * i);
		e[b].push_back(2 * i + 1);
		e1[a].push_back(make_pair(b, c));
		e1[b].push_back(make_pair(a, c));
		edge[2 * i] = make_pair(make_pair(a, b), c);
		edge[2 * i + 1] = make_pair(make_pair(b, a), c);
	}
	if (m == n - 1) {
		dfs1(0, 0, inf, -inf);
		for (ll i = 1; i < n; i++) {
			cout << ans[i] << '\n';
		}
		return 0;
	}
	for (ll i = 0; i < n; i++) {
		ans[i] = inf;
	}
	dfs(0, 0, inf, -inf);
	for (ll i = 1; i < n; i++) {
		cout << ans[i] << '\n';
	}
}