#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const int N = 10005;

int n, q;
int x[N], h[N];
int pl[N], pr[N];
bool used[N];

int get_l(int v) {
    vector<int> way;
    while (v != pl[v]) {
        way.push_back(v);
        v = pl[v];
    }
    for (int u : way) pl[u] = v;
    return v;
}

int get_r(int v) {
    vector<int> way;
    while (v != pr[v]) {
        way.push_back(v);
        v = pr[v];
    }
    for (int u : way) pr[u] = v;
    return v;
}

void kill(int v) {
    pl[v] = v - 1, pr[v] = v + 1;
}

int solve(int l, int r) {
    for (int i = l - 1; i <= r + 1; ++i) {
        used[i] = false;
        pl[i] = pr[i] = i;
    }
    auto can_l = [&](int i) {
        if (x[i] - h[i] < x[1]) return false;
        int pp = get_l(i - 1);
        return pp == 0 || x[i] - h[i] >= x[pp];
    };
    auto can_r = [&](int i) {
        if (x[i] + h[i] > x[n]) return false;
        int pp = get_r(i + 1);
        return pp == n + 1 || x[i] + h[i] <= x[pp];
    };
    auto can = [&](int i) {
        return (can_l(i) || can_r(i));
    };
    queue<int> q;
    for (int i = l; i <= r; ++i) {
        if (can(i)) {
            used[i] = true;
            q.push(i);
        }
    }
    int ret = 0;
    while (!q.empty()) {
        int id = q.front();
        q.pop();
        ++ret;
        kill(id);
        int id_l = get_l(id);
        if (!used[id_l] && id_l >= l && can_r(id_l)) {
            used[id_l] = true;
            q.push(id_l);
        }
        int id_r = get_r(id);
        if (!used[id_r] && id_r <= r && can_l(id_r)) {
            used[id_r] = true;
            q.push(id_r);
        }
    }
    return ret;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> q;
    for (int i = 1; i <= n; ++i) cin >> x[i] >> h[i];
    while (q--) {
        int l, r;
        cin >> l >> r;
        cout << solve(l, r) << '\n';
    }
    return 0;
}
