#include <bits/stdc++.h>
using namespace std;

typedef long long ll;

const int T = 1e9;
const int N = 3e5 + 7;

int n, glob_m;
vector<pair<int, int>> g[N];
struct Edge {
    int u, v, t;
} glob_e[N];
bool bad[N];
int tin[N], fup[N], tt = 0;
bool vis[N];
int cmp[N], min_edge[N];
int cnt_cmp;
int mn[N];
int ans[N];
vector<pair<int, int>> srt;

void dfs(int v, int par = -1) {
    fup[v] = tin[v] = tt++;
    vis[v] = true;
    for (auto x : g[v]) {
        if (par == x.second) continue;
        int u = x.first;
        if (vis[u]) {
            fup[v] = min(fup[v], tin[u]);
        } else {
            dfs(u, x.second);
            fup[v] = min(fup[v], fup[u]);
            if (tin[v] < fup[u]) bad[x.second] = true;
        }
    }
}

void zhfs(int v, int cur_cmp) {
    cmp[v] = cur_cmp;
    vis[v] = true;
    for (auto x : g[v]) {
        if (bad[x.second]) continue;
        if (!vis[x.first]) zhfs(x.first, cur_cmp);
    }
}

void dfs_mn(int v, int par = -1) {
    vis[v] = true;
    mn[v] = min(mn[v], min_edge[v]);
    for (auto x : g[v]) {
        int u = x.first;
        if (u != par) {
            mn[u] = min(mn[u], mn[v]);
            mn[u] = min(mn[u], x.second);
            dfs_mn(u, v);
        }
    }
}

void go(vector<Edge> e, int add) {
    int m = e.size();
    for (int i = 0; i < n; ++i) {
        vis[i] = false;
        g[i] = {};
    }
    for (int i = 0; i < m; ++i) {
        bad[i] = false;
        g[e[i].u].push_back({e[i].v, i});
        g[e[i].v].push_back({e[i].u, i});
    }
    tt = 0;
    for (int i = 0; i < n; ++i) {
        if (!vis[i]) dfs(i);
    }
    for (int i = 0; i < n; ++i) vis[i] = false;
    cnt_cmp = 0;
    for (int i = 0; i < n; ++i) {
        if (!vis[i]) zhfs(i, cnt_cmp++);
    }
    for (int i = 0; i < cnt_cmp; ++i) {
        min_edge[i] = T;
        g[i] = {};
        mn[i] = T;
    }
    for (int i = 0; i < m; ++i) {
        if (!bad[i]) {
            min_edge[cmp[e[i].u]] = min(min_edge[cmp[e[i].u]], e[i].t);
        } else {
            g[cmp[e[i].u]].push_back({cmp[e[i].v], e[i].t});
            g[cmp[e[i].v]].push_back({cmp[e[i].u], e[i].t});
        }
    }
    for (int i = 0; i < cnt_cmp; ++i) vis[i] = false;
    dfs_mn(cmp[0]);
    for (int i = 1; i < n; ++i) {
        if (vis[cmp[i]]) ans[i] = min(ans[i], mn[cmp[i]] + add);
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n >> glob_m;
    for (int i = 0; i < glob_m; ++i) {
        cin >> glob_e[i].u >> glob_e[i].v >> glob_e[i].t;
        --glob_e[i].u, --glob_e[i].v;
        srt.push_back({glob_e[i].t, i});
    }
    sort(srt.begin(), srt.end());
    for (int i = 1; i < n; ++i) ans[i] = 2 * T;
    vector<Edge> e;
    for (int i = 0; i < srt.size(); ++i) {
        e.push_back(glob_e[srt[i].second]);
        go(e, srt[i].first);
    }
    for (int i = 1; i < n; ++i) cout << ans[i] << '\n';
    cout << endl;
    return 0;
}
