#include<bits/stdc++.h>

using std::cin;
using std::cout;
using std::cerr;
using std::vector;
using std::pair;
using std::string;

using ll = long long;
using ld = long double;

const int INF = 2e9;

vector<vector<pair<int, int>>> g;
vector<int> ans;

void dfs (int u, pair<int, int> cur = {-INF, INF}, int p = -1) {
	ans[u] = cur.first + cur.second;
	for (auto pr : g[u]) {
		int v = pr.first;
		int t = pr.second;
		if (v != p) {
			dfs(v, (pair<int, int>){std::max(cur.first, t), std::min(cur.second, t)}, u);
		}
	}
}

vector<int> p;

int getRoot (int v) {
	return (p[v] == -1 ? v : p[v] = getRoot(p[v]));
}

bool unite (int v, int u) {
	v = getRoot(v), u = getRoot(u);
	if (v == u)
		return false;
	p[v] = u;
	return true;
}

int main() {
	std::ios_base::sync_with_stdio(false);
	cin.tie(0), cout.tie(0);

	int n, m;
	cin >> n >> m;
	g.resize(n), ans.resize(n);

	vector<pair<int, pair<int, int>>> edges(m);
	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		--u, --v;
		edges[i] = {t, {u, v}};
	}

	std::sort(edges.begin(), edges.end(), [](auto a, auto b){
		return a > b;
	});

	p.resize(n, -1);
	for (auto edge : edges) {
		int u, v, t;
		std::tie(u, v) = edge.second;
		t = edge.first;
		if (unite(u, v)) {
			g[u].push_back({v, t});
			g[v].push_back({u, t});
		}
	}

	// for (int i = 0; i < m; ++i) {
	// 	int u, v, t;
	// 	cin >> u >> v >> t;
	// 	--u, --v;
	// 	g[u].push_back({v, t});
	// 	g[v].push_back({u, t});
	// }

	dfs(0);
	for (int i = 1; i < n; ++i)
		cout << ans[i] << ' ';



	return 0;
}