#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>;
using namespace std;

const int M = 3001;


int getr(int v, int n, vector<int>& rm, vector<bool>& used) {
	if (v == -1)
		return -1;
	if (used[v])
		return v;
	if (v == n - 1 || rm[v] == -1)
		return -1;
	return rm[v] = getr(rm[v], n, rm, used);
}
int getl(int v, int n, vector<int>& lm, vector<bool>& used) {
	if (v == -1)
		return -1;
	if (used[v])
		return v;
	if (v == 0 || lm[v] == -1)
		return -1;
	return lm[v] = getl(lm[v], n, lm, used);
}

void solve() {
	int n, q1;
	cin >> n >> q1;
	vector<int>x(n);
	vector<int>h(n);
	for (int i = 0; i < n; i++)
		cin >> x[i] >> h[i];
	vector<bool>used(n);
	vector<int>lm(n), rm(n);
	for (int i = 0; i < q1; i++) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		queue<int>q;
		int res = 0;
		for (int i = 0; i < n; i++) {
			used[i] = 1;
			if (i > 0)
				lm[i] = i - 1;
			if (i < n - 1)
				rm[i] = i + 1;
		}
		for (int y = l; y <= r; y++) {
			if (y == 0) {
				int rg = x[n - 1];
				if (n > 1)
					rg = x[y + 1];
				if (x[0] + h[0] <= rg) {
					q.push(0);
					used[0] = 0;
					res++;
				}
				continue;
			}
			if (y == n - 1) {
				if (x[n - 1] - h[n - 1] >= x[n - 2]) {
					q.push(n - 1);
					used[n - 1] = 0;
					res++;
				}
				continue;
			}
			if (x[y] + h[y] <= x[y + 1] || x[y] - h[y] >= x[y - 1]) {
				q.push(y);
				used[y] = 0;
				res++;
			}
		}
		while (q.size()) {
			int v = q.front();
			q.pop();
			int rt = getr(rm[v], n, rm, used);
			int lt = getl(lm[v], n, lm, used);
			if (rt == -1 && lt == -1)
				continue;
			int rg = x[n - 1];
			int lg = x[0];
			if (rt != -1)
				rg = x[rt];
			if (lt != -1)
				lg = x[lt];
			if (rt != -1 && rt <= r) {
				lm[rt] = lt;
				if (x[rt] - h[rt] >= lg) {
					res++;
					q.push(rt);
					used[rt] = 0;
				}
			}
			if (lt != -1 && lt >= l) {
				rm[lt] = rt;
				if (x[lt] + h[lt] <= rg) {
					res++;
					q.push(lt);
					used[lt] = 0;
				}
			}
		}
		cout << res << '\n';
	}
}
int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 

	int t;
	//cin >> t;
	t = 1;
	while (t) {

		t--;
		solve();
	}
}