#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <queue>;
using namespace std;

const int M = 2000;

int pos[300001];
int ans[300001];
int get(int v) {
	if (pos[v] == v)
		return v;
	return pos[v] = get(pos[v]);
}

void unite(int v, int u) {
	v = get(v);
	u = get(u);
	if (v == u)
		return;
	pos[v] = u;
}
vector<pair<int, int>>all[300001];
void dfs(int v,int p) {
	for (auto c : all[v]) {
		if (c.first == p)
			continue;
		ans[c.first] = c.second;
		dfs(c.first, v);
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector < pair<int, pair<int, int>>>w(m);
	for (int i = 0; i < m; i++) {
		int a, b, c;
		cin >> a >> b >> c;
		a--;
		b--;
		w.push_back({ c,{a,b} });
		all[a].push_back({ b,c });
		all[b].push_back({ a,c });
	}
	sort(begin(w), end(w));
	for (int i = 0; i < n; i++)
		pos[i] = i;
	for (int i = 0; i < m; i++) {
		int v = w[i].second.first;
		int u = w[i].second.second;
		unite(v, u);
	}
	dfs(0, -1);
	for (int i = 1; i < n; i++)
		cout << ans[i] << '\n';
}


int main()
{
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 

	int t;
	//cin >> t;
	t = 1;
	while (t) {

		t--;
		solve();
	}
}