#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <set>
#include <map>

using namespace std;

#define ll long long
#define int ll

#define pii pair<int, int>
#define vi vector<int>
#define vpii vector<pii>
#define vvi vector<vi>

const int N = 5005;
const ll INF = 1e18;

vi x(N), h(N);
vi vis(N, 0);

void solve() {

	int n, t; cin >> n >> t;
	for (int i = 0; i < n; ++i) {
		cin >> x[i] >> h[i];
	}

	while (t--) {
		int l, r; cin >> l >> r;
		--l, --r;
		set<int> a;
		for (int i = 0; i < n; ++i) {
			a.insert(i);
		}
		queue<int> q;
		for (int i = l; i <= r; ++i) {
			if (i && x[i] - h[i] >= x[i - 1]) {
				q.push(i);
				a.erase(i);
				vis[i] = 1;
			}
			else if (i != n - 1 && x[i] + h[i] <= x[i + 1]) {
				vis[i] = 1;
				q.push(i);
				a.erase(i);
			}
		}
		vis = vi(n, 0);
		int ans = 0;
		while (q.size()) {
			++ans;
			int v = q.front();
			q.pop();

			auto lid = a.lower_bound(v);
			int la = 0;
			if (lid != a.begin()) {
				la = *--lid;
			}
			auto rid = a.upper_bound(v);
			int ra = n - 1;
			if (rid != a.end()) {
				ra = *rid;
			}

			if (la >= l && !vis[la] && x[la] + h[la] <= x[ra]) {
				q.push(la);
				a.erase(la);
				vis[la] = 1;
			}
			if (ra <= r && !vis[ra] && x[ra] - h[ra] >= x[la]) {
				q.push(ra);
				a.erase(ra);
				vis[ra] = 1;
			}
		}
		cout << ans << '\n';
	}

}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);
	int t = 1; //cin >> t;
	while (t--) {
		solve();
	}
}

/*

C

3 3
1 3
3 1
4 2
1 1
2 3
1 3

D
3 3
1 2 2
1 3 1
2 3 1

4 4
1 2 2
3 2 0
2 4 3
4 3 1


*/