#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>

using namespace std;

#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

const int N = 1.5e5 + 228;

vector<pair<int, int>> G[N];

vector<array<int, 4>> ans;
pair<int, int> dp[N];
bool used[N];

void dfs(int v, int p) {
	used[v] = 1;
	array<vector<int>, 3> tmp;
	for (auto [i, t] : G[v]) {
		if (i == p)
			continue;
		dfs(i, v);
		if (dp[i].first == 1) {
			if (t == 1) {
				cout << "No\n";
				exit(0);
			} else if (t == 0) {
				ans.push_back({dp[i].second + 1, i + 1, i + 1, v + 1});
			} else if (t == 2) {
				ans.push_back({dp[i].second + 1, i + 1, i + 1, v + 1});
				tmp[2].push_back(i);
			}
		} else if (dp[i].first == 2) {
			if (t == 1) {
				ans.push_back({v + 1, i + 1, i + 1, dp[i].second + 1});
			} else if (t == 0) {
				cout << "No\n";
				exit(0);
			} else if (t == 2) {
				ans.push_back({v + 1, i + 1, i + 1, dp[i].second + 1});
				tmp[1].push_back(i);
			}
		} else if (dp[i].first == 0) {
			if (t == 2) {
				ans.push_back({v + 1, i + 1, i + 1, v + 1});
			} else if (t == 1) {
				tmp[2].push_back(i);
			} else if (t == 0) {
				tmp[1].push_back(i);
			}
		}
	}
	while (tmp[1].size() && tmp[2].size()) {
		ans.push_back({tmp[1].back() + 1, v + 1, v + 1, tmp[2].back() + 1});
		tmp[1].pop_back();
		tmp[2].pop_back();
	}
	if (tmp[1].size() > 1 || tmp[2].size() > 1) {
		cout << "No\n";
		exit(0);
	} else if (tmp[1].size()) {
		dp[v] = {1, tmp[1].back()};
	} else if (tmp[2].size()) {
		dp[v] = {2, tmp[2].back()};
	} else {
		dp[v] = {0, -1};
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m;
	set<pair<int, int>> e;
	for (int i = 0; i < m; ++i) {
		int a, b;
		cin >> a >> b;
		e.emplace(a - 1, b - 1);
	}
	for (auto i : e) {
		if (e.count(make_pair(i.second, i.first))) {
			G[i.first].emplace_back(i.second, 2);
		} else {
			G[i.first].emplace_back(i.second, 1);
			G[i.second].emplace_back(i.first, 0);
		}
	}
	for (int i = 0; i < n; ++i) {
		if (!used[i]) {
			dfs(i, i);
			if (dp[i].first != 0) {
				cout << "No\n";
				return 0;
			}
		}
	}
	if (ans.size() != m / 2) {
		return 1;
	}
	cout << "Yes\n";
	for (auto i : ans)
		cout << i[0] << ' ' << i[1] << ' ' << i[2] << ' ' << i[3] << '\n';
}