#include <iostream>
#include <vector>
#include <algorithm>
#include <stack>
#include <unordered_map>

using namespace std;

const long long int MAX = 1500000000000000001;

unordered_map<char, long long int> alphabet;
void init() {
	char ch = 'A';
	long long int now = 1;
	bool x5 = true;
	while (ch <= 'Z') {
		alphabet[ch] = now;
		ch++;
		if (x5) now *= 5;
		else now *= 2;
		x5 = !x5;
	}
}

long long int calc(string& s, char change) {
	long long int answ = 0;
	vector<int> first_larger(s.size());
	stack<int> help;
	for (int i = s.size() - 1; i >= 0; i--) {
		while (!help.empty()) {
			char a = s[i];
			char b = s[help.top()];
			if (a == '?') a = change;
			if (b == '?') b = change;
			if (a < b) break;
			help.pop();
		}
		if (help.empty()) first_larger[i] = -1;
		else first_larger[i] = help.top();
		help.push(i);
	}
	for (int i = 0; i < s.size(); i++) {
		char a = s[i];
		if (a == '?') a = change;
		if (first_larger[i] != -1) answ -= alphabet[a];
		else answ += alphabet[a];
	}
	return answ;
}

void solve() {
	string line;
	cin >> line;
	char best_ch = 'A';
	long long int answ = calc(line, 'A');
	for (char ch = 'B'; ch <= 'Z'; ch++) {
		long long int now = calc(line, ch);
		if (now > answ) {
			answ = now;
			best_ch = ch;
		}
	}
	cout << answ << endl;
	for (auto& elem : line) {
		if (elem == '?') cout << best_ch;
		else cout << elem;
	}
	cout << endl;
}

int main() {
	init();
	int t;
	cin >> t;
	for (int i = 0; i < t; i++) solve();
}