#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <cassert>
#include <cmath>
#include <cstring>

using namespace std;

#define int long long
#define fi first
#define se second
#define all(x) x.begin(),x.end()


int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector<int> x(n), h(n), nx(n, -1), ls(n, n);
    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }

    for (int i = 0; i < n; ++i) {
        for (int j = i+1; j < n; ++j) {
            if (x[j] - x[i] < h[i]) {
                nx[i] = j;
            } else break;
        }

        for (int j = i-1; j >= 0; --j) {
            if (x[i] - x[j] < h[i]) {
                ls[i] = j;
            } else break;
        }
    }

    int K = 30, sz = (n + K -1) / K;
    vector<pair<vector<int>, int>> d(sz);

    vector<char> used(n, 1);
    for (int f = 0; f < sz; ++f) {

        int l = f * K;
        int r = min(n-1, (f + 1) * K - 1);

        int cnt = 0;
        bool ok = 1;
        while (ok) {
            ok = 0;
            for (int i = l; i <= r; ++i) {
                if (used[i] == 0 || x[n-1]-x[i] < h[i]) continue;
                int g = 0;
                for (int j = i+1; j < n && x[j]-x[i] < h[i]; ++j) {
                    g += used[j];
                    if (g > 0) break;
                }
                if (g == 0) {
                    used[i] = 0;
                    cnt++;
                    ok = 1;
                    break;
                }
            }
            for (int i = l; i <= r; ++i) {
                if (used[i] == 0 || x[i]-x[0] < h[i]) continue;
                int g = 0;
                for (int j = i-1; j >= 0 && x[i]-x[j] < h[i]; --j) {
                    g += used[j];
                    if (g > 0) break;
                }
                if (g == 0) {
                    used[i] = 0;
                    cnt++;
                    ok = 1;
                    break;
                }
            }
        }
        d[f].se = cnt;
        for (int j = l; j <= r; ++j) {
            if (used[j] == 1) {
                d[f].fi.push_back(j);
            }
        }
        for (int i = l; i <= r; ++i) used[i] = 1;
    }


    used.assign(n, 1);

    while (q-->0) {
        int l, r;
        cin >> l >> r;
        l--; r--;
        int cnt = 0;
        vector<int> num;
        for (int i = l; i <= r; ++i) used[i] = 0;
        for (int f = 0; f < sz; ++f) {
            int lx = f * K, rx = min(n-1, (f+1) * K - 1);
            if (lx >= l && r >= rx) {
                for (int h : d[f].fi) {
                    num.push_back(h);
                    used[h] = 1;
                }
                cnt += d[f].se;
                continue;
            } else if (lx > r || l > rx) continue;
            for (int i = max(lx, l); i <= min(r, rx); ++i) {
                num.push_back(i);
                used[i] = 1;
            }
        }

        bool ok = 1;
        while (ok) {
            ok = 0;
            for (int I = 0; I < num.size(); ++I) {
                int i = num[I];
                if (used[i] == 0 || x[n-1]-x[i] < h[i]) continue;
                int g = 0;
                for (int j = i+1; j < n && x[j]-x[i] < h[i]; ++j) {
                    g += used[j];
                    if (g > 0) break;
                }
                if (g == 0) {
                    used[i] = 0;
                    cnt++;
                    ok = 1;
                }
            }
            for (int I = 0; I < num.size(); ++I) {
                int i = num[I];
                if (used[i] == 0 || x[i]-x[0] < h[i]) continue;
                int g = 0;
                for (int j = 0; j < i && x[i]-x[j] < h[i]; ++j) {
                    g += used[j];
                    if (g > 0) break;
                }
                if (g == 0) {
                    used[i] = 0;
                    cnt++;
                    ok = 1;
                }
            }
        }

        for (int i = l; i <= r; ++i) used[i] = 1;
        cout << cnt << "\n";
    }
}