#pragma GCC optimize("Ofast,unroll-loops,fast-math,inline,no-stack-protector")
#pragma GCC target("sse,sse2,sse3,ssse3,sse4,sse4.1,sse4.2,avx,avx2,abm,mmx,popcnt")
#include <bits/stdc++.h>
using namespace std;

const int MEM = 5e8;
char mem[MEM];
int cur = 0;

void *operator new(size_t sz) {
    void *ans = mem + cur;
    cur += sz;
    assert(cur < MEM);
    return ans;
}

void operator delete(void *) {}
void operator delete(void *, size_t) {}

#define right right1
#define left left1

typedef long long ll;
typedef long double ldb;
const int MAXN = 5e5;

int n;
pair<int, int> arr[MAXN];

int left[MAXN], right[MAXN];

mt19937 rd(228);

struct node {
    node *l, *r;
    int sz;
    int x;
    int y;
    int mn;

    node(int x) :x(x) {
        l = r = NULL;
        sz = 1;
        y =rd();
        mn = x;
    }
};

int get_sz(node *n) {
    return (n == NULL) ? 0 : n->sz;
}

int get_mn(node *n) {
    return (n == NULL) ? 1e9 : n->mn;
}

void pull(node *a) {
    a->sz = 1 + get_sz(a->l) + get_sz(a->r);
    a->mn = min(a->x, min(get_mn(a->l), get_mn(a->r)));
}

node *merge(node *a, node *b) {
    if (a == NULL)
        return b;
    if (b == NULL)
        return a;
    if (a->y > b->y) {
        a->r = merge(a->r, b);
        pull(a);
        return a;
    }
    b->l = merge(a, b->l);
    pull(b);
    return b;
}

pair<node *, node *> split(node *n, int x) { // [<= x, >x]
    if (n == NULL) {
        return {n, n};
    }
    if (n->x <= x) {
        auto pp = split(n->r, x);
        n->r = pp.first;
        pull(n);
        return {n, pp.second};
    }
    auto pp = split(n->l, x);
    n->l = pp.second;
    pull(n);
    return {pp.first, n};
}

pair<node *, node *> split_sz(node *n, int k) {
    if (n == NULL) {
        return {n, n};
    }
    if (get_sz(n->l) >= k) {
        auto pp = split_sz(n->l, k);
        n->l = pp.second;
        pull(n);
        return {pp.first, n};
    }
    auto pp = split_sz(n->r, k - 1 - get_sz(n->l));
    n->r = pp.first;
    pull(n);
    return {n, pp.second};
}

namespace Tree1 {
    
    const int MAXN = 5e5;
    const int NEUTRAL = 1e9;

    struct data {
        node *xs, *ys;
        data() {
            xs = NULL;
            ys = NULL;
        }

        void insert(int x, int y) {
            auto pp1 = split(xs, x);
            auto pp2 = split_sz(ys, get_sz(pp1.first));
            xs = merge(pp1.first, merge(new node(x), pp1.second));
            ys = merge(pp2.first, merge(new node(y), pp2.second));
        }

        int get(int x) {
            auto pp1 = split(xs, x);
            auto pp2 = split_sz(ys, get_sz(pp1.first));
            int ans = get_mn(pp2.second);
            xs = merge(pp1.first, pp1.second);
            ys = merge(pp2.first, pp2.second);
            return ans;
        }
    };


    data tree1[4 * MAXN];

    void init() {
        for (int i = 0; i < 4 * MAXN; i++) {
            tree1[i].xs = NULL;
            tree1[i].ys = NULL;
        }
    }

    void set(int v, int l, int r, int i, int x, int y) {
        if (i < l || i >= r) {
            return;
        }
        tree1[v].insert(x, y);
        if (l + 1 != r) {
            int m = (l + r) / 2;
            set(2 * v + 1, l, m, i, x, y);
            set(2 * v + 2, m, r, i, x, y);
        }
    }

    void set(int i, int x, int y) {
        set(0, 0, MAXN, i, x, y);
    }


    int get(int v, int l, int r, int ql, int qr, int x) {
        if (l >= qr || r <= ql) {
            return  NEUTRAL;
        }
        if (ql <= l && r <= qr) {
            return tree1[v].get(x);
        }
        int m = (l + r) / 2;
        return min(
                get(2 * v + 1, l, m, ql, qr, x),
                get(2 * v + 2, m, r, ql, qr, x)
                );
    }

    int get(int l, int r, int x) {
        return get(0, 0, MAXN, l, r, x);
    }
};


void calcLeft() {
    fill(left, left + n, -1);
    Tree1::set(n - 1, arr[n - 1].first + arr[n - 1].second, -1);
    for (int i = 1; i < n; i++) {
        if (arr[i].first - arr[i].second < arr[0].first) {
        } else {
            int x = arr[i].first - arr[i].second;
            int l = 0;
            int r = i;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (arr[m].first <= x) {
                    l = m;
                } else {
                    r = m;
                }
            }
            left[i] = min(r, Tree1::get(r, i, arr[i].first));
        }
        Tree1::set(i, arr[i].first + arr[i].second, left[i]);
    }
}

int left228[MAXN];

void calcRight() {
    for (int i = 0; i < n; i++)
        left228[i] = left[i];
    reverse(arr, arr + n);
    for (int i = 0; i < n; i++) {
        arr[i].first *= -1;
    }
    for (int i = n - 1; i >= 0; i--) {
        arr[i].first -= arr[0].first;
    }
    Tree1::init();
    calcLeft();
    for (int i = 0; i < n; i++) {
        right[i] = left[i];
    }
    reverse(right, right + n);
    for (int i = 0; i < n; i++) {
        right[i] = n - 1 - right[i];
    }
    for (int i = 0; i < n; i++)
        left[i] = left228[i];
}

node* tree2[4 * MAXN];
vector<int> arr2[MAXN];

void add(int v, int l, int r, int i, int x) {
    if (i < l || i >= r) {
        return;
    }
    auto pp = split(tree2[v], x);
    tree2[v] = merge(pp.first, merge(new node(x), pp.second));
    if (l + 1 != r) {
        int m = (l + r) / 2;
        add(2 * v + 1, l, m, i, x);
        add(2 * v + 2, m, r, i, x);
    }
}

int get(int v, int l, int r, int ql, int qr, int x) {
    if (ql >= r || qr <= l) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        auto pp = split(tree2[v], x - 1);
        int ans = get_sz(pp.first);
        tree2[v] = merge(pp.first, pp.second);
        return ans;
    }
    int m = (l + r) / 2;
    int a1 = get(2 * v + 1, l, m, ql, qr, x);
    int a2 = get(2 * v + 2, m, r, ql, qr, x);
    return a1 + a2;
}

pair<int, int> qq[MAXN];
int ans1[MAXN];
int ans2[MAXN];
int ans3[MAXN];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int q;
    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        cin >> arr[i].first >> arr[i].second;
    }
    calcLeft();
    calcRight();
    for (int i = 0; i < q; i++) {
        cin >> qq[i].first >> qq[i].second;
    }
    {
        for (int i = 0; i < n; i++) {
            if (left[i] != -1 && right[i] != n) {
                arr2[left[i]].push_back(right[i]);
            }
        }
        for (int i = 0; i < n; i++) {
            for (int el : arr2[i]) {
                add(0, 0, n, i, el);
            }
        }
        for (int i = 0; i < q; i++) {
            int l, r;
            l = qq[i].first;
            r = qq[i].second;
            l--;
            int ans = 0;
            ans1[i] = get(0, 0, n, l, n, r);
        }
    }
    for (int i = 0; i < MAXN; i++) {
        arr2[i].clear();
    }
    for (int i = 0; i < 4 * MAXN; i++) {
        tree2[i] = NULL;
    }
    {
        for (int i = 0; i < n; i++) {
            if (right[i] != n) {
                arr2[i].push_back(right[i]);
            }
        }
        for (int i = 0; i < n; i++) {
            for (int el : arr2[i]) {
                add(0, 0, n, i, el);
            }
        }
        for (int i = 0; i < q; i++) {
            int l, r;
            l = qq[i].first;
            r = qq[i].second;
            l--;
            int ans = 0;
            ans2[i] = get(0, 0, n, l, n, r);
        }
    }
    for (int i = 0; i < MAXN; i++) {
        arr2[i].clear();
    }
    for (int i = 0; i < 4 * MAXN; i++) {
        tree2[i] = NULL;
    }
    {
        for (int i = 0; i < n; i++) {
            if (left[i] != -1) {
                arr2[left[i]].push_back(i);
            }
        }
        for (int i = 0; i < n; i++) {
            for (int el : arr2[i]) {
                add(0, 0, n, i, el);
            }
        }
        for (int i = 0; i < q; i++) {
            int l, r;
            l = qq[i].first;
            r = qq[i].second;
            l--;
            int ans = 0;
            ans3[i] = get(0, 0, n, l, n, r);
        }
    }
    for (int i = 0; i < q; i++)
        printf("%d\n", ans2[i] + ans3[i] - ans1[i]);
}
