#include <iostream>
#include <vector>
#include <tuple>
#include <set>

using namespace std;

const int MAX_N = 25;
const int INF = 1e9 + 7;

struct Edge {
    int from, to, weight;
    Edge(int f, int t, int w): from(f), to(t), weight(w) {

    }
    const bool operator<(const Edge &e) const {
        return make_tuple(min(from, to), max(from, to)) <
               make_tuple(min(e.from, e.to), max(e.from, e.to));
    }
};

vector<Edge> graph[MAX_N];
int ans[MAX_N];

set<Edge> used;

void traverse(int v, int mi, int mx) {
    ans[v] = min(ans[v], mi + mx);
    for (const Edge &e : graph[v]) {
        if (used.find(e) == used.end()) {
            int u = e.to;
            int w = e.weight;
            used.insert(e);
            traverse(u, min(mi, w), max(mx, w));
            used.erase(e);
        }
    }
}

int main() {
    int n, m; cin >> n >> m;
    fill(ans, ans + MAX_N, 2 * INF + 1337);
    for (int i = 0; i < m; i++) {
        int f, t, w; cin >> f >> t >> w;
        f--; t--;
        graph[f].emplace_back(f, t, w);
        graph[t].emplace_back(t, f, w);
    }
    traverse(0, INF, -INF);
    for (int i = 1; i < n; i++) {
        cout << ans[i] << endl;
    }
}
