#include <bits/stdc++.h>

using namespace std;

const int maxn = 150'000 + 1329;

vector<int> tree [maxn];

vector<int> g [maxn];
bool has_up [maxn];
bool has_down [maxn];

bool used [maxn];

void dfs0(int u) {
    used[u] = true;
    for (int v : g[u]) {
        if (used[v]) has_up[u] = true;
        else has_down[v] = true;
    }
    for (int v : tree[u]) {
        if (used[v]) continue;
        dfs0(v);
    }
}

bool dp [maxn][2][2]; // u, up, down

bool dfs(int u) {
    used[u] = true;
    if (tree[u].size() == has_down[u] + has_up[u]) {
        dp[u][0][0] = true;
        dp[u][1][1] = true;
        return true;
    }
    int su = 0, sd = 0, sud = 0;
    for (int v : tree[u]) {
        if (used[v]) continue;
        if (!dfs(v)) return false;
        if (has_up[v]) {
            if (has_down[v]) {
                if (dp[v][0][0]) continue;
                if (dp[v][1][0] && dp[0][1]) sud += 1;
                else if (dp[v][1][0]) sd += 1;
                else if (dp[v][0][1]) su += 1;
                else return false;
            } else {
                if (dp[v][0][0]) su += 1;
                else if (!dp[v][1][0]) return false;
            }
        } else {
            if (has_down[v]) {
                if (dp[v][0][0]) sd += 1;
                else if (!dp[v][0][1]) return false;
            } else {
                if (!dp[v][0][0]) return false;
            }
        }
    }
    for (int up = 0; up <= 1 && up <= su; ++up) {
        for (int down = 0; down <= 1 && down <= sd; ++down) {
            // s_up - up - (s_ud - x) = s_down - down - x
            // 2x = s_down - down + up + s_ud - s_up
            if ((sd - down + up - su - sud) % 2 == 0) {
                int x = (sd - down + up - su - sud) / 2;
                if (x >= 0 && x <= sud) {
                    dp[u][up][down] = true;
                }
            }
        }
    }
    if (dp[u][0][0]) dp[u][1][1] = true;
    return (dp[u][0][0] || dp[u][1][0] || dp[u][0][1] || dp[u][1][1]);
}

struct ans_edge {
    int from1, to1, from2, to2;
    ans_edge(int from1, int to1, int from2, int to2): from1(from1), to1(to1), from2(from2), to2(to2) {}
};
ostream& operator<< (ostream& stream, const ans_edge& e) {
    stream << e.from1 << ' ' << e.to1 << ' ' << e.from2 << ' ' << e.to2;
    return stream;
}

bool up_in_ans [maxn];
bool down_in_ans [maxn];

vector<ans_edge> ans;
void find_ans(int u, int p, int up, int down) {
    used[u] = true;
    if (!dp[u][up][down]) {
        cout << "ALARM!!!" << '\n';
    }
    if (tree[u].size() == has_up[u] + has_down[u]) {
        return;
    }
    vector<int> su, sd, sud;
    for (int v : tree[u]) {
        if (used[v]) continue;
        if (has_up[v]) {
            if (has_down[v]) {
                if (dp[v][0][0]) {
                    ans.emplace_back(u, v, v, u);
                    find_ans(v, u, 0, 0);
                }
                else if (dp[v][1][0] && dp[0][1]) sud.push_back(v);
                else if (dp[v][1][0]) {
                    sd.push_back(v);
                    find_ans(v, u, 1, 0);
                }
                else if (dp[v][0][1]) {
                    su.push_back(v);
                    find_ans(v, u, 0, 1);
                }
            } else {
                if (dp[v][0][0]) {
                    su.push_back(v);
                    find_ans(v, u, 0, 0);
                }
            }
        } else {
            if (has_down[v]) {
                if (dp[v][0][0]) {
                    sd.push_back(v);
                    find_ans(v, u, 0, 0);
                }
            } else {

            }
        }
    }
    // s_up - up - (s_ud - x) = s_down - down - x
    // 2x = s_down - down + up + s_ud - s_up
    int x = (sd.size() - down + up - su.size() - sud.size()) / 2;
    if (up) {
        ans.emplace_back(su.back(), u, u, p);
        su.pop_back();
    } if (down) {
        ans.emplace_back(p, u, u, sd.back());
        sd.pop_back();
    }
    for (int i = 0; i < x; ++i) {
        ans.emplace_back(sud.back(), u, u, sd.back());
        find_ans(sud.back(), u, 0, 1);
        sud.pop_back();
        sd.pop_back();
    } for (int i = 0; i < sud.size(); ++i) {
        ans.emplace_back(su.back(), u, u, sud.back());
        sd.pop_back();
        find_ans(sud.back(), u, 1, 0);
        sud.pop_back();
    }
    while (!su.empty()) {
        ans.emplace_back(su.back(), u, u, sd.back());
        su.pop_back();
        sd.pop_back();
    }
}

signed main() {
    cin.tie(0)->sync_with_stdio(0);
    cout.tie(0)->sync_with_stdio(0);
    int n, m; cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v; cin >> u >> v;
        tree[u].push_back(v);
        tree[v].push_back(u);
        g[u].push_back(v);
    }
    fill(has_up, has_up + n + 1, false);
    fill(has_down, has_down + n + 1, false);
    vector<int> inits;
    fill(used, used + n + 1, false);
    for (int i = 1; i <= n; ++i) {
        if (!used[i]) {
            inits.push_back(i);
            dfs0(i);
        }
    }
    fill(used, used + n + 1, false);
    for (int u : inits) {
        dfs(u);
    }
    /*for (int i = 1; i <= n; ++i) {
        cout << i << ": " << has_up[i] << ' ' << has_down[i] << " , " << dp[i][0][0] << ' ' << dp[i][1][0] << ' ' <<dp[i][0][1] << ' ' <<dp[i][1][1] << '\n';
    }*/
    for (int u : inits) {
        if (!dp[u][0][0]) {
            cout << "No" << '\n';
            return 0;
        }
    }
    cout << "Yes" << '\n';
    fill(used, used + n + 1, false);
    for (int u : inits) {
        find_ans(u, 0, 0, 0);
    }
    for (ans_edge e : ans) {
        cout << e << '\n';
    }
}

/*

5 6
1 2
2 1
1 5
2 3
2 4
4 2

 */