#define _CRT_SECURE_NO_WARNINGS
#pragma comment(linker, "/stack:2000000000")
#include <iostream>
#include <vector>
#include <cstdio>
#include <algorithm>
#include <set>

using namespace std;

const long long INFL = 1000000000000000009ll;
const int SIZE = 300010;
set <int> g[SIZE];
set <int> rg[SIZE];
vector <pair <pair <int, int>, pair <int, int> > > ans;

pair <int, int> DFS(int v, int parent)
{
	vector <int> vh;
	vector <int> is;
	for (int to : g[v])
	{
		if (to != parent)
		{
			pair <int, int> p = DFS(to, v);
			bool vc = rg[v].count(to);
			bool tc = rg[to].count(v);
			if (p.first == 0)
			{
				if (vc && tc)
				{
					ans.push_back({ { v, to }, { to, v } });
					continue;
				}
				if (vc)
				{
					vh.push_back(to);
					continue;
				}
				if (tc)
				{
					is.push_back(to);
					continue;
				}
			}
			if (p.first == -1)
			{
				if (vc && tc)
				{
					ans.push_back({ { v, to }, { to, p.second } });
					is.push_back(to);
					continue;
				}
				if (vc)
				{
					ans.push_back({ { v, to }, { to, p.second } });
					continue;
				}
				cout << "No";
				exit(0);
			}
			if (p.first == 1)
			{
				if (vc && tc)
				{
					ans.push_back({ { p.second, to }, { to, v } });
					vh.push_back(to);
					continue;
				}
				if (tc)
				{
					ans.push_back({ { p.second, to }, { to, v } });
					continue;
				}
				cout << "No";
				exit(0);
			}
		}
	}
	for (int i = 0; i < min(vh.size(), is.size()); ++i)
	{
		ans.push_back({ { is[i], v }, { v, vh[i] } });
	}
	if (abs((int)is.size() - (int)vh.size()) >= 2)
	{
		cout << "No";
		exit(0);
	}
	if (vh.size() > is.size())
	{
		//cout << v << ' ' << -1 << ' ' << vh[vh.size() - 1] << '\n';
		return { -1, vh[vh.size() - 1] };
	}
	if (is.size() > vh.size())
	{
		//cout << v << ' ' << 1 << ' ' << is[is.size() - 1] << '\n';
		return { 1, is[is.size() - 1] };
	}
	//cout << v << ' ' << 0 << '\n';
	return { 0, 0 };
}

int color[SIZE];
void DFS2(int v)
{
	color[v] = 1;
	for (int to : g[v])
	{
		if (!color[to])
		{
			DFS2(to);
		}
	}
}

signed main()
{
	ios::sync_with_stdio(0);
	cin.tie();
	cout.tie();
	//freopen("input.txt", "r", stdin);

	int n, m;
	cin >> n >> m;
	for (int i = 0; i < m; ++i)
	{
		int u, v;
		cin >> u >> v;
		u--; v--;
		rg[u].insert(v);
		g[u].insert(v);
		g[v].insert(u);
	}
	DFS2(0);
	for (int i = 1; i < n; ++i)
	{
		if (!color[i])
		{
			g[0].insert(i);
			g[i].insert(0);
			DFS2(i);
		}
	}
	
	pair <int, int> p = DFS(0, -1);
	if (p.first)
	{
		cout << "No";
		return 0;
	}
	cout << "Yes\n";
	for (int i = 0; i < ans.size(); ++i)
	{
		cout << ans[i].first.first + 1 << ' ' << ans[i].first.second + 1 << ' ' <<
			ans[i].second.first + 1 << ' ' << ans[i].second.second + 1 << '\n';
	}

	return 0;
}