#include <iostream>
#include <vector>
#include <numeric>
#include <functional>
#include <algorithm>


constexpr int MAXN = 3e5 + 5;
constexpr int INF = 1.1e9;

int n, m;
int ans[MAXN];

int32_t main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);


	std::cin >> n >> m;
	std::vector<std::vector<int>> vec(n - 1);
	for (int i = 0; i < m; i++) {
		int u, v, t;
		std::cin >> u >> v >> t;
		u--; v--;
		vec[std::min(u, v)].push_back(t);
	}

	for (int i = 0; i < n - 1; i++) {
		std::sort(vec[i].begin(), vec[i].end());
	}

	int min = INF, max = 0;
	std::fill(ans, ans + n, 2.1e9);

	for (int i = 0; i < n - 1; i++) {
		min = std::min(min, vec[i][0]);
		max = std::max(max, vec[i][0]);

		ans[i + 1] = std::min(ans[i + 1], min + max);

		int mn = min, mx = max;
		for (int j = i; j < n - 1; j++) {
			if (vec[j].size() < 2) {
				break;
			}
			mn = std::min(mn, vec[i][0]);
			mx = std::max(mx, vec[i][1]);

			ans[i + 1] = std::min(ans[i + 1], mn + mx);
		}
	}

	for (int i = 1; i < n; i++) {
		std::cout << ans[i] << " \n"[i == n - 1];
	}
	return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1

*/