#include <bits/stdc++.h>
#define int long long
#define endl "\n"
using namespace std;
template <class T>
ostream& operator << (ostream& out, vector <T> &a) {
    for (auto &el : a) out << el << " ";
    return out;
}
int INF = 1e18;

struct PRS {
    vector <int> mt, used;
    int now_used = 1, n, m;
    vector <vector <int> > gr;
    PRS(int n, vector <vector <int> > gr) : gr(gr), n(n) {
        mt.resize(n, -1);
        used.resize(n);
    }

    int dfs(int v) {
        if (used[v] == now_used) return 0;
        used[v] = now_used;
        for (auto u : gr[v]) {
            if (mt[u] == -1 || dfs(mt[u])) {
                mt[v] = u;
                mt[u] = v;
                return 1;
            }
        }
        return 0;
    }

    set <pair<int, int> > get_mp() {
        for (int run = 1; run; ) {
            run = 0;
            for (int i = 0; i < n; i++) if (mt[i] == -1) run = max(run, dfs(i));
            now_used++;
        }
        set <pair <int, int> > ans;
        for (int i = 0; i < n; i++) if (mt[i] != -1) ans.insert({min(i, mt[i]), max(i, mt[i])});
        return ans;
    }
};

int n, m;
vector <vector <int> > in, out;
vector <pair <int, int> > edj;
vector <vector <pair <int, int> > > gr;
vector <vector <int> > ans;
vector <int> used;
vector <pair <int, int> > bal;
int can = 1;

void dfs(int v, int p) {
    used[v] = 1;
    map <int, vector <int> > cnt;
    for (auto par : gr[v]) {
        int u = par.first, t = par.second;
        if (u == p) continue;
        dfs(u, v);
        cnt[t].push_back(u);
        if (bal[u].first != -1) {
            if (t != 1) {
                ans.push_back({bal[u].first, u, u, v});
                cnt[t].pop_back();
                t++;
                if (t != 0) cnt[t].push_back(u);
            } else can = 0;
        }
        if (bal[u].second != -1) {
            if (t != -1) {
                ans.push_back({v, u, u, bal[u].second});
                cnt[t].pop_back();
                t--;
                if (t != 0) cnt[t].push_back(u);
            } else can = 0;
        }
    }
    for (auto u : cnt[0]) {
        ans.push_back({v, u, u, v});
    }
    int sz = min(cnt[-1].size(), cnt[1].size());
    if (max(cnt[-1].size(), cnt[1].size()) - sz > 1) can = 0;
    for (int i = 0; i < sz; i++) {
        ans.push_back({cnt[-1][i], v, v, cnt[1][i]});
    }
    bal[v] = {-1, -1};
    if (sz < cnt[-1].size()) bal[v].first = cnt[-1].back();
    if (sz < cnt[1].size()) bal[v].second = cnt[1].back();
}

int stupid() {
    vector <vector <int> > gr(m);
    for (int i = 0; i < n; i++) {
        for (auto a : in[i]) {
            for (auto b : out[i]) {
                gr[a].push_back(b);
                gr[b].push_back(a);
            }
        }
    }
    PRS par(m, gr);
    auto ans = par.get_mp();
    if (ans.size() != m / 2) {
        cout << "No" << endl;
        return 0;
    }
    cout << "Yes" << endl;
    for (auto p : ans) {
        cout << edj[p.first].first + 1 << " " << edj[p.first].second + 1 << " ";
        cout << edj[p.second].first + 1 << " " << edj[p.second].second + 1 << endl;
    }
    return 1;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m;
    cin >> n >> m;
    in.resize(n);
    gr.resize(n);
    out.resize(n);
    bal.resize(n);
    used.resize(n);
    map <pair <int, int>, int> mp;
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        a--;b--;
        int t = (a < b ? 1 : -1);
        mp[{min(a, b), max(a, b)}] += t;
        edj.push_back({a, b});
        in[b].push_back(i);
        out[a].push_back(i);
    }
    for (auto e : mp) {
        int a = e.first.first, b = e.first.second, t = e.second;
        gr[a].push_back({b, t});
        gr[b].push_back({a, -t});
    }
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            dfs(i, -1);
            can = min(can, (int)(bal[i].first == -1 && bal[i].second == -1));
        }
    }
    if (!can) {
        cout << "No" << endl;
        return 0;
    }
    cout << "Yes" << endl;
    for (auto el : ans) {
        for (auto x : el) cout << x + 1 << " ";
        cout << endl;
    }
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
*/
