#include <bits/stdc++.h>

using namespace std;

const int MAXN = 3e5;
vector<pair<int, int>> graph[MAXN];

int tin[MAXN];
int fup[MAXN];
int timer = 0;
int used[MAXN];
set<pair<int, int>> bridges;

void dfs(int v, int p) {
  used[v] = 1;
  fup[v] = tin[v] = timer++;
  for (auto[u, w] : graph[v]) {
    if (u == p)
      continue;
    if (used[u]) {
      fup[v] = min(fup[v], tin[u]);
    } else {
      dfs(u, v);
      fup[v] = min(fup[v], fup[u]);
      if (tin[v] < fup[u]) {
        bridges.emplace(v, u);
      }
    }
  }
}

int color[MAXN];
int colors = 1;

void dfs_c(int v, int c) {
  color[v] = c;
  for (auto[u, w] : graph[v]) {
    if (color[u])
      continue;
    if (bridges.count({v, u}))
      dfs_c(u, ++colors);
    else
      dfs_c(u, c);
  }
}

vector<pair<int, int>> graph2[MAXN + 1];
int colors_min[MAXN + 1];

void dfs3(int v, int p) {
  for (auto[u, w] : graph2[v]) {
    if (u == p)
      continue;
    colors_min[u] = min(colors_min[v], w);
    dfs3(u, v);
  }
}

signed main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; i++) {
    int v, u, t;
    cin >> v >> u >> t;
    v--;
    u--;
    graph[v].emplace_back(u, t);
    graph[u].emplace_back(v, t);
  }
  dfs(0, -1);
  dfs_c(0, colors);
  for (int v = 0; v < n; v++) {
    for (auto[u, w] : graph[v]) {
      if (color[v] < color[u])
        continue;
      if (color[u] != color[v]) {
        graph2[color[u]].emplace_back(color[v], w);
        graph2[color[v]].emplace_back(color[u], w);
      } else {
        colors_min[color[v]] = min(colors_min[color[v]], w);
      }
    }
  }
  for (int i = 0; i <= colors; i++)
    colors_min[i] = INT_MAX;
  dfs3(1, -1);
  for (int i = 1; i < n; i++) {
    cout << (int) 1e9 + colors_min[color[i]] << '\n';
  }
  return 0;
}