#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
// #define int ll
#define rep(i, n) for (int i = 0; i < int(n); ++i)
#define all(a) (a).begin(), (a).end()

int m, n;
struct Ed {
	int v;
	int u;
	int t;
};
const int N = 3e5 + 10;
vector<Ed> g[N];

int ans_min[N];
int ans_max[N];

void dfs(int v, int p, int mn, int mx) {
	ans_max[v] = mx;
	ans_min[v] = mn;
	for (Ed e : g[v]) {
		int u = e.u;
		if (u == p)
			continue;
		int t = e.t;
		dfs(u, v, min(mn, t), max(mx, t));
	}
}

int p[N];
int rk[N];
set<int> st[N];
int get_par(int i) {
	if (p[i] == -1) {
		return i;
	}
	int res = get_par(p[i]);
	p[i] = res;
	return res;
}

bool merge(int a, int b) {
	a = get_par(a);
	b = get_par(b);
	if (a == b)
		return 0;
	if (rk[a] > rk[b])
		swap(a, b);
	if (rk[a] == rk[b])
		rk[b]++;
	for (int u : st[a]) {
		st[b].insert(u);
	}
	p[a] = b;
	return 1;
}
Ed ed[N];
int val[N];

void solve() {
	cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int v, u, t;
		cin >> v >> u >> t;
		--u;
		--v;
		g[v].push_back(Ed{v, u, t});
		g[u].push_back(Ed{u, v, t});
		ed[i] = Ed{v, u, t};
	}
	if (m == n - 1) {
		dfs(0, -1, INT_MAX, INT_MIN);
		rep(i, n - 1) {
			cout << ans_min[i + 1] + ans_max[i + 1] << '\n';
		}
		return;
	}
	bool b2 = 1;
	bool b3 = 1;
	bool b6 = 1;
	for (int i = 0; i < m; ++i) {
		if (abs(ed[i].v - ed[i].u) != 1) {
			b6 = 0;
		}
	}
	for (Ed e : g[0]) {
		if (e.t != 0)
			b2 = 0;
		if (e.t != int(1e9))
			b3 = 0;
	}
	if (b2) {
		memset(p, -1, sizeof(p));
		for (int i = 0; i < n; ++i) {
			st[i].insert(i);
		}
		sort(ed, ed + m, [](Ed a, Ed b) {
			return a.t < b.t;
		});
		int cur = 0;
		for (int i = 0; i < m; ++i) {
			cur = max(cur, ed[i].t);
			int v = ed[i].v;
			int u = ed[i].u;
			v = get_par(v);
			u = get_par(u);
			
			if (u == v)
				continue;
			int fs = get_par(0);
			if (v != fs && u != fs) {
				merge(v, u);
				continue;
			}
			if (v == fs) {
				swap(u, v);
			}
			for (int el : st[v]) {
				ans_max[el] = cur;
			}
			merge(v, u);
		}
		rep(i, n - 1) {
			cout << ans_min[i + 1] + ans_max[i + 1] << '\n';
		}
		return;
	}


	if (b6) {
		fill_n(val, n, INT_MAX);
		rep(i, m) {
			int u = ed[i].u;
			int v = ed[i].v;
			int t = ed[i].t;
			if (u > v)
				swap(u, v);
			val[u] = min(t, val[u]);
			multiset<int> ms;
			for (int i = 0; i + 1 < n; ++i) {
				ms.insert(val[i]);
				if (ms.size() == 1) {
					cout << *ms.begin() + *ms.begin() << '\n';
				} else {
					cout << *ms.begin() + *ms.rend() << '\n';
				}
			}
		}
		return;
	}

	if (b3) {
		memset(p, -1, sizeof(p));
		for (int i = 0; i < n; ++i) {
			st[i].insert(i);
		}
		sort(ed, ed + m, [](Ed a, Ed b) {
			if ((a.v == 0 || a.u == 0) != (b.v == 0 || b.u == 0)) {
				return (a.v == 0 || a.u == 0) > (b.v == 0 || b.u == 0);
			}
			return a.t < b.t;
		});
		rep(i, n) {
			ans_max[i] = int(1e9);
		}
		for (Ed e : g[0]) {
			ans_min[e.u] = int(1e9);
		}
		int cur = 0;
		for (int i = 0; i < m; ++i) {
			if (ed[i].v == 0 || ed[i].u == 0) {
				ed[i].v = get_par(ed[i].v);
				ed[i].u = get_par(ed[i].u);
				merge(ed[i].v, ed[i].u);
				continue;
			}
			cur = max(cur, ed[i].t);
			int v = ed[i].v;
			int u = ed[i].u;
			v = get_par(v);
			u = get_par(u);
			
			if (u == v)
				continue;
			int fs = get_par(0);
			if (v != fs && u != fs) {
				merge(v, u);
				continue;
			}
			if (v == fs) {
				swap(u, v);
			}
			for (int el : st[v]) {
				ans_min[el] = cur;
			}
			merge(v, u);
		}
		rep(i, n - 1) {
			cout << ans_min[i + 1] + ans_max[i + 1] << '\n';
		}
		return;
	}

}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	solve();
	return 0;
}