#include <iostream>
#include <algorithm>
#include <vector>
#include <string>
#include <cstring>
#include <set>
#include <map>
#include <queue>
#include <random>
#include <iomanip>

using namespace std;

template<typename T> void uin(T &a, T b) {
	if (b < a) a = b;
}
template<typename T> void uax(T &a, T b) {
	if (b > a) a = b;
}

#define int long long
#define left left228
#define right right228
#define all(v) v.begin(), v.end()

const int N = 300 * 1000 + 7;
const int INF = 1e18 + 228;

int n, m;
vector< pair<int, int> > g[N];

int mint[N];
int maxt[N];

void treefs(int v, int tMin = INF, int tMax = -INF, int par = -1) {
	mint[v] = tMin;
	maxt[v] = tMax;
	for (pair<int, int> go : g[v]) {
		int to = go.first;
		int t = go.second;

		if (to != par) {
			treefs(to, min(tMin, t), max(tMax, t), v);
		}
	}
}


struct edge
{
	int u, v, t;
	edge() {}
	edge(int _u, int _v, int _t) {
		u = _u;
		v = _v;
		t = _t;
	}
};

vector< edge > edges;

void solveTree() {
	for (int i = 1; i <= n; ++i) {
		mint[i] = INF;
		maxt[i] = -INF;
	}
	treefs(1);
	for (int i = 2; i <= n; ++i) {
		cout << mint[i] + maxt[i] << '\n';
	}
}

int p[N], sz[N];
vector<int> sub[N];

void init() {
	for (int i = 1; i <= n; ++i) {
		p[i] = i;
		sz[i] = 1;
		sub[i] = {i};
	}
}

int getp(int v) {
	if (v == p[v]) {
		return v;
	}
	p[v] = getp(p[v]);
	return p[v];
}

vector<int> just_added;

void join(int u, int v) {
	u = getp(u);
	v = getp(v);
	if (u != v) {
		if (sz[u] > sz[v]) {
			swap(u, v);
		}
		{
			if (getp(1) == u) {
				for (int x : sub[v]) {
					just_added.push_back(x);
				}
			} else if (getp(1) == v) {
				for (int x : sub[u]) {
					just_added.push_back(x);
				}
			}
		}
		p[u] = v;
		sz[v] += sz[u];
		for (int x : sub[u]) {
			sub[v].push_back(x);
		}
	}
}

int ans[N];

void solve2() {
	sort(all(edges), [&] (edge a, edge b) {
		return a.t < b.t;
	});

	init();

	int i = 0;
	while (i < m) {
		join(edges[i].u, edges[i].v);
		int j = i;
		while (j + 1 < m && edges[j + 1].t == edges[i].t) {
			++j;
			join(edges[j].u, edges[j].v);
		}
		for (int x : just_added) {
			ans[x] = edges[i].t;
		}
		just_added.clear();
		i = j + 1;
	}

	for (int i = 2; i <= n; ++i) {
		cout << ans[i] << '\n';
	}
}

void solve3() {
	sort(all(edges), [&] (edge a, edge b) {
		return a.t > b.t;
	});

	init();

	int i = 0;
	while (i < m) {
		join(edges[i].u, edges[i].v);
		int j = i;
		while (j + 1 < m && edges[j + 1].t == edges[i].t) {
			++j;
			join(edges[j].u, edges[j].v);
		}
		for (int x : just_added) {
			ans[x] = edges[i].t + 1000 * 1000 * 1000;
		}
		just_added.clear();
		i = j + 1;
	}

	for (int i = 2; i <= n; ++i) {
		cout << ans[i] << '\n';
	}
}

void solve() {
	if (m == n - 1) {
		solveTree();
		exit(0);
	}
	bool is2 = true;
	bool is3 = true;
	for (pair<int, int> go : g[1]) {
		if (go.second != 0) {
			is2 = false;
		}
		if (go.second != 1000 * 1000 * 1000) {
			is3 = false;
		}
	}

	if (is2) {
		solve2();
		exit(0);
	}
	if (is3) {
		solve3();
		exit(0);
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cin >> n >> m;

	for (int i = 0; i < m; ++i) {
		int u, v, t;
		cin >> u >> v >> t;
		g[u].emplace_back(v, t);
		g[v].emplace_back(u, t);
		edges.emplace_back(u, v, t);
	}

	solve();
	return 0;
}


/*


*/