#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define fi first
#define se second
#define pb emplace_back
#define all(x) (x).begin(), (x).end()
#define pii pair<int, int>

const int INF = 1e9;
const ll INFLL = 1e18 + 1;

struct edge {
    int to, id, t;
    edge() {}
    edge(int to, int id, int t) : to(to), id(id), t(t) {}
};

vector<vector<edge>> g;
vector<int> tin, tup, usd;
int timer = 0;

vector<int> bridge;

void dfs(int v, int id) {
    usd[v] = 1;
    tin[v] = tup[v] = timer++;
    for (auto &e : g[v]) {
        if (e.id == id) continue;
        if (usd[e.to]) {
            tup[v] = min(tup[v], tin[e.to]);
            continue;
        }
        dfs(e.to, e.id);
        tup[v] = min(tup[v], tup[e.to]);
        if (tup[e.to] > tin[v]) {
            bridge[e.id] = 1;
        }
    }
}

void dfs1(int v, vector<int> &a) {
    usd[v] = 1;
    a.pb(v);
    for (auto &e : g[v]) {
        if (!usd[e.to] && !bridge[e.id]) dfs1(e.to, a);
    }
}

vector<vector<edge>> g1;
vector<int> mn_comp;

void dfs2(int v, int p, int mn) {
    mn_comp[v] = min(mn_comp[v], mn);
    mn = mn_comp[v];
    usd[v] = 1;
    for (auto &e : g1[v]) {
        if (e.to == p) continue;
        dfs2(e.to, v, min(mn, e.t));
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> g2(n);
    vector<int> val(m);
    for (int i = 0; i < m; i++) {
        int a, b, t;
        cin >> a >> b >> t;
        val[i] = t;
        a--; b--;
        g2[a].pb(b, i, t);
        g2[b].pb(a, i, t);
    }
    vector<int> ans(n, 2 * INF);
    for (int mx_id = 0; mx_id < m; mx_id++) {
        g.clear();
        g.resize(n);
        for (int v = 0; v < n; v++) {
            for (auto &e : g2[v]) {
                if (e.t <= val[mx_id]) g[v].pb(e);
            }
        }
        tin.clear();
        tup.clear();
        usd.clear();
        bridge.clear();
        tin.resize(n);
        tup.resize(n);
        usd.resize(n);
        bridge.resize(m);
        dfs(0, -1);
        vector<int> id_comp(n);
        usd.assign(n, 0);
        int cur_id = 0;
        for (int v = 0; v < n; v++) {
            if (!usd[v]) {
                vector<int> a;
                dfs1(v, a);
                for (auto &c : a) id_comp[c] = cur_id;
                cur_id++;
            }
        }
        g1.clear();
        g1.resize(n);
        mn_comp.assign(cur_id, INF);
        usd.assign(cur_id, 0);
        for (int v = 0; v < n; v++) {
            for (auto &e : g[v]) {
                if (id_comp[v] == id_comp[e.to]) mn_comp[id_comp[v]] = min(mn_comp[id_comp[v]], e.t);
                else {
                    g1[id_comp[v]].pb(id_comp[e.to], e.id, e.t);
                }
            }
        }
        dfs2(0, -1, INF);
        for (int i = 1; i < n; i++) {
            if (!usd[id_comp[i]]) continue;
            ans[i] = min(ans[i], val[mx_id] + mn_comp[id_comp[i]]);
        }
    }
    for (int i = 1; i < n; i++) cout << ans[i] << "\n";
    return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1
*/
/*
4 4
1 2 2
3 2 0
2 4 3
4 3 1
*/
