#include <iostream>
#include <vector>
#include <sstream>
#include <set>
#include <map>
#include <assert.h>
#include <cmath>
#include <algorithm>

using namespace std;
typedef long long LL;
typedef unsigned long long ULL;

map<char, LL> vals;

ULL calcOnlyZ(string s) {
	ULL answer = 0ull;
	char maxChar = '\0';
	for (int i = s.size() - 1; i >= 0; i--)
	{
		if (s[i] >= maxChar) {
			answer += vals[s[i]];
		}
		else {
			answer -= vals[s[i]];
		}
		maxChar = max(maxChar, s[i]);
	}

	return answer;
}

void initVals() {
	LL current = 1;
	for (char v = 'A'; v <= 'Z'; v++)
	{
		vals[v] = current;
		if ((v - 'A') % 2 == 0) {
			current *= 5;
		}
		else {
			current *= 2;
		}
	}
}

LL calcValue(string s) {
	char maxChar = '\0';
	LL answer = 0ll;
	for (int i = s.size() - 1; i >= 0; i--)
	{
		if (s[i] >= maxChar) {
			answer += vals[s[i]];
		}
		else {
			answer -= vals[s[i]];
		}
		maxChar = max(maxChar, s[i]);
	}

	return answer;
}

int main() {
	initVals();
	int t;
	cin >> t;
	while (t--) {
		string s;
		cin >> s;

		int zcnt = 0;
		vector<string> variants;
		variants.push_back(s);
		for (int i = 0; i < s.size(); i++)
		{
			if (s[i] == 'Z') {
				zcnt++;
			}
			if (s[i] == '?') {
				vector<string> nvariants;
				for (char j = 'A'; j <= 'Z'; j++)
				{
					for (auto var : variants)
					{
						var[i] = j;
						nvariants.push_back(var);
					}
				}

				variants.swap(nvariants);
			}
		}

		string maxVar = s;

		if (zcnt > 100000) {
			ULL maxSum = 0;
			for (auto variant : variants)
			{
				ULL value = calcOnlyZ(variant);
				if (value > maxSum) {
					maxSum = value;
					maxVar = variant;
				}
				
			}
			cout << maxSum << endl << maxVar << endl;
		}
		else {
			LL maxSum = LLONG_MIN;
			for (auto variant : variants)
			{
				LL value = calcOnlyZ(variant);
				if (value > maxSum) {
					maxSum = value;
					maxVar = variant;
				}

			}
			cout << maxSum << endl << maxVar << endl;
		}
	}

	return 0;
}