#include <bits/stdc++.h>
using namespace std;

using ll = long long;
#define vec vector
#define ar array

#define all(a) (a).begin(), (a).end()
#define len(a) ((int)((a).size()))

template<typename A, typename B>
ostream& operator<<(ostream &out, pair<A, B> p) { return out << '(' << p.first << ", " << p.second << ')'; }

template<typename A, typename B = typename enable_if<!is_same<A, string>::value, typename A::value_type>::type>
ostream& operator<<(ostream &out, A vec) { out << '{'; string sep; for (auto x : vec) out << sep << x, sep = ", "; return out << '}'; }

void dbg_print() { cerr << endl; }
template<typename A, typename... B> void dbg_print(A a, B... b) { cerr << ' ' << a; dbg_print(b...); }

#ifdef LOCAL
	#define dbg(...) cerr << '#' << __LINE__ << " [" << #__VA_ARGS__ << "]:", dbg_print(__VA_ARGS__)
#else
	#define dbg(...)
#endif

int n, m;
vec<vec<pair<int, int>>> g;

inline void read() {
	cin >> n >> m;
	g.resize(n);
	for (int i = 0; i < m; i++) {
		int v, u, w;
		cin >> v >> u >> w;
		v--, u--;
		g[v].emplace_back(u, w);
		g[u].emplace_back(v, w);
	}
}

struct tree {
	static const int INF = 2e9;

	int n, lg;
	vec<vec<pair<int, int>>> g;
	vec<vec<ar<int, 3>>> par;
	int timer;
	vec<int> tin, tout;

	tree(int n) : n(n), lg(__lg(n) + 1), g(n), par(lg, vec<ar<int, 3>>(n, {0, INF, -INF})), timer(0), tin(n), tout(n) {}

	inline void add_edge(int v, int u, int w) {
		g[v].emplace_back(u, w);
		g[u].emplace_back(v, w);
	}

	inline void dfs_init(int v, int p) {
		tin[v] = timer++;
		for (int i = 1; i < lg; i++) {
			par[i][v][0] = par[i - 1][par[i - 1][v][0]][0];
			par[i][v][1] = min(par[i - 1][v][1], par[i - 1][par[i - 1][v][0]][1]);
			par[i][v][2] = max(par[i - 1][v][2], par[i - 1][par[i - 1][v][0]][2]);
		}
		for (auto [u, w] : g[v]) {
			if (u == p) {
				continue;
			}
			par[0][u] = {v, w, w};
			dfs_init(u, v);
		}
		tout[v] = timer;
	}

	inline void init() {
		dfs_init(0, 0);
	}

	inline bool is_par(int v, int u) {
		return tin[v] <= tin[u] && tout[u] <= tout[v];
	}

	inline int lca(int v, int u) {
		if (is_par(v, u)) {
			return v;
		}
		for (int i = lg - 1; i >= 0; i--) {
			if (!is_par(par[i][v][0], u)) {
				v = par[i][v][0];
			}
		}
		return par[0][v][0];
	}

	inline pair<int, int> get_one(int v, int w) {
		int mn = INF, mx = -INF;
		for (int i = lg - 1; i >= 0; i--) {
			if (!is_par(par[i][v][0], w)) {
				mn = min(mn, par[i][v][1]);
				mx = max(mx, par[i][v][2]);
				v = par[i][v][0];
			}
		}
		mn = min(mn, par[0][v][1]);
		mx = max(mx, par[0][v][2]);
		return {mn, mx};
	}

	inline pair<int, int> get(int v, int u) {
		int w = lca(v, u);
		auto a = get_one(v, w);
		auto b = get_one(u, w);
		return {min(a.first, b.first), max(a.second, b.second)};
	}
};

void solve4() {
	tree t(n);
	for (int i = 0; i < n; i++) {
		for (auto [j, w] : g[i]) {
			if (j > i) {
				t.add_edge(i, j, w);
				dbg(i, j, w);
			}
		}
	}
	t.init();
	for (int i = 1; i < n; i++) {
		auto cur = t.get(0, i);
		dbg(i, cur);
		cout << cur.first + cur.second << '\n';
	}
	exit(0);
}

struct DSU {
	int n;
	vec<int> sz, par;

	DSU(int n) : n(n), sz(n), par(n) {}

	inline void init() {
		fill(all(sz), 1);
		iota(all(par), 0);
	}

	inline int get_par(int v) {
		return par[v] == v ? v : par[v] = get_par(par[v]);
	}

	inline void unite(int v, int u) {
		v = get_par(v);
		u = get_par(u);
		if (v == u) {
			return;
		}
		if (sz[v] < sz[u]) {
			swap(v, u);
		}
		sz[v] += sz[u];
		par[u] = v;
		return;
	}
};

void solve5() {
	vec<ar<int, 3>> edges;
	for (int i = 0; i < n; i++) {
		for (auto [j, w] : g[i]) {
			if (i < j) {
				edges.push_back({i, j, w});
			}
		}
	}
	vec<int> deg(n);
	vec<int> ans(n, int(2e9) + 3);
	const int INF = 1e9 + 4;
	DSU dsu(n);
	vec<int> dist(n, int(2e9) + 4);
	for (int mask = 0; mask < (1 << m); mask++) {
		fill(all(deg), 0);
		int mn = INF, mx = -INF;
		dsu.init();
		for (int i = 0; i < m; i++) {
			if ((mask >> i) % 2) {
				deg[edges[i][0]]++;
				deg[edges[i][1]]++;
				dsu.unite(edges[i][0], edges[i][1]);
				mn = min(mn, edges[i][2]);
				mx = max(mx, edges[i][2]);
			}
		}
		if (deg[0] % 2 == 0) {
			continue;
		}
		int cnt_ok = 0;
		for (int i = 0; i < n; i++) {
			cnt_ok += (deg[i] % 2 == 0);
		}
		if (cnt_ok != n - 2) {
			continue;
		}
		bool ok = 1;
		for (int i = 0; i < m; i++) {
			if ((mask >> i) % 2) {
				if (dsu.get_par(edges[i][0]) != dsu.get_par(0)) {
					ok = 0;
					break;
				}
			}
		}
		if (!ok) {
			continue;
		}
		for (int i = 1; i < n; i++) {
			if (deg[i] % 2 == 1) {
				dist[i] = min(dist[i], mx + mn);
			}
		}
	}
	for (int i = 1; i < n; i++) {
		cout << dist[i] << '\n';
	}
	exit(0);
}

#define int ll
struct sparse_table {
	int n, lg;
	vec<vec<int>> sparse;
	vec<int> bit;

	sparse_table(vec<int> &a) : n(len(a)), lg(__lg(n) + 1), sparse(lg, vec<int>(n)), bit(n + 1, -1) {
		for (int i = 1; i <= n; i++) {
			bit[i] = bit[i / 2] + 1;
		}
		for (int i = 0; i < n; i++) {
			sparse[0][i] = a[i];
		}
		for (int i = 1; i < lg; i++) {
			for (int j = 0; j + (1 << i) <= n; j++) {
				sparse[i][j] = min(sparse[i - 1][j], sparse[i - 1][j + (1 << (i - 1))]);
			}
		}
	}

	inline int get_min(int l, int r) {
		int level = bit[r - l];
		return min(sparse[level][l], sparse[level][r - (1 << level)]);
	}
};

void solve6() {
	vec<int> vals;
	auto compress = [&]() {
		for (int i = 0; i < n; i++) {
			for (auto [j, w] : g[i]) {
				vals.push_back(w);
			}
		}
		sort(all(vals));
		vals.resize(unique(all(vals)) - vals.begin());
		auto get_id = [&](int x) -> int {
			return lower_bound(all(vals), x) - vals.begin();
		};
		for (int i = 0; i < n; i++) {
			for (auto &[j, w] : g[i]) {
				w = get_id(w);
			}
		}
	};
	compress();
	dbg(vals);
	int sz = len(vals);
	vec<vec<int>> from(n);
	for (int i = 0; i < n; i++) {
		for (auto [j, w] : g[i]) {
			if (j > i) {
				assert(j == i + 1);
				from[i].push_back(w);
			}
		}
	}
	vec<vec<int>> dp(n, vec<int>(sz, sz));
	for (auto val : from[0]) {
		dp[1][val] = val;
	}
	for (int i = 2; i < n; i++) {
		for (auto val : from[i - 1]) {
			for (int prev = 0; prev < sz; prev++) {
				dp[i][min(prev, val)] = min(dp[i][min(prev, val)], max(dp[i - 1][prev], val));
			}
		}
	}
	vec<vec<int>> dp2(n, vec<int>(sz, sz));
	sort(all(from[n - 2]));
	for (int i = 0; i < len(from[n - 2]) - 1; i++) {
		dp2[n - 2][from[n - 2][i]] = from[n - 2][i + 1];
	}
	for (int i = n - 3; i >= 0; i--) {
		sort(all(from[i]));
		int p = 0;
		for (int prev = 0; prev < sz; prev++) {
			while (p < len(from[i]) && from[i][p] < prev) {
				p++;
			}
			if (dp2[i + 1][prev] != sz) {
				for (auto pos : {p, p - 1, p + 1, p - 2, p + 2}) {
					if (pos <= 0 || pos >= len(from[i])) {
						continue;
					}
					dp2[i][min(prev, from[i][pos - 1])] = min(dp2[i][min(prev, from[i][pos - 1])], max(dp2[i + 1][prev], from[i][pos]));
				}
			}
		}
	}
	dbg(dp2);
	for (int i = 1; i < n; i++) {
		int ans = int(2e10);
		for (int j = 0; j < sz; j++) {
			if (dp[i][j] != sz) {
				ans = min(ans, vals[j] + vals[dp[i][j]]);
			}
		}
		if (i != n - 1 && len(from[i]) > 1) {
			sparse_table sparse(dp[i]);
			for (int prev = 0; prev < sz; prev++) {
				if (dp2[i][prev] != sz) {
					int mn = sparse.get_min(prev, sz);
					if (mn == sz) {
						continue;
					}
					ans = min(ans, vals[prev] + vals[max(mn, dp2[i][prev])]);
					dbg(prev, max(mn, dp2[i][prev]));
				}
			}
		}
		cout << ans << '\n';
	}
	exit(0);
}
#undef int

void solve1() {
// 	vec<int> vals;
// 	for (int i = 0; i < n; i++) {
// 		for (auto [j, w] : g[i]) {
// 			vals.push_back(w);
// 		}
// 	}
// 	sort(all(vals));
// 	vals.resize(unique(all(vals)) - vals.begin());
// 	auto get_id = [&](int x) -> int {
// 		return lower_bound(all(vals), x) - vals.begin();
// 	};
// 	for (int i = 0; i < n; i++) {
// 		for (auto &[j, w] : g[i]) {
// 			w = get_id(w);
// 		}
// 	}
// 	int sz = len(vals);

	// vec<vec<int>> dist(n, vec<int>(sz, sz));
	// priority_queue<ar<int, 3>, vec<ar<int, 3>>, greater<ar<int, 3>>> pq;
	// auto relax = [&](int v, int mn, int mx)  {
	// 	if (dist[v][mn] > mx) {
	// 		dist[v][mn] = mx;
	// 		pq.push({mx, v, mn});
	// 	}
	// };
	// for (auto [i, w] : g[0]) {
	// 	relax(i, w, w);
	// }
	// while (len(pq)) {
	// 	auto [mx, v, mn] = pq.top();
	// 	pq.pop();
	// 	if (mx != dist[v][mn]) {
	// 		continue;
	// 	}
	// 	for (auto [u, w] : g[v]) {
	// 		relax(u, min(mn, w), max(mx, w));
	// 	}
	// }
	// for (int i = 1; i < n; i++) {
	// 	dbg(i, dist[i]);
	// 	int ans = int(2e9);
	// 	for (int j = 0; j < sz; j++) {
	// 		if (dist[i][j] != sz) {
	// 			ans = min(ans, vals[j] + vals[dist[i][j]]);
	// 		}
	// 	}
	// 	cout << ans << '\n';
	// }
	// exit(0);
}

void solve2() {
	// exit(0);
}

void solve3() {
	// exit(0);
}

int main() {
	ios::sync_with_stdio(false), cin.tie(nullptr);

	read();
#ifndef LOCAL
	if (m == n - 1) {
		solve4();
	}
	if (n <= 20 && m <= 20) {
		solve5();
	}
#endif
	{
		bool ok = true;
		for (int i = 0; i < n; i++) {
			for (auto [j, w] : g[i]) {
				ok &= abs(i - j) == 1;
			}
		}
		if (ok) {
			solve6();
		}
	}
	if (n <= 2000 && m <= 2000) {
		solve1();
	}
	{
		bool ok = true;
		for (auto [i, w] : g[0]) {
			ok &= (w == 1e9);
		}
		if (ok) {
			solve2();
		}
	}
	{
		bool ok = true;
		for (auto [i, w] : g[0]) {
			ok &= (w == 0);
		}
		if (ok) {
			solve3();
		}
	}
}
