#include <iostream>
#include <string>
#include <climits>
#include <set>
#include <random>
#include <cmath>
#include <cstdio>
#include <vector>
#include <array>

struct gadget
{
	int u, v, w;
};
int main(int argc, char*argv[])
{
	//find m/2 non-intersecting paths of length 2
	//u,v -> v,w
	//create 'edges of length 2'
	//outdegree 0 -> every parent must be the middle of a gadget including this edge
	//indegree 0 -> same for children
	//find the gadget and delete it
	int n, m; std::cin >> n >> m;
	std::vector<std::set<int>> graph(n);
	std::vector<std::set<int>> rgraph(n);
	std::vector<int> outdeg(n), indeg(n);
	for(int i = 0; i < m; i++)
	{
		int u, v; scanf("%d%d", &u, &v); u--; v--;
		graph[u].insert(v);
		rgraph[v].insert(u);
		outdeg[u]++; indeg[v]++;
	}
	std::vector<gadget> ans;
	bool ok = true;
	//each vertex has non-zero outdegree -> connected trees
	while(ok)
	{
		ok = false;
		for(int u = 0; u < n; u++)
		{
			if(outdeg[u] != 0) continue;
			//printf("%d: outdeg 0\n", u);
			for(int p : rgraph[u])
			{
				if(indeg[p] == 0) continue;
				//printf("%d: valid parent\n", p);
				ok = true;
				int p2 = *rgraph[p].begin();
				ans.push_back({p2, p, u});
				indeg[u]--; indeg[p]--; outdeg[p]--; outdeg[p2]--;
				rgraph[u].erase(rgraph[u].find(p));
				rgraph[p].erase(rgraph[p].find(p2));
				graph[p].erase(graph[p].find(u));
				graph[p2].erase(graph[p2].find(p));
				break;
			}
		}

	}
	for(int u = 0; u < n; u++)
	{
		for(int v : graph[u])
		{
			if(u > v) continue;
			if(graph[v].count(u) == 0) continue;
			ans.push_back({u, v, u});
		}
	}
	if(ans.size() != m / 2) { printf("No\n"); return 0; }
	printf("Yes\n");
	for(auto[u,v,w] : ans)
		printf("%d %d %d %d\n", u+1, v+1, v+1, w+1);
}
