//#pragma GCC optimize("Ofast")
//#define _GLIBCXX_DEBUG
#include <iostream>
#include <string>
#include <climits>
#include <set>
#include <random>
#include <cmath>
#include <cstdio>
#include <vector>
#include <array>

struct gadget
{
	int u, v, w;
};
std::vector<std::set<int>> graph;
std::vector<std::set<int>> rgraph;
std::vector<std::set<int>> ugraph;
std::vector<gadget> cur_ans;
std::vector<int> seen;
bool dfs2(int at, int prev)
{
	//check if current subtree has any half-edges
	bool ans = false;
	for(int to : ugraph[at])
	{
		if(to == prev) continue;
		if(graph[to].count(at) == 0 || rgraph[to].count(at) == 0) ans = true;
		//if(graph[at].count(to))
		ans |= dfs2(to, at);
	}
	if(ans) seen[at] = true;
	//if(!ok)
	//	for(int to : graph[at])
	//	{
	//		dfs2(to, at, true);
	//	}
	return ans;
}
bool dfs(int at, int prev)
{
	for(int to : graph[at])
	{
		if(to == prev) continue;
		if(graph[to].count(at) == 0 || rgraph[to].count(at) == 0) return true;
		if(dfs(to, at)) return true;
	}
	for(int to : rgraph[at])
	{
		if(graph[at].count(to)) continue;
		if(to == prev) continue;
		if(graph[to].count(at) == 0 || rgraph[to].count(at) == 0) return true;
		if(dfs(to, at)) return true;
	}
	return false;
}
int main(int argc, char*argv[])
{
	//find m/2 non-intersecting paths of length 2
	//u,v -> v,w
	//create 'edges of length 2'
	//outdegree 0 -> every parent must be the middle of a gadget including this edge
	//indegree 0 -> same for children
	//find the gadget and delete it
	int n, m; std::cin >> n >> m;
	graph.resize(n);
	rgraph.resize(n);
	ugraph.resize(n);
	seen.resize(n);
	std::vector<int> outdeg(n), indeg(n);
	for(int i = 0; i < m; i++)
	{
		int u, v; scanf("%d%d", &u, &v); u--; v--;
		graph[u].insert(v);
		rgraph[v].insert(u);
		ugraph[u].insert(v);
		ugraph[v].insert(u);
		outdeg[u]++; indeg[v]++;
	}
	std::vector<gadget> ans;
	//each vertex has non-zero outdegree and indegree -> connected trees
	//for(int root = 0; root < n; root++)
	//{
	//	cur_ans.clear();
	//	auto[ok, ok2] = dfs(root, -1);
	//	if(!ok || !ok2) continue;
	//	printf("root %d ok\n", root);
	//}
	//find subtrees unreachable via half-edges
	//if a subtree can't be reached via half-edges, it can't be used for them
	//for(int u = 0; u < n; u++)
	//{
	//	for(int v : graph[u])
	//	{
	//		if(graph[v].count(u)) continue;
	//		dfs2(u, v);
	//		dfs2(v, u);
	//		//mark vertices reachable via half-edges
	//	}
	//}
	//for(int el : seen) printf("%d ", el);
	//for(int el : outdeg) printf("%d ", el); printf("\n");
	bool ok = true;
	while(ok)
	{
		ok = false;
		for(int u = 0; u < n; u++)
		{
			if(seen[u]) continue;
			std::set<int> ngraphu = graph[u];
			for(int v : graph[u])
			{
				//if(seen[v]) continue;
				if(graph[v].count(u) == 0) continue;
				if(dfs(u, v) && dfs(v, u)) continue;
				ans.push_back({u, v, u});
				//printf("deleting %d-%d\n", u, v);
				indeg[u]--; indeg[v]--; outdeg[u]--; outdeg[v]--;
				graph[v].erase(u);
				ngraphu.erase(v);
				rgraph[v].erase(u);
				rgraph[u].erase(v);
				ugraph[v].erase(u);
				ugraph[u].erase(v);
				ok = true;
			}
			graph[u] = ngraphu;
		}
		//int minu = -1;
		//for(int u = 0; u < n; u++)
		//	if((minu == -1 || outdeg[u] < outdeg[minu]) && indeg[u] != 0) minu = u;
		bool ok2 = true;
		bool require_1 = true;
		while(ok2)
		{
			ok2 = false;
			int best_u = -1, best_p = -1, best_sz = INT_MAX;
			for(int u = 0; u < n; u++)
			{
				if(outdeg[u] != 0) continue;
				for(int p : rgraph[u])
					if(rgraph[p].size() > 0 && (best_u == -1 || rgraph[p].size() < best_sz))
						best_sz = rgraph[p].size(), best_u = u, best_p = p;
			}
			//printf("best_u=%d, best_p=%d, bsz=%d\n", best_u, best_p, best_sz);
			if(best_u != -1 && (require_1 ? best_sz == 1 : true))
			{
				int u = best_u; int p = best_p;
				//printf("%d: outdeg %d\n", u, outdeg[u]);
				//if(indeg[p] == 0) continue;
				//ok2 = true;
				ok2 = true; ok = true;
				int p2 = *rgraph[p].begin();
				//printf("%d: valid parent; p2=%d\n", p, p2);
				ans.push_back({p2, p, u});
				indeg[u]--; indeg[p]--; outdeg[p]--; outdeg[p2]--;
				rgraph[u].erase(rgraph[u].find(p));
				rgraph[p].erase(rgraph[p].find(p2));
				graph[p].erase(graph[p].find(u));
				graph[p2].erase(graph[p2].find(p));
			}
			//if(ok2) break;
			best_u = -1, best_p = -1, best_sz = INT_MAX;
			for(int u = 0; u < n; u++)
			{
				if(indeg[u] != 0) continue;
				for(int c : graph[u])
				{
					if(graph[c].size() > 0 && (best_u == -1 || graph[c].size() < best_sz))
						best_sz = graph[c].size(), best_u = u, best_p = c;
				}
			}
			//printf("best_u=%d, best_p=%d, bsz=%d\n", best_u, best_p, best_sz);
			if(best_u != -1  && (require_1 ? best_sz == 1 : true))
			//for(int u = 0; u < n; u++)
			{
				int u = best_u, c = best_p;
				if(indeg[u] != 0) continue;
				//printf("%d: outdeg %d\n", u);
				//some child must be
				if(outdeg[c] == 0) continue;
				ok2 = true; ok = true;
				int c2 = *graph[c].begin();
				//printf("%d: valid child; c2=%d\n", c, c2);
				ans.push_back({u, c, c2});
				indeg[c]--; indeg[c2]--; outdeg[u]--; outdeg[c]--;
				graph[u].erase(graph[u].find(c));
				graph[c].erase(graph[c].find(c2));
				rgraph[c].erase(rgraph[c].find(u));
				rgraph[c2].erase(rgraph[c2].find(c));
			}
			if(!ok2 && require_1)
				ok2 = true; require_1 = false;
		}
	}
	for(int u = 0; u < n; u++)
	{
		for(int v : graph[u])
		{
			if(u > v) continue;
			if(graph[v].count(u) == 0) continue;
			ans.push_back({u, v, u});
			indeg[u]--; indeg[v]--; outdeg[u]--; outdeg[v]--;
			//graph[v].erase(u);
			//graph[u].erase(v);
			//rgraph[v].erase(u);
			//rgraph[u].erase(v);
		}
	}
	if(ans.size() != m / 2) { printf("No\n"); return 0; }
	printf("Yes\n");
	for(auto[u,v,w] : ans)
		printf("%d %d %d %d\n", u+1, v+1, v+1, w+1);
}
//dfs from each half-edge, marking subtrees if they don't contain any other half-edges
