#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

vector<int> num(26);

pair<string, int> f(string s) {
    vector<vector<int>> dp(s.size(), vector<int>(26, -1000000000000000000));
    vector<vector<pair<int, int>>> pred(s.size(), vector<pair<int, int>>(26));
    if (s[s.size() - 1] == '?') {
        for (int i = 0; i < 26; ++i) {
            dp[s.size() - 1][i] = num[i];
            pred[s.size() - 1][i] = {i, -1};
        }
    } else {
        int now;
        int i = s[s.size() - 1] - 'A';
        dp[s.size() - 1][s[s.size() - 1] - 'A'] = num[i];
        pred[s.size() - 1][i] = {i, -1};
    }
    for (int j = s.size() - 2; j > -1; --j) {
        if (s[j] == '?') {
            for (int i = 0; i < 26; ++i) {
                for (int elem = 0; elem < 26; ++elem) {
                    if (i >= elem) {
                        if (dp[j][max(i, elem)] < dp[j + 1][elem] + num[i]) {
                            dp[j][max(i, elem)] = dp[j + 1][elem] + num[i];
                            pred[j][max(i, elem)] = {i, elem};
                        }
                    } else {
                        if (dp[j][max(i, elem)] < dp[j + 1][elem] - num[i]) {
                            dp[j][max(i, elem)] = dp[j + 1][elem] - num[i];
                            pred[j][max(i, elem)] = {i, elem};
                        }
                    }
                }
            }
        } else {
            int i = s[j] - 'A';
            for (int elem = 0; elem < 26; ++elem) {
                if (i >= elem) {
                    if (dp[j][max(i, elem)] < dp[j + 1][elem] + num[i]) {
                        dp[j][max(i, elem)] = dp[j + 1][elem] + num[i];
                        pred[j][max(i, elem)] = {i, elem};
                    }
                } else {
                    if (dp[j][max(i, elem)] < dp[j + 1][elem] - num[i]) {
                        dp[j][max(i, elem)] = dp[j + 1][elem] - num[i];
                        pred[j][max(i, elem)] = {i, elem};
                    }
                }
            }
        }
    }
    string ans;
    int ind = max_element(dp[0].begin(), dp[0].end()) - dp[0].begin();
    int ans1 = dp[0][ind];
    for (int i = 0; i < s.size(); ++i) {
        ans += pred[i][ind].first + 'A';
        ind = pred[i][ind].second;
    }
    return {ans, ans1};
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    for (int i = 0; i < 26; ++i){
        int now;
        if (i % 2 == 0) {
            now = pow(10, i / 2);
        } else {
            now = pow(10, i / 2) * 5;
        }
        num[i] = now;
    }
    while (t--) {
        string s;
        cin >> s;
        auto res = f(s);
        cout << res.second << "\n" << res.first << "\n";
    }
}
