#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <set>
#include <cmath>

using namespace std;

long long cnt12;
long long cnt21;

void dfs2(long long v, vector <vector<pair<pair<long long, long long>, long long>>> &graph, vector <long long> &usedd, vector <long long> &ans, long long maxx) {
    if (v != 0) {
        ans[v] = min(ans[v], maxx);
    }
    for (auto nw : graph[v]) {
        if (usedd[nw.first.first] == 0) {
            long long stmax = maxx;
            if (maxx < nw.first.second) {
                maxx = nw.first.second;
            }
            usedd[nw.first.first] = 1;
            dfs2(nw.first.first, graph, usedd, ans, maxx);
            usedd[nw.first.first] = 0;
            maxx = stmax;
        }
    }
}


void dfs(long long v,vector <long long> &ans, vector <vector<pair<pair<long long, long long>, long long>>> &graph, vector<long long> &used, long long minn, long long maxx) {
    if (v != 0) {
        ans[v] = min(ans[v], minn + maxx);
    }
    for (auto nw : graph[v]) {
        if (used[nw.second] == 0) {
            long long stmin = minn;
            long long stmax = maxx;
            if (minn > nw.first.second) {
                minn = nw.first.second;
            }
            if (maxx < nw.first.second) {
                maxx = nw.first.second;
            }
            used[nw.second] = 1;
            dfs(nw.first.first, ans, graph, used, minn, maxx);
            used[nw.second] = 0;
            minn = stmin;
            maxx = stmax;
        }
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    long long n, m;
    cin >> n >> m;
    long long mxfr1 = -1;
    vector <vector<pair<pair<long long, long long>, long long>>> graph(n);
    for (long long i = 0; i < m; i++) {
        long long v, u, t;
        cin >> v >> u >> t;
        v--;
        u--;
        if (v == 0 or u == 0) {
            mxfr1 = max(mxfr1, t);
        }
        graph[v].push_back({{u, t}, i});
        graph[u].push_back({{v, t}, i});
    }
    vector <long long> ans(n, 2000000009);
    long long minn = 2000000000;
    long long maxx = -1;
    vector <long long> used(m);
    if (mxfr1 != 0) {
        dfs(0, ans, graph, used, minn, maxx);
        for (long long y = 1; y < n; y++) {
            cout << ans[y] << "\n";
        }
    }
    else {
        set <pair<long long, long long>> deq;
        deq.insert({-1, 0});
        while (deq.size() != 0) {
            long long v = deq.begin() -> second;
            long long nm = deq.begin() -> first;
            deq.erase(deq.begin());
            for (auto nw : graph[v]) {
                long long nmax = max(nm, nw.first.second);
                if (ans[nw.first.first] < nmax) {
                    deq.erase({ans[nw.first.first], nw.first.first});
                    ans[nw.first.first] = nmax;
                    deq.insert({ans[nw.first.first], nw.first.first});
                }
            }
        }
        for (long long y = 1; y < n; y++) {
            cout << ans[y] << "\n";
        }
    }
}