#include <bits/stdc++.h>
using namespace std;

#pragma GCC optimize("Ofast")
#pragma GCC target("sse3,sse4")

const int N = 2e5 + 5, inf = 1e9;

// GONNA MAKE FLOW YEP

// Dinic

struct edgeF {
  int to; short f, c; int link;
};

struct Flow {
  int size, unow;
  vector<vector<edgeF>> g;
  int istok, stok, cur_flow;

  Flow() {}
  Flow(int sz) {
    size = sz + 2;
    istok = size - 2;
    stok = size - 1;
    unow = 1;
    cur_flow = 0;
    g.resize(size);
    used.resize(size);
  }

  void add_edge(int u, int v, int c) {  // or -1 or -1
    if (u == -1) u = istok;
    if (v == -1) v = stok;
    g[u].push_back({v, 0, (short)c, (int)g[v].size()});
    g[v].push_back({u, 0, 0, (int)g[u].size() - 1});
  }

  vector<int> dist, used, uk;

  void bfs() {
    uk.resize(size);
    fill(uk.begin(), uk.end(), 0);
    dist.resize(size);
    fill(dist.begin(), dist.end(), inf);
    dist[istok] = 0;
    vector<int> q = {istok};
    q.reserve(size);
    for (int i = 0; i < q.size(); ++i) {
      int v = q[i];
      for (auto &ed : g[v]) {
        if (dist[ed.to] > dist[v] + 1 && ed.f != ed.c) {
          dist[ed.to] = dist[v] + 1;
          q.push_back(ed.to);
        }
      }
    }
  }



  int dfs(int v, int d = inf) {
    if (v == stok)
      return d;
    used[v] = unow;
    for (int i = uk[v]; i < g[v].size(); ++i) {
      auto &ed = g[v][i];
      if (used[ed.to] == unow || dist[ed.to] != dist[v] + 1 || ed.f == ed.c) {
        uk[v]++;
        continue;
      }
      int dt = dfs(ed.to, min(d, ed.c - ed.f));
      if (dt) {
        ed.f += dt;
        g[ed.to][ed.link].f -= dt;
        return dt;
      }
    }
    return 0;
  }


  void dinic() {
//    for (int i = 0; i < size; ++i)
//      random_shuffle(g[i].begin(), g[i].end());
    while (true) {
      bfs();
      bool ok = false;
      while (true) {
        int dt = dfs(istok);
        unow++;
        if (!dt)
          break;
        ok = true;
        cur_flow += dt;
      }
      if (!ok)
        break;
    }
  }

};

int n, m;

struct edge {
  int u, v, id;
};

vector<edge> e;

vector<int> g[N], gfull[N];


int dolya[N], rev[N];

void dfs(int v, int col) {
  dolya[v] = col;
  for (int u : gfull[v]) {
    if (!dolya[u]) {
      dfs(u, -col);
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  srand(time(0));

  cin >> n >> m;
  fill(rev, rev + n, -1);
  e.resize(m);
  for (int i = 0; i < m; ++i) {
    int u, v;
    cin >> u >> v;
    u--, v--;
    e[i] = {u, v};
    g[u].push_back(v);
    gfull[u].push_back(v);
    gfull[v].push_back(u);
  }

  for (int i = 0; i < n; ++i) {
    if (!dolya[i])
      dfs(i, 1);
  }

  Flow F(n + m);

  for (int i = 0; i < m; ++i) {
    if (dolya[e[i].u] > 0) {
      F.add_edge(-1, n + i, 1);
      F.add_edge(n + i, e[i].u, 1);
      F.add_edge(n + i, e[i].v, 1);
    } else {
      F.add_edge(n + i, -1, 1);
      F.add_edge(e[i].v, n + i, 1);
      F.add_edge(e[i].u, n + i, 1);
    }
  }

  F.dinic();
  if (F.cur_flow != m / 2) {
    cout << "No\n";
    return 0;
  }
  cout << "Yes\n";

  vector<vector<int>> ng1(n + m), ng2(n + m);

  vector<pair<int, int>> out;

  for (int i = 0; i < n; ++i) {
    for (auto &ed : F.g[i]) {
      if (ed.f == -1)
        ng1[i].push_back(ed.to);
      else if (ed.f == 1)
        ng2[i].push_back(ed.to);
    }
    assert(ng1[i].size() == ng2[i].size());
    for (int j = 0; j < ng1[i].size(); ++j) {
      out.emplace_back(ng1[i][j] - n, ng2[i][j] - n);
    }
  }

  for (int i = 0; i < out.size(); ++i) {
    int id1 = out[i].first, id2 = out[i].second;
    cout << e[id1].u + 1 << ' ' << e[id1].v + 1 << ' ' << e[id2].u + 1 << ' ' << e[id2].v + 1 << '\n';
  }

}