#include <iostream>
#include <set>
#include <vector>

using namespace std;

struct tree {
    int d_l;
    int d_r;
    int h;
    int x;
};

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, q;
    cin >> n >> q;
    vector <tree> trees;
    for (int i = 0; i < n; ++i) {
        int x, h;
        cin >> x >> h;
        int d_l = 0;
        if (i != 0) {
            d_l = x - trees[i - 1].x;
            trees[i - 1].d_r = d_l;
        }
        trees.push_back({d_l, 0, h, x});
    }
    if (n == 1) {
        while (q--) {
            cout << 0;
        }
        return 0;
    }
    set <int> glob_cut;
    vector <int> glob_left(n), glob_right(n);
    for (int i = 0; i < n; ++i) {
        if (max(trees[i].d_l, trees[i].d_r) >= trees[i].h) {
            glob_cut.insert(glob_cut.end(), i);
        }
        glob_left[i] = i - 1;
        glob_right[i] = i + 1;
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        set <int> cut = glob_cut;
        auto l1 = cut.lower_bound(l - 1);
        int res = 0;
        vector <int> left = glob_left, right = glob_right;
        while (l1 != cut.end() && *l1 < r) {
            int i = *l1;
            cut.erase(l1);
            ++res;
            int i1 = right[i], i2 = left[i];
            if (i1 < n) {
                left[i1] = i2;
            }
            if (i2 >= 0) {
                right[i2] = i1;
            }
            if (i1 < n && i2 >= 0) {
                int d = trees[i1].x - trees[i2].x;
                trees[i1].d_l = d;
                trees[i2].d_r = d;
                if (max(trees[i1].d_r, d) >= trees[i1].h) {
                    cut.insert(l1, i1);
                }
                if (max(trees[i2].d_l, d) >= trees[i2].h) {
                    cut.insert(l1, i2);
                }
            }
            l1 = cut.lower_bound(l - 1);
        }
        cout << res << '\n';
    }
}
