#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll INF = 1e9;
const ll MOD = 228228227;

struct Edge {
    int id, a, b;
    Edge (int edge_id, int a, int b): id(edge_id), a(a), b(b) {}
};

inline void solve() {
    int n, m;
    cin >> n >> m;

    int u, v;
    vector <Edge> edges;
    vector <vector <int>> graph(n);
    for (int i = 0; i < m; i++) {
        cin >> u >> v;
        u--; v--;

        edges.emplace_back(i, u, v);
        graph[u].push_back((int) edges.size() - 1);
    }

    vector <bool> used;
    vector <tuple <int, int, int, int>> answer;
    for (int mask = 0; mask < (1 << m); mask++) {
        used.assign(m, false);
        answer.clear();

        for (const auto &edge: edges) {
            if ((mask & (1 << edge.id)) == 0) continue;

            // if (mask == 19) cout << edge.id << " looking for his wife...\n";

            bool married = false;
            for (int edge_id: graph[edge.b]) {
                if ((mask & (1 << edge_id)) != 0) continue;
                if (used[edge_id]) continue;

                answer.push_back({edge.a, edge.b, edges[edge_id].a, edges[edge_id].b});

                married = true;
                used[edge_id] = true;
                break;
            }

            if (!married) break;
            used[edge.id] = true;
        }

        bool shit_iteration = false;
        for (int i = 0; i < m; i++) {
            if (!used[i]) {
                shit_iteration = true;
                break;
            }
        }

        if (shit_iteration) continue;

        cout << "Yes\n";
        for (auto [a, b, c, d]: answer)
            cout << a + 1 << ' ' <<  b + 1 << ' ' << c + 1 << ' ' << d + 1 << '\n';

        return;
    }

    cout << "No\n";
}

signed main() {
    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    solve();
}
