#include <iostream>
#include <iostream>
#include <set>
#include <map>
#include <algorithm>
#include <vector>

using namespace std;
const int MAXN = 5e5 + 10;

int x[MAXN];
int h[MAXN];

struct tree {
    tree *left = nullptr;
    tree *right = nullptr;

    int h;
    int x;
    bool used = false;

    tree(int h, int x) : h(h), x(x) {}
};
int n, q;

tree* create(int i, tree* left, int r){
    if(i == r)
        return nullptr;


    tree* t = new tree(h[i], x[i]);
    t->left = left;
    t->right = create(i + 1, t, r);

    return t;
}

set<int> used;
int cut_cnt = 0;
void cut(tree* t, int lx, int rx, bool top_level_call = true){
    if(t == nullptr) return;
    if(t->used || used.count(t->x)){
        return;
    }

    if(t->x - t->h >= lx && (t->left == nullptr || t->x - t->h >= t->left->x)){
        //can cut to left
        cut_cnt++;
        if(t->left != nullptr){
            t->left->right = t->right;
        }
        if(t->right != nullptr){
            t->right->left = t->left;
        }
        t->used = true;
        used.insert(t->x);

        cut(t->left, lx, rx, false);
        cut(t->right, lx, rx, false);
    }else {
        if (t->x + t->h <= rx && (t->right == nullptr || t->x + t->h <= t->right->x)) {
            //can cut to right
            cut_cnt++;
            if (t->left != nullptr) {
                t->left->right = t->right;
            }
            if (t->right != nullptr) {
                t->right->left = t->left;
            }
            t->used = true;
            used.insert(t->x);

            cut(t->left, lx, rx, false);
            cut(t->right, lx, rx, false);
        }else{
            if(top_level_call)
                cut(t->right, lx, rx);
        }
    }

}

int main() {

    cin >> n >> q;

    for (int i = 0; i < n; ++i) {
        cin >> x[i] >> h[i];
    }

    while(q--){
        int l, r;
        cin >> l >> r;
        l--;
        r--;

        tree *first = create(l, nullptr, r+1);
        cut_cnt = 0;
        used.clear();

        int lx = x[0], rx = x[n - 1];
        if(l > 0) lx = x[l - 1];
        if(r < n - 1) rx = x[r + 1];

        int last_cnt = 0;
        for (int i = 0; i < (r-l + 1); ++i) {
            for (int j = l; j <= r; ++j) {

                if(used.count(j)) continue;

                int next_l = j - 1;
                while(next_l >= l && used.count(next_l)){
                    next_l--;
                }
                next_l = max(next_l, 0);
                if(x[j] - h[j] >= x[next_l]){
                    cut_cnt++;
                    used.insert(j);
                    continue;
                }

                int next_r = j + 1;
                while(next_r <= r && used.count(next_r)) {
                    next_r++;
                }
                next_r = min(next_r, n - 1);

                if(x[j] + h[j] <= x[next_r]){
                    cut_cnt++;
                    used.insert(j);
                    continue;
                }
            }
            if(last_cnt == cut_cnt) break;
            last_cnt = cut_cnt;
        }


        //cut(first, lx, rx);

        cout << cut_cnt << endl;

    }

    return 0;
}
