#include <iostream>
#include <vector>
#include <queue>
#include <set>

using namespace std;

struct Tree {
    long long x, h, ind;

    inline Tree(long long x = 0, long long h = 0, long long i = 0) {
        this->x = x;
        this->h = h;
        ind = i;
    }

    inline bool operator<(Tree other) const {
        return x < other.x;
    }
};

vector<Tree> trees;
long long taken[8192], launch = 1;
int n, x, h, qr, l, r, left_border, right_border;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> qr;
    for (int i = 0; i < n; i++) {
        cin >> x >> h;
        trees.emplace_back(x, h, i);
    }

    queue<Tree> q;
    Tree cur;
    int count;
    set<Tree>::iterator left, right;

    while (qr--) {
        launch++;
        cin >> l >> r;
        set<Tree> temp;

        left_border = trees[max(0, l - 2)].x;
        right_border = trees[min(n, r - 1)].x;

        for (int i = l - 1; i < r; i++) {
            if (i > 0 and trees[i].x - trees[i - 1].x >= trees[i].h or i < n - 1 and
                trees[i + 1].x - trees[i].x >= trees[i].h) {
                q.push(trees[i]);
                taken[trees[i].ind] = launch;
            }
            temp.insert(trees[i]);
        }
        count = 0;
        while (!q.empty()) {
            cur = q.front();
            left = temp.lower_bound(cur);
            right = left;
            right++;
            if (right != temp.end() and left != temp.begin()) {
                left--;
                if (right->x - left->x >= right->h and taken[right->ind] != launch and taken[right->ind] != launch) {
                    q.push(*right);
                    taken[right->ind] = launch;
                }
                if (right->x - left->x >= left->h and taken[left->ind] != launch) {
                    q.push(*left);
                    taken[left->ind] = launch;
                }
            } else if (right != temp.end()) {
                if (right->h <= right->x - left_border and taken[right->ind] != launch) {
                    q.push(*right);
                    taken[right->ind] = launch;
                }
            } else if (left != temp.begin()) {
                left--;
                if (left->h <= right_border - left->x and taken[left->ind] != launch) {
                    q.push(*left);
                    taken[left->ind] = launch;
                }
            }
            temp.erase(cur);
            count++;
            q.pop();
        }
        cout << count << '\n';
    }
}