#include <iostream>
#include <vector>
#include <queue>
#include <set>

using namespace std;

struct Tree {
    int x = 0, h = 0, ind = 0;

    Tree(int x = 0, int h = 0, int i = 0) {
        this->x = x;
        this->h = h;
        this->ind = i;
    }

    bool operator<(Tree other) const {
        return x < other.x;
    }
};

vector<Tree> trees;
set<Tree> temp, all;
int n, x, h, q, l, r, left_border = 999999999, right_border = -1;

void print(set<Tree> a) {
    for (Tree t: a) {
        cout << t.x << ", " << t.h << "; ";
    }
    cout << endl;
}

int main() {
    cin >> n >> q;
    for (int i = 0; i < n; i++) {
        cin >> x >> h;
        trees.emplace_back(x, h, i + 1);
        all.insert(Tree(x, h, i + 1));
    }

    while (q--) {
        cin >> l >> r;
        temp.clear();
        queue<Tree> q;
        Tree left, right, cur;
        set<int> taken;

        if (l == 1) left_border = trees[l - 1].x;
        else left_border = trees[l - 2].x;
        if (r == n) right_border = trees[r - 1].x;
        else right_border = trees[r].x;

        for (int i = l - 1; i < r; i++) {
            if (i > 0 and trees[i].x - trees[i - 1].x >= trees[i].h) {
                q.push(trees[i]);
                taken.insert(trees[i].x);
            } else if (i < n - 1 and trees[i + 1].x - trees[i].x >= trees[i].h) {
                q.push(trees[i]);
                taken.insert(trees[i].x);
            }
            temp.insert(trees[i]);
        }
        int count = 0;
       // print(temp);
        while (!q.empty()) {
            cur = q.front();
          //  cout << "Deleting " << cur.x << endl;
            auto next_right_p = temp.upper_bound(cur), next_left_p = temp.lower_bound(cur);
            if (next_right_p != temp.end() and next_left_p != temp.begin()) {
                right = *next_right_p;
                next_left_p--;
                left = *next_left_p;
                if (right.x - left.x >= right.h) {
                    if (taken.find(right.x) == taken.end()) {
                        q.push(right);
                       // cout << "Adding " << right.x << endl;
                        taken.insert(right.x);
                    }
                }
                if (right.x - left.x >= left.h) {
                    if (taken.find(left.x) == taken.end()) {
                        q.push(left);
                       // cout << "Adding " << left.x << endl;
                        taken.insert(left.x);
                    }
                }
            } else if (next_right_p != temp.end()) {
                right = *next_right_p;
                if (right.h <= right.x - left_border) {
                    if (taken.find(right.x) == taken.end()) {
                        q.push(right);
                        //cout << "Adding " << right.x << endl;
                        taken.insert(right.x);
                    }
                }
            } else if (next_left_p != temp.begin()) {
                next_left_p--;
                left = *next_left_p;
                if (left.h <= right_border - left.x){
                    if (taken.find(left.x) == taken.end()) {
                        q.push(left);
                       // cout << "Adding " << left.x << endl;
                        taken.insert(left.x);
                    }
                }
            }
            temp.erase(cur);
            count++;
            q.pop();
           // print(temp);
        }
        cout << count << endl;
    }
}