#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <iomanip>
#include <cassert>
using namespace std;
#define int long long
#define debug(x) cout << #x << " is " << x << '\n';
#define ld long double
vector <vector <int>> g;
vector <int> match, color;
void dfs(int v, int c) {
	color[v] = c;
	for (auto u : g[v]) {
		if (color[u]) assert(color[u] == 3 - c);
		else dfs(u, 3 - c);
	}
}
vector <bool> used;
bool kuhn(int v) {
	debug(v)
	if (used[v]) return false;
	used[v] = true;
	for (auto u : g[v]) {
		if (match[u] == -1) {
			match[u] = v;
			return true;
		}
	}
	for (auto u : g[v]) {
		if (kuhn(match[u])) {
			match[u] = v;
			return true;
		}
	}
	return false;
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout << fixed << setprecision(6);
	int n, m; cin >> n >> m;
	vector <vector <int>> e(m, vector <int>(2));
	color.resize(m);
	match.resize(m, -1);
	g.resize(m);
	for (auto& x : e)
		cin >> x[0] >> x[1];
	for (int i = 0; i < m; ++i) {
		for (int j = i + 1; j < m; ++j) {
			if (e[i][1] == e[j][0] or e[i][0] == e[j][1])
				g[i].push_back(j), g[j].push_back(i);
		}
	}
	for (int i = 0; i < m; ++i) {
		if (!color[i]) dfs(i, 1);
	}
	used.resize(m);
	for (int i = 0; i < m; ++i) {
		if (color[i] == 2) {
			for (int j = 0; j < m; ++j)
				used[j] = false;
			kuhn(i);
		}
	}
	int cnt = 0;
	for (int i = 0; i < m; ++i) {
		cnt += (match[i] != -1);
	}
	if (cnt == m / 2) {
		cout << "Yes\n";
		for (int i = 0; i < m; ++i) {
			if (match[i] != -1) {
				if (e[i][1] == e[match[i]][0]) {
					cout << e[i][0] << ' ' << e[i][1] << ' ';
					cout << e[match[i]][0] << ' ' << e[match[i]][1] << '\n';
				}
				else {
					cout << e[match[i]][0] << ' ' << e[match[i]][1] << ' ';
					cout << e[i][0] << ' ' << e[i][1] << '\n';
				}
			}
		}
	}
	else cout << "No\n";
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2
*/