#include <bits/stdc++.h>

#define ALL(x) (x).begin(), (x).end()

using namespace std;
using ll = long long;

map<char, ll> to_values;

int n;

int solve() {
    if (!(cin >> n))
        return 1;
    ll val = 1;
    for (char c = 'A'; c <= 'Z'; ++c) {
        to_values[c] = val;
        if ((c - 'A') % 2 == 0) {
            val *= 5LL;
        } else {
            val *= 2LL;
        }
    }

    for (int _ = 0; _ < n; ++_) {
        string s;
        cin >> s;
        int l = s.length();
        vector<char> suf_max(l + 1);
        suf_max[l] = 'A';
        for (int i = l - 1; i >= 0; --i) {
            suf_max[i] = max(suf_max[i + 1], s[i]);
        }

        vector<ll> cur_values(26, 0LL);
        ll all_sum = 0;
        vector<char> replacements;
        for (int i = 0; i < l; ++i) {
            if (s[i] != '?') {
                all_sum += to_values[s[i]];
                cur_values[s[i] - 'A'] += to_values[s[i]];      // we will die if the letter will be higher
            } else {
                replacements.emplace_back('Z');
                ll max_val = LONG_LONG_MIN;
                ll cur_live = 0;
                for (char c = 'Z'; c >= suf_max[i]; --c) {
                    cur_live += cur_values[c - 'A'];
                    ll now_val = 2 * cur_live + to_values[c] - all_sum;
                    if (now_val >= max_val) {
                        replacements.back() = c;
                        max_val = now_val;
                    }
                }
                for (char c = 'A'; c < replacements.back(); ++c) {
                    cur_values[c - 'A'] = 0;
                }
                cur_values[replacements.back() - 'A'] += to_values[replacements.back()];
            }
        }
        string n_s;
        int cur_rep = 0;
        for (int i = 0; i < l; ++i) {
            if (s[i] == '?') {
                n_s += replacements[cur_rep++];
            } else {
                n_s += s[i];
            }
        }
        s = n_s;

        suf_max.clear();
        suf_max.resize(l + 1);
        suf_max[l] = 'A';
        for (int i = l - 1; i >= 0; --i) {
            suf_max[i] = max(suf_max[i + 1], s[i]);
        }

        ll value = 0;
        for (int i = 0; i < l; ++i) {
            if (suf_max[i] > s[i]) {
                value -= to_values[s[i]];
            } else {
                value += to_values[s[i]];
            }
        }
        cout << value << '\n';
        cout << s << '\n';
    }
    return 0;
}


int main() {
#ifdef LOCAL
    freopen("A.in", "r", stdin);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int tests = 1e9;
    for (int i = 0; i < tests; ++i) {
        if (solve())
            break;

#ifdef LOCAL
        cout << "------------------------\n";
#endif
    }
}