#include <bits/stdc++.h>

#define ALL(x) (x).begin(), (x).end()
#define int long long

using namespace std;
using ll = long long;

int n, m;
const int MAX_N = 300000 + 566;
const int MAX_LOG = 20;
vector<pair<int, ll>> graph[MAX_N];
vector<pair<int, ll>> graph_ed_inds[MAX_N];
vector<pair<pair<int, int>, ll>> edges;
vector<ll> answer;

void dfs(int v, int parent = -1, ll cur_min = LONG_LONG_MAX, ll cur_max = 0) {
    answer[v] = cur_max + cur_min;
    for (auto[u, t] : graph[v]) {
        if (u == parent) continue;
        dfs(u, v, min(cur_min, t), max(cur_max, t));
    }
}

int dsu[21], rang[21];

int get(int v) {
    if (dsu[v] == v) return v;
    return dsu[v] = get(dsu[v]);
}

void unite(int a, int b) {
    a = get(a); b = get(b);
    if (rang[a] > rang[b]) {
        dsu[b] = a;
    } else if (rang[b] > rang[a]) {
        dsu[a] = b;
    } else {
        dsu[a] = b;
        rang[b]++;
    }
}

pair<int, ll> walk_on_mask(int mask) {
    for (int i = 0; i < m; ++i) {
        dsu[i] = i;
        rang[i] = 0;
    }

    vector<int> pos(n, 0);
    ll cur_min = LLONG_MAX, cur_max = 0;
    for (int i = 0; i < m; ++i) {
        if (!(mask & (1 << i))) continue;
        auto [vu, t] = edges[i];
        cur_min = min(cur_min, t);
        cur_max = max(cur_max, t);
        int v = vu.first, u = vu.second;
        unite(v, u);
        pos[v]++;
        pos[u]++;
    }
    int oth = 0;
    for (int i = 1; i < n; ++i) {
        if (pos[i] % 2 == 1) {
            if (oth != 0) {
                return {-1, -1};
            } else {
                oth = i;
            }
        }
    }
    if (oth == 0 || (pos[0] % 2 == 0)) {
        return {-1, -1};
    } else {
        return {oth, cur_min + cur_max};
    }
}


void reset() {
    answer.clear();
    answer.resize(n);
    for (int i = 0; i < n; ++i) {
        graph[i].clear();
    }
}

int solve() {
    if (!(cin >> n >> m))
        return 1;
    reset();
    bool is_second = true;
    bool is_sixth = true;
    for (int i = 0; i < m; ++i) {
        int u, v;
        ll t;
        cin >> u >> v >> t;
        u--;
        v--;
        if (abs(u - v) > 1) {
            is_sixth = false;
        }
        if (u * v == 0) {
            if (t != 0) {
                is_second = false;
            }
        }
        graph[u].emplace_back(make_pair(v, t));
        graph[v].emplace_back(make_pair(u, t));
        edges.emplace_back(make_pair(make_pair(v, u), t));
    }
    answer.clear();
    answer.resize(n, INT_MAX);
    if (m == n - 1) {
        dfs(0);
        for (int i = 1; i < n; ++i) {
            cout << answer[i] << '\n';
        }
    } else if (is_second) {
        priority_queue<pair<ll, int>> q;
        answer[0] = 0;
        vector<bool> used(n, false);
        q.push(make_pair(0, 0));
        while (!q.empty()) {
            int v = q.top().second;
            q.pop();
            if (used[v]) continue;
            used[v] = true;
            for (auto[u, t] : graph[v]) {
                if (max(answer[v], t) < answer[u]) {
                    answer[u] = max(answer[v], t);
                    q.push(make_pair(-answer[u], u));
                }
            }
        }
        for (int i = 1; i < n; ++i) {
            cout << answer[i] << '\n';
        }
    } else if (m <= 20) {
        for (int mask = 0; mask < (1 << m); ++mask) {
            auto [v, vall] = walk_on_mask(mask);
            if (v != -1) {
                answer[v] = min(answer[v], vall);
            }
        }
        for (int i = 1; i < n; ++i) {
            cout << answer[i] << '\n';
        }
    } else if (is_sixth) {
        vector<ll> real_min(n - 1, LLONG_MAX);
        for (int v = 0; v < n - 1; ++v) {
            for (auto[u, t] : graph[v]) {
                if (u < v) continue;
                real_min[v] = min(real_min[v], t);
            }
        }
        ll cur_min = LLONG_MAX, cur_max = 0;
        for (int i = 0; i < n - 1; ++i) {
            cur_min = min(cur_min, real_min[i]);
            cur_max = max(cur_max, real_min[i]);
            cout << cur_min + cur_max << '\n';
        }
    }
    return 0;
}


int main() {
#ifdef LOCAL
    freopen("D.in", "r", stdin);
#endif
    cin.tie(nullptr);
    cout.tie(nullptr);
    iostream::sync_with_stdio(false);

    int tests = 1e9;
    for (int i = 0; i < tests; ++i) {
        if (solve())
            break;

#ifdef LOCAL
        cout << "------------------------\n";
#endif
    }
}
