#include "bits/stdc++.h"

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define all(x) x.begin(), x.end()

//#define GLIBCXX_DEBUG

namespace {
    template<typename F, typename S>
    istream& operator>>(istream& in, pair<F, S>& p) {return in >> p.first >> p.second;}
    template<typename T>
    istream& operator>>(istream& in, vector<T>& v) {
        for (auto & e : v)
            in >> e;
        return in;
    }
}

void solve();

signed main(int argc, char* argv[]) {
#ifdef GEN
    freopen("gen.in", "r", stdin);
    freopen(argv[1], "w", stdout);
#endif
//    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
//    int t;
//    cin >> t;
//    while(t--)
        solve();
}

void solve() {
    int n, q;
    cin >> n >> q;
    vector<pii> trees(n);
    cin >> trees;
    vector<vector<int>> conflictsAtRight(n), conflictsAtLeft(n);
    vector<int> conflictsLeft(n, 0), conflictsRight(n, 0);
    for (int l = 0; l < n; l++) {
        if (trees[l].first + trees[l].second > trees[n - 1].first)
            conflictsRight[l]++;
        if (trees[l].first - trees[l].second < trees[0].first)
            conflictsLeft[l]++;

        for (int r = l + 1; r < n; r++) {
            if (trees[l].first + trees[l].second > trees[r].first) {
                conflictsRight[l]++;
                conflictsAtLeft[r].push_back(l);
            }
            if (trees[r].first - trees[r].second < trees[l].first) {
                conflictsLeft[r]++;
                conflictsAtRight[l].push_back(r);
            }
        }
    }

    vector<vector<int>> _conflictsAtRight(all(conflictsAtRight)), _conflictAtLeft(all(conflictsAtLeft));
    auto _conflictsLeft = conflictsLeft, _conflictsRight = conflictsRight;



    while (q--) {
        set<pii> leftQueue, rightQueue;
        int l, r;
        cin >> l >> r;

        conflictsAtRight = _conflictsAtRight;
        conflictsAtLeft = _conflictAtLeft;
        conflictsRight = _conflictsRight;
        conflictsLeft = _conflictsLeft;

        for (int i = l - 1; i < r; i++) {
            leftQueue.insert({conflictsLeft[i], i});
            rightQueue.insert({conflictsRight[i], i});
        }

        assert(leftQueue.size() == r - l + 1);

        vector<bool> done(n, false);

        while ((!leftQueue.empty() && leftQueue.begin()->first == 0) ||
               (!rightQueue.empty() && rightQueue.begin()->first == 0)) {
            while (!leftQueue.empty() && leftQueue.begin()->first == 0) {
                auto [cnt, idx] = *leftQueue.begin();
                leftQueue.erase({conflictsLeft[idx], idx});
                rightQueue.erase({conflictsRight[idx], idx});
                done[idx] = true;
                for (int e : conflictsAtLeft[idx]) {
                    if (done[e] || e < l - 1 || e >= r)
                        continue;
                    rightQueue.erase({conflictsRight[e], e});
                    conflictsRight[e]--;
                    rightQueue.insert({conflictsRight[e], e});
                }
                for (int e : conflictsAtRight[idx]) {
                    if (done[e] || e < l - 1 || e >= r)
                        continue;
                    leftQueue.erase({conflictsLeft[e], e});
                    conflictsLeft[e]--;
                    leftQueue.insert({conflictsLeft[e], e});
                }
            }
            while (!rightQueue.empty() && rightQueue.begin()->first == 0) {
                auto [cnt, idx] = *rightQueue.begin();
                leftQueue.erase({conflictsLeft[idx], idx});
                rightQueue.erase({conflictsRight[idx], idx});
                done[idx] = true;
                for (int e : conflictsAtLeft[idx]) {
                    if (done[e] || e < l - 1 || e >= r)
                        continue;
                    rightQueue.erase({conflictsRight[e], e});
                    conflictsRight[e]--;
                    rightQueue.insert({conflictsRight[e], e});
                }
                for (int e : conflictsAtRight[idx]) {
                    if (done[e] || e < l - 1 || e >= r)
                        continue;
                    leftQueue.erase({conflictsLeft[e], e});
                    conflictsLeft[e]--;
                    leftQueue.insert({conflictsLeft[e], e});
                }
            }
        }
        int ans = r - l + 1 - int(leftQueue.size());
        assert(ans >= 0);
        cout << ans << '\n';
    }



}