#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb push_back
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()

void debug_out() {
    cerr << endl;
}

template<typename Head, typename... Tail>
void debug_out(Head H, Tail... T) {
    cerr << " " << to_string(H);
    debug_out(T...);
}

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());
const int N = 5e3 + 5;
const int INF = 1e18;

#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)

int sootv[26];
int dp[N][26][26];
pair<int, int> p[N][26][26];

void solve() {
    string s;
    cin >> s;
    int n = sz(s);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < 26; j++) {
            for (int k = 0; k < 26; k++) {
                dp[i][j][k] = -INF;
                p[i][j][k] = {-1, -1};
            }
        }
    }
    if (s[n - 1] == '?') {
        for (int i = 0; i < 26; i++) {
            for (int j = 0; j <= i; j++) {
                dp[n - 1][i][j] = sootv[i];
            }
        }
    } else {
        int c = s[n - 1] - 'A';
        for (int i = 0; i <= c; i++) {
            dp[n - 1][c][i] = sootv[c];
        }
    }
    for (int i = n - 2; i >= 0; i--) {
        if (s[i] != '?') {
            int c = s[i] - 'A';
            for (int j = 0; j < 26; j++) {
                for (int prev = 0; prev <= j; prev++) {
                    if (j > c) {
                        int aga = dp[i + 1][prev][j] - sootv[c];
                        if (aga > dp[i][c][j]) {
                            dp[i][c][j] = aga;
                            p[i][c][j] = {prev, j};
                        }
                    } else {
                        int aga = dp[i + 1][prev][j] + sootv[c];
                        if (aga > dp[i][c][j]) {
                            dp[i][c][j] = aga;
                            p[i][c][j] = {prev, j};
                        }
                    }
                }
            }
        } else {
            for (int here = 0; here < 26; here++) {
                for (int mx = 0; mx < 26; mx++) {
                    for (int prev = 0; prev <= mx; prev++) {
                        if (here >= mx) {
                            int aga = dp[i + 1][prev][mx] + sootv[here];
                            if (aga > dp[i][here][here]) {
                                dp[i][here][here] = aga;
                                p[i][here][here] = {prev, mx};
                            }
                        } else {
                            int aga = dp[i + 1][prev][mx] - sootv[here];
                            if (aga > dp[i][here][mx]) {
                                dp[i][here][mx] = aga;
                                p[i][here][mx] = {prev, mx};
                            }
                        }
                    }
                }
            }
        }
    }
    int res = -INF;
    for (int i = 0; i < 26; i++) {
        for (int j = 0; j < 26; j++) {
            res = max(res, dp[0][i][j]);
        }
    }
    int x, y;
    for (int i = 0; i < 26; i++) {
        for (int j = 0; j < 26; j++) {
            if (dp[0][i][j] == res) {
                x = i;
                y = j;
            }
        }
    }
    string ss;
    ss += 'A' + x;
    for (int i = 1; i < n; i++) {
        auto [next_x, next_y] = p[i - 1][x][y];
        x = next_x;
        y = next_y;
        ss += 'A'  + x;
    }
    cout << res << '\n';
    cout << ss << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    sootv[0] = 1;
    for (int i = 1; i < 26; i++) {
        if (i % 2) {
            sootv[i] = sootv[i - 1] * 5;
        } else {
            sootv[i] = sootv[i - 1] * 2;
        }
    }

    int T = 1;
    cin >> T;

    while (T-- > 0) {
        solve();
    }

    return 0;
}
