#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>

using namespace std;
#define x first
#define y second

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

mt19937 rand1(chrono::high_resolution_clock::now().time_since_epoch().count());
int randlr(int l, int r) {
    return rand1() % (r - l + 1) + l;
}

int x[500009];
int h[500009];

const int inf = 1e9 + 7;
bool ers[500009];

pii lefseg[500009];
pii rigseg[500009];

vector<int> tree[2000009];
inline vector<int> relax(vector<int> &lef, vector<int> &rig, int l, int r) {
    int n = lef.size(), m = rig.size();
    int i = n - 1, j = 0;
    while (i >= 0 && j < m) {
        if (rigseg[lef[i]].y < rig[j]) {
            i--;
        }

        else if (lefseg[rig[j]].x > lef[i]) {
            j++;
        }

        else {
            break;
        }
    }

    if (j == m) {
        while (i >= 0) {
            if (rigseg[lef[i]].y <= r) {
                i--;
            }

            else {
                break;
            }
        }
    }

    if (i < 0) {
        while (j < m) {
            if (lefseg[rig[j]].x >= l) {
                j++;
            }

            else {
                break;
            }
        }
    }

    vector<int> answ;

    int il = 0;
    while (il <= i && l <= lefseg[lef[il]].x) {
        il++;
    }

    int jl = m - 1;
    while (jl >= j && r >= rigseg[rig[jl]].y) {
        jl--;
    }

    for (int t = il; t <= i; t++) answ.push_back(lef[t]);
    for (int t = j; t <= jl; t++) answ.push_back(rig[t]);

    return answ;
}

void build(int v, int tl, int tr) {
    if (tr - tl == 1) {
        tree[v] = {tl};
        if (lefseg[tl].x > lefseg[tl].y || rigseg[tl].y < rigseg[tl].x) tree[v] = {};
        return;
    }

    int tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build((v << 1) + 1, tm, tr);
    tree[v] = relax(tree[v << 1], tree[(v << 1) + 1], tl, tr - 1);
}

vector<int> get(int v, int tl, int tr, int l, int r) {
    if (tl >= r || l >= tr) return {};
    if (tl >= l && tr <= r) return tree[v];
    int tm = (tl + tr) >> 1;
    auto retl = get(v << 1, tl, tm, l, r), retr = get((v << 1) + 1, tm, tr, l, r);
    //cout << v << ' ' << tl << ' ' << tr << ' ' << retl.size() << ' ' << retr.size() << endl;
    return relax(retl, retr, max(tl, l), min(tr, r) - 1);
}

signed main() {
    ios :: sync_with_stdio(0);
    cin.tie(0);

    #ifdef localfile
        freopen("input.txt", "r", stdin);
    #endif // localfile

    int n, q;
    cin >> n >> q;

    for (int i = 1; i <= n; i++) {
        cin >> x[i] >> h[i];
    }

    x[0] = x[1];
    x[n + 1] = x[n];

    for (int i = 1; i <= n; i++) {
        int l = 0, r = i + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (x[m] <= x[i] - h[i]) {
                l = m;
            }

            else {
                r = m;
            }
        }

        lefseg[i] = {r, i - 1};
        if (x[i] - h[i] < x[1]) lefseg[i] = {0, i - 1};

        l = i, r = n + 1;
        while (r - l > 1) {
            int m = (r + l) / 2;
            if (x[m] >= x[i] + h[i]) {
                r = m;
            }

            else {
                l = m;
            }
        }

        rigseg[i] = {i + 1, l};
        if (x[i] + h[i] > x[n]) rigseg[i] = {i  +1, n + 1};

        //cout << i << ' ' << lefseg[i].x << ' ' << lefseg[i].y << endl;
        //cout << i << ' ' << rigseg[i].x << ' ' << rigseg[i].y << endl;
    }

    build(1, 1, n+ 1);
    for (int qqq = 0; qqq < q; qqq++) {
        int l, r;
        cin >> l >> r;

        auto ret = get(1, 1, n + 1, l, r + 1);

        int answ = (r - l + 1) - ret.size();
        cout << answ << "\n";
    }

    return 0;
}


