#include<bits/stdc++.h>

#define fi first
#define se second
#define mp make_pair
#define em emplace
#define eb emplace_back
#define pb pop_back
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

const int inf = 1e9;
const int N = 3e5 + 5;

int n, m;
vector<pii> g[N];
vector<pii> edges;
int wei[N];

void add_edge(int i) {
    int v = edges[i - 1].fi, u = edges[i - 1].se;
    g[v].eb(u, i);
    g[u].eb(v, i);
}

int dp[3][N];
set<pii> Q;
bool ban[N];

void dijkstra(int s, int i) {
    fill(dp[i] + 1, dp[i] + n + 1, inf);
    dp[i][s] = 0;
    Q.em(dp[i][s], s);
    while (!Q.empty()) {
        int v = Q.begin()->se;
        Q.erase(Q.begin());
        for (auto &e : g[v]) {
            int u = e.fi, j = e.se, w = wei[j];
            if (!ban[j] && max(dp[i][v], w) < dp[i][u]) {
                Q.erase(mp(dp[i][u], u));
                dp[i][u] = max(dp[i][v], w);
                Q.em(dp[i][u], u);
            }
        }
    }
}

int ans[N];

int32_t main() {
    freopen("input.txt", "r", stdin);
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m;
    for (int i = 1; i <= m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        wei[i] = w;
        edges.eb(v, u);
    }
    fill(ans + 1, ans + n + 1, 2 * inf);
    for (int i = 1; i <= m; ++i) {
        ban[i] = 1;
        for (int j = 1; j <= n; ++j) g[j].clear();
        for (int j = 1; j <= m; ++j) {
            if (wei[j] >= wei[i]) {
                add_edge(j);
            }
        }
        int A = edges[i - 1].fi, B = edges[i - 1].se;
        dijkstra(1, 0);
        dijkstra(A, 1);
        dijkstra(B, 2);
        for (int k = 2; k <= n; ++k) {
            ans[k] = min(ans[k], wei[i] + max({wei[i], dp[0][A], dp[2][k]}));
            ans[k] = min(ans[k], wei[i] + max({wei[i], dp[0][B], dp[1][k]}));
        }
        ban[i] = 0;
    }
    for (int i = 2; i <= n; ++i) cout << ans[i] << "\n";
    return 0;
}
