#include <bits/stdc++.h>
using namespace std;


#define ll long long
#define pb push_back
#define all(x) x.begin(), x.end()


mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());


int rnd(int l, int r) {
    uniform_int_distribution<int> range(l, r);
    return range(rng);
}


struct edge {
    int u, w;
    int index;
};


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> g(n);
    vector<vector<int>> ed;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[v].pb({u, w, i});
        g[u].pb({v, w, i});
        ed.pb({v, u, w});
    }
    vector<int> tin(n), fup(n), used(n);
    set<int> br;
    int timer = 0;

    function<void(int, int)> dfs = [&](int v, int pr) {
        tin[v] = timer++;
        fup[v] = tin[v];
        used[v] = 1;
        for (auto e : g[v]) {
            if (e.index == pr) {
                continue;
            }
            if (used[e.u]) {
                fup[v] = min(fup[v], tin[e.u]);
            } else {
                dfs(e.u, e.index);
                fup[v] = min(fup[v], fup[e.u]);
                if (fup[e.u] > tin[v]) {
                    br.insert(e.index);
                }
            }
        }
    };

    dfs(0, -1);
    vector<int> minEdge(n, 1e9 + 1);
    vector<int> compInd(n, -1);
    int cmp = 0;

    function<void(int)> dfs1 = [&](int v) {
        compInd[v] = cmp;
        for (auto e : g[v]) {
            if (br.count(e.index)) {
                continue;
            }
            minEdge[cmp] = min(minEdge[cmp], e.w);
            if (compInd[e.u] == -1) {
                dfs1(e.u);
            }
        }
    };

    for (int i = 0; i < n; i++) {
        if (compInd[i] == -1) {
            dfs1(i);
            cmp++;
        }
    }
    vector<vector<edge>> gt(cmp);
    for (auto i : br) {
        gt[ed[i][0]].pb({ed[i][1], ed[i][2]});
        gt[ed[i][1]].pb({ed[i][0], ed[i][2]});
    }
    vector<int> answer(cmp, 2e9 + 1);

    function<void(int, int, int)> dfs2 = [&](int v, int pr, int mn) {
        mn = min(mn, minEdge[v]);
        answer[v] = mn;
        for (auto e : gt[v]) {
            if (e.u == pr) {
                continue;
            }
            dfs2(e.u, v, min(mn, e.w));
        }
    };

    dfs2(0, -1, 1e9 + 1);
    for (int i = 1; i < n; i++) {
        cout << 1000000000 + answer[compInd[i]] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
    return 0;
}