
#include "bits/stdc++.h"

using namespace std;

#define fi first
#define se second

typedef long long ll;

vector<set<int>> g, ginv;
set<pair<int, int>> e;

vector<int> cnt;
vector<int> parent;

int n, m;

int dfs(int v, int p) {
    int ans = 0;
    parent[v] = p;
    for(auto u: g[v]) {
        if(u == p) continue;
        int x = 1;
        if(e.count({u, v})) {
            x = 2;
        }
        ans += x + dfs(u, v);
    }
    cnt[v] = ans;
    return ans;
}

int getcnt(int st, int en) {
    int x = 1;
    if(e.count({en, st})) x = 2;
    if(parent[en] == st) {
        return x + cnt[en];
    }else{
        //cout << m << '\n';
        //cout << cnt[st] << '\n';
        return m - cnt[st];
    }
}

vector<pair<pair<int, int>, pair<int, int>>> ans;

void del(int u, int v) {
    //cout << "DEL: " << u << ' ' << v << '\n';
    g[u].erase(v);
    ginv[v].erase(u);
    e.erase({u, v});
}

int main() {
    cin >> n >> m;
    g.resize(n); ginv.resize(n);
    for(int i = 0; i < m; ++i) {
        int x, y; cin >> x >> y; --x; --y;
        g[x].insert(y);
        ginv[y].insert(x);
        e.insert({x, y});
    }

    cnt.resize(n);
    parent.resize(n);
    dfs(0, -1);

    queue<pair<int, int>> q;

    for(auto x: e) {
        if(!e.count({x.se, x.fi})) q.push(x);
    }

    while(!q.empty()) {
        //dfs(0, -1);
        auto x = q.front();
        q.pop();
        if(!e.count(x)) continue;
        int u = x.fi, v = x.se;
        //cout << u << ' ' << v << '\n';
        //cout << getcnt(u, v) <<  ' ' << getcnt(v, u) << "\n\n\n";
        if((getcnt(u, v) + getcnt(v, u)) % 2 == 0) {
            cout << "No";
            return 0;
        }
        bool tr;
        if(getcnt(u, v) % 2 == 0) {
            tr = false;
            for(auto t: g[v]) {
                if(getcnt(v, t) % 2 == 1) {
                    del(u, v);
                    del(v, t);
                    ans.push_back({{u, v}, {v, t}});
                    if(e.count({t, v})) q.push({t, v});
                    tr = true;
                    break;
                }
            }
        }else{
            tr = false;
            for(auto t: ginv[u]) {
                if(getcnt(u, t) % 2 == 1) {
                    del(u, v);
                    del(t, u);
                    ans.push_back({{t, u}, {u, v}});
                    if(e.count({u, t})) q.push({u, t});
                    tr = true;
                    break;
                }
            }
        }
        if(!tr) {
            cout << "No";
            return 0;
        }
    }

    for(auto x: e) {
        if(x.fi < x.se) {
            ans.push_back({x, {x.se, x.fi}});
        }
    }
    cout << "Yes\n";
    for(auto x: ans) {
        cout << x.fi.fi + 1 << ' ' << x.fi.se + 1 << ' ' << x.se.fi + 1 << ' ' << x.se.se + 1 << '\n';
    }



    return 0;
}
/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

 */
