#include <iostream>
#include <vector>
#include <cstring>
#include <algorithm>

using namespace std;

vector<pair<pair<int, int>, int>>* gr;

const int INF = 1e9 + 7;

int* ans;
bool* used;

void dfs(int v, int mn, int mx)
{
	ans[v] = min(ans[v], mn + mx);
	for (const auto& to : gr[v])
	{
		if (used[to.second])
			continue;
		used[to.second] = 1;
		int u = to.first.first, t = to.first.second;
		dfs(u, min(mn, t), max(mx, t));
		used[to.second] = 0;
	}
}

int main()
{
	int n, m;
	cin >> n >> m;
	gr = new vector<pair<pair<int, int>, int>>[n];
	int u, v, t;
	for (int i = 0; i < m; i++)
	{
		cin >> u >> v >> t;
		u--, v--;
		gr[u].push_back({ { v, t }, i });
		gr[v].push_back({ { u, t }, i });
	}
	ans = new int[n];
	for (int i = 0; i < n; i++)
		ans[i] = 2 * INF;
	used = new bool[m];
	memset(used, 0, m * sizeof(bool));
	dfs(0, INF, -INF);
	for (int k = 1; k < n; k++)
		cout << ans[k] << "\n";
}
