#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

vector<pair<int, int>>* gr;

const int INF = 1e9 + 7;

int n;
int* max_on_way;

void dejkstra()
{
	max_on_way = new int[n];
	for (int i = 0; i < n; i++)
		max_on_way[i] = INF;
	max_on_way[0] = 0;
	set<pair<int, int>> q;
	q.insert({ max_on_way[0], 0 });
	while (!q.empty())
	{
		int v = q.begin()->second;
		q.erase(q.begin());
		for (const auto& to : gr[v])
		{
			int u = to.first, t = to.second;
			if (max(max_on_way[v], t) < max_on_way[u])
			{
				q.erase({ max_on_way[u], u });
				max_on_way[u] = max(max_on_way[v], t);
				q.insert({ max_on_way[u], u });
			}
		}
	}
}

int main()
{
	int m;
	cin >> n >> m;
	gr = new vector<pair<int, int>>[n];
	int u, v, t;
	for (int i = 0; i < m; i++)
	{
		cin >> u >> v >> t;
		u--, v--;
		gr[u].push_back({ v, t });
		gr[v].push_back({ u, t });
	}
	dejkstra();
	for (int k = 1; k < n; k++)
		cout << max_on_way[k] << "\n";
}
