#include <algorithm>
#include <iostream>
#include <vector>
#include <set>
#include <bitset>

#define all(x) x.begin(), x.end()

using namespace std;

typedef long long ll;

const ll cst = (ll)6e3 + 50;
const ll inf = (ll)1e18 + 228;

struct edge {
	ll v, u, c, f;
};

ll n, m;

vector<ll> inc[cst];
vector<ll> out[cst];

vector<pair<ll, ll>> dgs;

ll s = 6006, t = s + 1;

vector<ll> g[cst];

vector<edge> edges;

void addEdg(ll v, ll u, ll c) {
	g[v].push_back(edges.size());
	edges.push_back({ v, u, c, 0 });
}

void add(ll v, ll u, ll c) {
	addEdg(v, u, c);
	addEdg(u, v, 0);
}

void push(ll e, ll d) {
	edges[e].f += d;
	edges[e ^ 1].f -= d;
}

set<ll> gp[cst];

ll col[cst];

void colfs(ll v, ll cl = 1) {
	col[v] = cl;
	for (ll u : gp[v]) {
		if (!col[u]) {
			colfs(u, -cl);
		}
		else if (col[u] == cl) {
			throw 1;
		}
	}
}

bitset<cst> used;

ll an = 0;

ll dfs(ll v, ll mn = inf) {
	if (v == t || mn == 0) return mn;
	used[v] = 1;
	for (ll i : g[v]) {
		if (edges[i].c == edges[i].f) continue;
		ll u = edges[i].u;
		if (used[u]) continue;
		ll delt = dfs(u, min(mn, edges[i].c - edges[i].f));
		if (delt) {
			push(i, delt);
			return delt;
		}
	}
	return 0;
}

int main() {
	cin.tie(0)->sync_with_stdio(0);
	cin >> n >> m;
	for (ll i = 0; i < m; i++) {
		ll a, b;
		cin >> a >> b;
		inc[b].push_back(dgs.size());
		out[a].push_back(dgs.size());
		dgs.push_back({ a, b });
	}
	for (ll i = 1; i <= n; i++) {
		for(ll q1 : inc[i]){
			for (ll q2 : out[i]) {
				gp[q1].insert(q2);
				gp[q2].insert(q1);
			}
		}
	}
	for (ll i = 0; i < dgs.size(); i++) {
		if (!col[i]) colfs(i);
		if (col[i] == 1) {
			add(s, i, 1);
			for (ll u : gp[i]) add(i, u, 1);
		}
		if (col[i] == -1) add(i, t, 1);
	}
	ll kek = 0;
	do {
		kek = dfs(s);
		for (ll i = 0; i < 2 * m; i++) used[i] = 0;
		used[s] = 0;
		used[t] = 0;
		an += kek;
	} while (kek);
	if (an < m / 2) {
		cout << "No";
		return 0;
	}
	cout << "Yes" << endl;
	for (auto& i : edges) {
		if (i.u < s && i.v < s && i.f > 0) {
			cout << dgs[i.v].first << " " << dgs[i.v].second << " " << dgs[i.u].first << " " << dgs[i.u].second << endl;
		}
	}
	return 0;
}

/*

5 6
1 2
2 1
1 5
2 3
2 4
4 2

*/