#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>

#define all(a) a.begin(), a.end()

using namespace std;

#define pii pair<int, int>
#define mp make_pair
#define ft first
#define sd second

struct edge {
	int to, val, ind;
	edge() {};
	edge(int to_, int val_, int ind_) :
		to(to_),
		val(val_),
		ind(ind_)
	{};
};

vector<vector<edge>> gr;
vector<int> minn, maxx;

void dfs(int v, int p = -1) {
	if (v == 0)
		for (auto e : gr[v]) {
			minn[e.to] = e.val;
			maxx[e.to] = e.val;
			dfs(e.to, v);
		}
	else {
		for (auto e: gr[v])
			if (e.to != p) {
				minn[e.to] = min(minn[v], e.val);
				maxx[e.to] = max(maxx[v], e.val);
				dfs(e.to, v);
			}
	}
}


void solve() {
	int n, m;
	cin >> n >> m;
	gr.resize(n);
	for (int i = 0; i < m; i++) {
		int x, y, t;
		cin >> x >> y >> t;
		x--;
		y--;
		gr[x].push_back(edge(y, t, i));
		gr[y].push_back(edge(x, t, i));
	}
	if (m == n - 1) {
		minn.resize(n);
		maxx.resize(n);
		dfs(0);
		for (int i = 1; i < n; i++)
			cout << minn[i] + maxx[i] << '\n';
	}
}

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
    // cin >> t;
	while (t--)
		solve();
}