#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <algorithm>

#define all(a) a.begin(), a.end()

using namespace std;

#define pii pair<int, int>
#define mp make_pair
#define ft first
#define sd second

struct edge {
	int from, to, val, ind;
	edge() {};
	edge(int from_, int to_, int val_, int ind_) :
		from(from_),
		to(to_),
		val(val_),
		ind(ind_)
	{};
	bool operator<(edge& other) {
		return val < other.val;
	}
};

vector<vector<edge>> gr;
vector<int> minn, maxx, ans;

void dfs(int v, int p = -1) {
	ans[v] = min(ans[v], minn[v] + maxx[v]);
	if (v == 0)
		for (auto e : gr[v]) {
			minn[e.to] = e.val;
			maxx[e.to] = e.val;
			dfs(e.to, v);
		}
	else {
		for (auto e: gr[v])
			if (e.to != p) {
				minn[e.to] = min(minn[v], e.val);
				maxx[e.to] = max(maxx[v], e.val);
				dfs(e.to, v);
			}
	}
}

vector<int> p, rankk;

int get_p(int v) {
	if (p[v] != v)
		return p[v] = get_p(p[v]);
	return v;
}

void unite(int a, int b) {
	a = get_p(a);
	b = get_p(b);
	if (rankk[a] < rankk[b])
		swap(a, b);
	if (rankk[a] == rankk[b])
		rankk[a]++;
	p[b] = a;
}

vector<bool> possible;

void rec(int mask, int last, int minn = 1e9, int maxx = 0) {
	if (possible[mask])
		return;
	possible[mask] = true;
	ans[last] = min(ans[last], minn + maxx);
	for (auto e : gr[last])
		if ((mask >> e.ind) & 1)
			continue;
		else
			rec(mask ^ (1 << e.ind), e.to, min(minn, e.val), max(maxx, e.val));
}

void solve() {
	int n, m;
	cin >> n >> m;
	gr.resize(n);
	for (int i = 0; i < m; i++) {
		int x, y, t;
		cin >> x >> y >> t;
		x--;
		y--;
		gr[x].push_back(edge(x, y, t, i));
		gr[y].push_back(edge(y, x, t, i));
	}
	// tree
	if (m == n - 1) {
		minn.resize(n);
		maxx.resize(n);
		ans.resize(n, 2e9);
		dfs(0);
		for (int i = 1; i < n; i++)
			cout << ans[i] << '\n';
		return;
	}
	// straight
	if (n <= 2000 && m <= 2000) {
		bool good = true;
		for (int i = 0; i < n; i++)
			for (auto e : gr[i])
				if (abs(e.to - e.from) != 1) {
					good = false;
					break;
				}
		if (good) {
			vector<int> rightcnt(n - 1), minright(n - 1, 1e9), nextmin(n - 1, 1e9);
			for (int i = 0; i < n - 1; i++)
				for (auto e : gr[i])
					if (e.to == (i + 1)) {
						rightcnt[i]++;
						if (e.val < minright[i]) {
							nextmin[i] = minright[i];
							minright[i] = e.val;
						}
						else if (e.val < nextmin[i]) {
							nextmin[i] = e.val;
						}
					}
			int curmin = 1e9;
			int curmax = 0;
			ans.resize(n, 2e9);
			for (int i = 1; i < n; i++) {
				curmin = min(curmin, minright[i - 1]);
				curmax = max(curmax, minright[i - 1]);
				ans[i] = min(ans[i], curmin + curmax);
				int j = i;
				int curmin1 = curmin;
				int curmax1 = curmax;
				while (j > 0 && rightcnt[j - 1] > 1) {
					j--;
					curmin1 = min(curmin1, nextmin[j]);
					curmax1 = max(curmax1, nextmin[j]);
					ans[j] = min(ans[j], curmin1 + curmax1);
				}
			}
			for (int i = 1; i < n; i++)
				cout << ans[i] << '\n';
			return;
		}
	}
	// 
	if (gr[0][0].val == 0) {
		bool good = true;
		for (auto e : gr[0])
			if (e.val != 0) {
				good = false;
				break;
			}
		if (good) {
			vector<bool> used(m);
			vector<edge> edges;
			for (int i = 0; i < n; i++)
				for (auto e : gr[i])
					if (!used[e.ind]) {
						used[e.ind] = true;
						edges.push_back(e);
					}
			gr.clear();
			sort(all(edges));
			p.resize(n);
			rankk.resize(n);
			for (int i = 0; i < n; i++)
				p[i] = i;
			vector<edge> ostov;
			for (auto e : edges) {
				if (get_p(e.from) != get_p(e.to)) {
					ostov.push_back(e);
					unite(e.from, e.to);
				}
			}
			gr.resize(n);
			for (auto e : ostov) {
				gr[e.from].push_back(e);
				gr[e.to].push_back(edge(e.to, e.from, e.val, e.ind));
			}
			minn.resize(n);
			maxx.resize(n);
			ans.resize(n, 2e9);
			dfs(0);
			for (int i = 1; i < n; i++)
				cout << ans[i] << '\n';
			return;
		}
	}
	// small
	if (m <= 20) {
		ans.resize(n, 2e9);
		possible.resize(1 << m);
		rec(0, 0);
		for (int i = 1; i < n; i++)
			cout << ans[i] << '\n';
		return;
	}

}

/*
7 10
1 2 0
1 2 0
2 3 3
3 4 5
3 5 4
4 5 3
6 5 7
6 4 4
1 7 0
6 7 9
*/

int32_t main()
{
	cin.tie(0);
	cout.tie(0);
	ios_base::sync_with_stdio(0);
	int t = 1;
    // cin >> t;
	while (t--)
		solve();
}