#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using namespace std;

typedef long long ll;

const ll INF = 1e18;

ll values[26];

ll func(string s) {
  ll res = 0;
  int mx = -1;
  int n = s.size();
  for (int i = n - 1; i >= 0; i--) {
    int dig = s[i] - 'A';
    if (dig < mx) {
      res -= values[dig];
    } else {
      res += values[dig];
    }
    mx = max(mx, dig);
  }
  return res;
}

int main() {
  values[0] = 1;
  values[1] = 5;
  for (int i = 2; i <= 25; i++) {
    values[i] = values[i - 2] * 10;
  }
  int q;
  cin >> q;
  while (q--) {
    string s;
    cin >> s;
    int n = s.size();
    vector <vector <ll>> dp(n + 1, vector<ll>(26, -INF));
    vector <vector <int>> opt_prev(n + 1, vector<int>(26, -1));
    vector <vector <int>> opt_char(n + 1, vector<int>(26, -1));
    dp[n][0] = 0;
    for (int i = n - 1; i >= 0; i--) {
      if (s[i] == '?') {
        for (int prev = 1; prev <= 25; prev++) {
          if (dp[i][prev] < dp[i + 1][prev] - values[0]) {
            dp[i][prev] = dp[i + 1][prev] - values[0];
            opt_char[i][prev] = 0;
            opt_prev[i][prev] = prev;
          }
        }
        for (int prev = 0; prev <= 25; prev++) {
          for (int j = prev; j <= 25; j++) {
            if (dp[i][j] < dp[i + 1][prev] + values[j]) {
              dp[i][j] = dp[i + 1][prev] + values[j];
              opt_char[i][j] = j;
              opt_prev[i][j] = prev;
            }
          }
        }
      } else {
        int dig = s[i] - 'A';
        for (int prev = 0; prev <= 25; prev++) {
          if (dig >= prev) {
            if (dp[i][dig] < dp[i + 1][prev] + values[dig]) {
              dp[i][dig] = dp[i + 1][prev] + values[dig];
              opt_prev[i][dig] = prev;
              opt_char[i][dig] = dig;
            }
          } else {
            if (dp[i][prev] < dp[i + 1][prev] - values[dig]) {
              dp[i][prev] = dp[i + 1][prev] - values[dig];
              opt_prev[i][prev] = prev;
              opt_char[i][prev] = dig;
            }
          }
        }
      }
    }
    int prev = max_element(dp[0].begin(), dp[0].end()) - dp[0].begin();
    cout << *max_element(dp[0].begin(), dp[0].end()) << '\n';
    for (int i = 0; i < n; i++) {
      cout << (char)('A' + opt_char[i][prev]);
      prev = opt_prev[i][prev];
    }
    cout << '\n';
  }
  return 0;
}

/*
4
BBBC
????
 A?B?C?D
 YYYYY?

 */