#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;

int timer = 0;
vvi g;
vi mt;
vi used;
vi d;

void dfs(int v, int p = -1) {
  for (int u : g[v]) {
    if (u != p) {
      d[u] = d[v] + 1;
      dfs(u, v);
    }
  }
}

bool kuhn(int v) {
  if (used[v] == timer) {
    return false;
  }
  used[v] = timer;
  for (int u : g[v]) {
    if (mt[u] == -1 || kuhn(mt[u])) {
      mt[u] = v;
      return true;
    }
  }
  return false;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(0);
  int n, m;
  cin >> n >> m;
  g.resize(n), d.resize(n);
  vector <pair <int, int>> e;
  for (int i = 0; i < m; i++) {
    int u, v;
    cin >> u >> v;
    u--, v--;
    g[u].push_back(v);
    g[v].push_back(u);
    e.push_back({u, v});
  }
  for (int i = 0; i < n; i++) {
    if (d[i] == 0) {
      dfs(i);
    }
  }
  vector <pair <int, int>> left;
  vector <pair <int, int>> right;
  for (auto [u, v] : e) {
    if (d[u] & 1) {
      left.push_back({u, v});
    } else {
      right.push_back({u, v});
    }
  }
  if (left.size() != right.size()) {
    cout << "No\n";
    return 0;
  }
  g.assign(m / 2, {});
  used.assign(m / 2, -1);
  mt.assign(m / 2, -1);
  for (int i = 0; i < m / 2; i++) {
    for (int j = 0; j < m / 2; j++) {
      if (left[i].first == right[j].second || left[i].second == right[j].first) {
        g[i].push_back(j);
      }
    }
  }
  int cnt = 0;
  for (int v = 0; v < m / 2; v++) {
    for (int u : g[v]) {
      if (mt[u] == -1) {
        mt[u] = v;
        cnt++;
        break;
      }
    }
  }
  for (int v = 0; v < m / 2 && cnt < m / 2; v++) {
    if (kuhn(v)) {
      timer++;
      cnt++;
    }
  }
  if (cnt != m / 2) {
    cout << "No\n";
    return 0;
  }
  cout << "Yes\n";
  for (int u = 0; u < m / 2; u++) {
    pii a = right[u], b = left[mt[u]];
    if (a.second != b.first) {
      swap(a, b);
    }
    cout << a.first + 1 << ' ' << a.second + 1 << ' ' << b.first + 1 << ' ' << b.second + 1 << '\n';
  }
  return 0;
}

/*
5 6
 1 2
 2 1
 1 5
 2 3
 2 4
4 2
 */