#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <array>
#include <bitset>
#include <algorithm>
#include <functional>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <cmath>
#include <cassert>
#include <limits>
#include <time.h>

using namespace std;

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

// #define int long long 
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
#else 
	#define dbg(x)
#endif

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

#pragma GCC optimize("Ofast,fast-math")

const long long INF = 1e18;

const int N = 1e5 + 10;

int n, q;
long long x[N], h[N];
int down[N];
bitset<N> havel[N], haver[N];

int p[N], sz[N], l[N], r[N];

int par(int v) {
	if (p[v] == v) return v;
	return p[v] = par(p[v]);
}

void join(int u, int v) {
	u = par(u), v = par(v);
	if (u != v) {
		if (sz[u] > sz[v]) swap(u, v);
		p[u] = v;
		sz[v] += sz[u];
		chkmin(l[v], l[u]);
		chkmax(r[v], r[u]);
	}
}

void relax(int ind, int ql, int qr, bitset<N>& have) {
	if (ind < ql || ind > qr || down[ind]) return;
	int nl = ind - 1;
	if (down[ind - 1]) nl = l[par(ind - 1)] - 1;
	int nr = ind + 1;
	if (down[ind + 1]) nr = r[par(ind + 1)] + 1;
	// dbg(ind);
	// dbg(nl);
	// dbg(nr);
	// cout << "--" << endl;
	if ((x[ind] - h[ind] >= x[1] && x[ind] - x[nl] >= h[ind]) || (x[ind] + h[ind] <= x[n] && x[nr] - x[ind] >= h[ind])) {
		down[ind] = 1;
		have[ind] = 1;
		if (down[ind - 1]) join(ind, ind - 1);
		if (down[ind + 1]) join(ind, ind + 1);
		relax(nl, ql, qr, have);
		relax(nr, ql, qr, have);
	}
}

void reset() {
	for (int i = 0; i <= n + 1; i++) {
		sz[i] = 1;
		p[i] = l[i] = r[i] = i;
		down[i] = 0;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> q;
	for (int i = 1; i <= n; i++) {
		cin >> x[i] >> h[i];
	}
	x[0] = -INF;
	x[n + 1] = INF;
	reset();
	relax(1, 1, 1, havel[1]);
	for (int i = 2; i <= n; i++) {
		havel[i] = havel[i - 1];
		relax(i, 1, i, havel[i]);
	}
	reset();
	relax(n, n, n, haver[n]);
	for (int i = n - 1; i > 0; i--) {
		haver[i] = haver[i + 1];
		relax(i, i, n, haver[i]);
	}
	unordered_map<int, int> was;
	while (q--) {
		int ql, qr;
		cin >> ql >> qr;
		int w = ql * 10001 + qr;
		if (was.count(w)) {
			cout << was[w] << "\n";
			continue;
		}
		// cout << havel[qr] << "\n" << haver[ql] << "\n";
		int ans = (havel[qr] & haver[ql]).count();
		was[w] = ans;
		cout << ans << "\n";
	}
}
/*
3 3
1 3
3 1 
4 2 
1 1 
2 3 
1 3
-> 0 2 3 

5 3 
1 5
3 1 
4 2 
5 3
6 1 
1 5 
5 5 
1 1 
-> 5 1 0 

1 1 
100 100 
1 1 
-> 0
*/