#include <iostream>
#include <iomanip>
#include <istream>
#include <ostream>
#include <vector>
#include <string>
#include <stack>
#include <queue>
#include <deque>
#include <array>
#include <bitset>
#include <algorithm>
#include <functional>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <chrono>
#include <cmath>
#include <cassert>
#include <limits>
#include <time.h>

using namespace std;

template<typename T> ostream& operator<< (ostream& out, const vector<T>& a) {
	for (auto k : a) {
		out << k << " ";
	}
	return out;
}

template<typename T1, typename T2> bool chkmin(T1& a, const T2& b) {if (b < a) {a = b; return 1;} return 0;}
template<typename T1, typename T2> bool chkmax(T1& a, const T2& b) {if (a < b) {a = b; return 1;} return 0;}

#define int long long 
#define pii pair<int, int>
#define pb push_back
#define ppb pop_back
#define all(a) a.begin(), a.end()

#ifdef LOCAL
	#define dbg(x) cout << #x << " : " << x << endl;
#else 
	#define dbg(x)
#endif

mt19937 gen(chrono::high_resolution_clock::now().time_since_epoch().count());

const long long INF = 1e18;

const int N = 2010;

struct edge {
	int u, w, id;
	edge() {}
	edge(int u_, int w_, int id_) {
		u = u_, w = w_, id = id_;
	}
};

inline bool comp(const edge& a, const edge& b) {
	return a.w < b.w;
}

int n, m;
vector<edge> g[N];
int used[N], dp[N], d[N];
int ans[N];

int p[N], sz[N], mn[N];

int par(int v) {
	if (p[v] == v) return v;
	return p[v] = par(p[v]);
}

void join(int u, int v, int w) {
	u = par(u), v = par(v);
	if (u != v) {
		if (sz[u] > sz[v]) {
			swap(u, v);
		}
		p[u] = v;
		sz[v] += sz[u];
		chkmin(mn[v], mn[u]);
		chkmin(mn[v], w);
	} else chkmin(mn[v], w);
}

void dfs(int v, int curmn, int p = -1, int pid = -1) {
	if (p == -1) {
		d[v] = 0;
	} else {
		d[v] = d[p] + 1;
	}
	// dbg(v);
	// ans[v] = curmn;
	dp[v] = d[v];
	used[v] = 1;
	for (auto ww : g[v]) {
		int u = ww.u;
		int w = ww.w;
		int id = ww.id;
		// if (v == 3) {
		// 	cout << u << " " << w << " " << id << " " << pid << "\n";
		// }
		if (id == pid) {
			continue;
		}
		if (used[u]) {
			// if (v == 3) {
				// cout << dp[v] << " " << d[u] << "\n";
			// }
			chkmin(dp[v], d[u]);
			join(u, v, w);
		} else {
			dfs(u, min(curmn, w), v, id);
			if (dp[u] <= d[v]) {
				// cout << u << " " << v << " " << w << "\n";
				join(u, v, w);
			}
			chkmin(dp[v], dp[u]);
		}
	}
}

void dfs1(int v, int curmn, int p = -1) {
	chkmin(curmn, mn[par(v)]);
	chkmin(ans[v], curmn);
	used[v] = 1;
	for (auto ww : g[v]) {
		int u = ww.u;
		int w = ww.w;
		int id = ww.id;
		if (!used[u]) {
			dfs1(u, min(curmn, w), v);
		}
	}
}

int realans[N];

void solve(int curmx) {
	for (int i = 0; i < n; i++) {
		sz[i] = 1;
		p[i] = i;
		mn[i] = INF;
		ans[i] = INF;
	}
	for (int i = 0; i < n; i++) {
		used[i] = 0;
	}
	dfs(0, INF);
	// dbg(dp[2]);
	// dbg(dp[3]);
	for (int i = 0; i < n; i++) {
		used[i] = 0;
	}
	dfs1(0, INF);
	for (int i = 1; i < n; i++) {
		chkmin(realans[i], ans[i] + curmx);
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cin >> n >> m;
	vector<array<int, 3>> have(m);
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--, v--;
		have[i] = {w, u, v};
	}
	sort(all(have));
	for (int i = 0; i < n; i++) {
		realans[i] = INF;
	}
	int curmx = have[0][0];
	for (int i = 0; i < m; i++) {
		if (have[i][0] != curmx) {
			solve(curmx);
			curmx = have[i][0];
		}
		g[have[i][1]].pb(edge(have[i][2], have[i][0], i));
		g[have[i][2]].pb(edge(have[i][1], have[i][0], i));	
	}
	solve(curmx);
	for (int i = 1; i < n; i++) {
		cout << realans[i] << "\n";
	}
}
/*
4 4 
1 2 1000000000
1 3 1000000000
2 3 2 
3 4 3
*/