#include <iostream>
#include <set>
#include <vector>
using namespace std;

const int MAXN = 1.5e5 + 123;
set<int> edg[MAXN];
set<int> redg[MAXN];
set<int> bedg[MAXN];
bool used[MAXN];
vector<pair<pair<int, int>, pair<int, int>>> ans;

int dfs(int v, int rt){
	used[v] = true;
	vector<int> rdgx;
	vector<int> edgx;
	for(auto u : edg[v]){
		if(u != rt){
			int x = dfs(u, v);
			if(x == -2 || x == -1){
				cout << -2 << "] ";
				return -2;
			}
			if(x == 0){
				edgx.push_back(u);
			} 
		}
	}
	for(auto u : redg[v]){
		if(u != rt){
			int x = dfs(u, v);
			if(x == -2 || x == 1){
				return -2;
			}
			if(x == 0){
				rdgx.push_back(u);
			}
		}
	}
	for(auto u : bedg[v]){
		if(u != rt){
			int x = dfs(u, v);
			if(x == -2){
				return -2;
			}
			if(x == 0){
				ans.push_back({{u, v}, {v, u}});
			} else if(x == 1){
				rdgx.push_back(u);
			} else if(x == -1){
				edgx.push_back(v);
			}
		}
	}
	if(edgx.size() == rdgx.size()){
		for(int i = 0; i < edgx.size(); ++i){
			ans.push_back({{rdgx[i], v}, {v, edgx[i]}});
		}
		return 0;
	} else if(edgx.size() == rdgx.size() + 1){
		for(int i = 0; i < rdgx.size(); ++i){
			ans.push_back({{rdgx[i], v}, {v, edgx[i]}});
		}
		ans.push_back({{rt, v}, {v, edgx.back()}});
		return 1;
	} else if(edgx.size() + 1 == rdgx.size()){
		for(int i = 0; i < edgx.size(); ++i){
			ans.push_back({{rdgx[i], v}, {v, edgx[i]}});
		}
		ans.push_back({{rdgx.back(), v}, {v, rt}});
		return -1;
	} else {
		return -2;
	}
}

signed main(){
	int n, m;
	cin >> n >> m;
	while(m--){
		int u, v;
		cin >> u >> v;
		--u, --v;
		if(edg[v].find(u) != edg[v].end()){
			edg[v].erase(u);
			redg[u].erase(v);
			bedg[v].insert(u);
			bedg[u].insert(v);
			continue;
		}
		edg[u].insert(v);
		redg[v].insert(u);
	}
	for(int i = 0; i < n; ++i){
		if(!used[i]){
			if(dfs(i, -1) != 0){
				
				cout << "No";
				return 0;
			}
		}
	}
	cout << "Yes\n";
	for(auto [e1, e2] : ans){
		if(e1.second != e2.first)
			swap(e1, e2);
		cout << e1.first + 1 << ' ' << e1.second + 1 << ' ' << e2.first + 1 << ' ' << e2.second + 1 << endl;
	}
}
