#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <tuple>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

#define int long long

typedef long long ll;
typedef long double ld;

const ll SZ = 3e5 + 100, INF = INT64_MAX / 2 - 2;

ll num(char ch) {
	ll cur = 1, mul = 0;
	for (char c = 'A'; c < ch; c++) {
		if (mul == 0) {
			cur *= 5;
		} else {
			cur *= 2;
		}
		mul = !mul;
	}

	return cur;
}

ll dp[SZ][26];
tuple<char, int, int> par[SZ][26];

string s;
void recalc(int i, char ch) {
	int nm = ch - 'A';
	for (int k = 0; k < 26; k++) {
		if (k > nm) {
			if (dp[i][k] < dp[i + 1][k] - num(ch)) {
				dp[i][k] = dp[i + 1][k] - num(ch);
				par[i][k] = { ch, i + 1, k };
			}
		}
		else {
			if (dp[i][nm] < dp[i + 1][k] + num(ch)) {
				dp[i][nm] = dp[i + 1][k] + num(ch);
				par[i][nm] = { ch, i + 1, k };
			}
		}
	}
}

signed main() {
	fastInp;

	ll t;
	cin >> t;

	while (t--) {
		cin >> s;

		for (int k = 0; k < 26; k++) dp[s.size()][k] = 0;
		for (int i = s.size() - 1; i >= 0; i--) {
			for (int k = 0; k < 26; k++) dp[i][k] = -INF;
			if (s[i] == '?') {
				for (int k = 0; k < 26; k++) {
					ll nm = k;
					recalc(i, k + 'A');
				}
			}
			else {
				recalc(i, s[i]);
			}
		}

		pair<int, int> bst = { -INF, -INF };
	
		for (int k = 0; k < 26; k++) bst = max(bst, { dp[0][k], k });

		cout << bst.first << "\n";
		bst.first = 0;
		string ans;
		while (ans.size() != s.size()) {
			ans.push_back(get<0>(par[bst.first][bst.second]));

			pair<ll, ll> nw = { get<1>(par[bst.first][bst.second]), get<2>(par[bst.first][bst.second]) };
			bst = nw;
		}
		cout << ans << "\n";
	}

	return 0;
}