#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <tuple>
#include <map>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

#define int long long

typedef long long ll;
typedef long double ld;

const ll SZ = 3e5 + 100, INF = INT64_MAX / 2 - 2;

ll n, m;
vector<vector<ll>> gr, tree;

map<pair<int, int>, int> ind;

bool used[SZ];

vector<pair<ll, ll>> ans;

ll edges[SZ];

//map<pair<ll, ll>, ll> mp;

ll dfs(int v, int par = -1) {
	used[v] = 1;

	int cnt[4];
	vector<ll> sv[4];
	cnt[0] = 0; cnt[1] = 0; cnt[2] = 0; cnt[3] = 0;

	for (auto to : tree[v]) {
		if (!used[to]) {
			ll q = dfs(to, v);
			cnt[q]++;
			sv[q].push_back(to);
		}
	}

	if (v == 1) {
		cout << "";
	}
	while (!sv[1].empty() && !sv[2].empty()) {
		ans.push_back({ edges[sv[1].back()], edges[sv[2].back()] });
		sv[1].pop_back();
		sv[2].pop_back();
	}

	pair<ll, ll> lft = { -1, -1 };

	if (ind.find({ v, par }) != ind.end()) {
		lft.first = ind[{v, par}];
	}
	if (ind.find({ par, v }) != ind.end()) {
		lft.second = ind[{par, v}];
	}

	if (!sv[1].empty() && lft.first != -1) {
		
		ans.push_back({ lft.first, edges[sv[1].back()] });
		lft.first = -1;
		sv[1].pop_back();
	}

	if (!sv[2].empty() && lft.second != -1) {
		
		ans.push_back({ lft.second, edges[sv[2].back()] });
		lft.second = -1;
		sv[2].pop_back();
	}

	if (lft.second != -1 && lft.first != -1) {
		ans.push_back({ lft.second, lft.first });
		lft = { -1, -1 };
	}

	if (!sv[1].empty()) {
		cout << "No";
		exit(0);
	}

	if (!sv[2].empty()) {
		cout << "No";
		exit(0);
	}

	if (lft == make_pair(-1ll, -1ll)) return 0;
	if (lft.first != -1) {
		edges[v] = lft.first;
		return 1;
	}
	else {
		edges[v] = lft.second;
		return 2;
	}
}

vector<pair<ll, ll>> saved;
signed main() {
	fastInp;

	cin >> n >> m;

	gr.resize(n);
	tree.resize(n);
	for (int i = 0; i < m; i++) {
		ll u, v;
		cin >> u >> v;
		u--; v--;
		saved.push_back({ u + 1, v + 1 });
		gr[u].push_back(v);
		ind[{u, v}] = i;
		tree[u].push_back(v);
		tree[v].push_back(u);
	}

	for (int i = 0; i < n; i++) {
		if (!used[i]) {
			if (dfs(i) != 0) {
				cout << "No";
				return 0;
			}
		}
	}

	cout << "Yes\n";

	for (auto c : ans) {
		cout << saved[c.first].first << " " << saved[c.first].second << " " << saved[c.second].first << " " << saved[c.second].second << "\n";
	}

	return 0;
}

/*
5 6
1 2
2 1
1 5
2 3
2 4
4 2

4 4
2 1
2 3
2 4
4 2

4 4
1 2
2 1
3 4
4 3
*/