#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <tuple>
#include <map>
#include <queue>
#include <set>

using namespace std;

#define fastInp cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);

#define int long long

typedef long long ll;
typedef long double ld;

const ll SZ = 3e5 + 100, INF = INT64_MAX / 2 - 2;

ll n, m;
vector<vector<pair<ll, ll>>> gr;

bool used[SZ];
ll ans[SZ];
ll dist[SZ];

void dfs(int v, pair<int, int> vl = make_pair(INF, -INF)) {
	used[v] = 1;

	ans[v] = vl.first + vl.second;
	for (auto to : gr[v]) {
		if (!used[to.first]) {
			pair<int, int> nw = vl;
			nw.first = min(nw.first, to.second);
			nw.second = max(nw.second, to.second);
			dfs(to.first, nw);
		}
	}
}
signed main() {
	fastInp;

	cin >> n >> m;

	gr.resize(n);
	for (int i = 0; i < m; i++) {
		ll u, v, t;
		cin >> u >> v >> t;
		u--; v--;
		gr[u].push_back({ v, t });
		gr[v].push_back({ u, t });
	}

	set<pair<ll, ll>> st;
	for (int i = 1; i < n; i++) dist[i] = INF;
	for (int i = 0; i < n; i++) st.insert({ dist[i], i });

	while (!st.empty()) {
		pair<ll, ll> v = (*st.begin());
		st.erase(st.begin());

		for (auto to : gr[v.second]) {
			if (dist[to.first] > max(v.first, to.second)) {
				st.erase({ dist[to.first], to.first });
				dist[to.first] = max(v.first, to.second);
				st.insert({ dist[to.first], to.first });
			}
		}
	}

	for (int i = 1; i < n; i++) {
		cout << dist[i] << "\n";
	}

	return 0;
}

/*
3 3
1 3
3 1
4 2
1 1
2 3
1 3
*/