#include <map>
#include <set>
#include <vector>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int MAXN = 5000;

int x[MAXN];
int h[MAXN];

bool dp[MAXN][MAXN];
int dp2[MAXN][MAXN];
int ll[MAXN];
int rr[MAXN];

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, q;
  cin >> n >> q;
  for (int i = 0; i < n; ++i)
    cin >> x[i] >> h[i];
  for (int i = 0; i < n; ++i) {
    ll[i] = upper_bound(x, x + n, x[i] - h[i]) - x;
    rr[i] = lower_bound(x, x + n, x[i] + h[i]) - x - 1;
  }
  for (int i = 0; i < n; ++i) {
    if (x[i] - h[i] < x[0])
      ll[i] = -1;
    if (x[i] + h[i] > x[n - 1])
      rr[i] = n;
  }
  for (int i = n - 1; i >= 0; --i) {
    dp[i][i] = (ll[i] == i || rr[i] == i);
    for (int j = i + 1; j < n; ++j) {
      if (dp[i + 1][j] && j >= rr[i]) {
        dp[i][j] = true;
        continue;
      }
      if (dp[i][j - 1] && i <= ll[j]) {
        dp[i][j] = true;
        continue;
      }
      for (int k = i + 1; k < j; ++k) {
        if (dp[i][k - 1] && dp[k + 1][j] && (j >= rr[k] || i <= ll[k])) {
          dp[i][j] = true;
          break;
        }
      }
    }
  }
  for (int i = n - 1; i >= 0; --i) {
    for (int j = i; j < n; ++j) {
      if (dp[i][j]) {
        dp2[i][j] = j - i + 1;
        continue;
      }
      for (int k = j; k >= i; --k) {
        if ((k == j || dp[k + 1][j]))
          dp2[i][j] = max(dp2[i][j], (k == i ? 0 : dp2[i][k - 1]) + j - k);
      }
    }
  }
  while (q--) {
    int a, b;
    cin >> a >> b;
    --a;
    --b;
    cout << dp2[a][b] << '\n';
  }
  return 0;
}
