#include <map>
#include <set>
#include <vector>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int INF = 1e9;
const int MAXN = 300000;

vector<pair<int, int>> G[MAXN];
int dist[MAXN];

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; ++i) {
    int a, b, c;
    cin >> a >> b >> c;
    G[a - 1].emplace_back(b - 1, c);
    G[b - 1].emplace_back(a - 1, c);
  }
  fill(dist, dist + n, INF + 1);
  dist[0] = 0;
  set<pair<int, int>> Q;
  Q.emplace(0, 0);
  while (!Q.empty()) {
    int v = Q.begin()->second;
    Q.erase(Q.begin());
    for (auto t : G[v]) {
      if (dist[t.first] > max(dist[v], t.second)) {
        Q.erase(make_pair(dist[t.first], t.first));
        dist[t.first] = max(dist[v], t.second);
        Q.emplace(dist[t.first], t.first);
      }
    }
  }
  for (int i = 1; i < n; ++i)
    cout << dist[i] << ' ';
  cout << '\n';
  return 0;
}
