#include <map>
#include <set>
#include <vector>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int INF = 1e9;
const int MAXN = 300000;

vector<pair<int, int>> G[MAXN];
int mn[MAXN];
int mx[MAXN];

void dfs(int v, int p) {
  for (auto t : G[v]) {
    if (t.first == p)
      continue;
    mn[t.first] = min(mn[v], t.second);
    mx[t.first] = max(mx[v], t.second);
    dfs(t.first, v);
  }
}

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, m;
  cin >> n >> m;
  for (int i = 0; i < m; ++i) {
    int a, b, c;
    cin >> a >> b >> c;
    G[a - 1].emplace_back(b - 1, c);
    G[b - 1].emplace_back(a - 1, c);
  }
  mn[0] = INF;
  mx[0] = 0;
  dfs(0, -1);
  for (int i = 1; i < n; ++i)
    cout << mn[i] + mx[i] << '\n';
  return 0;
}
