#include <map>
#include <set>
#include <deque>
#include <vector>
#include <cstdio>
#include <iomanip>
#include <iostream>
#include <algorithm>

using namespace std;

const int INF = 1e9;
const int MAXN = 300000;

vector<int> G[MAXN];

map<int, int> dp[MAXN];

int main() {
#ifdef DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#else
  ios::sync_with_stdio(false);
  cin.tie(0);
  cout.tie(0);
#endif

  int n, m;
  cin >> n >> m;
  vector<int> mn1(n - 1, INF + 1);
  vector<int> mn2(n - 1, INF + 1);
  for (int i = 0; i < m; ++i) {
    int a, b, c;
    cin >> a >> b >> c;
    a = min(a, b) - 1;
    if (mn1[a] >= c) {
      mn2[a] = mn1[a];
      mn1[a] = c;
    } else if (mn2[a] >= c) {
      mn2[a] = c;
    }
  }
  vector<int> ans(n, 2 * INF);
  int cur_mn = INF, cur_mx = 0;
  for (int i = 1; i < n; ++i) {
    cur_mn = min(cur_mn, mn1[i - 1]);
    cur_mx = max(cur_mx, mn1[i - 1]);
    ans[i] = min(ans[i], cur_mn + cur_mx);
    int cur_mn1 = cur_mn, cur_mx1 = cur_mx;
    for (int j = i - 1; j >= 0 && mn2[j] != INF + 1; --j) {
      cur_mn1 = min(cur_mn1, mn2[j]);
      cur_mx1 = max(cur_mx1, mn2[j]);
      ans[j] = min(ans[j], cur_mn1 + cur_mx1);
    }
  }
  for (int i = 1; i < n; ++i)
    cout << ans[i] << ' ';
  cout << '\n';
  return 0;
}
