#include <iostream>
#include <vector>
#include <string>
#include <set>
#include <map>
#include <algorithm>
#include <utility>
#include <deque>
using namespace std;
#define int long long
const int INF = 1e10;
struct base {
	int u, v, cost, ind;
	base() { u = 0, v = 0, cost = 0, ind = 0; }
	base(int u, int v, int cost, int ind) : u(u), v(v), cost(cost), ind(ind) {};
};

void gen(int u, vector <vector <base>>& w, vector <int>& used, vector <int>& ans, int mn, int mx) {
	if (mn + mx < ans[u]) {
		ans[u] = mn + mx;
	}
	for (auto vt : w[u]) {
		if (!used[vt.ind]) {
			used[vt.ind] = 1;
			gen(vt.v, w, used, ans, min(mn, vt.cost), max(mx, vt.cost));
			used[vt.ind] = 0;
		}
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	vector <vector <base>> w(n);
	vector <base> eg(m);
	for (int i = 0; i < m; ++i) {
		int u, v, cost;
		cin >> u >> v >> cost;
		--u, --v;
		w[u].emplace_back(u, v, cost, i);
		w[v].emplace_back(v, u, cost, i);
		eg[i] = base(u, v, cost, i);
	}
	vector <int> used(m);
	vector <int> ans(n, INF);
	gen(0, w, used, ans, INF, -INF);
	
	for (int i = 1; i < n; ++i) {
		cout << ans[i] << "\n";
	}
}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#ifdef _LOCAL
	freopen("input.txt", "r", stdin);
#endif;
	int test = 1;
	//cin >> test;
	while (test--) solve();
}