#include <bits/stdc++.h>
using namespace std;

#define all(x) begin(x), end(x)
#define fastream ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)
typedef long long ll;
typedef pair<int, int> pii;

int p[300000], rnk[300000];
struct DSU {
    int n;

    DSU(int n) : n(n) {
        memset(p, 255, sizeof(p));
    }

    int get(int u) {
        if (p[u] == -1) {
            return u;
        }
        return p[u] = get(p[u]);
    }

    bool check(int u, int v) {
        return get(u) == get(v);
    }

    void merge(int u, int v) {
        u = get(u);
        v = get(v);
        if (u == v) {
            return;
        }
        if (rnk[u] < rnk[v]) {
            swap(u, v);
        }
        p[v] = u;
        if (rnk[u] == rnk[v]) {
            rnk[u]++;
        }
    }
};

struct edge {
    int u, v, w, i;

    edge() = default;
    edge(int u, int v, int w, int i) : u(u), v(v), w(w), i(i) {}

    bool operator<(const edge &b) const {
        return w < b.w;
    }
};

vector<edge> edges;
vector<edge> g[300000];
int res[300000];
bool used[20][1100000];

void dfs(int u, int p = -1, int mn = 2e9, int mx = -2e9) {
    res[u] = mn + mx;
    for (auto &e : g[u]) {
        if (e.v == p) {
            continue;
        }
        dfs(e.v, u, min(mn, e.w), max(mx, e.w));
    }
}

void dfs2(int u, int mask, int mn = 2e9, int mx = -2e9) {
    if (used[u][mask]) {
        return;
    }
    used[u][mask] = 1;
    res[u] = min(res[u], mn + mx);
    for (auto &e : g[u]) {
        if (mask & (1 << e.i)) {
            continue;
        }
        dfs2(e.v, mask | (1 << e.i), min(mn, e.w), max(mx, e.w));
    }
}

bool used2[2000];

signed main() {
    fastream;
    int n, m;
    cin >> n >> m;
    fill(res, res + n, INT32_MAX);
    bool fl = 1;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        if (abs(u - v) > 1) {
            fl = 0;
        }
        edges.emplace_back(u, v, w, i);
        g[u].emplace_back(u, v, w, i);
        g[v].emplace_back(v, u, w, i);
    }
    if (fl) {
        assert(0);
        int mn = 2e9, mx = -2e9;
        for (int i = 0; i < n - 1; i++) {
            int mni = -1;
            for (auto &e : g[i]) {
                if (e.v == i + 1) {
                    if (mni == -1 || e.w < edges[mni].w) {
                        mni = e.i;
                    }
                }
            }
            used2[mni] = 1;
            mn = min(mn, edges[mni].w);
            mx = max(mx, edges[mni].w);
            res[i + 1] = mn + mx;
            int mn_ = mn;
            int mx_ = mx;
            for (int j = i + 1; j > 0; j--) {
                mni = -1;
                for (auto &e : g[j]) {
                    if (e.v == i - 1 && !used2[e.i]) {
                        if (mni == -1 || e.w < edges[mni].w) {
                            mni = e.i;
                        }
                    }
                }
                if (mni == -1) {
                    break;
                }
                mn_ = min(mn_, edges[mni].w);
                mx_ = max(mx_, edges[mni].w);
                res[j - 1] = min(res[j - 1], mn_ + mx_);
            }
        }
        for (int i = 1; i < n; i++) {
            cout << res[i] << endl;
        }
    } else if (n <= 20 && m <= 20) {
        dfs2(0, 0);
        for (int i = 1; i < n; i++) {
            cout << res[i] << endl;
        }
    } else if (m == n - 1) {
        dfs(0);
        for (int i = 1; i < n; i++) {
            cout << res[i] << endl;
        }
    } else {
        sort(all(edges));
        DSU dsu(n);
        for (int i = 0; i < n; i++) {
            g[i].clear();
        }
        for (auto &e : edges) {
            if (!dsu.check(e.u, e.v)) {
                dsu.merge(e.u, e.v);
                g[e.u].emplace_back(e);
                g[e.v].emplace_back(e.v, e.u, e.w, e.i);
            }
        }
        dfs(0);
        for (int i = 1; i < n; i++) {
            cout << res[i] << endl;
        }
    }
}