#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <queue>
#include <deque>
#include <string>
#include <array>
#include <list>

#define ar array

using namespace std;
using ll=long long;
using ld=long double;
const int inf=2e9;

int n, m;
vector<vector<int>> g;
vector<ar<int,3>> e;
vector<int> mnc, mxc;

void dfs(int v, int p = -1) {
	for (auto i : g[v]) {
		int u=e[i][1];
		if (u==p) continue;
		mnc[u]=min(e[i][2],mnc[v]);
		mxc[u]=max(e[i][2],mxc[v]);
		dfs(u,v);
	}
}

struct dsu {
	vector<int> p, h;
	vector<list<int>> l;
	dsu(int n = 0) {
		p.resize(n);
		h.assign(n,0);
		l.resize(n);
		for (int i=0; i<n; ++i) {
			p[i]=i;
			l[i]={i};
		}
	}
	inline int get(int a) {
		return p[a]=(p[a]==a?a:get(p[a]));
	}
	inline void unite0(int a, int b) {
		a=get(a); b=get(b);
		if (a==b) return;
		if (h[a]>h[b]) swap(a,b);
		p[a]=b;
		h[b]=max(h[b],h[a]+1);
		l[b].splice(l[b].end(),l[a]);
	}
	inline list<int> unite1(int a, int b) {
		a=get(a); b=get(b);
		if (a==b) return {};
		list<int> ans=l[b];
		if (h[a]>h[b]) swap(a,b);
		p[a]=b;
		h[b]=max(h[b],h[a]+1);
		l[b].splice(l[b].end(),l[a]);
		return ans;
	}
};

void solve() {
	cin >> n >> m;
	g.assign(n,{});
	for (int i = 0; i < m; ++i) {
		int u, v, t; cin >> u >> v >> t; --u, --v;
		g[u].push_back(e.size());
		e.push_back({u,v,t});
		g[v].push_back(e.size());
		e.push_back({v,u,t});
	}
	if (m == n - 1) {
		mnc.resize(n); mxc.resize(n);
		mnc[0]=2e9, mxc[0]=0;
		dfs(0);
		for (int i = 1; i < n; ++i) {
			cout << mnc[i]+mxc[i] << "\n";
		}
		return;
	}
	vector<ar<int,3>> se;
	for (auto x : e) {
		se.push_back({x[2],x[0],x[1]});
	}
	bool t2=1, t3=1;
	for (auto i : g[0]) {
		if (e[i][2]>0) t2=0;
		if (e[i][2]<1e9) t3=0;
	}
	if (t2) {
		sort(se.begin(),se.end());
		dsu con(n);
		vector<int> ans(n);
		for (auto x : se) {
			if (con.get(0) == con.get(x[1]) && con.get(0) != con.get(x[2])) {
				list<int> cur=con.unite1(x[1],x[2]);
				for (auto el : cur) ans[el]=x[0];
			}
			else if (con.get(0) == con.get(x[2]) && con.get(0) != con.get(x[1])) {
				list<int> cur=con.unite1(x[2],x[1]);
				for (auto el : cur) ans[el]=x[0];
			}
			else con.unite0(x[1],x[2]);
		}
		for (int i = 1; i < n; ++i) {
			cout << ans[i] << "\n";
		}
		return;
	}
	if (t3) {
		sort(se.begin(),se.end());
		dsu con(n);
		vector<int> ans(n);
		for (auto i : g[0]) {
			int u=e[i][1];
			ans[u]=0;
			con.unite0(0,u);
		}
		for (auto x : se) {
			if (con.get(0) == con.get(x[1]) && con.get(0) != con.get(x[2])) {
				list<int> cur=con.unite1(x[1],x[2]);
				for (auto el : cur) ans[el]=x[0];
			}
			else if (con.get(0) == con.get(x[2]) && con.get(0) != con.get(x[1])) {
				list<int> cur=con.unite1(x[2],x[1]);
				for (auto el : cur) ans[el]=x[0];
			}
			else con.unite0(x[1],x[2]);
		}
		for (int i = 1; i < n; ++i) {
			cout << ans[i]+int(1e9) << "\n";
		}
		return;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0); cout.tie(0);
	int test_case=1;
	for (int i = 0; i < test_case; ++i) {
		solve();
		cout << "\n";
	}
}