#include <bits/stdc++.h>

using namespace std;

const int MAXN = 2000;
const long long INF = 1e10;

vector<pair<int, long long>> g[MAXN], mg[MAXN];

int tin[MAXN], up[MAXN];
bool used[MAXN];

int height[MAXN], parent[MAXN];
long long dist[MAXN];

inline void init(int n) {
    for (int i = 0; i < n; i++) {
        height[i] = 0;
        parent[i] = i;
        used[i] = false;
        dist[i] = INF;
        mg[i].clear();
        mg[i].shrink_to_fit();
    }
}

int get_parent(int v) {
    if (parent[v] == v) {
        return v;
    }
    return get_parent(parent[v]);
}

inline void merge(int v, int u) {
    v = get_parent(v), u = get_parent(u);
    if (v == u) {
        return;
    }
    if (height[v] == height[u]) {
        height[v]++;
    }
    if (height[v] > height[u]) {
        parent[u] = v;
    } else {
        parent[v] = u;
    }
}

int dfs(int v = 0, int prev = -1) {
    static int time = 0;
    tin[v] = up[v] = time++;
    used[v] = true;
    int x = 0;
    for (auto &[u, w] : g[v]) {
        if (u != prev) {
            if (!used[u]) {
                int y = dfs(u, v);
                up[v] = min(up[v], up[u]);
                if (up[u] <= tin[v] || y > 1) {
                    merge(v, u);
                }
            } else {
                up[v] = min(up[v], tin[u]);
            }
        } else {
            x++;
        }
    }
    return x;
}

void mini_dfs(int v, int prev = -1, long long cur_mn = INF) {
//    cout << v << endl;
    cur_mn = min(cur_mn, dist[v]);
    dist[v] = cur_mn;
    for (auto &[u, w] : mg[v]) {
        if (u != prev) {
            mini_dfs(u, v, min(cur_mn, w));
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    vector<tuple<int, int, int>> e;
    for (int i = 0; i < m; i++) {
        int v, u, t;
        cin >> v >> u >> t;
        g[v - 1].emplace_back(u - 1, t);
        g[u - 1].emplace_back(v - 1, t);
    }
    init(n);
    dfs();
    for (int v = 0; v < n; v++) {
        if (used[v]) {
            for (auto &[u, w] : g[v]) {
                if (get_parent(v) == get_parent(u)) {
                    dist[get_parent(v)] = min(dist[get_parent(v)], w);
                } else {
                    mg[get_parent(v)].emplace_back(get_parent(u), w);
                }
            }
        }
    }
    mini_dfs(get_parent(0));
    for (int i = 1; i < n; i++) {
        cout << dist[get_parent(i)] + (int)(1e9) << '\n';
    }
    return 0;
}
/*
3 3
1 2 2
1 3 1
2 3 1

7 10
1 2 2
1 2 8
2 3 3
3 4 5
3 5 4
4 5 4
6 5 7
6 4 4
1 7 6
6 7 9
*/