#include <bits/stdc++.h>

#define endl "\n"
using namespace std;

#define double long double
#define int long long

#ifdef int
#define IMIN INT64_MIN
#define IMAX INT64_MAX
#else
#define IMIN INT32_MIN
#define IMAX INT32_MAX
#endif

#ifdef LOCAL
ifstream fin; // NOLINT(cert-err58-cpp)
#define cin fin
#endif

struct rb_t {
    int a, b, t;
    bool is_brg;
};

int call_timer;
chrono::system_clock::time_point prog_start;

bool dfs(int v, bool *rused, int *res, int mx, int mn, vector<int> *gr, rb_t *rbs) {
    if (call_timer == 10000) {
        call_timer = 0;
        if (chrono::duration_cast<chrono::milliseconds>(chrono::system_clock::now() - prog_start).count() >= 2700) {
            return true;
        }
    }
    call_timer++;
    res[v] = min(res[v], mx + mn);
    for (int r : gr[v]) {
        if (rused[r]) {
            continue;
        }
        rused[r] = true;

        if (dfs(rbs[r].a + rbs[r].b - v, rused, res, max(mx, rbs[r].t), min(mn, rbs[r].t), gr, rbs)) {
            return true;
        }

        rused[r] = false;
    }
    return false;
}

void solve() {
    prog_start = chrono::system_clock::now();

    int n, m;
    cin >> n >> m;
    vector<int> gr[n];
    rb_t rbs[m];
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;

        rbs[i] = {.a = a, .b = b, .t = c, .is_brg = false};

        gr[a].push_back(i);
        gr[b].push_back(i);
    }

    for (int i = 0; i < n; i++) {
        sort(gr[i].begin(), gr[i].end(), [&](int a, int b) {
            return rbs[a].t < rbs[b].t;
        });
    }

    bool used[m];
    memset(used, false, sizeof(used));
    int res[n];
    for (int i = 0; i < n; i++) {
        res[i] = IMAX;
    }
    dfs(0, used, res, -IMAX, IMAX, gr, rbs);
    for (int i = 1; i < n; i++) {
        cout << res[i] << endl;
    }
}

//#define MULTITEST

int32_t main() {
#ifdef LOCAL
    fin.open("in.txt");
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef MULTITEST
    int32_t _t;
    cin >> _t;
    while (_t--)
#endif
    solve();
    return 0;
}
