#pragma GCC optimize("Ofast")
#include <iostream>
#include <algorithm>
#include <vector>
#include <map>
#include <cmath>
#include <string>
#include <set>

using namespace std;

#define rep(i, n) for (int i = 0; i < n; i++)
#define per(i, n) for (int i = n - 1; i >= 0; i--)
#define sz(x) ((int)x.size())
#define all(x) x.begin(),x.end()
#define pb push_back

typedef long long ll;
typedef vector<int> vi;
typedef set<int> si;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<ll> vll;

struct Tree {
	int x, h;
};

si ml[500100];
si mr[500100];
si cml[500100];
si cmr[500100];

vi wml[500100];
vi wmr[500100];

const int inf = 1e9;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int n, q;
	cin >> n >> q;
	vector<Tree> t;
	rep(i, n) {
		int x, h;
		cin >> x >> h;
		t.pb({ x, h });
	}
	rep(i, n) {
		if (t[i].x - t[i].h < t[0].x) {
			ml[i].insert(inf);
		}
		if (t[i].x + t[i].h > t[n - 1].x) {
			mr[i].insert(inf);
		}
		for (int j = 0; j < i; j++) {
			if (t[i].x - t[i].h < t[j].x) {
				ml[i].insert(j);
				wml[j].pb(i);
			}
		}
		for (int j = i + 1; j < n; j++) {
			if (t[i].x + t[i].h > t[j].x) {
				mr[i].insert(j);
				wmr[j].pb(i);
			}
		}
	}

	for (; q; q--) {
		int l, r;
		cin >> l >> r;

		l--; r--;

		set<pii> cur;
		for (int i = l; i <= r; i++) {
			cur.insert({ min(sz(ml[i]), sz(mr[i])), i });
			cml[i] = ml[i];
			cmr[i] = mr[i];
		}
		vector<bool>used(n);
		int ans = 0;
		while (cur.size()) {
			if (cur.begin()->first != 0) break;
			int v = cur.begin()->second;
			cur.erase(cur.begin());
			ans++;
			used[v] = true;
			for (int u : wml[v]) {
				if (u >= l && u <= r) {
					if (used[u]) continue;
					cur.erase({ min(sz(cml[u]), sz(cmr[u])), u });

					cml[u].erase(v);

					cur.insert({ min(sz(cml[u]), sz(cmr[u])), u });
				}
			}

			for (int u : wmr[v]) {
				if (u >= l && u <= r) {
					if (used[u]) continue;
					cur.erase({ min(sz(cml[u]), sz(cmr[u])), u });

					cmr[u].erase(v);

					cur.insert({ min(sz(cml[u]), sz(cmr[u])), u });
				}
			}
		}
		cout << ans << "\n";
	}

	return 0;
}