#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>


#define ll long long
#define all(a) a.begin(), a.end()


using namespace std;


vector<int> gl;
vector<int> gr;


int n;
int m;
vector<bool> t;
vector<int> p;
string sx;
vector<bool> x;
string sz;


int build_tree(int tl, int tr, int par) {
	int ind = t.size();
	p[ind] = par;
	if (tl == tr) {
		t.push_back(x[tl]);
		gl[ind] = -1;
		gr[ind] = -1;
		return ind;
	}
	t.push_back(true);
	int tm = (tl + tr) / 2;
	gl[ind] = build_tree(tl, tm, ind);
	gr[ind] = build_tree(tm + 1, tr, ind);
	t[ind] = (t[gl[ind]] != t[gr[ind]]);
	return ind;
}


void build_tree() {
	gl.resize(2 * n);
	gr.resize(2 * n);
	p.resize(2 * n);
	build_tree(0, n - 1, -1);
}


bool ok(int ind) {
	if (gl[ind] == -1) {
		return false;
	}
	return (t[ind] == (t[gl[ind]] != t[gr[ind]]));
}


void recover_tree() {
	for (int i = 1; i < t.size(); ++i) {
		if ((!ok(i)) && (!ok(p[i]))) {
			t[i] = (!t[i]);
			break;
		}
	}
}


void get_x() {
	x.clear();
	for (int i = 1; i < t.size(); ++i) {
		if (gl[i] == -1) {
			x.push_back(t[i]);
		}
	}
}


int32_t main() {
	int work_type;
	cin >> work_type;
	if (work_type == 1) {
		cin >> sx;
		n = sx.size();
		x.resize(n);
		for (int i = 0; i < n; ++i) {
			if (sx[i] == '1') {
				x[i] = true;
			}
			else if (sx[i] == '0') {
				x[i] = false;
			}
		}
		build_tree();
		for (auto c : t) {
			cout << c;
		}
		cout << "\n";
	}
	else if (work_type == 2) {
		cin >> sz;
		m = sz.size();
		n = (m + 1) / 2;
		x.resize(n);
		build_tree();
		for (int i = 0; i < m; ++i) {
			if (sz[i] == '1') {
				t[i] = true;
			}
			else if (sz[i] == '0') {
				t[i] = false;
			}
		}
		recover_tree();
		get_x();
		for (auto c : x) {
			cout << c;
		}
		cout << "\n";
	}
	return 0;
}

/*
2
0110110
*/