#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>


#define ll long long
#define all(a) a.begin(), a.end()
int HSHS_CNT = 6;
int STR_SZ = 10;



using namespace std;


int h_sz = STR_SZ * HSHS_CNT;


void set_str_sz() {
	HSHS_CNT = 1;
	STR_SZ = 10;
	h_sz = STR_SZ * HSHS_CNT;
}


struct Hasher {
	int str_sz = STR_SZ;
	ll mod = 1e9 + 7;
	ll p = 2;

	int n;
	vector<ll> p_pow;
	vector<bool> x;
	ll h;


	void cnt_p_pow() {
		p_pow.resize(n + 1);
		p_pow[0] = 1;
		for (int i = 1; i <= n; ++i) {
			p_pow[i] = (p_pow[i - 1] * p) % mod;
		}
	}


	void cnt_h() {
		h = 0;
		for (int i = 0; i < n; ++i) {
			h = (h + p_pow[i] * x[i]) % mod;
		}
	}


	void build(vector<bool> &x, int mod = 1e9 + 7) {
		this->mod = mod;
		this->x = x;
		n = x.size();
		cnt_p_pow();
		cnt_h();
	}


	void set(int i) {
		h = (h - p_pow[i] * x[i]);
		x[i] = (!x[i]);
		h = (h + p_pow[i] * x[i]);
	}

	string to_str() {
		string res;
		for (int i = str_sz - 1; i >= 0; --i) {
			res.push_back('0' + ((h >> i) & 1));
		}
		return res;
	}
};


struct NHasher {
	vector<ll> mod = { (ll)(1e9 + 7),
					(ll)(1e9 + 8),
					(ll)(1e9 + 9),
					(ll)(1e9 + 10),
					(ll)(1e9 + 11) };
	int n = HSHS_CNT;
	vector<Hasher> h;


	void build(vector<bool>& x) {
		h.resize(n);
		for (int i = 0; i < n; ++i) {
			h[i].build(x, mod[i]);
		}
	}


	


	string to_str() {
		string res;
		for (int i = 0; i < n; ++i) {
			res += h[i].to_str();
		}
		return res;
	}



	void set(int j) {
		for (int i = 0; i < n; ++i) {
			h[i].set(j);
		}
	}
};


char _xor(string s) {
	bool res = 0;
	for (int i = 0; i < s.size(); ++i) {
		if (s[i] == '1') {
			res = (!res);
		}
	}
	return '0' + res;
}


vector<int> gl;
vector<int> gr;


int n;
int m;
vector<bool> t;
vector<int> p;
string sx;
vector<bool> x;
string sz;
string res;
NHasher h;



void simple_solve1() {
	n = sx.size();
	for (int j = 0; j < 3; ++j) {
		for (int i = 0; i < n; ++i) {
			res.push_back(sx[i]);
		}
	}
	cout << res << "\n";
}


void simple_solve2() {
	n = sz.size() / 3;
	if (sz.size() % 3 != 0) {
		throw - 1;
	}
	res.resize(n);
	for (int i = 0; i < n; ++i) {
		int zcnt = 0;
		int ocnt = 0;
		for (int j = i; j < sz.size(); j += n) {
			if (sz[i] == '0') {
				zcnt += 1;
			}
			else if(sz[i] == '1' ){
				ocnt += 1;
			}
		}
		if (zcnt > ocnt) {
			res[i] = '0';
		}
		else {
			res[i] = '1';
		}
	}
	cout << res << "\n";
}



void get_x() {
	x.clear();
	for (int i = 1; i < t.size(); ++i) {
		if (gl[i] == -1) {
			x.push_back(t[i]);
		}
	}
}


int32_t main() {
	int work_type;
	cin >> work_type;
	if (work_type == 1) {
		cin >> sx;
		if (sx.size() == 10) {
			set_str_sz();
		}
		if (false) {
			simple_solve1();
		}
		else {
			n = sx.size();
			x.resize(n);
			for (int i = 0; i < n; ++i) {
				if (sx[i] == '1') {
					x[i] = true;
				}
				else if (sx[i] == '0') {
					x[i] = false;
				}
			}
			h.build(x);
			string hsh = h.to_str();
			res = sx + hsh + _xor(hsh);
			cout << res << "\n";
		}
	}
	else if (work_type == 2) {
		cin >> sz;
		if (sz.size() < 100) {
			set_str_sz();
		}
		if (false) {
			simple_solve2();
		}
		else {
			m = sz.size();
			n = (m - 1 - h_sz);
			sx = string(sz.begin(), sz.begin() + n);
			string hsh(sz.begin() + n, sz.end() - 1);
			char xr = sz.back();
			x.resize(n);
			for (int i = 0; i < n; ++i) {
				if (sx[i] == '1') {
					x[i] = true;
				}
				else if (sx[i] == '0') {
					x[i] = false;
				}
			}
			h.build(x);
			if (_xor(hsh) == xr && h.to_str() != hsh) {
				for (int i = 0; i < n; ++i) {
					h.set(i);
					if (h.to_str() == hsh) {
						x[i] = (!x[i]);
						break;
					}
					h.set(i);
				}
			}
			res.clear();
			for (int i = 0; i < n; ++i) {
				res.push_back('0' + x[i]);
			}
			cout << res << "\n";
		}
	}
	return 0;
}

/*
1
101110101
*/

/*
2
101110101101110101101110111


101110101101110101101110101
*/