#include <algorithm>
#include <iostream>
#include <string>
#include <vector>
using namespace std;

const int N = 100100;
const int A = 30;
int pw[N];
int base, mod;

vector<int> buildh(const string& s) {
	vector<int> res(s.size());
	for (int i = 0; i < s.size(); i++) {
		res[i] = ((long long)base * res[max(0, i - 1)] + (s[i] == '0' ? 228 : 6661337)) % mod;
	}
	return res;
}

int add(int a, int b) {
	int res = a + b;
	if (res >= mod) res -= mod;
	return res;
}

int sub(int a, int b) {
	int res = a - b;
	if (res < 0) res += mod;
	return res;
}

int mult(int a, int b) {
	return (long long)a * (long long)b % (long long)mod;
}

int geth(const vector<int>& h, int l, int r) {
	return !l ? h[r] : sub(h[r], mult(h[l - 1], pw[r - l + 1]));
}

string gen(int h) {
	string res;
	for (int i = 0; i < A; i++) {
		res += (h & i ? '1' : '0');
	}
	return res;
}

string get1(string s) {
	return s + gen(buildh(s).back());
}

string get2(string s) {
	int n = (int)s.size() - A;
	vector<int> h = buildh(s.substr(0, n));

	string res;
	string g1 = s.substr(n, A), g2 = gen(h.back());
	int cnt = 0;
	for (int i = 0; i < g1.size(); i++) {
		cnt += g1[i] != g2[i];
	}
	if (cnt <= 1) {
		return s.substr(0, n);
	}
	else {
		for (int i = 0; i < n; i++) {
			int H = h.back();
			if (s[i] == '0') H = add(H, mult(6661337 - 228, pw[n - 1 - i]));
			else H = sub(H, mult(6661337 - 228, pw[n - 1 - i]));
			if (gen(H) == g1) {
				string res = s.substr(0, n);
				res[i] = (s[i] == '0' ? '1' : '0');
				return res;
			}
		}
	}
	throw(0);
}

int main() {
	mod = 1e9 + 7;
	base = 12354;
	pw[0] = 1;
	for (int i = 1; i < N; i++) pw[i] = (long long)pw[i - 1] * base % mod;

	int x;
	cin >> x;
	if (x == 1) {
		string s;
		cin >> s;
		cout << get1(s) << '\n';
	}
	else {
		string s;
		cin >> s;
		cout << get2(s) << '\n';
	}
	return 0;
}