#include <iostream>
#include <vector>
#include <algorithm>

#define BITS 17
#define BASE 5

#define MOD ((1 << BITS) - 1)

int32_t bits_to_num(std::string bits) {
    int32_t res = 0;
    for(int32_t i = 0; i < BITS; i++)
        res += (bits[i] - '0') * (1 << (BITS - 1 - i));
    return res;
}

std::string num_to_bits(int32_t num) {
    std::string res;
    for(int32_t i = 0; i < BITS; i++)
        res.push_back((char)('0' + ((num  >> (BITS - i - 1)) & 1)));
    return res;
}

int32_t num_diff(std::string s1, std::string s2) {
    int32_t res = 0;
    for(int32_t i = 0; i < BITS; i++)
        if(s1[i] != s2[i])
            res++;
    return res;
}

int main() {
    int32_t run;
    std::cin >> run;

    if(run == 1) {
        std::string str;
        std::cin >> str;
        int32_t n = str.size();

        int32_t hash = 0;
        int32_t power = BASE;
        for(int32_t i = 0 ; i < n; i++) {
            hash += power * (str[i] - '0');
            hash %= MOD;
            power *= BASE;
            power %= MOD;
        }

        std::cout << str;
        for(int32_t i = BITS - 1; i >= 0; i--)
            std::cout << (char)('0' + ((hash  >> i) & 1));
    } else {
        std::string str;
        std::cin >> str;

        int32_t n = str.size() - BITS;

        int32_t hash_real = 0;
        int32_t power = BASE;
        for(int32_t i = 0 ; i < n; i++) {
            hash_real += power * (str[i] - '0');
            hash_real %= MOD;
            power *= BASE;
            power %= MOD;
        }

        int32_t hash_offered = bits_to_num(str.substr(str.size() - BITS));
        if(hash_real == hash_offered)
            std::cout << str.substr(0, n);
        else {
            std::string offered_hash_str = num_to_bits(hash_offered);
            if(num_diff(num_to_bits(hash_real), offered_hash_str) == 1) {
                //they modified the hash
                std::cout << str.substr(0, n);
            } else {
                power = BASE;
                for(int32_t i = 0; i < n; i++) {
                    int32_t modified_hash = hash_real;
                    if(str[i] == '0')
                        modified_hash = (modified_hash + power) % MOD;
                    else
                        modified_hash = (modified_hash - power + MOD) % MOD;
                    if(modified_hash == hash_offered) {
                        str[i] = '0' + ('1' - str[i]);
                        std::cout << str.substr(0, n);
                        return 0;
                    }
                    power *= BASE;
                    power %= MOD;
                }
            }
        }
    }
    return 0;
}