#include <iostream>
#include <vector>

using namespace std;

string protect(const string &data) {
    int n = data.length();
    string protected_data;
    //protected_data += data[0];
    
    protected_data += data[0];
    int cur = data[0] - '0';

    for (int i = 1; i < n; i++) {
        int c = data[i] - '0';
        cur ^= c;
        protected_data += cur + '0';
    }
    protected_data = data + protected_data;
    return protected_data;
}

bool check(const string &data, const string &prefix) {
    int n = prefix.length();
    if (data[0] != prefix[0]) {
        return false;
    }
    int cur = prefix[0] - '0';
    for (int i = 1; i < n; i++) {
        int datac = data[i] - '0';
        int prefixc = prefix[i] - '0';
        if (datac != (prefixc ^ cur)) {
            return false;
        }
        cur = prefixc;
    }
    return true;
}

inline char flip(const char &c) {
    if (c == '0') {
        return '1';
    }
    return '0';
}

string recover(const string &damaged_data) {
    int n = damaged_data.size();
    n /= 2;
    string data = damaged_data.substr(0, n);
    string prefix = damaged_data.substr(n, n);
    int cur = 0;
    for (int i = 0; i < n; i++) {
        int datac = data[i] - '0';
        int prefixc = prefix[i] - '0'; 
        if (datac != (prefixc ^ cur)) {
            data[i] = flip(data[i]);
            if (check(data, prefix)) {
                return data;
            }
            data[i] = flip(data[i]);
            prefix[i] = flip(prefix[i]);
            if (check(data, prefix)) {
                return prefix;
            }
            prefix[i] = flip(prefix[i]);
        }
        cur = prefixc;
    }
    return data;
}

int main() {
    int t; cin >> t;
    if (t == 1) {
        string s; cin >> s;
        cout << protect(s) << endl;
    }
    if (t == 2) {
        string s; cin >> s;
        cout << recover(s) << endl;
    }
}
