#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
using namespace std;

const int mod = 200002;
const int max_log = 18;

int calculate_sum(const string& s) {
	int sum = 0;
	for (int i = 0; i < s.size(); i++) {
		if (s[i] == '1') {
			sum += (i + 1);
			sum %= mod;
		}
	}
	return sum;
}

string encode_sum(int sum) {
	string result;
	for (int i = 0; i < max_log; i++) {
		result += (char)('0' + sum % 2);
		sum /= 2;
	}
	
	string encoded_result;
	for (char c : result) {
		for (int i = 0; i < 3; i++)
			encoded_result += c;
	}
	return encoded_result;
}

int decode_sum(const string& encoded) {
	string stuff;
	for (int i = 0; i < encoded.size(); i += 3) {
		map<char, int> symbols;
		for (int j = 0; j < 3; j++) {
			symbols[encoded[i + j]]++;
		}
		if (symbols['0'] > symbols['1'])
			stuff += '0';
		else
			stuff += '1';
	}

	reverse(stuff.begin(), stuff.end());
	int sum = 0;
	for (char c : stuff) {
		sum *= 2;
		if (c == '1')
			sum++;
	}
	return sum;
}

int main() {
	int type;
	cin >> type;
	if (type == 1) {
		string s;
		cin >> s;
		int sum = calculate_sum(s);
		s += encode_sum(sum);
		cout << s;
	}
	else {
		string s;
		cin >> s;
		string encoded_sum = s.substr(s.size() - max_log * 3, max_log * 3);
		string original = s.substr(0, s.size() - max_log * 3);
		int new_sum = calculate_sum(original);
		int old_sum = decode_sum(encoded_sum);
		int diff = new_sum - old_sum;
		if (diff * 2 > mod)
			diff = mod - diff;
		diff = abs(diff);
		if (diff != 0) {
			if (original[diff - 1] == '0')
				original[diff - 1] = '1';
			else
				original[diff - 1] = '0';
		}
		cout << original;
	}
}
